package com.gx.obe.common.composite;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.business.entity.EvaluationFactorItem;
import com.gx.obe.business.entity.ScoreItem;
import com.gx.obe.business.entity.SupplierEvaluationFactor;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.InputDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.util.utils.NumberFormatUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.SerializeUtils;
import com.gx.obe.util.utils.SortUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.obe.web.entity.EvaluationFactorResult;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.ExpertEvaluationResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.EvaluationFactorItemService;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierEvaluationFactorService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationFactorResultService;
import com.gx.obe.web.service.evaluation.EvaluationFactorService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertEvaluationResultService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.KTableCellMouseRightAdapter;
import de.kupzog.ktable.KTableCellSelectionAdapter;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.editors.KTableCellEditorGCombo;
import de.kupzog.ktable.editors.KTableCellEditorText;
import de.kupzog.ktable.model.CommonKtableCModel;
import de.kupzog.ktable.renderers.CellAlignmentRender;
import de.kupzog.ktable.renderers.CellBackgroundRender;
import de.kupzog.ktable.renderers.CellContentRender;
import de.kupzog.ktable.renderers.CellEditContentRender;
import de.kupzog.ktable.renderers.CellEditorRender;
import de.kupzog.ktable.renderers.CellForegroundRender;
import de.kupzog.ktable.renderers.CellRender;
import de.kupzog.ktable.renderers.CellTooltipRender;
import de.kupzog.ktable.renderers.FixedWrapCellRenderer;
import de.kupzog.ktable.renderers.TextWrapCellRenderer;

/**
 * @Description: 打分评审面板
 * @author guoyr
 */
public class AIScoreEvaluationTableComposite extends Composite{

	private TenderProjectEntity tenderProjectEntity;
	private EvaluationStep evaluationStep;
	private ImageResolver imageResolver = new ImageResolver();
	private SupplierEvaluationFactorService supplierEvaluationFactorService;
	private EvaluationFactorService evaluationFactorService = new EvaluationFactorService();
	private ExpertEvaluationStepService expertEvaluationStepService ;
	private EvaluationFactorResultService evaluationFactorResultService = new EvaluationFactorResultService();
	private ExpertEvaluationResultService expertEvaluationResultService ;
	public EvaluationStepService evaluationStepService = new EvaluationStepService();
	public SupplierService supplierService = new SupplierService();
	public TenderProjectService tenderProjectService;
	private Composite evaluationComposite;
	private Composite evaluationTableComposite;
	private List<EvaluationFactor> evaluationFactorList = new ArrayList<EvaluationFactor>();
	private int maxLevel = 1;
	private List<Supplier> supplierList;
	private KTable resultKTable;
	private CommonKtableCModel commKTableModel;
	private int curRow = 0;
	private int curCol = 0;
	private boolean resultChanged = false;
//	private Logger LOG = Logger.getLogger(AIScoreEvaluationTableComposite.class);
	private Map<String, Color> contentBackgroundMap = new HashMap<String, Color>();
	private Map<String, Color> contentForegroundMap = new HashMap<String, Color>();
	private Color importColor = SWTResourceManager.getColor(SWT.COLOR_BLUE);
	private Color rightBgColor = SWTResourceManager.getColor(194, 236, 150);
	private Color errorBgColor = SWTResourceManager.getColor(255, 153, 153);
	// 记录供应商每个指标的评审结果
	private Map<String, Map<String, EvaluationFactorResult>> supplierEvaluationFactorResultMap;
	// 记录专家对供应商的评审汇总结果
	private Map<String, ExpertEvaluationResult> expertEvaluationResultMap;
	private AuthUser curUser;
//	private EvaluationSupplierFactorListener evaluationSupplierFactorListener;
	private boolean isShowError = false;
	private BigDecimal evaluationStepWeight;
	private int fontSize = 9;
	private int scoreRound = 2;
	private boolean indexIsBidNumber = false;
	private boolean evaluationBySupplier = false;
	BigDecimal warningRange = null;
	private int maxFactorNameLength = 10;
	private String FACTOR_MEMO = "factorMemo";
	private String FACTOR_RESPONSE = "factorresponse";
	private String FACTOR_SCORE = "factorscore";
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Map<String, Map<String, SupplierEvaluationFactor>> supplierEvaluationFactorResponseMap;
	private EvaluationFactorItemService evaluationFactorItemService;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public AIScoreEvaluationTableComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		evaluationComposite = new Composite(this, SWT.NONE);
		evaluationComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		evaluationComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_evaluationComposite = new GridLayout(1, false);
		gl_evaluationComposite.verticalSpacing = 0;
		gl_evaluationComposite.horizontalSpacing = 0;
		gl_evaluationComposite.marginHeight = 0;
		gl_evaluationComposite.marginWidth = 0;
		evaluationComposite.setLayout(gl_evaluationComposite);
		tenderProjectService = new TenderProjectService();
		evaluationTableComposite = new Composite(evaluationComposite, SWT.NONE);
		evaluationTableComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
		evaluationTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
//		ESepator factor_sep = new ESepator(evaluationComposite, SWT.NONE);
//		factor_sep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		factor_sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
//		
//		Composite composite_5 = new Composite(evaluationComposite, SWT.NONE);
//		composite_5.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		GridLayout gl_composite_5 = new GridLayout(3, false);
//		gl_composite_5.marginHeight = 1;
//		gl_composite_5.marginWidth = 1;
//		gl_composite_5.verticalSpacing = 0;
//		gl_composite_5.horizontalSpacing = 0;
//		composite_5.setLayout(gl_composite_5);
//		composite_5.setBackgroundMode(SWT.INHERIT_FORCE);
//		
//		Composite composite_9 = new Composite(composite_5, SWT.NONE);
//		composite_9.setLayout(new GridLayout(1, false));
//		composite_9.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
//		
//		EButton submit_result_btn = new EButton(composite_9, SWT.NONE | EButton.CSS_GREEN);
//		GridData gd_submit_result_btn = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
//		gd_submit_result_btn.widthHint = 90;
//		submit_result_btn.setLayoutData(gd_submit_result_btn);
//		submit_result_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
//		submit_result_btn.setText(Messages.Button_confirm);
//		submit_result_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/submit.png"));
//		submit_result_btn.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
////				submitEvaluationResultAction();
//				saveEvaluationFactorResult();
////				saveAction();
//			}
//		});
//		
		expertEvaluationStepService = new ExpertEvaluationStepService();
		expertEvaluationResultService = new ExpertEvaluationResultService();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity projectRule1, AuthUser user, EvaluationStep evaluationStep, List<Supplier> supplierList){
		if(null == evaluationFactorItemService){
			evaluationFactorItemService = new EvaluationFactorItemService();
		}
		this.tenderProjectEntity = tenderProjectEntity;
		ProjectRuleService projectRuleService = new ProjectRuleService();
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		this.curUser = user;
		this.evaluationStep = evaluationStep;
		this.supplierList = supplierList;
		warningRange = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_WARNING_RANGE, BigDecimal.class);
		if(null != warningRange && warningRange.compareTo(BigDecimal.ZERO) > 0){
			// 转换为百分率
			warningRange = BigDecimalUtils.div(warningRange,  new BigDecimal(100));
		}else {
			warningRange = null;
		}
		curRow = 0;
		curCol = 0;
		ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "进入" + evaluationStep.getStepName(), Constants.USER.getUserName());
		// 修改评标专家的评审记录
		expertEvaluationStepService.updateExpertEvaluationStatus(CommonEnum.IN_PROGRESS, tenderProjectEntity.getId(), evaluationStep, curUser.getId());
		String indexIsBidNumberObj = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_INDEX_IS_BIDNUMBER);
		indexIsBidNumber = CommonEnum.YES.equals(indexIsBidNumberObj);
		scoreRound = tenderProjectRuleEntity.getScoreRoundIntVal();
		initEvaluationResult();
		drawLeftFactorEvaluationTable();
		
		if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)){
			resultChanged = true;
		}
		// 按供应 商打分
		boolean evaluationBySupplierObj = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_EVALUATION_BY_SUPPLIER, Boolean.class);
		if(null != tenderProjectEntity.getParentId() && evaluationBySupplierObj){
			evaluationBySupplier = true;
		}else {
			evaluationBySupplier = false;
		}
	}
	/**
	 * @Description: 设置表格中的字体大小
	 * @author guoyr
	 * @param fontSize 
	 */
	public void setTableFontSize(int fontSize){
		this.fontSize = fontSize;
		resultKTable.refreshRowResize(0, commKTableModel.getRowCount()-1);
		resultKTable.redraw();
	}
	
	/**
	 * @Description: 初始化当前评标步骤的评审指标
	 * @author guoyr
	 */
	private void initEvaluationStepFactor(){
		evaluationFactorList.clear();
		maxLevel = 1;
		evaluationStepWeight = null;
		List<EvaluationFactor> evaluationTopFactorList = evaluationFactorService.getEvaluationStepFactorTreeList(tenderProjectEntity.getId(), evaluationStep);
		if(null != evaluationTopFactorList && evaluationTopFactorList.size() > 0){
			for(EvaluationFactor topFactor : evaluationTopFactorList){
				if(null != topFactor.getFactorWeight()){
					evaluationStepWeight = BigDecimalUtils.add(evaluationStepWeight, topFactor.getFactorWeight());
				}
				initAddChildEvaluationFactor(topFactor);
			}
		}
		if(null != evaluationStepWeight && (evaluationStepWeight.compareTo(BigDecimal.ZERO) == 0 || evaluationStepWeight.compareTo(new BigDecimal(100)) >= 0)){
			evaluationStepWeight = null;
		}
	}
	
	/**
	 * @Description: 递归获取所有的评审叶子指标
	 * @author guoyr
	 * @param evalFactor
	 */
	private void initAddChildEvaluationFactor(EvaluationFactor evalFactor){
		if(null != evalFactor.getChildFactorList() && evalFactor.getChildFactorList().size() > 0){
			for(EvaluationFactor childFactor : evalFactor.getChildFactorList()){
				childFactor.setLevel(evalFactor.getLevel() + 1);
				initAddChildEvaluationFactor(childFactor);
			}
		}else {
			maxLevel = Math.max(maxLevel, evalFactor.getLevel());
			EvaluationFactor factor1 = new EvaluationFactor();
			EvaluationFactor factor2 = new EvaluationFactor();
			
			factor1.setParentFactor(evalFactor.getParentFactor());
			factor2.setParentFactor(evalFactor.getParentFactor());
			
			factor1.setFactorName(evalFactor.getFactorName());
			factor2.setFactorName(evalFactor.getFactorName());
			
			factor1.setFactorCode("");
			factor2.setFactorCode("");
			
			factor1.setId(UuidUtils.getUUID());
			factor2.setId(UuidUtils.getUUID());
			
			factor2.setFactorCode(evalFactor.getFactorCode());
			factor1.setFactorCode(evalFactor.getFactorCode());
			
			factor1.setParentId(evalFactor.getParentFactor().getId());
			factor2.setParentId(evalFactor.getParentFactor().getId());
			
			factor1.setLevel(evalFactor.getLevel());
			evalFactor.setFactorType(FACTOR_SCORE);
			factor1.setFactorType(FACTOR_MEMO);
			factor2.setFactorType(FACTOR_RESPONSE);
			
			factor2.setScoreStatus(evalFactor.getScoreStatus());
			factor2.setLevel(evalFactor.getLevel());
			factor1.setChildFactorList(new ArrayList<EvaluationFactor>());
			factor2.setChildFactorList(new ArrayList<EvaluationFactor>());
			factor1.setMemo(evalFactor.getMemo());
			factor2.setScoreStatus(evalFactor.getScoreStatus());
//			evalFactor.getParentFactor().addChild(factor1);
//			evalFactor.getParentFactor().addChild(factor2);
			evaluationFactorList.add(factor1);
			evaluationFactorList.add(factor2);
			evaluationFactorList.add(evalFactor);
		}
	}
	
	/** 
	 * @Description: 关闭编辑器
	 * @author guoyr 
	 */
	public void closeCellEditor(){
		if(null != resultKTable){
			resultKTable.closeCellEditor();
		}
	}
	
	/**
	 * @Description: 切换评分面板
	 * @author guoyr
	 */
	public void switchCoordinateAction(){
		if(null != resultKTable && !resultKTable.isDisposed()){
			resultKTable.dispose();
		}
		Constants.FACTOR_IS_HORIZONTAL = !Constants.FACTOR_IS_HORIZONTAL;
		drawLeftFactorEvaluationTable();
		evaluationTableComposite.layout();
	}
	/**
	 * @Description: 评审表格鼠标右键点击事件
	 * @author guoyr
	 * @param row
	 * @param col
	 */
	private void resultMouseRightClickEventAction(final Supplier supplier, final EvaluationFactor evaluationFactor, final ExpertEvaluationResult expertEvaluationResult, final EvaluationFactorResult  evalFactorResult){
		final EMenu gmenu = new EMenu(getShell());
		if(curRow >= commKTableModel.getFixedRowCount()){
			
			gmenu.addMenuItem((resultKTable.isLockedRow(curRow)?Messages.Button_unlockRow:Messages.Button_lockRow), imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/my-account.png"), null != supplier, new EMenu.ClickListener() {
				public void click() {
					if(resultKTable.isLockedRow(curRow)){
						resultKTable.releaseLockRow(curRow);
					}else {
						resultKTable.addLockedRow(curRow);
					}
					resultKTable.refreshRowResize(curRow);
				}
			});
		}

		gmenu.addSeparator();
		gmenu.addMenuItem(Messages.Button_setMaxFactorNameLength, null, true, new EMenu.ClickListener() {
			public void click() {
				InputDialog dialog = new InputDialog(getShell(), Messages.Button_setMaxFactorNameLength, maxFactorNameLength > 0 ? maxFactorNameLength + "" : "");
				dialog.open();
				String pageSizeStr = dialog.getInputValue();
				try {
					int length = Integer.parseInt(pageSizeStr);
					maxFactorNameLength = Math.max(5, length);
				} catch (NumberFormatException e) {
					maxFactorNameLength = -1;
				}finally{
					drawLeftFactorEvaluationTable();
				}
			}
		});
		gmenu.addMenuItem(Messages.Button_enlargeColumnWidth, null, true, new EMenu.ClickListener() {
			public void click() {
				resultKTable.fillColumnWidth();
				for(int i = 0; i < commKTableModel.getFixedRowCount(); i++){
					resultKTable.refreshRowResize(i);
				}
			}
		});
		gmenu.addMenuItem(Messages.Button_reducedColumnWidth, null, true, new EMenu.ClickListener() {
			public void click() {
				resizeColumn(110);
			}
		});
		gmenu.open();
	}
	
	/**
	 * @Description: 递归获取当前指标指定上级如果上级为空则为本身
	 * @author guoyr
	 * @param factor
	 * @param row
	 * @return
	 */
	private EvaluationFactor getParentFactor(EvaluationFactor evaluationFactor, int level){
		EvaluationFactor parent = evaluationFactor.getParentFactor();
		if(null != parent){
			if(parent.getLevel() == level){
				return parent;
			}else if(parent.getLevel() > level) {
				return getParentFactor(parent, level);
			}else {
				return evaluationFactor;
			}
		}
		return parent;
	}
	
	/**
	 * @Description: 递归获取当前指标的所有下级指标的个数
	 * @author guoyr
	 * @param factor
	 * @return
	 */
	private int getChildCount(EvaluationFactor evaluationFactor){
		List<EvaluationFactor> childrenList = evaluationFactor.getChildFactorList();
		int childCount = null != childrenList?childrenList.size():0;
		if(childCount > 0){
			for(EvaluationFactor childrenFactor : childrenList){
				List<EvaluationFactor> subChildrenList = childrenFactor.getChildFactorList();
				if(null != subChildrenList && subChildrenList.size() > 0){
					childCount--;
					childCount += getChildCount(childrenFactor);
				}
			}
		}
		return childCount;
	}
	
	/**
	 * @Description: 检查观项指标的结果是否一致
	 * @author guoyr
	 * @param evaluationFactorResult
	 * @param supplierId
	 * @param factorId 
	 */
	private void checklObjectiveFactorResult(EvaluationFactorResult evaluationFactorResult, String supplierId, String factorId){
		boolean equalsResult = true;
		BigDecimal curEvaluationScore = evaluationFactorResult.getEvaluationScore();
		if(null != curEvaluationScore){
            List<BigDecimal> evaluationResultList = evaluationFactorResultService.getEvaluationScoreListNotUserId(
                        tenderProjectEntity.getId(), 
                        evaluationStep.getId(), 
                        supplierId, 
                        factorId, 
                        curUser.getId()
                    );
			if(null != evaluationResultList){
				for(BigDecimal evaluationResult : evaluationResultList){
					if(null != evaluationResult && curEvaluationScore.compareTo(evaluationResult) != 0){
						equalsResult = false;
						break;
					}
				}
			}
		}
		contentBackgroundMap.put(evaluationFactorResult.getId(), equalsResult ? rightBgColor : errorBgColor);
	}
	
	/**
	 * @Description: 初始化评标结果
	 * @author guoyr 
	 */
	private void initEvaluationResult(){
		if(null == supplierEvaluationFactorService){
			supplierEvaluationFactorService = new SupplierEvaluationFactorService();
		}
		if(null == evaluationFactorList)evaluationFactorList = new ArrayList<EvaluationFactor>();
		initEvaluationStepFactor();
		supplierEvaluationFactorResponseMap = new HashMap<String, Map<String, SupplierEvaluationFactor>>();
		// 记录供应商每个指标的评审结果
		supplierEvaluationFactorResultMap = new HashMap<String, Map<String, EvaluationFactorResult>>();
		// 记录专家对供应商的评审汇总结果
		expertEvaluationResultMap = new HashMap<String, ExpertEvaluationResult>();
		
		// 评审当前评标专家所有的评标结果
		List<EvaluationFactorResult> expertEvaluateFactorResultList = evaluationFactorResultService.getExpertEvaluationFactorResult(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId(), null);
		List<ExpertEvaluationResult> queryExpertEvaluationResultList = expertEvaluationResultService.getExpertStepAllSupplierEvaluationResultList(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId());
		contentBackgroundMap.clear();
		contentForegroundMap.clear();

		Supplier firstSupplier = null;
		EvaluationFactor firstEvaluationFactor = null;
		EvaluationFactorResult firstEvaluationFactorResult = null;
		List<Double> sortList = new ArrayList<Double>();
		for(Supplier supplier : supplierList){
			
			
			
			Map<String, SupplierEvaluationFactor> SupplierEvaluationFactorResponseMap = new HashMap<String, SupplierEvaluationFactor>();
 			
			for(EvaluationFactor evaluationFactor : evaluationFactorList){	
				// 获得已评审的结果
				List<SupplierEvaluationFactor> evalFactorResultList = supplierEvaluationFactorService.getSupplierEvaluationFactorByFactorCodeAndSupplierId(evaluationFactor.getFactorCode(),supplier.getId());
				SupplierEvaluationFactor evalFactorResult = null;
				if(null != evalFactorResultList && evalFactorResultList.size() > 0){
					evalFactorResult = evalFactorResultList.get(0);
				}else{
					evalFactorResult = new SupplierEvaluationFactor();
					evalFactorResult.setTenderId(tenderProjectEntity.getId());
					evalFactorResult.setSupplierId(supplier.getId());
					evalFactorResult.setFactorName(evaluationFactor.getFactorName());
					evalFactorResult.setFactorCode(evaluationFactor.getFactorCode());
				}
				SupplierEvaluationFactorResponseMap.put(evaluationFactor.getId(), evalFactorResult);
				// 如果是客观项，检查所有评标专家的评标结果是否相同
			}
			supplierEvaluationFactorResponseMap.put(supplier.getId(), SupplierEvaluationFactorResponseMap);
			
			// 获取评标专家对投标人的评审记录
			ExpertEvaluationResult expertEvaluationResult = null;
			if(null != queryExpertEvaluationResultList && queryExpertEvaluationResultList.size() > 0){
				for(ExpertEvaluationResult queryExpertEvaluationResult : queryExpertEvaluationResultList){
					if(ObjectUtils.equals(queryExpertEvaluationResult.getSupplierId(), supplier.getId())){
						expertEvaluationResult = queryExpertEvaluationResult;
					}
				}
			}
			if(null == expertEvaluationResult){
				expertEvaluationResult = new ExpertEvaluationResult();
				expertEvaluationResult.setTenderId(tenderProjectEntity.getId());
				expertEvaluationResult.setStepId(evaluationStep.getId());
				expertEvaluationResult.setUserId(curUser.getId());
				expertEvaluationResult.setSupplierId(supplier.getId());
			}
			
			Map<String, EvaluationFactorResult> evaluationFactorResultMap = new HashMap<String, EvaluationFactorResult>();
			BigDecimal totalEvaluationScore = null;
			BigDecimal totalEvaluationFinalScore = null;
			
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				String scoreStatus = "";
				if(null != evaluationFactor.getScoreStatus() && evaluationFactor.getScoreStatus().length() > 0){
					scoreStatus = evaluationFactor.getScoreStatus();
				}
				
				// 获得已评审的结果
				if(null == evaluationFactor.getId()  || evaluationFactor.getId().trim().length() == 0){
					continue;
				}
				EvaluationFactorResult  evalFactorResult = null;
				if(null != expertEvaluateFactorResultList && expertEvaluateFactorResultList.size() > 0){
					for(EvaluationFactorResult factorResult : expertEvaluateFactorResultList){
						if(ObjectUtils.equals(supplier.getId(), factorResult.getSupplierId()) && ObjectUtils.equals(evaluationFactor.getId(), factorResult.getFactorId())){
							evalFactorResult = factorResult;
							break;
						}
					}
				}
				if(null == evalFactorResult){
					evalFactorResult = new EvaluationFactorResult();
					evalFactorResult.setTenderId(tenderProjectEntity.getId());
					evalFactorResult.setStepId(evaluationStep.getId());
					evalFactorResult.setUserId(curUser.getId());
					evalFactorResult.setSupplierId(supplier.getId());
					evalFactorResult.setFactorId(evaluationFactor.getId());
					evalFactorResult.setFactorName(evaluationFactor.getFactorName());
					evalFactorResult.setId(UuidUtils.getUUID());
				}
				if(evaluationFactor.getFactorType().equals(FACTOR_MEMO)){
					contentForegroundMap.put(evalFactorResult.getId(), importColor);
				}
				if(scoreStatus.equals("01")){
					SupplierEvaluationFactor supplierEvaluationFactor = SupplierEvaluationFactorResponseMap.get(evaluationFactor.getId());
					if(null != supplierEvaluationFactor && null != supplierEvaluationFactor.getScoreStatus() &&supplierEvaluationFactor.getScoreStatus().equals("01")){
						totalEvaluationScore = evaluationFactor.getFactorScore();
					}else{
						totalEvaluationScore = BigDecimal.ZERO;
					}
					evalFactorResult.setEvaluationFinalScore(totalEvaluationFinalScore);
					evalFactorResult.setEvaluationScore(totalEvaluationScore);
				}else if(scoreStatus.equals("02")){
				//评审点为智能评审数据类型的，先计算当前评审点所有供应商相应的数量，在计算供应商评价的相应数量，最高的供应商将得到满分，最低的得到	
					totalEvaluationScore = evaluationFactorItemService.getAIScore(supplier.getId(), evaluationFactor.getFactorCode(), evaluationFactor.getTenderId(),evaluationFactor.getFactorScore());
					evalFactorResult.setEvaluationFinalScore(totalEvaluationFinalScore);
					evalFactorResult.setEvaluationScore(totalEvaluationScore);
				}else{
					if(null != evalFactorResult.getEvaluationScore()){
						totalEvaluationScore = BigDecimalUtils.add(totalEvaluationScore, evalFactorResult.getEvaluationScore());
					}
					evalFactorResult.setEvaluationFinalScore(getEvaluationFinalScore(evaluationFactor, evalFactorResult.getEvaluationScore()));
					if(null != evalFactorResult.getEvaluationFinalScore()){
						totalEvaluationFinalScore = BigDecimalUtils.add(totalEvaluationFinalScore, evalFactorResult.getEvaluationFinalScore());
					}
				}
//				evalFactorResult.setEvaluationFinalScore(totalEvaluationFinalScore);
//				evalFactorResult.setEvaluationScore(totalEvaluationScore);
				evaluationFactorResultMap.put(evaluationFactor.getId(), evalFactorResult);
				
				// 如果是客观项，检查所有评标专家的评标结果是否相同
				if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
					checklObjectiveFactorResult(evalFactorResult, supplier.getId(), evaluationFactor.getId());
				}else if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_WARING)){
					checkScoreFactorResult(evalFactorResult, supplier.getId(), evaluationFactor.getId());
				}
				if(null == firstEvaluationFactor){
					firstEvaluationFactor = evaluationFactor;
				}
				if(null == firstEvaluationFactorResult){
					firstEvaluationFactorResult = evalFactorResult;
				}
				
			}
			expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
			expertEvaluationResult.setEvaluationScore(BigDecimalUtils.round(totalEvaluationScore, scoreRound));
			expertEvaluationResult.setEvaluationFinalScore(BigDecimalUtils.round(totalEvaluationFinalScore, scoreRound));
			expertEvaluationResultMap.put(supplier.getId(), expertEvaluationResult);
			if(null != totalEvaluationFinalScore){
				sortList.add(totalEvaluationFinalScore.doubleValue());
			}
			if(null == firstSupplier){
				firstSupplier = supplier;
			}
			
			supplierEvaluationFactorResultMap.put(supplier.getId(), evaluationFactorResultMap);
			if(indexIsBidNumber && (null == supplier.getBidNumber() || "".equals(supplier.getBidNumber()))){
				indexIsBidNumber = false;
			}
		}
		reSetSortNo(sortList);
	}
	
	/**
	 * @Description: 设置排名
	 * @author guoyr 
	 */
	private void reSetSortNo(List<Double> sortList){
		if(null == sortList){
			sortList = new ArrayList<Double>();
			for(Entry<String, ExpertEvaluationResult> expertEvaluationResultEntry : expertEvaluationResultMap.entrySet()){
				ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultEntry.getValue();
				if(null != expertEvaluationResult.getEvaluationFinalScore()){
					sortList.add(expertEvaluationResult.getEvaluationFinalScore().doubleValue());
				}
				
			}
		}
		SortUtils sortUtil = new SortUtils(sortList);
		List<Map<String, Object>> supplierSumEvaluationScoreList = null;
		if(null != warningRange){
			supplierSumEvaluationScoreList = expertEvaluationResultService.getSupplierSumEvaluationResultList(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId());
		}
		for(Entry<String, ExpertEvaluationResult> expertEvaluationResultEntry : expertEvaluationResultMap.entrySet()){
			String supplierId = expertEvaluationResultEntry.getKey();
			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultEntry.getValue();
			boolean overRange = false;
			
			if(null != supplierSumEvaluationScoreList && null != expertEvaluationResult.getEvaluationScore()){
				int expertCount = 0;
				BigDecimal sumResult = expertEvaluationResult.getEvaluationScore();
				for(Map<String, Object> supplierSumEvaluationScore : supplierSumEvaluationScoreList){
					
					String _supId = (String)supplierSumEvaluationScore.get("SUPPLIER_ID");
					if(null != _supId && _supId.equals(supplierId)){
						try {
							expertCount = Integer.parseInt(supplierSumEvaluationScore.get("COUNT").toString());
						} catch (NumberFormatException e) {
						}finally {
							expertCount += 1;
						}
						sumResult = BigDecimalUtils.add(sumResult, ObjectUtils.getObjBigDecimal(supplierSumEvaluationScore.get("SUM_EVALUATION_SCORE")));
						if(expertCount > 1){
							BigDecimal avgValue = BigDecimalUtils.div(sumResult, new BigDecimal(expertCount));
							BigDecimal percentValue = BigDecimalUtils.sub(expertEvaluationResult.getEvaluationScore(), avgValue) ;//获取差值
							if(avgValue.compareTo(BigDecimal.ZERO) != 0){
								percentValue = BigDecimalUtils.div(percentValue, avgValue).abs();//偏差率绝对值
							}
							if(percentValue.compareTo(warningRange) >= 0){
								overRange = true;
							}
						}
						break;
					}
				}
			}
			contentBackgroundMap.put(supplierId, overRange ? errorBgColor : null);
			
			if(null != expertEvaluationResult.getEvaluationFinalScore()){
				expertEvaluationResultEntry.getValue().setSortNo(sortUtil.getSortNo(expertEvaluationResult.getEvaluationFinalScore().doubleValue()));
			}else {
				expertEvaluationResultEntry.getValue().setSortNo(0);
			}
		}
	}

	/**
	 * @Description: 左边是评审指标表格
	 * @author guoyr 
	 */
	private void drawLeftFactorEvaluationTable(){
		if(null == evaluationFactorItemService){
			evaluationFactorItemService = new EvaluationFactorItemService();
		}
		if(null != resultKTable && !resultKTable.isDisposed()){
			resultKTable.dispose();
		}
		resultKTable = new KTable(evaluationTableComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.EDIT_ON_KEY);
		commKTableModel = new CommonKtableCModel(resultKTable, 1, maxLevel, evaluationFactorList.size() + 2 + (null != evaluationStepWeight? 1 : 0), supplierList.size());
		final Map<String, String> tableTitleMap = new HashMap<String, String>();
		tableTitleMap.put("0_0", Messages.EvalFactor);
		commKTableModel.addColSpan(0, 0, commKTableModel.getFixedColumnCount());
		int col = commKTableModel.getFixedColumnCount();
		for(Supplier supplier : supplierList){
			tableTitleMap.put("0_"+col, supplier.getSupplierName());
			commKTableModel.setColumnWidth(col, 110);
			col ++;
		}
		// 排名列
		final int sortRow = commKTableModel.getRowCount() -1;
		commKTableModel.addColSpan(sortRow, 0, commKTableModel.getFixedColumnCount());
		tableTitleMap.put(sortRow +"_0", Messages.SortNo);
		// 最终得分列
		final int finalScoreSumRow= commKTableModel.getRowCount() -2;
		tableTitleMap.put(finalScoreSumRow +"_0", Messages.EvalFactor);
		commKTableModel.addColSpan(finalScoreSumRow, 0, commKTableModel.getFixedColumnCount());
		// 得分汇总列
		final int scoreSumRow = null != evaluationStepWeight?commKTableModel.getRowCount() -3 : -1;
		if(scoreSumRow > 0){
			commKTableModel.addColSpan(scoreSumRow, 0, commKTableModel.getFixedColumnCount());
			tableTitleMap.put(scoreSumRow+"_0", Messages.TotalScore);
			tableTitleMap.put(finalScoreSumRow+"_0", Messages.FinalScore);
		}else {
			tableTitleMap.put(finalScoreSumRow+"_0", Messages.FinalScore);
		}
		String parentId = "";
		int childCount = 0;
		for(col = 0; col < maxLevel; col++){
			commKTableModel.addRowSpan(0, col, commKTableModel.getFixedRowCount());
			if(col == maxLevel -1){
				// 将指标的最后一列设置宽一点
				commKTableModel.setColumnMaxWidth(col, 250);
			}else {
				commKTableModel.setColumnMaxWidth(col, 200);
			}
			int row = commKTableModel.getFixedRowCount();
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				EvaluationFactor parentFactor = getParentFactor(evaluationFactor, col + 1 );
				if(null != parentFactor && StringUtils.isNotEmpty(parentFactor.getId())){
					if(!parentId.equals(parentFactor.getId())){
						childCount = 0;
					}
					if(childCount++ == 0 ){
						commKTableModel.addRowSpan(row, col, getChildCount(parentFactor) * 3);
					}
					parentId = parentFactor.getId();
					tableTitleMap.put(row+"_"+col, maxFactorNameLength > 0 ? parentFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, parentFactor.getFactorName().length())) : parentFactor.getFactorName());
				}else {
					childCount = 0;
					tableTitleMap.put(row+"_"+col, maxFactorNameLength > 0 ? evaluationFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, evaluationFactor.getFactorName().length())) : evaluationFactor.getFactorName());
				}
				if(col + 1 == evaluationFactor.getLevel()){
					commKTableModel.addColSpan(row, col, commKTableModel.getFixedColumnCount() - col);
				}
				if(col < commKTableModel.getFixedColumnCount()){
					if(null != evaluationFactor){
						tableTitleMap.put(row+"_"+(maxLevel -1), maxFactorNameLength > 0 ? evaluationFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, evaluationFactor.getFactorName().length())) : evaluationFactor.getFactorName());
					}
				}
				if(null != evaluationFactor.getFactorType() && evaluationFactor.getFactorType().equals(FACTOR_RESPONSE)){
					commKTableModel.setRowHeight(row, 40);
					
				}else if(null != evaluationFactor.getFactorType() && evaluationFactor.getFactorType().equals(FACTOR_MEMO)){
					commKTableModel.addRowSpan(row, maxLevel -1 , 3);
					commKTableModel.addColSpan(row, maxLevel, 3);
					commKTableModel.setRowHeight(row, 40);
				}
				row ++;
			}
		}

		// 设置单元格内容
		CellContentRender contentRender = new CellContentRender(){
			public Object receiveContent(int row, int col) {
				// 表头
				if(col < commKTableModel.getFixedColumnCount()){
					if(row < commKTableModel.getFixedRowCount()){
						return Messages.EvalFactor;
					}else if(row < commKTableModel.getFixedRowCount() + evaluationFactorList.size() && col == commKTableModel.getFixedColumnCount() -1){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
						if(col == commKTableModel.getFixedColumnCount() -1 && resultKTable.isLockedRow(row)){
							return (maxFactorNameLength > 0 ? evaluationFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, evaluationFactor.getFactorName().length())) : evaluationFactor.getFactorName())+"\r\n[已锁定]";
						}else {
							return maxFactorNameLength > 0 ? evaluationFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, evaluationFactor.getFactorName().length())) : evaluationFactor.getFactorName();
						}
					}else if(null != tableTitleMap.get(row+"_"+col)){
						return tableTitleMap.get(row+"_"+col);
					}
					return "";
				}else if(col < commKTableModel.getFixedColumnCount() + supplierList.size()){
					Supplier supplier = supplierList.get(col - commKTableModel.getFixedColumnCount());
					if(row < commKTableModel.getFixedRowCount()){
						if(indexIsBidNumber){
							return supplier.getBidNumber() + "、"+supplier.getSupplierName();
						}else {
							return (col - commKTableModel.getFixedColumnCount() +1)+"、"+supplier.getSupplierName();
						}
					}else if(row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
						if(evaluationFactor.getFactorType().equals(FACTOR_MEMO)){
							StringBuilder evaluationFactorMemo = new StringBuilder();
							if(null == evaluationFactor.getMemo() || StringUtils.isEmpty(evaluationFactor.getMemo())){
								if(null != evaluationFactor.getFactorMinScore() && null != evaluationFactor.getFactorMaxScore()){
									evaluationFactorMemo.append("分值范围：[").append(NumberFormat.getInstance().format(evaluationFactor.getFactorMinScore())).append("-").append(NumberFormat.getInstance().format(evaluationFactor.getFactorMaxScore())).append("分]");
								}
								if(null != evaluationFactor.getFactorWeight()){
									evaluationFactorMemo.append("(权重").append(BigDecimalUtils.round(evaluationFactor.getFactorWeight(), 2).toString()).append("%)");
								}
								evaluationFactorMemo.append("   ");
								evaluationFactorMemo.append("评审指标：").append(evaluationFactor.getFactorName());
							}else{
								evaluationFactorMemo.append(evaluationFactor.getMemo());
							}
							return evaluationFactorMemo.toString();
						}else if(evaluationFactor.getFactorType().equals(FACTOR_RESPONSE)){
							String scoreStatus = "";
							if(null != evaluationFactor.getScoreStatus() && evaluationFactor.getScoreStatus().length() > 0){
								scoreStatus = evaluationFactor.getScoreStatus();
							}
							String value = "";
							SupplierEvaluationFactor evalFactorResult = supplierEvaluationFactorResponseMap.get(supplier.getId()).get(evaluationFactor.getId());
							if(scoreStatus.equals("01")){
								if(null != evalFactorResult && null != evalFactorResult.getScoreStatus() && evalFactorResult.getScoreStatus().equals("01")){
									if(null != evalFactorResult.getMemo() && evalFactorResult.getMemo().length() > 0){
										value = evalFactorResult.getMemo();
									}
								}
							}else if(scoreStatus.equals("02")){
								List<EvaluationFactorItem> evaluationFactorItemList  = evaluationFactorItemService.getItemByTenderIdAndSupplierIdAndfactorCode(supplier.getTenderId(), supplier.getId(),evaluationFactor.getFactorCode());
								if(null != evaluationFactorItemList && evaluationFactorItemList.size() > 0){
									for(EvaluationFactorItem item : evaluationFactorItemList){
										if(null != item.getItemContent()){
											value = value + " ["+ item.getItemContent() + "] ,";
										}
									}
								}
								
							}else{
								if(null != evalFactorResult && null != evalFactorResult.getMemo() && evalFactorResult.getMemo().length() > 0){
									value = evalFactorResult.getMemo();
								}
							}
							if(StringUtils.isEmpty(value)){
								if(null != evalFactorResult && null != evalFactorResult.getMemo()){
									value = evalFactorResult.getMemo();
								}
							}
							return value;
							
						}else if(evaluationFactor.getFactorType().equals(FACTOR_SCORE)){
							EvaluationFactorResult evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
							if(null != evalFactorResult && null != evalFactorResult.getEvaluationScore()){
								return NumberFormatUtils.format(evalFactorResult.getEvaluationScore(), scoreRound);
							}
						}
						return "";
						
					}else {
						ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
						if(null != expertEvaluationResult){
							if(row == scoreSumRow){
								if(null != expertEvaluationResult.getEvaluationScore()){
									return NumberFormatUtils.format(expertEvaluationResult.getEvaluationScore(), scoreRound);
								}
							}else if(row == finalScoreSumRow){
								if(null != expertEvaluationResult.getEvaluationFinalScore()){
									return NumberFormatUtils.format(expertEvaluationResult.getEvaluationFinalScore(), scoreRound);
								}
							}else if(row == sortRow){
								if(expertEvaluationResult.getSortNoIntValue() > 0){
									return expertEvaluationResult.getSortNoIntValue();
								}
							}
						}
					}
				}
				return "";
			}
		};
		commKTableModel.setCellContentRender(contentRender);
		final FixedWrapCellRenderer fixedWrapCellRenderer = new FixedWrapCellRenderer();
		final TextWrapCellRenderer textWrapCellRenderer = new TextWrapCellRenderer();
		// 设置单元格渲染器
		CellRender cellRender = new CellRender(){
			public Object receiveCellRender(int row, int col) {
				if(commKTableModel.isFixedCell(col, row)){
					fixedWrapCellRenderer.setFont(SWTResourceManager.getFont("微软雅黑", fontSize, SWT.NORMAL));
					return fixedWrapCellRenderer;
				}else{
					if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + supplierList.size() && row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
						if(evaluationFactor.getFactorType().equals(FACTOR_SCORE)){
							textWrapCellRenderer.setFont(SWTResourceManager.getFont("微软雅黑", fontSize + 1, SWT.NORMAL));
							return textWrapCellRenderer;
						}else{
							return fixedWrapCellRenderer;
						}
					}
					return fixedWrapCellRenderer;
				}
			}
		};
		commKTableModel.setCellRender(cellRender);
		
		// 设置单元格编辑器
        final KTableCellEditorText text = new KTableCellEditorText();
		text.setSingleClickEdit(true);
		CellEditorRender cellEditorRender = new CellEditorRender(){
			public Object receiveCellEditor(int row, int col) {
				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + supplierList.size() && row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
					EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
					if(evaluationFactor.getFactorType().equals(FACTOR_SCORE)){
						
						if(null != evaluationFactor && StringUtils.equals(EvaluationFactorEnum.SCORE_TYPE_OBJECTIVE, evaluationFactor.getScoreType())){
							List<ScoreItem> itemList = SerializeUtils.deserializeObject(evaluationFactor.getObjectiveItem());
							if(null != itemList && itemList.size() > 0){
								KTableCellEditorGCombo combo = new KTableCellEditorGCombo();
								combo.setSingleClickEdit(true);
								for(ScoreItem item : itemList){
									BigDecimal score = item.getScore();
									String name = item.getName();
									combo.addItem(score+"分"+(StringUtils.isNotEmpty(name) ? " "+name : ""), score);
								}
								return combo;
							}
						}
						return text;
					}
				}
				return null;
			}
		};
		commKTableModel.setCellEditorRender(cellEditorRender);
		
		// 编辑单元格内容
		CellEditContentRender editContentRender = new CellEditContentRender(){
			public void receiveContent(int row, int col, Object content) {
				
				if(col >= commKTableModel.getFixedColumnCount() && row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
					BigDecimal evaluationScore = null;
					if(null != content && !"".equals(content.toString())){
						evaluationScore = ObjectUtils.getObjBigDecimal(content);
						if(null != evaluationScore){
							evaluationScore = BigDecimalUtils.round(evaluationScore, scoreRound);
						}
					}
					Supplier supplier = supplierList.get(col - commKTableModel.getFixedColumnCount());
					EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
					ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
					Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
					EvaluationFactorResult evalFactorResult = supplierFactorResultMap.get(evaluationFactor.getId());
					if(null != evaluationScore){
						if(evaluationScore.compareTo(evaluationFactor.getFactorMinScore()) >= 0 && evaluationScore.compareTo(evaluationFactor.getFactorMaxScore()) <= 0){
							if(null != evaluationFactor.getContainId() && !"".equals(evaluationFactor.getContainId())){
								EvaluationFactor containEvaluationFactor = evaluationFactor.getContainFactor();
								if(null != containEvaluationFactor){
									EvaluationFactorResult containtEvaluationFactorResult= supplierFactorResultMap.get(evaluationFactor.getContainId());
									if(null != containtEvaluationFactorResult){
										BigDecimal maxSumScore = (evaluationFactor.getFactorMaxScore().compareTo(containEvaluationFactor.getFactorMaxScore()) > 0)?evaluationFactor.getFactorMaxScore():containEvaluationFactor.getFactorMaxScore();
										if(BigDecimalUtils.add(evaluationScore, containtEvaluationFactorResult.getEvaluationScore()).compareTo(maxSumScore) > 0){
											if(!isShowError){
												isShowError = true;
												MessageDialog.openError(getShell(), "["+evaluationFactor.getFactorName()+"]和["+containEvaluationFactor.getFactorName()+"]的评分之和不能超过" + maxSumScore+"！");
												isShowError = false;
											}
											return;
										}
									}
								}
							}
						}else {
							if(!isShowError){
								isShowError = true;
								MessageDialog.openError(getShell(), MessageFormat.format(Messages.Tips_entryScroeRange, evaluationFactor.getFactorMinScore(), evaluationFactor.getFactorMaxScore()));
								isShowError = false;
							}
							return;
						}
					}					
					evalFactorResult.setEvaluationScore(evaluationScore);
					evalFactorResult.setEvaluationFinalScore(getEvaluationFinalScore(evaluationFactor, evaluationScore));
					// 如果是客观项，检查所有评标专家的评标结果是否相同
					contentForegroundMap.put(evalFactorResult.getId(), null);
					if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
						checklObjectiveFactorResult(evalFactorResult, evalFactorResult.getSupplierId(), evaluationFactor.getId());
					}else if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_WARING)){
						checkScoreFactorResult(evalFactorResult, evalFactorResult.getSupplierId(), evaluationFactor.getId());
					}
					resultChanged = true;
					BigDecimal totalEvaluationScore = null;
					BigDecimal totalEvaluationFinalScore = null;
					for(Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()){
						EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
						if(null != evaluationFactorResult.getEvaluationScore()){
							totalEvaluationScore = BigDecimalUtils.add(totalEvaluationScore, evaluationFactorResult.getEvaluationScore());
						}
						if(null != evaluationFactorResult.getEvaluationFinalScore()){
							totalEvaluationFinalScore = BigDecimalUtils.add(totalEvaluationFinalScore, evaluationFactorResult.getEvaluationFinalScore());
						}
					}
					expertEvaluationResult.setEvaluationScore(BigDecimalUtils.round(totalEvaluationScore, scoreRound));
					expertEvaluationResult.setEvaluationFinalScore(BigDecimalUtils.round(totalEvaluationFinalScore, scoreRound));
					reSetSortNo(null);
					resultKTable.redraw();
				}
			}
		};
		commKTableModel.setCellEditContentRender(editContentRender);
		
		// 编辑单元格对齐方式
		CellAlignmentRender cellAlignmentRender = new CellAlignmentRender(){
			public int receiveCellAlignment(int row, int col) {
				if(col < commKTableModel.getFixedColumnCount()){
				}else if(col < commKTableModel.getFixedColumnCount() + supplierList.size()){
					if(row < commKTableModel.getFixedRowCount()){
					}else if(row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
						if(evaluationFactor.getFactorType().equals(FACTOR_MEMO)){
							return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
						}else if(evaluationFactor.getFactorType().equals(FACTOR_RESPONSE)){
							return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
						}
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
					}
				}
				return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
			}
		};
		commKTableModel.setCellAlignmentRender(cellAlignmentRender);
		
		// 设置单元格前景颜色
		CellForegroundRender cellForegroundRender = new CellForegroundRender(){
			public Color receiveCellForeground(int row, int col) {
			 if(!commKTableModel.isFixedCell(col, row) && row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
					EvaluationFactor evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
					if(evaluationFactor.getFactorType().equals(FACTOR_RESPONSE)){
						Color foreColor = importColor;
						return foreColor;
					}
				}
				return null;
			}
		};
		commKTableModel.setCellForegroundRender(cellForegroundRender);
		
		// 设置单元格背景颜色
		CellBackgroundRender cellBackgroundRender = new CellBackgroundRender(){
			public Color receiveCellBackground(int row, int col) {
				return null;
			}
		};
		commKTableModel.setCellBackgroundRender(cellBackgroundRender);
		
		// 设置单元格内容
		CellTooltipRender cellTooltipRender = new CellTooltipRender(){
			public String receiveCellTooltip(int row, int col) {
				return "";
			}
		};	
		commKTableModel.setCellTooltipRender(cellTooltipRender);
		
		resultKTable.addCellSelectionListener(new KTableCellSelectionAdapter(){
			@Override
			public void cellSelected(int col, int row, int statemask) {
				return;
			}
			@Override
			public void fixedCellSelected(int col, int row, int statemask) {
				resultKTable.setSelection(curCol > commKTableModel.getFixedColumnCount()?curCol:commKTableModel.getFixedColumnCount(), row, true);
			}
		});
		
		resultKTable.addCellMouseRightListener(new KTableCellMouseRightAdapter(){
			public void cellMouseRightClick(int col, int row, Rectangle rectangle) {
				Supplier supplier = null;
				EvaluationFactor evaluationFactor = null;
				EvaluationFactorResult  evalFactorResult = null;
				ExpertEvaluationResult expertEvaluationResult = null;
				if(col >= commKTableModel.getFixedColumnCount()){
					supplier = supplierList.get(col - commKTableModel.getFixedColumnCount());
				}
				if(row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + evaluationFactorList.size()){
					evaluationFactor = evaluationFactorList.get(row - commKTableModel.getFixedRowCount());
				}
				if(null != supplier && null != evaluationFactor){
					evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
					expertEvaluationResult = expertEvaluationResultMap.get(supplier.getId());
				}
				resultMouseRightClickEventAction(supplier, evaluationFactor, expertEvaluationResult, evalFactorResult);
			}
		});
		resultKTable.setModel(commKTableModel);
		reSetSortNo(null);
		resultKTable.redraw();
		evaluationTableComposite.layout();
	}
	
	public void resizeColumn(int width){
		for(int i = commKTableModel.getFixedColumnCount(); i < commKTableModel.getColCount(); i++){
			commKTableModel.setColumnWidth(i, width);
		}
		resultKTable.autoComputerColumnWidth();
	}

	/**
	 * @Description: 全部满分
	 * @author guoyr
	 */
	public void initDefaultFactorResult(){
		if(!MessageDialog.openConfirm(getShell(), Messages.Tips_setQuickEvaluationScore)){
			return;
		}
		resultKTable.closeCellEditor();
		List<Double> sortList = new ArrayList<Double>();
		for(Supplier supplier : supplierList){
			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplier.getId());
			// 当前供应商的所有评审结果
			Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
			BigDecimal totalEvaluationScore = null;
			BigDecimal totalEvaluationFinalScore = null;
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				EvaluationFactorResult evaluationFactorResult = supplierFactorResultMap.get(evaluationFactor.getId());
				if(null == evaluationFactorResult.getEvaluationScore()){
					if(StringUtils.equals(EvaluationFactorEnum.SCORE_TYPE_OBJECTIVE, evaluationFactor.getScoreType())){
						// 如果是客观评分项，则设置为最大值
						List<ScoreItem> itemList = SerializeUtils.deserializeObject(evaluationFactor.getObjectiveItem());
						if(null != itemList && itemList.size() > 0){
							BigDecimal maxScore = null;
							for(ScoreItem item : itemList){
								BigDecimal score = item.getScore();
								if(null == maxScore || score.compareTo(maxScore) > 0){
									maxScore = score;
								}
							}
							evaluationFactorResult.setEvaluationScore(maxScore);
						}
					}
					if(null == evaluationFactorResult.getEvaluationScore()){
						evaluationFactorResult.setEvaluationScore(evaluationFactor.getFactorMaxScore());
					}
					
					contentForegroundMap.put(evaluationFactorResult.getId(), importColor);// 设置为非自己录入的颜色
					resultChanged = true;
				}
				
				// 如果是客观项，检查所有评标专家的评标结果是否相同
				if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
					checklObjectiveFactorResult(evaluationFactorResult, evaluationFactorResult.getSupplierId(), evaluationFactor.getId());
				}else if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_WARING)){
					checkScoreFactorResult(evaluationFactorResult, evaluationFactorResult.getSupplierId(), evaluationFactor.getId());
				}
				if(null != evaluationFactorResult.getEvaluationScore()){
					totalEvaluationScore = BigDecimalUtils.add(totalEvaluationScore, evaluationFactorResult.getEvaluationScore());
				}
				evaluationFactorResult.setEvaluationFinalScore(getEvaluationFinalScore(evaluationFactor, evaluationFactorResult.getEvaluationScore()));
				if(null != evaluationFactorResult.getEvaluationFinalScore()){
					totalEvaluationFinalScore = BigDecimalUtils.add(totalEvaluationFinalScore, evaluationFactorResult.getEvaluationFinalScore());
				}
			}
			expertEvaluationResult.setEvaluationScore(BigDecimalUtils.round(totalEvaluationScore, scoreRound));
			expertEvaluationResult.setEvaluationFinalScore(BigDecimalUtils.round(totalEvaluationFinalScore, scoreRound));
			if(null != totalEvaluationFinalScore){
				sortList.add(totalEvaluationFinalScore.doubleValue());
			}
		}
		reSetSortNo(null);
		resultKTable.redraw();
	}
	
	/**
	 * @Description: 得到最终得分
	 * @author guoyr
	 * @param evaluationFactor
	 * @param evaluationScore
	 * @return 
	 */
	private BigDecimal getEvaluationFinalScore(EvaluationFactor evaluationFactor, BigDecimal evaluationScore){
		BigDecimal evaluationFinalScore = evaluationScore;
		if(null != evaluationScore && null != evaluationFactor.getFactorFinalWeight() && evaluationFactor.getFactorFinalWeight().compareTo(BigDecimal.ZERO) != 0){
			evaluationFinalScore = BigDecimalUtils.div(BigDecimalUtils.mul(evaluationFactor.getFactorFinalWeight(), evaluationScore), new BigDecimal(100));
		}
//		return BigDecimalUtils.round(evaluationFinalScore, scoreRound);
		return evaluationFinalScore;
	}
	
	/**
	 * @Description: 保存评审结果
	 * @author guoyr
	 * @return 
	 */
	public boolean saveEvaluationFactorResult(){
		resultKTable.closeCellEditor();
		boolean saveSuccess = true;
		// 如果修改了结果，才保存结果
		if(resultChanged){
			saveSuccess = expertEvaluationStepService.saveEvaluationResult(tenderProjectEntity.getId(), curUser.getId(), evaluationStep, expertEvaluationResultMap, supplierEvaluationFactorResultMap);
			if(saveSuccess){
				resultChanged = false;
				if(evaluationBySupplier){
					saveEvaluationFactorResultBySupplier();
				}
			}else {
				resultChanged = true;
			}
			if(saveSuccess){
				MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
			}else{
				MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
			}
		}
		return saveSuccess;
	}
	
	
	private void saveAction(){

		// 先保存
		boolean saveSuccess = saveEvaluationFactorResult();
		if(saveSuccess){
			String errorMessage = checkSubmit();
			if(null != errorMessage){
				MessageDialog.openInformation(getShell(), errorMessage);
				return;
			}
			String message = MessageFormat.format(Messages.Tips_submitEvaluationResult, evaluationStep.getStepName());
			if(!MessageDialog.openConfirm(getShell(), Messages.Button_submitEvaluationResult, message, new String[]{Messages.Button_confirmComplate, Messages.Button_continueEvaluation})){
				return ;
			}
//			Object experSignature = evaluationStep.getEvaluationParamByKey(EvaluationStepEnum.PARAM_EXPER_SIGNATURE);
//			if(null != experSignature && (Boolean)experSignature){
//				ExpertSignReportDialog dialog = new ExpertSignReportDialog(getShell(), tenderProjectEntity, evaluationStep, Constants.CUR_USER);
//				dialog.setTitle(Messages.Button_generateReport);
//				// 最大化和关闭
//				dialog.setOperator(SWT.NONE);
//				dialog.open();
//				if(dialog.isBack()){
//					return ;
//				}
//			}
			
			if(submitEvaluationFactorResult()){
			}else {
				MessageDialog.openWarning(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveEvalResultFailed);
			}
		}else {
			MessageDialog.openWarning(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveEvalResultFailed);
		}
	}
	/**
	 * @Description: 保存按供应商打分结果
	 * @author guoyr 
	 */
	private void saveEvaluationFactorResultBySupplier(){
		new Thread(new Runnable(){
			public void run(){
				List<Map<String, Object>> supplierEvaluationFactorResultList = new ArrayList<Map<String, Object>>();
				String groupCode = tenderProjectEntity.getPurcategoryNames();
				for(Supplier supplier : supplierList){
					Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
					for(Entry<String, EvaluationFactorResult> resultEntry : supplierFactorResultMap.entrySet()){
						EvaluationFactorResult evaluationFactorResult = resultEntry.getValue();
						if(null != evaluationFactorResult.getEvaluationScore()){
							Map<String, Object> resultMap = new HashMap<String, Object>();
							resultMap.put("SUPPLIER_NAME", supplier.getSupplierName());
							resultMap.put("FACTOR_NAME", evaluationFactorResult.getFactorName());
							resultMap.put("EVALUATION_SCORE", evaluationFactorResult.getEvaluationScore());
							supplierEvaluationFactorResultList.add(resultMap);
						}
					}
				}
				evaluationFactorResultService.saveEvaluationResultBySupplier(tenderProjectEntity.getParentId(), groupCode, curUser.getId(), supplierEvaluationFactorResultList);
			}
		}).start();
	}
	/**
	 * @Description: 检查是否可以提交
	 * @author guoyr
	 * @return 
	 */
	public String checkSubmit(){
		resultKTable.closeCellEditor();
		for(Supplier supplier : supplierList){
			Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
			for(Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()){
				EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
				if(null == evaluationFactorResult.getEvaluationFinalScore()){
					return supplier.getSupplierName().concat("存在未打分的指标，请检查并对所有指标打分！");
				}
			}
		}
		return null;
	}
	/** 
	 * @Description: 提交评审结果
	 * @author guoyr
	 * @return 
	 */
	public boolean submitEvaluationFactorResult() {
		return expertEvaluationStepService.submitEvaluationResult(tenderProjectEntity.getId(),tenderProjectRuleEntity, curUser.getId(), evaluationStep, supplierList);
	}
	
	/**
	 * @Description: 检查观项指标的结果是否一致
	 * @author guoyr
	 * @param evaluationFactorResult
	 * @param supplierId
	 * @param factorId 
	 */
	private void checkScoreFactorResult(EvaluationFactorResult evaluationFactorResult, String supplierId, String factorId){
		boolean overRange = false;
		BigDecimal curEvaluationScore = evaluationFactorResult.getEvaluationScore();
		if(null != curEvaluationScore && null != warningRange){
			List<BigDecimal> evaluationResultList = evaluationFactorResultService.getEvaluationScoreListNotUserId(tenderProjectEntity.getId(), evaluationStep.getId(), supplierId, factorId, curUser.getId());
			BigDecimal totalScore = curEvaluationScore;//把自身报价添加进列表
			int count = 1;
			if(null != evaluationResultList && evaluationResultList.size() > 0){
				for(BigDecimal evaluationResult : evaluationResultList){
					if(null != evaluationResult){
						count ++;
						totalScore = BigDecimalUtils.add(totalScore, evaluationResult);
					}
				}
			
				BigDecimal avgValue = BigDecimalUtils.div(totalScore, new BigDecimal(count));
				BigDecimal percentValue = BigDecimalUtils.sub(curEvaluationScore, avgValue) ;//获取差值
				if(avgValue.compareTo(BigDecimal.ZERO) != 0){
					percentValue = BigDecimalUtils.div(percentValue, avgValue).abs();//偏差率绝对值
				}
				if(percentValue.compareTo(warningRange) >= 0){
					overRange = true;
				}
			}
		}
		contentBackgroundMap.put(evaluationFactorResult.getId(), overRange ? errorBgColor : null);
	}
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
