package com.gx.obe.common.composite;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.business.entity.EvaluationFactorItem;
import com.gx.obe.business.entity.ScoreItem;
import com.gx.obe.business.entity.SupplierEvaluationFactor;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.InputDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.util.utils.NumberFormatUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.SerializeUtils;
import com.gx.obe.util.utils.SortUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.obe.web.entity.EvaluationFactorResult;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.ExpertEvaluationResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.EvaluationFactorItemService;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierEvaluationFactorService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationFactorResultService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertEvaluationResultService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.KTableCellMouseRightAdapter;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.editors.KTableCellEditorGCombo;
import de.kupzog.ktable.editors.KTableCellEditorText;
import de.kupzog.ktable.model.CommonKtableCModel;
import de.kupzog.ktable.renderers.CellAlignmentRender;
import de.kupzog.ktable.renderers.CellBackgroundRender;
import de.kupzog.ktable.renderers.CellContentRender;
import de.kupzog.ktable.renderers.CellEditContentRender;
import de.kupzog.ktable.renderers.CellEditorRender;
import de.kupzog.ktable.renderers.CellForegroundRender;
import de.kupzog.ktable.renderers.CellImageRender;
import de.kupzog.ktable.renderers.CellRender;
import de.kupzog.ktable.renderers.FixedWrapCellRenderer;
import de.kupzog.ktable.renderers.TextWrapCellRenderer;

/**
 * @Description: 打分评审面板
 * @author guoyr
 */
public class AIScoreSingleEvaluationTableComposite extends Composite{

	private TenderProjectEntity tenderProjectEntity;
	private EvaluationStep evaluationStep;
	private ImageResolver imageResolver = new ImageResolver();
	private SupplierEvaluationFactorService supplierEvaluationFactorService ;
	private ExpertEvaluationStepService expertEvaluationStepService ;;
	private EvaluationFactorResultService evaluationFactorResultService = new EvaluationFactorResultService();
	private ExpertEvaluationResultService expertEvaluationResultService;
	public EvaluationStepService evaluationStepService = new EvaluationStepService();
	public SupplierService supplierService = new SupplierService();
	public TenderProjectService tenderProjectService ;
	private Composite evaluationComposite;
	private Composite evaluationTableComposite;
	private List<EvaluationFactor> evaluationFactorList = new ArrayList<EvaluationFactor>();
	private List<Supplier> supplierList;
	private KTable resultKTable;
	private CommonKtableCModel commKTableModel;
	private int curRow = 0;
	private int curCol = 0;
	private boolean resultChanged = false;
//	private Logger LOG = Logger.getLogger(AIScoreEvaluationTableComposite.class);
	private Map<String, Color> contentBackgroundMap = new HashMap<String, Color>();
	private Map<String, Color> contentForegroundMap = new HashMap<String, Color>();
	private Color importColor = SWTResourceManager.getColor(SWT.COLOR_BLUE);
	private Color rightBgColor = SWTResourceManager.getColor(194, 236, 150);
	private Color errorBgColor = SWTResourceManager.getColor(255, 153, 153);
	// 记录供应商每个指标的评审结果
	private Map<String, Map<String, EvaluationFactorResult>> supplierEvaluationFactorResultMap;
	// 记录专家对供应商的评审汇总结果
	private Map<String, ExpertEvaluationResult> expertEvaluationResultMap;
	private AuthUser curUser;
//	private EvaluationSupplierFactorListener evaluationSupplierFactorListener;
	private boolean isShowError = false;
	private BigDecimal evaluationStepWeight;
	private int fontSize = 9;
	private int scoreRound = 2;
	private boolean indexIsBidNumber = false;
	private boolean evaluationBySupplier = false;
	BigDecimal warningRange = null;
	private int maxFactorNameLength = 10;
//	private String FACTOR_MEMO = "factorMemo";
	private String FACTOR_RESPONSE = "factorresponse";
	private String FACTOR_EVALUATION_OPINION = "factorevaluationOpinion";
	private String FACTOR_SCORE = "factorscore";
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Map<String, Map<String, SupplierEvaluationFactor>> supplierEvaluationFactorResponseMap;
	private boolean nullEvaluationFlag = false;
	private EvaluationFactorItemService evaluationFactorItemService ;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public AIScoreSingleEvaluationTableComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		evaluationComposite = new Composite(this, SWT.NONE);
		evaluationComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		evaluationComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_evaluationComposite = new GridLayout(1, false);
		gl_evaluationComposite.verticalSpacing = 0;
		gl_evaluationComposite.horizontalSpacing = 0;
		gl_evaluationComposite.marginHeight = 0;
		gl_evaluationComposite.marginWidth = 0;
		evaluationComposite.setLayout(gl_evaluationComposite);
		
		evaluationTableComposite = new Composite(evaluationComposite, SWT.NONE);
		evaluationTableComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		evaluationTableComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
		evaluationTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tenderProjectService = new TenderProjectService();
		expertEvaluationStepService = new ExpertEvaluationStepService();
		expertEvaluationResultService = new ExpertEvaluationResultService();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, AuthUser user, EvaluationStep evaluationStep, EvaluationFactor evaluationFactor, List<Supplier> supplierList){
		if(null == evaluationFactorItemService){
			evaluationFactorItemService = new EvaluationFactorItemService();
		}
		if(evaluationFactor.getFactorName().length() > 0){
			nullEvaluationFlag = false;
		}else{
			nullEvaluationFlag = true;
		}
		this.tenderProjectEntity = tenderProjectEntity;
		ProjectRuleService projectRuleService = new ProjectRuleService();
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		this.curUser = user;
		this.evaluationStep = evaluationStep;
		this.supplierList = supplierList;
		warningRange = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_WARNING_RANGE, BigDecimal.class);
		if(null != warningRange && warningRange.compareTo(BigDecimal.ZERO) > 0){
			// 转换为百分率
			warningRange = BigDecimalUtils.div(warningRange, new BigDecimal(100));
		}else {
			warningRange = null;
		}
		curRow = 0;
		curCol = 0;
		ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "进入" + evaluationStep.getStepName(), Constants.USER.getUserName());
		// 修改评标专家的评审记录
		expertEvaluationStepService.updateExpertEvaluationStatus(CommonEnum.IN_PROGRESS, tenderProjectEntity.getId(), evaluationStep, curUser.getId());
		String indexIsBidNumberObj = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_INDEX_IS_BIDNUMBER);
		indexIsBidNumber  = CommonEnum.YES.equals(indexIsBidNumberObj);
		scoreRound = tenderProjectRuleEntity.getScoreRoundIntVal();
		initEvaluationResult(evaluationFactor);
		drawLeftSupplierEvaluationTable();
		
		if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)){
			resultChanged = true;
		}
		
		// 按供应商打分
		boolean evaluationBySupplierObj = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_EVALUATION_BY_SUPPLIER, Boolean.class);
		if(null != tenderProjectEntity.getParentId() && evaluationBySupplierObj){
			evaluationBySupplier = true;
		}else {
			evaluationBySupplier = false;
		}
	}
	/**
	 * @Description: 设置表格中的字体大小
	 * @author guoyr
	 * @param fontSize 
	 */
	public void setTableFontSize(int fontSize){
		this.fontSize = fontSize;
		resultKTable.refreshRowResize(0, commKTableModel.getRowCount()-1);
		resultKTable.redraw();
	}
	
	/**
	 * @Description: 初始化当前评标步骤的评审指标
	 * @author guoyr
	 */
	private void initEvaluationStepFactor(EvaluationFactor evaluationFactor){
		evaluationFactorList.clear();
		evaluationStepWeight = null;
		initAddChildEvaluationFactor(evaluationFactor);
	}
	
	/**
	 * @Description: 递归获取所有的评审叶子指标
	 * @author guoyr
	 * @param evalFactor
	 */
	private void initAddChildEvaluationFactor(EvaluationFactor evalFactor){
			EvaluationFactor factor1 = new EvaluationFactor();
			EvaluationFactor factor2 = new EvaluationFactor();
			
			factor1.setParentFactor(evalFactor.getParentFactor());
			factor2.setParentFactor(evalFactor.getParentFactor());
			
			factor1.setFactorName("供应商响应");
			factor2.setFactorName("评议意见");
			evalFactor.setFactorName("供应商得分");
			
			factor1.setFactorCode("");
			factor2.setFactorCode("");
			
			factor1.setId(UuidUtils.getUUID());
			factor2.setId(UuidUtils.getUUID());
			
			factor2.setFactorCode(evalFactor.getFactorCode());
			factor1.setFactorCode(evalFactor.getFactorCode());
			
			
			factor1.setFactorType(FACTOR_RESPONSE);
			factor2.setFactorType(FACTOR_EVALUATION_OPINION);
			evalFactor.setFactorType(FACTOR_SCORE);
			factor2.setScoreStatus(evalFactor.getScoreStatus());
			factor1.setScoreStatus(evalFactor.getScoreStatus());
			factor2.setLevel(evalFactor.getLevel());
			factor1.setChildFactorList(new ArrayList<EvaluationFactor>());
			factor2.setChildFactorList(new ArrayList<EvaluationFactor>());
			factor1.setMemo(evalFactor.getMemo());
			factor2.setScoreStatus(evalFactor.getScoreStatus());
			evaluationFactorList.add(evalFactor);
			evaluationFactorList.add(factor1);
			evaluationFactorList.add(factor2);
	}
	
	/** 
	 * @Description: 关闭编辑器
	 * @author guoyr 
	 */
	public void closeCellEditor(){
		if(null != resultKTable){
			resultKTable.closeCellEditor();
		}
	}
	
	/**
	 * @Description: 切换评分面板
	 * @author guoyr
	 */
	public void switchCoordinateAction(){
		if(null != resultKTable && !resultKTable.isDisposed()){
			resultKTable.dispose();
		}
		Constants.FACTOR_IS_HORIZONTAL = !Constants.FACTOR_IS_HORIZONTAL;
		drawLeftSupplierEvaluationTable();
		evaluationTableComposite.layout();
	}
	/**
	 * @Description: 评审表格鼠标右键点击事件
	 * @author guoyr
	 * @param row
	 * @param col
	 */
	private void resultMouseRightClickEventAction(final Supplier supplier, final EvaluationFactor evaluationFactor, final ExpertEvaluationResult expertEvaluationResult, final EvaluationFactorResult  evalFactorResult){
		final EMenu gmenu = new EMenu(getShell());
		if(curRow >= commKTableModel.getFixedRowCount()){
			
			gmenu.addMenuItem((resultKTable.isLockedRow(curRow)?Messages.Button_unlockRow:Messages.Button_lockRow), imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/my-account.png"), null != supplier, new EMenu.ClickListener() {
				public void click() {
					if(resultKTable.isLockedRow(curRow)){
						resultKTable.releaseLockRow(curRow);
					}else {
						resultKTable.addLockedRow(curRow);
					}
					resultKTable.refreshRowResize(curRow);
				}
			});
		}

		gmenu.addSeparator();
		gmenu.addMenuItem(Messages.Button_setMaxFactorNameLength, null, true, new EMenu.ClickListener() {
			public void click() {
				InputDialog dialog = new InputDialog(getShell(), Messages.Button_setMaxFactorNameLength, maxFactorNameLength > 0 ? maxFactorNameLength + "" : "");
				dialog.open();
				String pageSizeStr = dialog.getInputValue();
				try {
					int length = Integer.parseInt(pageSizeStr);
					maxFactorNameLength = Math.max(5, length);
				} catch (NumberFormatException e) {
					maxFactorNameLength = -1;
				}finally{
					drawLeftSupplierEvaluationTable();
				}
			}
		});
		gmenu.addMenuItem(Messages.Button_enlargeColumnWidth, null, true, new EMenu.ClickListener() {
			public void click() {
				resultKTable.fillColumnWidth();
				for(int i = 0; i < commKTableModel.getFixedRowCount(); i++){
					resultKTable.refreshRowResize(i);
				}
			}
		});
		gmenu.addMenuItem(Messages.Button_reducedColumnWidth, null, true, new EMenu.ClickListener() {
			public void click() {
				resizeColumn(110);
			}
		});
		gmenu.open();
	}
	
	/**
	 * @Description: 检查观项指标的结果是否一致
	 * @author guoyr
	 * @param evaluationFactorResult
	 * @param supplierId
	 * @param factorId 
	 */
	private void checklObjectiveFactorResult(EvaluationFactorResult evaluationFactorResult, String supplierId, String factorId){
		boolean equalsResult = true;
		BigDecimal curEvaluationScore = evaluationFactorResult.getEvaluationScore();
		if(null != curEvaluationScore){
			List<BigDecimal> evaluationResultList = evaluationFactorResultService.getEvaluationScoreListNotUserId(tenderProjectEntity.getId(), evaluationStep.getId(), supplierId, factorId, curUser.getId());
			if(null != evaluationResultList){
				for(BigDecimal evaluationResult : evaluationResultList){
					if(null != evaluationResult && curEvaluationScore.compareTo(evaluationResult) != 0){
						equalsResult = false;
						break;
					}
				}
			}
		}
		contentBackgroundMap.put(evaluationFactorResult.getId(), equalsResult ? rightBgColor : errorBgColor);
	}
	
	/**
	 * @Description: 初始化评标结果
	 * @author guoyr 
	 */
	private void initEvaluationResult(EvaluationFactor evaluationFactor1){
		if(null == supplierEvaluationFactorService){
			supplierEvaluationFactorService = new SupplierEvaluationFactorService();
		}
		if(null == evaluationFactorItemService){
			evaluationFactorItemService = new EvaluationFactorItemService();
		}
		if(null == evaluationFactorList)evaluationFactorList = new ArrayList<EvaluationFactor>();
		initEvaluationStepFactor(evaluationFactor1);
		supplierEvaluationFactorResponseMap = new HashMap<String, Map<String, SupplierEvaluationFactor>>();
		// 记录供应商每个指标的评审结果
		supplierEvaluationFactorResultMap = new HashMap<String, Map<String, EvaluationFactorResult>>();
		// 记录专家对供应商的评审汇总结果
		expertEvaluationResultMap = new HashMap<String, ExpertEvaluationResult>();
		
		// 评审当前评标专家所有的评标结果
		List<EvaluationFactorResult> expertEvaluateFactorResultList = evaluationFactorResultService.getExpertEvaluationFactorResult(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId(), null);
		List<ExpertEvaluationResult> queryExpertEvaluationResultList = expertEvaluationResultService.getExpertStepAllSupplierEvaluationResultList(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId());
		contentBackgroundMap.clear();
		contentForegroundMap.clear();

		Supplier firstSupplier = null;
		EvaluationFactor firstEvaluationFactor = null;
		EvaluationFactorResult firstEvaluationFactorResult = null;
		List<Double> sortList = new ArrayList<Double>();
		for(Supplier supplier : supplierList){
			
			Map<String, SupplierEvaluationFactor> SupplierEvaluationFactorResponseMap = new HashMap<String, SupplierEvaluationFactor>();
			
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				// 获得已评审的结果
				List<SupplierEvaluationFactor> evalFactorResultList = supplierEvaluationFactorService.getSupplierEvaluationFactorByFactorCodeAndSupplierId(evaluationFactor.getFactorCode(),supplier.getId());
				SupplierEvaluationFactor evalFactorResult = null;
				if(null != evalFactorResultList && evalFactorResultList.size() > 0){
					evalFactorResult = evalFactorResultList.get(0);
				}else{
					evalFactorResult = new SupplierEvaluationFactor();
					evalFactorResult.setTenderId(tenderProjectEntity.getId());
					evalFactorResult.setSupplierId(supplier.getId());
					evalFactorResult.setFactorName(evaluationFactor.getFactorName());
					evalFactorResult.setFactorCode(evaluationFactor.getFactorCode());
				}
				SupplierEvaluationFactorResponseMap.put(evaluationFactor.getId(), evalFactorResult);
				// 如果是客观项，检查所有评标专家的评标结果是否相同
			}
			supplierEvaluationFactorResponseMap.put(supplier.getId(), SupplierEvaluationFactorResponseMap);
			
			// 获取评标专家对投标人的评审记录
			ExpertEvaluationResult expertEvaluationResult = null;
			if(null != queryExpertEvaluationResultList && queryExpertEvaluationResultList.size() > 0){
				for(ExpertEvaluationResult queryExpertEvaluationResult : queryExpertEvaluationResultList){
					if(ObjectUtils.equals(queryExpertEvaluationResult.getSupplierId(), supplier.getId())){
						expertEvaluationResult = queryExpertEvaluationResult;
					}
				}
			}
			if(null == expertEvaluationResult){
				expertEvaluationResult = new ExpertEvaluationResult();
				expertEvaluationResult.setTenderId(tenderProjectEntity.getId());
				expertEvaluationResult.setStepId(evaluationStep.getId());
				expertEvaluationResult.setUserId(curUser.getId());
				expertEvaluationResult.setSupplierId(supplier.getId());
			}
			
			Map<String, EvaluationFactorResult> evaluationFactorResultMap = new HashMap<String, EvaluationFactorResult>();
			BigDecimal totalEvaluationScore = null;
			BigDecimal totalEvaluationFinalScore = null;
			
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				String scoreStatus = "";
				if(null != evaluationFactor.getScoreStatus() && evaluationFactor.getScoreStatus().length() > 0){
					scoreStatus = evaluationFactor.getScoreStatus();
				}
				
				// 获得已评审的结果
				if(null == evaluationFactor.getId()  || evaluationFactor.getId().trim().length() == 0){
					continue;
				}
				EvaluationFactorResult  evalFactorResult = null;
				if(null != expertEvaluateFactorResultList && expertEvaluateFactorResultList.size() > 0){
					for(EvaluationFactorResult factorResult : expertEvaluateFactorResultList){
						if(ObjectUtils.equals(supplier.getId(), factorResult.getSupplierId()) && ObjectUtils.equals(evaluationFactor.getId(), factorResult.getFactorId())){
							evalFactorResult = factorResult;
							break;
						}
					}
				}
				if(null == evalFactorResult){
					evalFactorResult = new EvaluationFactorResult();
					evalFactorResult.setTenderId(tenderProjectEntity.getId());
					evalFactorResult.setStepId(evaluationStep.getId());
					evalFactorResult.setUserId(curUser.getId());
					evalFactorResult.setSupplierId(supplier.getId());
					evalFactorResult.setFactorId(evaluationFactor.getId());
					evalFactorResult.setFactorName(evaluationFactor.getFactorName());
					evalFactorResult.setId(UuidUtils.getUUID());
				}
//				if(evaluationFactor.getFactorType().equals(FACTOR_MEMO)){
//					contentForegroundMap.put(evalFactorResult.getId(), importColor);
//				}
				if(scoreStatus.equals("01")){
					SupplierEvaluationFactor supplierEvaluationFactor = SupplierEvaluationFactorResponseMap.get(evaluationFactor.getId());
					if(null != supplierEvaluationFactor && null != supplierEvaluationFactor.getScoreStatus() &&supplierEvaluationFactor.getScoreStatus().equals("01")){
						totalEvaluationScore = evaluationFactor.getFactorScore();
					}else{
						totalEvaluationScore = BigDecimal.ZERO;
					}
					evalFactorResult.setEvaluationFinalScore(totalEvaluationFinalScore);
					evalFactorResult.setEvaluationScore(totalEvaluationScore);
				}else if(scoreStatus.equals("02")){
				//评审点为智能评审数据类型的，先计算当前评审点所有供应商相应的数量，在计算供应商评价的相应数量，最高的供应商将得到满分，最低的得到	
					totalEvaluationScore = evaluationFactorItemService.getAIScore(supplier.getId(), evaluationFactor.getFactorCode(), evaluationFactor.getTenderId(),evaluationFactor.getFactorScore());
					evalFactorResult.setEvaluationFinalScore(totalEvaluationFinalScore);
					evalFactorResult.setEvaluationScore(totalEvaluationScore);
				}else{
					if(null != evalFactorResult.getEvaluationScore()){
						totalEvaluationScore = BigDecimalUtils.add(totalEvaluationScore, evalFactorResult.getEvaluationScore());
					}
					evalFactorResult.setEvaluationFinalScore(getEvaluationFinalScore(evaluationFactor, evalFactorResult.getEvaluationScore()));
					if(null != evalFactorResult.getEvaluationFinalScore()){
						totalEvaluationFinalScore = BigDecimalUtils.add(totalEvaluationFinalScore, evalFactorResult.getEvaluationFinalScore());
					}
				}
				evaluationFactorResultMap.put(evaluationFactor.getId(), evalFactorResult);
				
				// 如果是客观项，检查所有评标专家的评标结果是否相同
				if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
					checklObjectiveFactorResult(evalFactorResult, supplier.getId(), evaluationFactor.getId());
				}else if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_WARING)){
					checkScoreFactorResult(evalFactorResult, supplier.getId(), evaluationFactor.getId());
				}
				if(null == firstEvaluationFactor){
					firstEvaluationFactor = evaluationFactor;
				}
				if(null == firstEvaluationFactorResult){
					firstEvaluationFactorResult = evalFactorResult;
				}
				
			}
			expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
			expertEvaluationResult.setEvaluationScore(BigDecimalUtils.round(totalEvaluationScore, scoreRound));
			expertEvaluationResult.setEvaluationFinalScore(BigDecimalUtils.round(totalEvaluationFinalScore, scoreRound));
			expertEvaluationResultMap.put(supplier.getId(), expertEvaluationResult);
			if(null != totalEvaluationFinalScore){
				sortList.add(totalEvaluationFinalScore.doubleValue());
			}
			if(null == firstSupplier){
				firstSupplier = supplier;
			}
			
			supplierEvaluationFactorResultMap.put(supplier.getId(), evaluationFactorResultMap);
			if(indexIsBidNumber && (null == supplier.getBidNumber() || "".equals(supplier.getBidNumber()))){
				indexIsBidNumber = false;
			}
		}
		reSetSortNo(sortList);
	}
	
	/**
	 * @Description: 设置排名
	 * @author guoyr 
	 */
	private void reSetSortNo(List<Double> sortList){
		if(null == sortList){
			sortList = new ArrayList<Double>();
			for(Entry<String, ExpertEvaluationResult> expertEvaluationResultEntry : expertEvaluationResultMap.entrySet()){
				ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultEntry.getValue();
				if(null != expertEvaluationResult.getEvaluationFinalScore()){
					sortList.add(expertEvaluationResult.getEvaluationFinalScore().doubleValue());
				}
				
			}
		}
		SortUtils sortUtil = new SortUtils(sortList);
		List<Map<String, Object>> supplierSumEvaluationScoreList = null;
		if(null != warningRange){
			supplierSumEvaluationScoreList = expertEvaluationResultService.getSupplierSumEvaluationResultList(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId());
		}
		for(Entry<String, ExpertEvaluationResult> expertEvaluationResultEntry : expertEvaluationResultMap.entrySet()){
			String supplierId = expertEvaluationResultEntry.getKey();
			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultEntry.getValue();
			boolean overRange = false;
			
			if(null != supplierSumEvaluationScoreList && null != expertEvaluationResult.getEvaluationScore()){
				int expertCount = 0;
				BigDecimal sumResult = expertEvaluationResult.getEvaluationScore();
				for(Map<String, Object> supplierSumEvaluationScore : supplierSumEvaluationScoreList){
					
					String _supId = (String)supplierSumEvaluationScore.get("SUPPLIER_ID");
					if(null != _supId && _supId.equals(supplierId)){
						try {
							expertCount = Integer.parseInt(supplierSumEvaluationScore.get("COUNT").toString());
						} catch (NumberFormatException e) {
						}finally {
							expertCount += 1;
						}
						sumResult = BigDecimalUtils.add(sumResult, ObjectUtils.getObjBigDecimal(supplierSumEvaluationScore.get("SUM_EVALUATION_SCORE")));
						if(expertCount > 1){
							BigDecimal avgValue = BigDecimalUtils.div(sumResult, new BigDecimal(expertCount));
							BigDecimal percentValue = BigDecimalUtils.sub(expertEvaluationResult.getEvaluationScore(), avgValue) ;//获取差值
							if(avgValue.compareTo(BigDecimal.ZERO) != 0){
								percentValue = BigDecimalUtils.div(percentValue, avgValue).abs();//偏差率绝对值
							}
							if(percentValue.compareTo(warningRange) >= 0){
								overRange = true;
							}
						}
						break;
					}
				}
			}
			contentBackgroundMap.put(supplierId, overRange ? errorBgColor : null);
			
			if(null != expertEvaluationResult.getEvaluationFinalScore()){
				expertEvaluationResultEntry.getValue().setSortNo(sortUtil.getSortNo(expertEvaluationResult.getEvaluationFinalScore().doubleValue()));
			}else {
				expertEvaluationResultEntry.getValue().setSortNo(0);
			}
		}
	}
 
	/**
	 * @Description: 左边是供应商表格
	 * @author guoyr 
	 */
	private void drawLeftSupplierEvaluationTable(){
		if(null == evaluationFactorItemService){
			evaluationFactorItemService = new EvaluationFactorItemService();
		}
		if(null == evaluationFactorList)evaluationFactorList = new ArrayList<EvaluationFactor>();
		if(null != resultKTable && !resultKTable.isDisposed()){
			resultKTable.dispose();
		}
		
		resultKTable = new KTable(evaluationTableComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.EDIT_ON_KEY);
		commKTableModel = new CommonKtableCModel(resultKTable, 1, 1, supplierList.size() , evaluationFactorList.size() + (null != evaluationStepWeight ? 1 : 0));
 		commKTableModel.addRowSpan(0, 0, commKTableModel.getFixedRowCount());
 		resultKTable.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
 		commKTableModel.setColumnWidth(0, 200);
		commKTableModel.setColumnMinWidth(0, 200);
		commKTableModel.setColumnWidth(1, 80);
		commKTableModel.setColumnMaxWidth(1, 200);
		commKTableModel.setColumnWidth(2, 200);
		commKTableModel.setColumnWidth(3, 200);
		
		
	
		final Map<String, String> tableTitleMap = new HashMap<String, String>();
		
		for(int row = 0; row < 1; row++){
			int col = commKTableModel.getFixedColumnCount();
			tableTitleMap.put(row+"_0", "供应商名称");
			
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				if(col < commKTableModel.getFixedColumnCount()){
				}else {
					tableTitleMap.put(row+"_"+col, maxFactorNameLength > 0 ? evaluationFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, evaluationFactor.getFactorName().length())) : evaluationFactor.getFactorName());
					if(row + 1 == evaluationFactor.getLevel()){
						commKTableModel.addRowSpan(row, col, commKTableModel.getFixedRowCount() - row);
					}
				}
				col ++;
			}
		}
		for(int row = commKTableModel.getFixedRowCount(); row < commKTableModel.getRowCount(); row++){
			commKTableModel.setRowHeight(row, 50);
		}
	
		// 设置单元格内容
		CellContentRender contentRender = new CellContentRender(){
			public Object receiveContent(int row, int col) {
				// 表头
				if(row < commKTableModel.getHeadRow()){
					if(null != tableTitleMap.get(row+"_"+col)){
						return tableTitleMap.get(row+"_"+col);
					}else {
						return "";
					}
				}else {
					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					if(col < commKTableModel.getFixedColumnCount()){
						if(resultKTable.isLockedRow(row)){
							return (indexIsBidNumber ? supplier.getBidNumber() : (row - commKTableModel.getFixedRowCount() +1))+"、"+supplier.getSupplierName() + "[已锁定]";
						}else {
							return (indexIsBidNumber ? supplier.getBidNumber() : (row - commKTableModel.getFixedRowCount() +1))+"、"+supplier.getSupplierName();
						}
					}else if(col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
//						EvaluationFactorResult evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
//						if(null != evalFactorResult && null != evalFactorResult.getEvaluationScore()){
//							return NumberFormatUtils.format(evalFactorResult.getEvaluationScore(), scoreRound);
//						}
						
						
						if(evaluationFactor.getFactorType().equals(FACTOR_RESPONSE)){
							String scoreStatus = "";
							if(null != evaluationFactor.getScoreStatus() && evaluationFactor.getScoreStatus().length() > 0){
								scoreStatus = evaluationFactor.getScoreStatus();
							}
							String value = "";
							SupplierEvaluationFactor evalFactorResult = supplierEvaluationFactorResponseMap.get(supplier.getId()).get(evaluationFactor.getId());
							if(scoreStatus.equals("01")){
								if(null != evalFactorResult && null != evalFactorResult.getScoreStatus() && evalFactorResult.getScoreStatus().equals("01")){
									if(null != evalFactorResult.getMemo() && evalFactorResult.getMemo().length() > 0){
										value = evalFactorResult.getMemo();
									}
								}
							}else if(scoreStatus.equals("02")){
								List<EvaluationFactorItem> evaluationFactorItemList  = evaluationFactorItemService.getItemByTenderIdAndSupplierIdAndfactorCode(supplier.getTenderId(),supplier.getId(),evaluationFactor.getFactorCode());
								if(null != evaluationFactorItemList && evaluationFactorItemList.size() > 0){
									for(EvaluationFactorItem item : evaluationFactorItemList){
										if(null != item.getItemContent()){
											value = value + " ["+ item.getItemContent() + "] ,";
										}
									}
								}
								
							}else{
								if(null != evalFactorResult && null != evalFactorResult.getMemo() && evalFactorResult.getMemo().length() > 0){
									value = evalFactorResult.getMemo();
								}
							}
							if(StringUtils.isEmpty(value)){
								if(null != evalFactorResult && null != evalFactorResult.getMemo()){
									value = evalFactorResult.getMemo();
								}
							}
							return value;
							
						}else if(evaluationFactor.getFactorType().equals(FACTOR_SCORE)){
							EvaluationFactorResult evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
							if(null != evalFactorResult && null != evalFactorResult.getEvaluationScore()){
								return NumberFormatUtils.format(evalFactorResult.getEvaluationScore(), scoreRound);
							}
						}else if(evaluationFactor.getFactorType().equals(FACTOR_EVALUATION_OPINION)){
							SupplierEvaluationFactor evalFactorResult = supplierEvaluationFactorResponseMap.get(supplier.getId()).get(evaluationFactor.getId());
							if(null != evalFactorResult && null != evalFactorResult.getOpinion()){
								return evalFactorResult.getOpinion();
							}
						}
						return "";
					}else {
					}
				}
				return "";
		}};
		commKTableModel.setCellContentRender(contentRender);
		
		// 设置单元格渲染器
		final FixedWrapCellRenderer fixedWrapCellRenderer = new FixedWrapCellRenderer();
		final TextWrapCellRenderer textWrapCellRenderer = new TextWrapCellRenderer();
		CellRender cellRender = new CellRender(){
			public Object receiveCellRender(int row, int col) {
				if(commKTableModel.isFixedCell(col, row)){
					fixedWrapCellRenderer.setFont(SWTResourceManager.getFont("微软雅黑", fontSize, SWT.NORMAL));
					return fixedWrapCellRenderer;
				}else{
					textWrapCellRenderer.setFont(SWTResourceManager.getFont("微软雅黑", fontSize + 1, SWT.NORMAL));
					return textWrapCellRenderer;
				}
		}};
		commKTableModel.setCellRender(cellRender);
		
		// 设置单元格编辑器
        final KTableCellEditorText text = new KTableCellEditorText();
		text.setSingleClickEdit(true);
		CellEditorRender cellEditorRender = new CellEditorRender(){
			public Object receiveCellEditor(int row, int col) {
				if(nullEvaluationFlag){
					return null;
				}
				if(row >= commKTableModel.getFixedRowCount() && col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
					EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
					if(evaluationFactor.getFactorType().equals(FACTOR_SCORE)){
						if(null != evaluationFactor && StringUtils.equals(EvaluationFactorEnum.SCORE_TYPE_OBJECTIVE, evaluationFactor.getScoreType())){
							List<ScoreItem> itemList = (List<ScoreItem>)SerializeUtils.deserializeObject(evaluationFactor.getObjectiveItem());
							if(null != itemList && itemList.size() > 0){
								KTableCellEditorGCombo combo = new KTableCellEditorGCombo();
								combo.setSingleClickEdit(true);
								for(ScoreItem item : itemList){
									BigDecimal score = item.getScore();
									String name = item.getName();
									combo.addItem(score+"分"+(StringUtils.isNotEmpty(name) ? " "+name : ""), score);
								}
								return combo;
							}
						}
						return text;
					}
				}
				return null;
			}};
		commKTableModel.setCellEditorRender(cellEditorRender);
		
		// 编辑单元格内容
		CellEditContentRender editContentRender = new CellEditContentRender(){
			public void receiveContent(int row, int col, Object content) {
				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size() && row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + supplierList.size()){
					BigDecimal evaluationScore = null;
					if(null != content && !"".equals(content.toString())){
						evaluationScore = ObjectUtils.getObjBigDecimal(content);
						if(null != evaluationScore){
							evaluationScore = BigDecimalUtils.round(evaluationScore, scoreRound);
						}
					}
					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
					ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
					Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
					EvaluationFactorResult evalFactorResult = supplierFactorResultMap.get(evaluationFactor.getId());
					if(null != evaluationScore){
						if(evaluationScore.compareTo(evaluationFactor.getFactorMinScore()) >= 0 && evaluationScore.compareTo(evaluationFactor.getFactorMaxScore()) <= 0){
							if(null != evaluationFactor.getContainId() && !"".equals(evaluationFactor.getContainId())){
								EvaluationFactor containEvaluationFactor = evaluationFactor.getContainFactor();
								if(null != containEvaluationFactor){
									EvaluationFactorResult containtEvaluationFactorResult= supplierFactorResultMap.get(evaluationFactor.getContainId());
									if(null != containtEvaluationFactorResult){
										BigDecimal maxSumScore = (evaluationFactor.getFactorMaxScore().compareTo(containEvaluationFactor.getFactorMaxScore()) > 0)?evaluationFactor.getFactorMaxScore():containEvaluationFactor.getFactorMaxScore();
										if(BigDecimalUtils.add(evaluationScore, containtEvaluationFactorResult.getEvaluationScore()).compareTo(maxSumScore) > 0){
											if(!isShowError){
												isShowError = true;
												MessageDialog.openError(getShell(), "["+evaluationFactor.getFactorName()+"]和["+containEvaluationFactor.getFactorName()+"]的评分之和不能超过" + maxSumScore+"！");
												isShowError = false;
											}
											return;
										}
									}
								}
							}
						}else {
							if(!isShowError){
								isShowError = true;
								MessageDialog.openError(getShell(), MessageFormat.format(Messages.Tips_entryScroeRange, evaluationFactor.getFactorMinScore(), evaluationFactor.getFactorMaxScore()));
								isShowError = false;
							}
							return;
						}
					}					
					evalFactorResult.setEvaluationScore(evaluationScore);
					evalFactorResult.setEvaluationFinalScore(getEvaluationFinalScore(evaluationFactor, evalFactorResult.getEvaluationScore()));
					// 如果是客观项，检查所有评标专家的评标结果是否相同
					if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
						checklObjectiveFactorResult(evalFactorResult, evalFactorResult.getSupplierId(), evaluationFactor.getId());
					}else if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_WARING)){
						checkScoreFactorResult(evalFactorResult, evalFactorResult.getSupplierId(), evaluationFactor.getId());
					}
					resultChanged = true;
					contentForegroundMap.put(evalFactorResult.getId(), null);
					BigDecimal totalEvaluationScore = null;
					BigDecimal totalEvaluationFinalScore = null;
					for(Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()){
						EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
						if(null != evaluationFactorResult.getEvaluationScore()){
							totalEvaluationScore = BigDecimalUtils.add(totalEvaluationScore, evaluationFactorResult.getEvaluationScore());
						}
						if(null != evaluationFactorResult.getEvaluationFinalScore()){
							totalEvaluationFinalScore = BigDecimalUtils.add(totalEvaluationFinalScore, evaluationFactorResult.getEvaluationFinalScore());
						}
					}
					expertEvaluationResult.setEvaluationScore(BigDecimalUtils.round(totalEvaluationScore, scoreRound));
					expertEvaluationResult.setEvaluationFinalScore(BigDecimalUtils.round(totalEvaluationFinalScore, scoreRound));
					reSetSortNo(null);
					resultKTable.redraw();
				}
			}
		};
		commKTableModel.setCellEditContentRender(editContentRender);
		
		// 编辑单元格对齐方式
		CellAlignmentRender cellAlignmentRender = new CellAlignmentRender(){
			public int receiveCellAlignment(int row, int col) {
				if(col < commKTableModel.getFixedColumnCount() && row >= commKTableModel.getFixedRowCount()){
					if(row < commKTableModel.getFixedRowCount() + supplierList.size()){
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					}else {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
					}
				}
				return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
			}
		};
		commKTableModel.setCellAlignmentRender(cellAlignmentRender);
		
		final Image editImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png");
		// 设置单元格图片
		CellImageRender cellImageRender = new CellImageRender() {
			public Image receiveCellImage(int row, int col) {
				if(row >= commKTableModel.getFixedRowCount() && col == 1){
					return editImage;
				}
				return null;
			}
		};
		commKTableModel.setCellImageRender(cellImageRender);
		
		// 设置单元格前景颜色
		CellForegroundRender cellForegroundRender = new CellForegroundRender(){
			public Color receiveCellForeground(int row, int col) {
				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size() && row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + supplierList.size()){
					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
//					ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
					EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
					EvaluationFactorResult  evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
					Color foreColor = contentForegroundMap.get(evalFactorResult.getId());
					return foreColor;
				
				}
				return null;
		}};
		commKTableModel.setCellForegroundRender(cellForegroundRender);
		
		// 设置单元格背景颜色
		CellBackgroundRender cellBackgroundRender = new CellBackgroundRender(){
			public Color receiveCellBackground(int row, int col) {
				if(col >= commKTableModel.getFixedColumnCount() && row >= commKTableModel.getFixedRowCount() && row < commKTableModel.getFixedRowCount() + supplierList.size()){
					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					if(col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
						EvaluationFactorResult  evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
//					ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
						if(null != evalFactorResult){
							Color bgColor = contentBackgroundMap.get(evalFactorResult.getId());
							return bgColor;
						}
					}
					
				}
				return null;
			}
		};
		commKTableModel.setCellBackgroundRender(cellBackgroundRender);
		
		
		resultKTable.addCellMouseRightListener(new KTableCellMouseRightAdapter(){
		
			public void cellMouseRightClick(int col, int row, Rectangle rectangle) {
				curCol = col; 
				curRow = row;
				Supplier supplier = null;
				EvaluationFactor evaluationFactor = null;
				EvaluationFactorResult  evalFactorResult = null;
				ExpertEvaluationResult expertEvaluationResult = null;
				if(row >= commKTableModel.getFixedRowCount()){
					supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
				}
				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
					evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
				}
				if(null != supplier && null != evaluationFactor){
					evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
				}
				resultMouseRightClickEventAction(supplier, evaluationFactor, expertEvaluationResult, evalFactorResult);
			}
		});
		resultKTable.setModel(commKTableModel);
		evaluationTableComposite.layout();
	}
	
	public void resizeColumn(int width){
		for(int i = commKTableModel.getFixedColumnCount(); i < commKTableModel.getColCount(); i++){
			commKTableModel.setColumnWidth(i, width);
		}
		resultKTable.autoComputerColumnWidth();
	}
	
	/**
	 * @Description: 得到最终得分
	 * @author guoyr
	 * @param evaluationFactor
	 * @param evaluationScore
	 * @return 
	 */
	private BigDecimal getEvaluationFinalScore(EvaluationFactor evaluationFactor, BigDecimal evaluationScore){
		BigDecimal evaluationFinalScore = evaluationScore;
		if(null != evaluationScore && null != evaluationFactor.getFactorFinalWeight() && evaluationFactor.getFactorFinalWeight().compareTo(BigDecimal.ZERO) != 0){
			evaluationFinalScore = BigDecimalUtils.div(BigDecimalUtils.mul(evaluationFactor.getFactorFinalWeight(), evaluationScore), new BigDecimal(100));
		}
		return BigDecimalUtils.round(evaluationFinalScore, scoreRound);
	}
	
	/**
	 * @Description: 保存评审结果
	 * @author guoyr
	 * @return 
	 */
	public boolean saveEvaluationFactorResult(){
		resultKTable.closeCellEditor();
		boolean saveSuccess = true;
		// 如果修改了结果，才保存结果
		if(resultChanged){
			saveSuccess = expertEvaluationStepService.saveEvaluationResult(tenderProjectEntity.getId(), curUser.getId(), evaluationStep, expertEvaluationResultMap, supplierEvaluationFactorResultMap);
			if(saveSuccess){
				resultChanged = false;
				if(evaluationBySupplier){
					saveEvaluationFactorResultBySupplier();
				}
			}else {
				resultChanged = true;
			}
			if(saveSuccess){
				MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
			}else{
				MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
			}
		}
		return saveSuccess;
	}
	
	
	private void saveAction(){

		// 先保存
		boolean saveSuccess = saveEvaluationFactorResult();
		if(saveSuccess){
			String errorMessage = checkSubmit();
			if(null != errorMessage){
				MessageDialog.openInformation(getShell(), errorMessage);
				return;
			}
			String message = MessageFormat.format(Messages.Tips_submitEvaluationResult, evaluationStep.getStepName());
			if(!MessageDialog.openConfirm(getShell(), Messages.Button_submitEvaluationResult, message, new String[]{Messages.Button_confirmComplate, Messages.Button_continueEvaluation})){
				return ;
			}
			
			if(submitEvaluationFactorResult()){
			}else {
				MessageDialog.openWarning(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveEvalResultFailed);
			}
		}else {
			MessageDialog.openWarning(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveEvalResultFailed);
		}
	}
	/**
	 * @Description: 保存按供应商打分结果
	 * @author guoyr 
	 */
	private void saveEvaluationFactorResultBySupplier(){
		new Thread(new Runnable(){
			public void run(){
				List<Map<String, Object>> supplierEvaluationFactorResultList = new ArrayList<Map<String, Object>>();
				String groupCode = tenderProjectEntity.getPurcategoryNames();
				for(Supplier supplier : supplierList){
					Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
					for(Entry<String, EvaluationFactorResult> resultEntry : supplierFactorResultMap.entrySet()){
						EvaluationFactorResult evaluationFactorResult = resultEntry.getValue();
						if(null != evaluationFactorResult.getEvaluationScore()){
							Map<String, Object> resultMap = new HashMap<String, Object>();
							resultMap.put("SUPPLIER_NAME", supplier.getSupplierName());
							resultMap.put("FACTOR_NAME", evaluationFactorResult.getFactorName());
							resultMap.put("EVALUATION_SCORE", evaluationFactorResult.getEvaluationScore());
							supplierEvaluationFactorResultList.add(resultMap);
						}
					}
				}
				evaluationFactorResultService.saveEvaluationResultBySupplier(tenderProjectEntity.getParentId(), groupCode, curUser.getId(), supplierEvaluationFactorResultList);
			}
		}).start();
	}
	/**
	 * @Description: 检查是否可以提交
	 * @author guoyr
	 * @return 
	 */
	public String checkSubmit(){
		resultKTable.closeCellEditor();
		for(Supplier supplier : supplierList){
			Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
			for(Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()){
				EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
				if(null == evaluationFactorResult.getEvaluationFinalScore()){
					return supplier.getSupplierName().concat("存在未打分的指标，请检查并对所有指标打分！");
				}
			}
		}
		return null;
	}
	/** 
	 * @Description: 提交评审结果
	 * @author guoyr
	 * @return 
	 */
	public boolean submitEvaluationFactorResult() {
		return expertEvaluationStepService.submitEvaluationResult(tenderProjectEntity.getId(),tenderProjectRuleEntity, curUser.getId(), evaluationStep, supplierList);
	}
	
	/**
	 * @Description: 检查观项指标的结果是否一致
	 * @author guoyr
	 * @param evaluationFactorResult
	 * @param supplierId
	 * @param factorId 
	 */
	private void checkScoreFactorResult(EvaluationFactorResult evaluationFactorResult, String supplierId, String factorId){
		boolean overRange = false;
		BigDecimal curEvaluationScore = evaluationFactorResult.getEvaluationScore();
		if(null != curEvaluationScore && null != warningRange){
			List<BigDecimal> evaluationResultList = evaluationFactorResultService.getEvaluationScoreListNotUserId(
                    tenderProjectEntity.getId(), 
                    evaluationStep.getId(), 
                    supplierId, 
                    factorId, 
                    curUser.getId()
                );
			BigDecimal totalScore = curEvaluationScore;//把自身报价添加进列表
			int count = 1;
			if(null != evaluationResultList && evaluationResultList.size() > 0){
				for(BigDecimal evaluationResult : evaluationResultList){
					if(null != evaluationResult){
						count ++;
						totalScore = BigDecimalUtils.add(totalScore, evaluationResult);
					}
				}
			
				BigDecimal avgValue = BigDecimalUtils.div(totalScore, new BigDecimal(count));
				BigDecimal percentValue = BigDecimalUtils.sub(curEvaluationScore, avgValue) ;//获取差值
				if(avgValue.compareTo(BigDecimal.ZERO) != 0){
					percentValue = BigDecimalUtils.div(percentValue, avgValue).abs();//偏差率绝对值
				}
				if(percentValue.compareTo(warningRange) >= 0){
					overRange = true;
				}
			}
		}
		contentBackgroundMap.put(evaluationFactorResult.getId(), overRange ? errorBgColor : null);
	}
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
