package com.gx.obe.common.composite;

import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.listener.BorderLineListener;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.ExpertEvaluationResultEnum;
import com.gx.obe.business.vo.SupplierTotalProjectParameter;
import com.gx.obe.business.vo.TotalPriceEvaluationResult;
import com.gx.obe.business.vo.TotalProjectParameter;
import com.gx.obe.common.dialog.EvaluationOpinionInputDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.components.core.util.MoneyUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.expert.ExpertEvaluationResult;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.editors.KTableCellEditorGRadio;
import de.kupzog.ktable.model.CommonKtableCModel;
import de.kupzog.ktable.renderers.CellAlignmentRender;
import de.kupzog.ktable.renderers.CellBackgroundRender;
import de.kupzog.ktable.renderers.CellContentRender;
import de.kupzog.ktable.renderers.CellEditContentRender;
import de.kupzog.ktable.renderers.CellEditorRender;
import de.kupzog.ktable.renderers.CellForegroundRender;
import de.kupzog.ktable.renderers.CellRender;
import de.kupzog.ktable.renderers.CellTooltipRender;
import de.kupzog.ktable.renderers.FixedWrapCellRenderer;
import de.kupzog.ktable.renderers.RowHeightRender;
import de.kupzog.ktable.renderers.TextWrapCellRenderer;

public class BelowCostTotalPriceComposite extends Composite {

	private String ACCESSMENT_YES = "不低于成本";
	private String ACCESSMENT_NO = "低于成本";
	private Composite kTableComposite;
	private KTable kTable;
	private List<Supplier> supplierList;
	private Map<String, ExpertEvaluationResult> expertEvaluationResultMap;
	private TotalProjectParameter totalProjectParameter;
	private Label controlPriceLabel;
	private Label avgValueText;
	private String unitType = CommonEnum.YUAN;
	private ELink init_default_link;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BelowCostTotalPriceComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(2, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 5;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayout(new GridLayout(4, false));
		composite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		Label label_1 = new Label(composite, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_1.setText("平均值：");
		label_1.setForeground(ColorConstants.FONT_BLUE_COLOR);
		
		avgValueText = new Label(composite, SWT.NONE);
		avgValueText.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		GridData gd_label = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_label.widthHint = 150;
		avgValueText.setLayoutData(gd_label);
		avgValueText.setText("");
		
		Label label_2 = new Label(composite, SWT.NONE);
		label_2.setForeground(ColorConstants.FONT_BLUE_COLOR);
		label_2.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		label_2.setText("控制线：");
		
		controlPriceLabel = new Label(composite, SWT.NONE);
		controlPriceLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		GridData gd_controlPriceLabel = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_controlPriceLabel.widthHint = 150;
		controlPriceLabel.setLayoutData(gd_controlPriceLabel);
		controlPriceLabel.setText("");
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		composite_1.setLayout(new GridLayout(1, false));
		
		init_default_link = new ELink(composite_1, SWT.NONE);
		init_default_link.setText(Messages.Button_quickEvaluation);
		init_default_link.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		
		kTableComposite = new Composite(this, SWT.NONE);
		GridLayout gl_composite_8 = new GridLayout(1, false);
		gl_composite_8.verticalSpacing = 0;
		gl_composite_8.horizontalSpacing = 0;
		gl_composite_8.marginHeight = 1;
		gl_composite_8.marginWidth = 1;
		kTableComposite.setLayout(gl_composite_8);
		kTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		kTableComposite.addPaintListener(new BorderLineListener(ColorConstants.BORDER_LINE_COLOR, true, true, true, true));

		init();
	}

	private void init() {
		init_default_link.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				initDefaultAction();
			}
		});
	}

	/**
	 * @Description: 投标人一键评审
	 * @author chenxw 
	 */
	private void initDefaultAction() {
		List<SupplierTotalProjectParameter> supplierTotalProjectParameterList = totalProjectParameter.getSupplierTotalProjectParameterList();
		for (SupplierTotalProjectParameter supplierTotalProjectParameter : supplierTotalProjectParameterList) {
			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplierTotalProjectParameter.getSupplierId());
			TotalPriceEvaluationResult evaluationResult = expertEvaluationResult.getEvaluationResultByKey(ExpertEvaluationResultEnum.BELOW_COST_TOTAL);
			if (null == evaluationResult) {
				evaluationResult = new TotalPriceEvaluationResult();
				evaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
				expertEvaluationResult.setEvaluationResult(ExpertEvaluationResultEnum.BELOW_COST_TOTAL, evaluationResult);
			}
		}
		refreshTotalPriceGrid();
	}

	/**
	 * @Description: 刷新
	 * @author chenxw
	 * @param tenderProjectEntity
	 * @param evaluationStep 
	 * @param supplierEvaluationStepMap 
	 * @param expertEvaluationResultMap 
	 * @param expertEvaluationResultMap 
	 */
	public void refresh(List<Supplier> supplierList, Map<String, ExpertEvaluationResult> expertEvaluationResultMap, TotalProjectParameter totalProjectParameter) {
		this.supplierList = supplierList;
		this.expertEvaluationResultMap = expertEvaluationResultMap;
		this.totalProjectParameter = totalProjectParameter;
		
		avgValueText.setText(MoneyUtils.getMoneyWidthUnit(totalProjectParameter.getTotalPriceAverageValue(), CommonEnum.getPriceUintCN(unitType)));
		controlPriceLabel.setText(MoneyUtils.getMoneyWidthUnit(totalProjectParameter.getTotalPriceControlLine(), CommonEnum.getPriceUintCN(unitType)));
		
		refreshTotalPriceGrid();
	}
	

	/**
	 * @Description: 列出供应商清单列表
	 * @author guoyr
	 * @param supplierQdParameterList 
	 * @param constructProject 
	 */
	private void refreshTotalPriceGrid() {
		if(null != kTable && !kTable.isDisposed()){
			kTable.dispose();
		}
		
		final Map<String, String> supplierNameMap = new HashMap<String, String>();
		for (Supplier supplier : supplierList) {
			supplierNameMap.put(supplier.getId(), supplier.getSupplierName());
		}
		
		final List<SupplierTotalProjectParameter> supplierTotalProjectParameterList = totalProjectParameter.getSupplierTotalProjectParameterList();
		
		Collections.sort(supplierTotalProjectParameterList, new Comparator<SupplierTotalProjectParameter>() {
			public int compare(SupplierTotalProjectParameter o1, SupplierTotalProjectParameter o2) {
				return o1.getTotalPrice().compareTo(o2.getTotalPrice());
			}
		});
		
		kTable = new KTable(kTableComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.FILL_WITH_LASTCOL | SWTX.EDIT_ON_KEY);
		kTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		final CommonKtableCModel commonKtableCModel = new CommonKtableCModel(kTable, 1, 0, supplierTotalProjectParameterList.size(), 5);
		commonKtableCModel.setColumnMinWidth(0, 200);
		commonKtableCModel.setColumnMinWidth(commonKtableCModel.getColCount() - 1, 200);
		
		//设置行高
		commonKtableCModel.setRowHeightRender(new RowHeightRender() {
			public int receiveRowHeight(int row) {
				return Constants.ROW_HIGHT;
			}
		});
		
		//设置单元格内容
		commonKtableCModel.setCellContentRender(new CellContentRender() {
			public Object receiveContent(int row, int col) {
				if (row == 0) {
					switch (col) {
					case 0: return "企业名称";
					case 1: return "企业报价";
					case 2: return "报价偏差";
					case 3: return "偏差百分比";
					case 4: return "是否低于成本";
					}
				} else {
					int supplierIndex = row - 1;
					SupplierTotalProjectParameter supplierTotalProjectParameter = supplierTotalProjectParameterList.get(supplierIndex);
					switch (col) {
					case 0: return supplierNameMap.get(supplierTotalProjectParameter.getSupplierId());
					case 1: return ObjectUtils.getObjString(BigDecimalUtils.round(supplierTotalProjectParameter.getTotalPrice(), 2));
					case 2: return ObjectUtils.getObjString(BigDecimalUtils.round(supplierTotalProjectParameter.getOfferDeviation(), 2));
					case 3: return supplierTotalProjectParameter.getDeviationPercentageString();
					case 4:
						ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplierTotalProjectParameter.getSupplierId());
						TotalPriceEvaluationResult evaluationResult = expertEvaluationResult.getEvaluationResultByKey(ExpertEvaluationResultEnum.BELOW_COST_TOTAL);
						if (null != evaluationResult) {
							if (evaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED)) {
								return ACCESSMENT_YES;
							} else if (evaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED)) {
								return ACCESSMENT_NO;
							}
						}
					}
				}
				return "";
			}
		});

		final FixedWrapCellRenderer fixedWrapCellRenderer = new FixedWrapCellRenderer();
		final TextWrapCellRenderer textWrapCellRenderer = new TextWrapCellRenderer();
		
		// 设置单元格渲染器
		commonKtableCModel.setCellRender(new CellRender() {
			public Object receiveCellRender(int row, int col) {
				if (commonKtableCModel.isFixedCell(col, row)) {
					return fixedWrapCellRenderer;
				} else {
					return textWrapCellRenderer;
				}
			}
		});
		
		final KTableCellEditorGRadio radio = new KTableCellEditorGRadio();
        radio.setSingleClickEdit(true);
        radio.addItem(ACCESSMENT_YES, com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
        radio.addItem(ACCESSMENT_NO, com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
        
        // 设置单元格编辑器
		commonKtableCModel.setCellEditorRender(new CellEditorRender() {
			public Object receiveCellEditor(int row, int col) {
				if (row >= 1 && col == 4) {
					return radio;
				}
				return null;
			}
		});
		
		// 编辑单元格内容
		commonKtableCModel.setCellEditContentRender(new CellEditContentRender() {
			public void receiveContent(int row, int col, Object content) {
				if (null != content && row >= 1 && col == 4) {
					int supplierIndex = row - 1;
					SupplierTotalProjectParameter supplierTotalProjectParameter = supplierTotalProjectParameterList.get(supplierIndex);
					ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplierTotalProjectParameter.getSupplierId());
					TotalPriceEvaluationResult evaluationResult = expertEvaluationResult.getEvaluationResultByKey(ExpertEvaluationResultEnum.BELOW_COST_TOTAL);
					if (null == evaluationResult) {
						evaluationResult = new TotalPriceEvaluationResult();
					}
					evaluationResult.setAccessment(content.toString());
					if (com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED.equals(content.toString())) {
						expertEvaluationResult.setEvaluationResult(ExpertEvaluationResultEnum.BELOW_COST_TOTAL, evaluationResult);
					} else if (com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED.equals(content.toString())) {
						String evaluationOpinion = evaluationResult.getEvaluationOpinion();
						EvaluationOpinionInputDialog evaluationOpinionDialog = new EvaluationOpinionInputDialog(getShell(), evaluationOpinion);
						evaluationOpinionDialog.setTitle("请输入评审意见");
						evaluationOpinionDialog.open();
						evaluationOpinion = evaluationOpinionDialog.getEvaluationOpinion();
						if (null != evaluationOpinion) {
							evaluationResult.setEvaluationOpinion(evaluationOpinion);
							expertEvaluationResult.setEvaluationResult(ExpertEvaluationResultEnum.BELOW_COST_TOTAL, evaluationResult);
						}
					}
				}
			}
		});
		
		// 编辑单元格对齐方式
		commonKtableCModel.setCellAlignmentRender(new CellAlignmentRender() {
			public int receiveCellAlignment(int row, int col) {
				if (!kTable.isFixedCell(col, row)) {
					if (col == 0) {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					} else if (col == commonKtableCModel.getColCount() - 1) {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
					} else {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_RIGHT;
					}
				}
				return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
			}
		});

		// 设置单元格前景颜色
		commonKtableCModel.setCellForegroundRender(new CellForegroundRender() {
			public Color receiveCellForeground(int row, int col) {
				if (row >= 1 && col == 4) {
					int supplierIndex = row - 1;
					SupplierTotalProjectParameter supplierTotalProjectParameter = supplierTotalProjectParameterList.get(supplierIndex);
					ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplierTotalProjectParameter.getSupplierId());
					TotalPriceEvaluationResult evaluationResult = expertEvaluationResult.getEvaluationResultByKey(ExpertEvaluationResultEnum.BELOW_COST_TOTAL);
					if (null != evaluationResult) {
						if (evaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED)) {
							return SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN);
						} else if (evaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED)) {
							return SWTResourceManager.getColor(SWT.COLOR_RED);
						}
					}
				}
				return null;
			}
		});

		// 设置单元格背景颜色
		commonKtableCModel.setCellBackgroundRender(new CellBackgroundRender() {
			public Color receiveCellBackground(int row, int col) {
				return SWTResourceManager.getColor(SWT.COLOR_WHITE);
			}
		});
		
		// 设置单元格提示内容
		commonKtableCModel.setCellTooltipRender(new CellTooltipRender() {
			public String receiveCellTooltip(int row, int col) {
				return "";
			}
		});
		
		kTable.setModel(commonKtableCModel);
		kTableComposite.layout();
		
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
