package com.gx.obe.common.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.http.UploadListener;
import com.gx.obe.common.dialog.SelectTemplateDialog;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.ProgressDialog;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.webservice.UploadBidOpeningReport;
import com.gx.obe.report.dataset.ReportDataSetProvider;
import com.gx.obe.report.listener.ReportGenerateListener;
import com.gx.obe.report.listener.TenderTemplateListener;
import com.gx.obe.report.utils.CreateReportThread;
import com.gx.obe.template.entity.ProjectTemplate;
import com.gx.obe.template.enumeration.TemplateTypeEnum;
import com.gx.obe.template.utils.TemplateUtil;
import com.gx.obe.thread.DownloadBidOpeningReportThread;
import com.gx.obe.thread.HttpDownloadSupplierOpenFileSignThread;
import com.gx.obe.thread.ReUploadBidOpeningResultThread;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.pdf.utils.transfer.TransferUtils;
import com.gx.tools.widget.FileOperatorButton;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 开标一览表结果报表
 * @author wangx
 */
public class BidOpeningReportComposite extends Composite {
	
	private TenderProjectService tenderProjectService = new TenderProjectService();
	private TenderProjectEntity tenderProject;
	private ImageResolver imageResolver = new ImageResolver();
	private Logger LOG = Logger.getLogger(BidOpeningReportComposite.class);
	private Composite composite_2;
	private BigButton creatReportElink;
	private File reportFile;
	private Composite composite;
 	private SupplierService supplierService ;
	private String reportName = Messages.BidOpeningList;
	private List<ProjectTemplate> templateFileList = new ArrayList<ProjectTemplate>();
//	private String reportFilePath;
	private BigButton uploadFile_btn;
	private UploadListener uploadCallBack;
	private ProgressDialog synchShellInfo;
	private HttpDownloadSupplierOpenFileSignThread downloadSupplierOpenFileSignThread;
	private Composite parentComposite;
	private Grid supplierGrid;
	private ELink downSignStatusELink;
	private List<Supplier> supplierList;
	private Map<String,GridItem> itemMap;
	private MenuFunctionUtils menuFunctionUtils;
	private Composite supplierComposite;
	private ELink reUploadELink;
	{
		LogUtils.logClass(BidOpeningReportComposite.class);
	}
	
	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 */
	public BidOpeningReportComposite(Composite parent, int style) {
		super(parent, style);
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				Point point = e.gc.textExtent(Messages.Tips_loading, SWT.NONE);
				e.gc.setFont(SWTResourceManager.getFont("微软雅黑", 20, SWT.BOLD));
				e.gc.drawText(Messages.Tips_loading, (e.width - point.x)/2, (e.height - point.y)/2);
			}
		});
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		setBackgroundMode(SWT.INHERIT_FORCE);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
			}
		});
//		reportFile = (File)parent.getData("reportFile"); 
		menuFunctionUtils = (MenuFunctionUtils)parent.getData("menuFunctionUtils");
		parentComposite = new Composite(this, SWT.NONE);
		GridLayout gl_parentComposite = new GridLayout(1, false);
		gl_parentComposite.horizontalSpacing = 1;
		gl_parentComposite.verticalSpacing = 1;
		gl_parentComposite.marginHeight = 1;
		gl_parentComposite.marginWidth = 1;
		parentComposite.setLayout(gl_parentComposite);
		parentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		composite = new Composite(parentComposite, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
//		
//		ESepator sep_3 = new ESepator(parentComposite, SWT.NONE);
//		sep_3.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		sep_3.setBackground(ColorConstants.SKIN_BG);
//		sep_3.setLineWidth(2);
		
		composite_2 = new Composite(parentComposite, SWT.NONE);
		composite_2.setLayout(new GridLayout(2, false));
		composite_2.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		
		creatReportElink = new BigButton(composite_2, SWT.NONE);
		creatReportElink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		creatReportElink.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		creatReportElink.setText(MessageFormat.format(Messages.Creat, Messages.BidOpeningList));
		creatReportElink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				creatReportAction();
			}
		});
		
		uploadFile_btn = new BigButton(composite_2, SWT.NONE);
		uploadFile_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		uploadFile_btn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		uploadFile_btn.setText(MessageFormat.format(Messages.Button_uploadFormat, Messages.BidOpeningList));
		uploadFile_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				upLoadFileAction();
			}
		});
		
		supplierComposite = new Composite(parentComposite, SWT.NONE);
		GridLayout gl_supplierComposite = new GridLayout(3, false);
		gl_supplierComposite.marginHeight = 1;
		gl_supplierComposite.marginWidth = 1;
		supplierComposite.setLayout(gl_supplierComposite);
		supplierComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		supplierComposite.addPaintListener(new RoundBorderLineListener(ColorConstants.BORDER_LINE_COLOR));
		
		Label emptyLabel = new Label(supplierComposite, SWT.NONE);
		emptyLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		reUploadELink = new ELink(supplierComposite, SWT.NONE);
		reUploadELink.setData(Menu.FUNCTION, "RE_UPLOAD_OPEN_RESULT");
		reUploadELink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				reUploadResultAction();
			}
		});
		reUploadELink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		reUploadELink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/upload.png"));
		reUploadELink.setText(Messages.Button_openingResultReSignature);
		
		downSignStatusELink = new ELink(supplierComposite, SWT.NONE);
		downSignStatusELink.setData(Menu.FUNCTION, "SUPPLIER_OPENFILESTATUS");
		downSignStatusELink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				downSupplierOpenningFileSignStatus();
			}
		});
		downSignStatusELink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		downSignStatusELink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"));
		downSignStatusELink.setText(Messages.Button_refresh);
		
		supplierGrid = new Grid(supplierComposite, SWT.V_SCROLL);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1));
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setAutoWidth(true);
		
		GridColumn indexColumn = new GridColumn(supplierGrid, SWT.CENTER);
		indexColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NATIVE));
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(50);
		
		GridColumn supplierNameColumn = new GridColumn(supplierGrid, SWT.NONE);
		supplierNameColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NATIVE));
		supplierNameColumn.setText(Messages.Tender);
		supplierNameColumn.setWordWrap(true);
		supplierNameColumn.setWidth(150);
		
		GridColumn signColumn = new GridColumn(supplierGrid, SWT.CENTER);
		signColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NATIVE ));
		signColumn.setText(Messages.Status);
		signColumn.setWidth(50);
		signColumn.setMaxmumWidth(150);
		
		
		init();
	}
	
	private File getOpeningFile() {
		File reportFileDir = new File(FileConstants.getOpeningReportFilePath(tenderProject.getId()));
		File reportFile = null;
		if(reportFileDir.exists()) {
			File[] files = reportFileDir.listFiles();
			if(null != files) {
				for(File file : files) {
					reportFile = file;
					if(file.getName().endsWith(".pdf")) {
						return file;
					}
				}
			}
		}
		return reportFile;
	}
	/**
	 * @Description: 初始化
	 * @author wangx
	 */
	private void init() {
		if(null != menuFunctionUtils && MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("SIGNATURE_STATUS"))){
			WidgetUtils.setControlVisible(supplierComposite, false);
		}
		if(null != menuFunctionUtils && !MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("RE_UPLOAD_OPEN_RESULT"))){
			WidgetUtils.setControlVisible(reUploadELink, false);
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("NEED_APPLY_REUPLOAD"))){
				reUploadELink.setText(Messages.Button_openingResultReSignature);
			}
		}
		supplierService = new SupplierService();
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);
		supplierGrid.setAutoHeight(true);
		uploadCallBack = new UploadListener() {
			@Override
			public void finish(final boolean uploadFlag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(null != synchShellInfo){
							synchShellInfo.close();
						}
						if (uploadFlag) {
							tenderProject.setBidOpeningFile(CommonEnum.YES);
							if(tenderProjectService.updateAssignProperty(tenderProject, new String[]{"bidOpeningFile"})){
								refreshBidOpegingReport();
								MessageDialog.openShortMessage(Messages.Tips_uploadComplete);
								uploadFile_btn.setText(MessageFormat.format(Messages.Button_uploadedFormat, Messages.BidOpeningList));
								uploadFile_btn.setEnabled(false);
								downSignStatusELink.setEnabled(true);
								composite_2.layout();
							}else{
								MessageDialog.openShortMessage(Messages.Tips_uploadFailed);
							}
						}else{
							MessageDialog.openShortMessage(Messages.Tips_uploadFailed);
						}
					}
				});
			}
		};
		
	}
	public void refresh(TenderProjectEntity tenderProject) {
		tenderProject = tenderProjectService.getById(tenderProject.getId());
		this.tenderProject = tenderProject;
		parentComposite.setVisible(null != tenderProject);
		if(null == tenderProject)return;
		supplierList = supplierService.getOpenBidSuccessSupplier(tenderProject.getId());
		if(null != supplierList && supplierList.size() > 0){
			refreshSupplierGrid();
		}
		refreshTemplate();
		refreshBidOpegingReport();
		if(CommonEnum.YES.equals(tenderProject.getBidOpeningFile())){
			new Thread(new Runnable() {
				public void run() {
					Display.getDefault().syncExec(new Runnable(){
						public void run() {
							if(!downSignStatusELink.isDisposed()) {
								downSupplierOpenningFileSignStatus();
							}
						}
					});
				}
			}).start();
		}
		
	}
	
	private void refreshTemplate() {
		templateFileList.clear();
		templateFileList.addAll(TemplateUtil.getCustomList("开标"));
		templateFileList.addAll(TemplateUtil.getList(tenderProject.getId(), TemplateTypeEnum.OPEN_BID.getKey()));
		
		//没有代理机构只过滤开标一览表
		List<ProjectTemplate> openTemplateFileList = new ArrayList<ProjectTemplate>();
		if(templateFileList.size() > 0 ) {
			for(ProjectTemplate projectTemplate : templateFileList) {
				if("02".equals(projectTemplate.getTemplateType())) {
					openTemplateFileList.add(projectTemplate);
				}
			}
			templateFileList = openTemplateFileList;
		}
	}
	
	/**
	 * @Description: 重新上传开标一览表
	 * @author wangxiang 
	 */
	private void reUploadResultAction(){
		if(!reUploadELink.getEnabled())return;
		ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Button_openingResultReSignature, Messages.Tips_reSignatureOpeningFileConfirm, null);
		confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
		confirmDialog.setTips(Messages.Tips_reSignatureOpeningFileTip);
		confirmDialog.addButton(Messages.Button_confirm, "01", null);
		confirmDialog.addCancel(Messages.Button_cancel, null);
		confirmDialog.open();
		if("01".equals(confirmDialog.getClickStatus())){
			reUploadELink.setEnabled(false);
			boolean needApply = null != menuFunctionUtils && MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("NEED_APPLY_REUPLOAD"));
			new ReUploadBidOpeningResultThread(tenderProject, needApply, new LoadingAdatper(){
				public void finish(boolean bool) {
					if(bool && null != reportFile){
						reportFile.delete();
					}
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if(!composite.isDisposed()) {
								refreshBidOpegingReport();
							}
							if(bool){
								if(!supplierGrid.isDisposed()){
									refreshSignStatus();
								}
								MessageDialog.openShortMessage(Messages.Tips_operateSuccess);
							}else{
								MessageDialog.openShortMessage(Messages.Tips_operateFail);
							}
						}
					});
				}
			}).start();
			
		}
	
	}
	
	
	private void refreshBidOpegingReport() {
		reportFile = getOpeningFile();
		for(Control control : composite.getChildren()) {
			control.dispose();
		}
		
		if(CommonEnum.YES.equals(tenderProject.getBidOpeningFile())){
			uploadFile_btn.setText(MessageFormat.format(Messages.Button_uploadedFormat, Messages.BidOpeningList));
			uploadFile_btn.setEnabled(false);
			downSignStatusELink.setEnabled(true);
			creatReportElink.setEnabled(false);
			uploadFile_btn.setEnabled(false);
			reUploadELink.setVisible(true);
			reUploadELink.setEnabled(true);
		}else{
			uploadFile_btn.setText(MessageFormat.format(Messages.Button_uploadFormat, Messages.BidOpeningList));
			downSignStatusELink.setEnabled(false);
			if(null != reportFile && reportFile.exists()) {
				creatReportElink.setEnabled(false);
				uploadFile_btn.setEnabled(true);
			}else {
				creatReportElink.setEnabled(true);
				uploadFile_btn.setEnabled(false);
			}
			reUploadELink.setVisible(false);
			reUploadELink.setEnabled(false);
		}
		composite_2.layout();
		
		creatFileBtn();
		
		composite.layout();
		parentComposite.layout();
	}
	

	/**
	 * @Description: 创建文件按钮
	 * @author wangx
	 * @param isExcel 
	 */
	private void creatFileBtn(){
		FileOperatorButton fileOperatorButton = null;
		if(null != reportFile && reportFile.exists()) {
			fileOperatorButton = new FileOperatorButton(composite, reportFile, Messages.BidOpeningList);
			fileOperatorButton.addOperator(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/open.png"), "", Messages.Button_openFile, new FileOperatorButton.ClickListener() {
				public void click(File file, FileOperatorButton fileButton) {
					if(file.exists()) {
						RuntimeUtils.openFIle(file);
					}
				}
			});
			if(!(reportFile.getName().endsWith(".pdf"))){
				fileOperatorButton.addOperator(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/pdf.png"), "", Messages.Button_convertPdf, new FileOperatorButton.ClickListener() {
					public void click(File file, FileOperatorButton fileButton) {

						final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
							public void finish(boolean flag) {
							}
						});
						new Thread(new Runnable() {
							public void run() {
								messageProgress.message(MessageFormat.format(Messages.Tips_convertingToPdf, file.getName()), 0);
								String rePortFileURL = file.getPath();
								String testFilePath = rePortFileURL.substring(0,rePortFileURL.lastIndexOf("."))+".pdf";
								File testFile  = new File(testFilePath);
								if(testFile.exists()){
									testFile.delete();
								}
								final File pdfFile = TransferUtils.convert2PDF(file.getAbsolutePath());
								if(null != pdfFile){
									reportFile = testFile;
									messageProgress.message(MessageFormat.format(Messages.Tips_successFormat, Messages.Button_pdfFormat), 1);
									Display.getDefault().syncExec(new Runnable() {
										public void run() {
											if(!composite.isDisposed() && !uploadFile_btn.isDisposed()) {
												refreshBidOpegingReport();
											}
										}
									});
								}else {
									messageProgress.message(MessageFormat.format(Messages.Tips_failFormat, Messages.Button_pdfFormat), -1);
								}
								messageProgress.finish(null != pdfFile);
							}
						}).start();
						messageProgress.setTitle(Messages.Button_pdfFormat);
						messageProgress.open();
					}
				});
			}
			fileOperatorButton.addOperator(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), "", Messages.Button_exportLocal, new FileOperatorButton.ClickListener() {
				public void click(File file, FileOperatorButton fileButton) {
					if(file.exists()) {
						String saveDir = FileDialogUtils.getDirectorySavePath(Messages.Button_export, Messages.Tips_selectExportDic);
						if(null != saveDir && saveDir.length() > 0){
							saveDir = saveDir+File.separator+("["+tenderProject.getTenderNo()+"]"+StringUtils.filenameFilter(tenderProject.getTenderName())).replaceAll("\\\\", "_");
							File exportFile = new File(saveDir+File.separator + file.getName());
							if (exportFile.exists()) {
								if(!MessageDialog.openConfirm(getShell(), Messages.Button_export, MessageFormat.format(Messages.Tips_alreadyExistAndCover, exportFile.getName()), new String[]{Messages.Button_overwrite, Messages.Button_cancel})){
									return;
								}
							}
							if(FileUtils.copy(file.getAbsolutePath(), exportFile.getAbsolutePath())){
								MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_exportSuccessFormat, exportFile.getName()));
							}
						}
					}
				}
			});
			if(CommonEnum.YES.equals(tenderProject.getBidOpeningFile())) {
				fileOperatorButton.addOperator(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"), "", Messages.Button_refresh, new FileOperatorButton.ClickListener() {
					public void click(File file, FileOperatorButton fileButton) {
						if(file.exists()) {
							if(!file.delete()){
								MessageDialog.openWarning(getShell(), "当前文件被占用，无法同步！");
								return ;
							}
							downSupplierOpenningFileSignStatus();
						}
					}
				});
				Label tips = new Label(composite, SWT.WRAP);
				tips.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
				tips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
				tips.setText(Messages.Tips_doubleClickViewFile);
			}else {
				Label tips = new Label(composite, SWT.WRAP);
				tips.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
				tips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
				tips.setText(Messages.Tips_doubleClickViewAndEditFile);
				fileOperatorButton.addOperator(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"), "", Messages.Button_delete, new FileOperatorButton.ClickListener() {
					public void click(File file, FileOperatorButton fileButton) {
						if(file.exists()) {
							if(!MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, MessageFormat.format(Messages.Tips_deleteObj, file.getName()), new String[]{Messages.Button_confirm, Messages.Button_cancel})){
								return ;
							}
							if(!file.delete()){
								file.deleteOnExit();
							}
							refreshBidOpegingReport();
						}
					}
				});
			}
		}else {
			if(CommonEnum.YES.equals(tenderProject.getBidOpeningFile())) {
				fileOperatorButton = new FileOperatorButton(composite, new File("开标一览表"));
				fileOperatorButton.setEnabled(false);
			}else {
				fileOperatorButton = new FileOperatorButton(composite, new File(Messages.BidOpeningList));
				fileOperatorButton.addOperator(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"), Messages.Button_import, MessageFormat.format(Messages.Tips_importFileTypeFormat, "PDF"), new FileOperatorButton.ClickListener() {
					public void click(File file, FileOperatorButton fileButton) {
						String filPath = FileDialogUtils.getFileNames(SWT.SINGLE, MessageFormat.format(Messages.Tips_importFileTypeFormat, "PDF"), new String[]{"*.pdf;*.xlsx"}, new String[]{});
						if(null != filPath && !"".equals(filPath)){
							File reportFile = new File(filPath);
							if(FileUtils.copy(reportFile.getAbsolutePath(), FileConstants.getOpeningReportFilePath(tenderProject.getId()) + reportFile.getName())){
								refreshBidOpegingReport();
							}
						}
					}
				});
			}
		}
		fileOperatorButton.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
	}
	
	/**
	 * @Description: 上传文件
	 * @author wangx
	 */
	private void upLoadFileAction(){
		if(uploadFile_btn.isEnabled()) {
			if(null != reportFile && reportFile.exists()) {
				if(!CommonEnum.COMPLETE.equals(tenderProject.getBidOpeningStatus())){
					if(!MessageDialog.openConfirm(getShell(), null, Messages.Tips_notComplateBidOpeningOperate, new String[]{Messages.Button_confirm, Messages.Button_cancel})){
						return;
					}
				}
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Button_remoteSignatureOpeningResult, Messages.Tips_uploadOpeningSignatureFileConfirm, null);
				confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
				confirmDialog.setTips(Messages.Tips_uploadOpeningSignatureFile);
				confirmDialog.addButton(Messages.Button_openFile, "openFile", null);
				confirmDialog.addButton(Messages.Button_checkedAndUpload, "01", null);
				confirmDialog.setTipsColor(ColorConstants.FONT_RED_COLOR);
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.setAlpha(230);
				confirmDialog.open();
				if("openFile".equals(confirmDialog.getClickStatus())){
					if(reportFile.exists()) {
						RuntimeUtils.openFIle(reportFile);
					}
					return;
				}
				if(!"01".equals(confirmDialog.getClickStatus())){
					return;
				}
				synchShellInfo = new ProgressDialog(getShell(), MessageFormat.format(Messages.Tips_uploadingFormat, Messages.BidOpeningList));
				UploadBidOpeningReport UploadBidOpeningReport = new UploadBidOpeningReport(tenderProject, reportFile, uploadCallBack);
				UploadBidOpeningReport.start();
				synchShellInfo.open();
			}
		}
		
	}
	
	/**
	 * @Description: 下载文件
	 * @author wangx
	 */
	private void downLoadFileAction(){
		ProgressDialog synchShellInfo = new ProgressDialog(getShell(), MessageFormat.format(Messages.Tips_synchronizingFormat, Messages.BidOpeningList));
		DownloadBidOpeningReportThread downloadBidOpeningReportThread = new DownloadBidOpeningReportThread(tenderProject, reportName,new CallBack(){
			public void callBackBoolean(final boolean flag) {
				Display.getDefault().syncExec(new Runnable(){
					public void run() {
						if(null != synchShellInfo) {
							synchShellInfo.close();
						}
						if(!composite.isDisposed()) {
							if(flag){
								MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_synchronizedSuccessFormat, Messages.BidOpeningList));
								refreshBidOpegingReport();
							}else{
								MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_synchronizedFailedFormat, Messages.BidOpeningList));
							}
						}
					}
				});
			}
		});
		downloadBidOpeningReportThread.start();
		synchShellInfo.open();
	}
	
	/**
	 * @Description: 生成开标一览表
	 * @author wangx
	 */
	private void creatReportAction(){
		if (!creatReportElink.getEnabled()) return;
		try {
			if (null != templateFileList && templateFileList.size() > 0) {
				File reportGroupFileDir = new File(FileConstants.getOpeningReportFilePath(tenderProject.getId()));
				final List<ProjectTemplate>  reportList = new ArrayList<ProjectTemplate>();
				//多个模板时
				if(templateFileList.size() > 1){
					SelectTemplateDialog dialog = new SelectTemplateDialog(getShell(), templateFileList, new TenderTemplateListener() {
						public void select(ProjectTemplate file) {
							reportList.add(file);
							generateReport(reportList, reportGroupFileDir);
						}
						@Override
						public void refreshTemplateList() {
							refreshTemplate();
							creatReportAction();
						}
					});
					dialog.setTitle("请选择开标一览表模板");
					dialog.open();
				}else{
					reportList.add(templateFileList.get(0));
					generateReport(reportList, reportGroupFileDir);
				}
				
			} else {
				if(MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, "没有可生成开标一览表的模板，是否导入模板？", new String[] { "导入模板", "取消" })){
					String filPath = FileDialogUtils.getFileNames(SWT.SINGLE, "请选择开标一览表模板", new String[]{"*.xls;*.xlsx;"}, new String[]{});
					if(null != filPath && !"".equals(filPath)){
						importTemplate(filPath);
					}
				}else{
					return;
				}
			}
		} catch (Exception e) {
			LOG.error("", e);
		}
	}
	
	private void generateReport(List<ProjectTemplate>  reportList, File reportDir) {
		FileUtils.delAllFile(reportDir.getAbsolutePath());
		ReportDataSetProvider reportDataSetProvider = new ReportDataSetProvider(tenderProject);
		final ProgressDialog creatSynchShellInfo = new ProgressDialog(getShell(), MessageFormat.format(Messages.Tips_generatingFormat, Messages.BidOpeningList));
		CreateReportThread	createReportThread = new CreateReportThread(reportList, reportDir, false, reportDataSetProvider, new ReportGenerateListener(){
			public void onGenerate(ProjectTemplate templateFile, String reportPath) {
			}
			public void afterGenerate(ProjectTemplate templateFile, boolean generate, String reportPath) {
				Display.getDefault().syncExec(new Runnable(){
					public void run() {
						if(null != creatSynchShellInfo){
							creatSynchShellInfo.close();
						}
						if(!generate) {
							MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_generatingFailFormat, Messages.BidOpeningList));
						}else {
							if(!composite.isDisposed()) {
								refreshBidOpegingReport();
							}
						}
					}
				});
			}
			
		});
		createReportThread.start();
		creatSynchShellInfo.open();
	}
	
	/**
	 * @Description: 导入模板
	 * @author wangx
	 */
	private void importTemplate(String filePath) {
		File importFile = new File(filePath);
		String importFileName = importFile.getName();
		File templateFile = new File(FileConstants.CUSTOM_TEMPLATE_PATH.concat(importFileName));
		if (templateFile.exists() && !MessageDialog.openConfirm(getShell(), "当前项目中已经存在模板：" + importFileName + "，是否覆盖？")) {
			return;
		}
		if (!FileUtils.copy(importFile.getAbsolutePath(), templateFile.getAbsolutePath())) {
			MessageDialog.openInformation(getShell(), "导入失败！");
			return;
		}
		MessageDialog.openInformation(getShell(), "已导入模板，请重新生成开标一览表！");
		reportName = importFileName;
		refreshTemplate();
	}

	
	/**
	 * @Description: 同步供应商签字状态
	 * @author wangxiang 
	 */
	private void downSupplierOpenningFileSignStatus(){
		if(!downSignStatusELink.isEnabled()){
			return;
		}
		synchShellInfo = new ProgressDialog(getShell(), MessageFormat.format(Messages.Tips_synchronizingFormat, Messages.ConfirmStatus));
		if(null != downloadSupplierOpenFileSignThread) {
			downloadSupplierOpenFileSignThread.stop();
		}
		downloadSupplierOpenFileSignThread = new HttpDownloadSupplierOpenFileSignThread(tenderProject, new CallBack(){
			public void callBackBoolean(final boolean bool) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(null != synchShellInfo){
							synchShellInfo.close();
						}
						if(bool){
							MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_synchronizedSuccessFormat, Messages.ConfirmStatus));
							refreshSignStatus();
						}else{
							MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_synchronizedFailedFormat, Messages.ConfirmStatus));
						}
						//同步成功后，下载报表
						downLoadFileAction();
					}
				});
			}
		});
		downloadSupplierOpenFileSignThread.start();
		synchShellInfo.open();
		
	}
	
	/**
	 * @Description:加载供应商签字状态 
	 * @author wangxiang 
	 */
	private void refreshSupplierGrid(){
		if(null != itemMap) {
			itemMap.clear();
		}else {
			itemMap = new HashMap<String,GridItem>();
		}
		supplierGrid.removeAll();
		if(null != supplierList) {
			int index = 1;
			for(Supplier supplier : supplierList){
				GridItem item = new GridItem(supplierGrid,SWT.None);
				item.setText(0, (index ++)+"");
				item.setText(1, supplier.getSupplierName());
				item.setText(2, "");
				itemMap.put(supplier.getId(), item);
			}
		}
		refreshSignStatus();
	}
	/**
	 * @Description:刷新供应商签字状态 
	 * @author wangxiang 
	 */
	private void refreshSignStatus(){
		supplierList =  supplierService.getOpenBidSuccessSupplier(tenderProject.getId());
		if(null != supplierList) {
			for(Supplier supplier : supplierList){
				GridItem item = (GridItem)itemMap.get(supplier.getId());
				if(null != item && !item.isDisposed()) {
					if(CommonEnum.YES.equals(supplier.getOpenFileSignStatus())){
						item.setText(2,"已签章");
						item.setForeground(1,SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
					}else if("02".equals(supplier.getOpenFileSignStatus())) {
						item.setText(2,"正在签章");
						item.setForeground(1,SWTResourceManager.getColor(SWT.COLOR_DARK_YELLOW));
					}else {
						item.setText(2,"");
						item.setForeground(1,null);
					}
				}
			}
		}
	}

	
	@Override
	protected void checkSubclass() {}
	
}
