package com.gx.obe.common.composite;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.bpt.composite.BidPriceTableInfoListComposite;
import com.gx.obe.bpt.thread.ParseBidPriceTableThread;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.business.enumeration.ProjectRuleEnum;
import com.gx.obe.business.enumeration.SupplierEnum;
import com.gx.obe.business.enumeration.UserEnum;
import com.gx.obe.business.vo.ExchangeRate;
import com.gx.obe.common.dialog.BidPriceSubItemDialog;
import com.gx.obe.common.dialog.ExchangeRateDialog;
import com.gx.obe.common.dialog.GridResizeDialog;
import com.gx.obe.common.dialog.RevokeSupplierDialog;
import com.gx.obe.common.dialog.SupplementBriceDialog;
import com.gx.obe.common.dialog.UploadOpenBiddingResultAndFileDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.listener.SelectBidOpeningStageListener;
import com.gx.obe.common.shell.SelectBidOpeningStageComfirmShell;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.dialog.PublicDialog;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.BidPriceEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.listener.ProgressMessageAdapter;
import com.gx.obe.message.Messages;
import com.gx.obe.thread.DownloadBidOpeningResultThread;
import com.gx.obe.thread.ExportBidOpenResultThread;
import com.gx.obe.thread.ImportBidOpenResultThread;
import com.gx.obe.thread.RefreshProjectSupplierTenderInfoThread;
import com.gx.obe.thread.SyncThreadSet;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.util.utils.ColumnAlignmentUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.price.BidPrice;
import com.gx.obe.web.entity.price.BidPriceResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.BidPriceResultService;
import com.gx.obe.web.service.BidPriceService;
import com.gx.obe.web.service.EncEnvelopeService;
import com.gx.obe.web.service.SupplierOpeningResultService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.security.NowTimeUtils;
import com.gx.tools.utils.BidPriceUtils;
import com.gx.utils.ActionLogUtils;
import com.gx.utils.ExchangeRateUitls;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningResultLoadComposite extends Composite {
	private Text openBidResultText;
	private BigButton reOpenbidBtn;
	private BigButton complateBtn;
	private SupplierService supplierService = new SupplierService();
	private TenderProjectService tenderProjectService ;
//	private ProjectRuleService projectRuleService ;
	private SupplierOpeningResultService supplierOpeningResultService;
	private BidPriceService bidPriceService ;
	private BidPriceResultService bidPriceResultService ;
	private EncEnvelopeService encEnvelopeService;
	private TenderProjectEntity tenderProject;
	private Supplier curSupplier;
	private Label openBidResultTitle;
	private BigButton upload_result_btn;
	private BigButton download_result_btn;
	private Grid priceResultGrid;
	private Label openBidResultWordsLabel;
	private List<Supplier> supplierList;
	private TenderProjectRuleEntity projectRule;
	private List<BidPrice> bidPriceList;
	private ELink export_result_btn;
	private ELink import_result_btn;
	private String importBidOpeningStage = com.gx.obe.components.core.enumeration.TenderProjectEnum.BID_OPENING_ONE_STAGE;
	private Map<String, Integer> bidPriceTableTotalColumnMap;
	private Composite reEditBidPrice_composite;
	private Composite bottomComposite;
	private ELink addSubbidPriceBtn;
	private Menu menu;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private ELink editBidPriceBtn;
	private Date bidOpeningTime;
	private boolean isAnonymous = false;
	private BidOpeningResutTips tipsComposite;
	private Action projectAction;


	/**
	 * Create the bottomComposite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningResultLoadComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		this.projectAction = projectAction;
		tenderProjectService = new TenderProjectService();
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		
		tipsComposite = new BidOpeningResutTips(this, SWT.NONE);
		tipsComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
//		tipsComposite.setBackground(SWTResourceManager.getColor(252, 252, 238));
		
		Composite composite_5 = new Composite(this, SWT.NONE);
		GridLayout gl_composite_5 = new GridLayout(6, false);
		gl_composite_5.marginWidth = 0;
		gl_composite_5.marginHeight = 0;
		composite_5.setLayout(gl_composite_5);
		composite_5.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		reEditBidPrice_composite = new Composite(composite_5, SWT.NONE);
		reEditBidPrice_composite.setLayout(new RowLayout(SWT.HORIZONTAL));
		reEditBidPrice_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		reEditBidPrice_composite.setData(MenuFunction.FUNCTION, "RE_BID_PRICE");
		
		ELink exchange_rate_label = new ELink(composite_5, SWT.NONE);
		exchange_rate_label.setData(MenuFunction.FUNCTION, "EXCHANGE_RATE");
		exchange_rate_label.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				ExchangeRateDialog exchangeRateDialog = new ExchangeRateDialog(getShell(), tenderProject, projectRule);
				exchangeRateDialog.setTitle(Messages.SetCurrencyConversionRate);
				exchangeRateDialog.open();
			}
		});
		exchange_rate_label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"));
		exchange_rate_label.setText(Messages.SetCurrencyConversionRate);
		
		editBidPriceBtn = new ELink(composite_5, SWT.NONE);
		editBidPriceBtn.setData(MenuFunction.FUNCTION, "EDIT_BID_PRICE_TABLE");
		editBidPriceBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		editBidPriceBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		editBidPriceBtn.setText(Messages.Button_inputBidOpiningList);
		editBidPriceBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				editBidPriceTableAction();
			}
		});
		
		addSubbidPriceBtn = new ELink(composite_5, SWT.NONE);
		addSubbidPriceBtn.setData(MenuFunction.FUNCTION, "CONFIG_BID_PRICE_TABLE");
		addSubbidPriceBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		addSubbidPriceBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/add.png"));
		addSubbidPriceBtn.setText(Messages.Button_configBidOpiningList);
		addSubbidPriceBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				addSubbidPriceAction();
			}
		});
		
		export_result_btn = new ELink(composite_5, SWT.NONE);
		export_result_btn.setData(MenuFunction.FUNCTION, "EXPORT_RESULT");
		export_result_btn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		export_result_btn.setText(Messages.Button_exportBidOpeningResult);
		export_result_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"));
		export_result_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				exportOpenbidResultAction();
			}
		});
		
		import_result_btn = new ELink(composite_5, SWT.NONE);
		import_result_btn.setData(MenuFunction.FUNCTION, "IMPORT_RESULT");
		import_result_btn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		import_result_btn.setText(Messages.Button_importBidOpeningResult);
		import_result_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		import_result_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				importOpenbidResultAction();
			}
		});
		
		Composite composite_4 = new Composite(this, SWT.NONE);
		composite_4.setBackground(SWTResourceManager.getColor(211, 211, 211));
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.marginHeight = 1;
		gl_composite_4.marginWidth = 1;
		composite_4.setLayout(gl_composite_4);
		
		Composite composite_2 = new Composite(composite_4, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.marginHeight = 0;
		gl_composite_2.marginWidth = 0;
		composite_2.setLayout(gl_composite_2);
		
		priceResultGrid = new Grid(composite_2, SWT.H_SCROLL | SWT.V_SCROLL);
		priceResultGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		priceResultGrid.setHeaderVisible(true);
		
		ESepator label = new ESepator(composite_2, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		menuFunctionUtils.addFunction(label, "OPENION");
		
		Composite composite_1 = new Composite(composite_2, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(3, false);
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		menuFunctionUtils.addFunction(composite_1, "OPENION");
		
		openBidResultTitle = new Label(composite_1, SWT.NONE);
		openBidResultTitle.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, true, 1, 2));
		openBidResultTitle.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		openBidResultTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		openBidResultTitle.setText(Messages.BidOpeningOpinion+"：");
		
		Composite composite_3 = new Composite(composite_1, SWT.NONE);
		FillLayout fl_composite_3 = new FillLayout(SWT.HORIZONTAL);
		fl_composite_3.marginHeight = 1;
		fl_composite_3.marginWidth = 1;
		composite_3.setLayout(fl_composite_3);
		GridData gd_composite_3 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2);
		gd_composite_3.heightHint = 80;
		composite_3.setLayoutData(gd_composite_3);
		composite_3.addPaintListener(new RoundBorderLineListener(ColorConstants.BORDER_LINE_COLOR));
		
		openBidResultText = new Text(composite_3, SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
		openBidResultText.setTextLimit(1000);
		openBidResultText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent arg0) {
				countWords();
			}
		});
		openBidResultText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		openBidResultWordsLabel = new Label(composite_1, SWT.WRAP);
		openBidResultWordsLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		GridData gd_openBidResultWordsLabel = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_openBidResultWordsLabel.widthHint = 200;
		openBidResultWordsLabel.setLayoutData(gd_openBidResultWordsLabel);
		openBidResultWordsLabel.setText("");
		
		BigButton save_btn = new BigButton(composite_1, SWT.NONE);
		save_btn.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false, 1, 1));
		save_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveOpenBidResult();
			}
		});
		save_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		save_btn.setText(Messages.Button_save);

		bottomComposite = new Composite(this, SWT.NONE);
		RowLayout rowLayout = new RowLayout(SWT.HORIZONTAL);
		rowLayout.spacing = 5;
		rowLayout.fill = true;
		bottomComposite.setLayout(rowLayout);
		bottomComposite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
		
		complateBtn = new BigButton(bottomComposite, SWT.BOTTOM);
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				complateAction();
			}
		});
		complateBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		complateBtn.setText(Messages.Button_complateBidOpening);
		complateBtn.setData(MenuFunction.FUNCTION, "COMPLATE");
		
		reOpenbidBtn =new BigButton(bottomComposite, SWT.BOTTOM);
		reOpenbidBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				reOpenbidAction();
			}
		});
		reOpenbidBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		reOpenbidBtn.setText(Messages.Button_reBidOpening);
		reOpenbidBtn.setData(MenuFunction.FUNCTION, "RE_OPENING");
		
		upload_result_btn = new BigButton(bottomComposite, SWT.BOTTOM);
		upload_result_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				uploadOpenbidResultAction();
			}
		});
		upload_result_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		upload_result_btn.setText(Messages.Button_uploadBidOpeningResult);
		upload_result_btn.setData(MenuFunction.FUNCTION, "UPLOAD_RESULT");
		
		download_result_btn = new BigButton(bottomComposite, SWT.BOTTOM);
		download_result_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				downloadOpenbidResultAction();
			}
		});
		download_result_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		download_result_btn.setText(Messages.Button_downloadBidOpeningResult);
		download_result_btn.setData(MenuFunction.FUNCTION, "DOWNLOAD_RESULT");
		
		
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		this.menu = projectAction.getMenu();
		tenderProject = projectAction.refreshTenderProject();
		projectRule = projectAction.refreshTenderProjectRule();
		encEnvelopeService = new EncEnvelopeService();
		bidPriceResultService = new BidPriceResultService();
		bidPriceService = new BidPriceService();
		supplierOpeningResultService = new SupplierOpeningResultService();
//		projectRuleService = new ProjectRuleService();
		openBidResultText.setText(ObjectUtils.getObjString(tenderProject.getBidOpeningOpinion()));
		
		priceResultGrid.setItemHeight(Constants.ROW_HIGHT);
		
		priceResultGrid.setAutoHeight(true);
		priceResultGrid.setAutoWidth(true);
		
		// 添加投标人表格的选中事件和右键菜单事件
		priceResultGrid.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			@Override
			public void leftMouseButtonDown(GridItem item) {
				supplierSupplierAction();
			}
		});
		WidgetUtils.setControlVisible(export_result_btn, false);
		WidgetUtils.setControlVisible(import_result_btn, false);
		WidgetUtils.setControlVisible(reOpenbidBtn, false);
		
		// 如果能手动控件开标状态(远程开标不允许重新开标)
//		if(PropertiesUtils.getProperty("controlBidOpening", "00").equals("01")){
//			final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
//			if(null != keyCharacter && keyCharacter.length() > 0){
//				final Listener keyListener = new Listener() {
//					public void handleEvent(Event e) {
//						if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
//							if(!reOpenbidBtn.isDisposed()){
//								WidgetUtils.setControlVisible(reOpenbidBtn, !reOpenbidBtn.getVisible());
//								bottomComposite.layout();
//								bottomComposite.getParent().layout();
//							}
//						}
//					}
//				};
//				complateBtn.getParent().getDisplay().addFilter(SWT.KeyDown, keyListener);
//				complateBtn.getParent().addDisposeListener(new DisposeListener() {
//					public void widgetDisposed(DisposeEvent e) {
//						complateBtn.getParent().getDisplay().removeFilter(SWT.KeyDown, keyListener);  
//					}
//				});
//			}
//		}
		
		menuFunctionUtils.initFunctionAuthority(menu, bottomComposite);
		menuFunctionUtils.initFunctionAuthority(menu, addSubbidPriceBtn.getParent());
		
		if(!reEditBidPrice_composite.getVisible()){
			((GridData)reEditBidPrice_composite.getParent().getLayoutData()).horizontalAlignment = SWT.RIGHT;
		}
		
		// 全流程项目不允许手动操作完成和上传
		if(TenderProjectEnum.REMOTE.equals(tenderProject.getRemoteStatus())){
			WidgetUtils.setControlVisible(complateBtn, false);
			WidgetUtils.setControlVisible(upload_result_btn, false);
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority((String)complateBtn.getData(MenuFunction.FUNCTION)))){
				WidgetUtils.setControlVisible(complateBtn, true);
			}
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority((String)upload_result_btn.getData(MenuFunction.FUNCTION)))){
				WidgetUtils.setControlVisible(upload_result_btn, true);
			}
		}else {
			
		}
		if(StringUtils.isEmpty(tenderProject.getTransactionServerId())) {
			WidgetUtils.setControlVisible(upload_result_btn, false);
			WidgetUtils.setControlVisible(download_result_btn, false);
		}
		tipsComposite.refresh(tenderProject, menuFunctionUtils);
		refreshBidPriceTable();
	}
	
	/**
	 * @Description: 统计字数
	 * @author guoyr 
	 */
	private void countWords(){
		openBidResultWordsLabel.setText(MessageFormat.format(Messages.Tips_inputWordsCountWidthMax, openBidResultText.getText().trim().length(), openBidResultText.getTextLimit()));
	}

	
	/**
	 * @Description: 刷新开标一览表
	 * @author guoyr 
	 */
	private void refreshBidPriceTable(){
		for(Control control : bottomComposite.getChildren()){
			control.setEnabled(false);
		}
		SyncThreadSet myThreadSet = new SyncThreadSet(new SyncThreadSet.Runnable() {
			public void run() {
				getSupplierList();
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!priceResultGrid.isDisposed()){
							showBidPriceTitle();
							showResultList();
						}
					} 
				});
			}
		});
		
		myThreadSet.addSyncExec(new SyncThread(new SyncThread.Runnable(){
			public void run() {
				tenderProject = projectAction.refreshTenderProject();
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!tipsComposite.isDisposed()){
							tipsComposite.refresh(tenderProject, menuFunctionUtils);
						}
					}
				});
			}
		}));
		
		myThreadSet.addSyncExec(new SyncThread(new SyncThread.Runnable(){
			public void run() {
				// 如果没有获取过最新投标信息，则自动下载供应商
				if(!tenderProjectService.isGetLatestBidinfo(tenderProject.getId())){
					RefreshProjectSupplierTenderInfoThread thread = new RefreshProjectSupplierTenderInfoThread(tenderProject, new ProgressMessageAdapter(){
						public int getErrorMessagesSize() {
							return 0;
						}});
					thread.start();
					thread.join();
				}
			}
		}));
		myThreadSet.showMessage(Messages.Tips_requesting);
		myThreadSet.start();
	}
	
	private void getSupplierList() {
		List<Supplier> allSupplierList = supplierService.getSupplierOpenBidList(tenderProject.getId());
		
		if(null != allSupplierList){
			if(TenderProjectEnum.LOCAL.equals(tenderProject.getRemoteStatus())) {
				supplierList = allSupplierList;
			}else if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("ONLY_SIGN_SUPPLIER"))){
				if(null == supplierList){
					supplierList = new ArrayList<Supplier>();
				}else {
					supplierList.clear();
				}
				for(Supplier supplier : allSupplierList){
					if(null != supplier.getSignTime()){
						supplierList.add(supplier);
					}
				}
			}else if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("ONLY_TENDER_TIME_SUPPLIER"))){
				if(null == supplierList){
					supplierList = new ArrayList<Supplier>();
				}else {
					supplierList.clear();
				}
				for(Supplier supplier : allSupplierList){
					if(null != supplier.getTenderTime()){
						supplierList.add(supplier);
					}
				}
			}else {
				supplierList = allSupplierList;
			}
			
			//开标时间未到 不显示信息
			bidOpeningTime = projectRule.getBidOpeningStartTime();
			isAnonymous = false;
			// 如果开标时间未到，则匿名显示
			if(projectRule.getIsAnonymous() && null != bidOpeningTime && bidOpeningTime.after(NowTimeUtils.getNowDate())){
				isAnonymous = true;
			}
		}
		if(null == supplierList){
			supplierList = new ArrayList<Supplier>();
		}
	
	}
	/**
	 * @Description: 开标结果表头
	 * @author guoyr 
	 */
	private void showBidPriceTitle(){
		if(null == bidPriceTableTotalColumnMap){
			bidPriceTableTotalColumnMap = new HashMap<String, Integer>();
		}else {
			bidPriceTableTotalColumnMap.clear();
		}
		for(GridColumn column : priceResultGrid.getColumns()){
			column.dispose();
		}
		GridColumn numberColumn = new GridColumn(priceResultGrid, SWT.CENTER);
		numberColumn.setText(Messages.Num);
		numberColumn.setWidth(50);
		numberColumn.setMaxmumWidth(50);
		numberColumn.setWordWrap(true);
		GridColumn supplierNameColumn = new GridColumn(priceResultGrid, SWT.NONE);
		supplierNameColumn.setText(com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType()));
		supplierNameColumn.setWidth(200);
		supplierNameColumn.setMaxmumWidth(300);
		supplierNameColumn.setWordWrap(true);
		
		GridColumn businessBidStatusColumn = new GridColumn(priceResultGrid, SWT.CENTER);
		businessBidStatusColumn.setText(Messages.BidOpeningStatus);
		businessBidStatusColumn.setWidth(100);
		
		bidPriceList = bidPriceService.getTenderBidPriceTableList(tenderProject.getId());
		if(null == bidPriceList || bidPriceList.size() == 0){
			bidPriceList = new ArrayList<BidPrice>();
			bidPriceList.add(BidPriceUtils.getTotalBidprice());
		
		}
		if(null != bidPriceList && bidPriceList.size() > 0){
			for(BidPrice bidPrice : bidPriceList){
				if(StringUtils.isEmpty(bidPrice.getBidPriceName())){
					continue;
				}
				GridColumn gridColumn = new GridColumn(priceResultGrid, SWT.CENTER);;
				if(BidPriceEnum.IS_PRICE_ITEM.equals(bidPrice.getBidPriceType())){
					gridColumn.setAlignment(SWT.RIGHT);
				}else {
					gridColumn.setAlignment(ColumnAlignmentUtils.getAlignment(bidPrice.getBidPriceName()));
				}
				gridColumn.setWordWrap(true);
				gridColumn.setHeaderWordWrap(true);
				gridColumn.setText(bidPrice.getBidPriceName());
				gridColumn.setMinimumWidth(100);
				gridColumn.setWidth(100);
				gridColumn.setMaxmumWidth(250);
				bidPriceTableTotalColumnMap.put(bidPrice.getId(), priceResultGrid.indexOf(gridColumn));
			}
		}
		// 空列
		GridColumn emptyColumn = new GridColumn(priceResultGrid, SWT.CENTER);
		emptyColumn.setWidth(0);
		
	}
	/**
	 * @Description: 列出投标人报价信息
	 * @author guoyr
	 */
	private void showResultList(){
		
		priceResultGrid.removeAll();

		//获取报价结果
		List<BidPriceResult> allBidPriceResultList = bidPriceResultService.getBidPriceResultTableList(tenderProject.getId(), null);
		
		boolean hasComplateSupplier = false;
		int index  = 1;
		for(Supplier supplier : supplierList){
			supplier.setAnonymous(isAnonymous,index);
			GridItem gridItem = new GridItem(priceResultGrid, SWT.NONE);
			gridItem.setData("supplier", supplier);
			gridItem.setText(0, "" +index );
			gridItem.setText(1, supplier.getSupplierName());
			List<BidPriceResult> bidPriceResultList = CollectionUtils.getFilterList(allBidPriceResultList, t -> {
				return supplier.getId().equals(t.getSupplierId());
			});
			refreshSupplierOpenBidResult(supplier, bidPriceResultList, gridItem);
			SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
			if(!hasComplateSupplier && null != supplierOpeningResult && SupplierEnum.OPENBID_SUCCESS.equals(supplierOpeningResult.getBidOpeningStatus())){
				hasComplateSupplier = true;
			}
			index++;
		}
		
		complateBtn.setEnabled(false);
		upload_result_btn.setEnabled(false);
		WidgetUtils.setControlVisible(reOpenbidBtn, false);
		reOpenbidBtn.setEnabled(false);
		// 已完成开标
		if(CommonEnum.COMPLETE.equals(tenderProject.getBidOpeningStatus())){
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("RE_OPENING"))){
				WidgetUtils.setControlVisible(reOpenbidBtn, true);
				reOpenbidBtn.setEnabled(true);
			}
		}else {
			if(hasComplateSupplier){
				complateBtn.setEnabled(true);
			}
		}
		
		upload_result_btn.setSubImage(null);
		// 如果项目已完成开标或废标则可以上传结果
		if(CommonEnum.COMPLETE.equals(tenderProject.getBidOpeningStatus()) || com.gx.obe.components.core.enumeration.TenderProjectEnum.EFFECTIVE_NO.equals(tenderProject.getEffectiveType())){
			upload_result_btn.setEnabled(true);
			if(CommonEnum.COMPLETE.equals(tenderProject.getUploadOpeningResultStatus())){
				upload_result_btn.setEnabled(false);
				upload_result_btn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/yes.png"));
				if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("RE_UPLOAD_RESULT")) && null != tenderProject.getTransactionServerId()){
					WidgetUtils.setControlVisible(upload_result_btn, true);
					upload_result_btn.setEnabled(true);
				}
			}
		} 
		if (projectRule.getBidOpeningStartTime().after(NowTimeUtils.getNowDate())) {
			download_result_btn.setEnabled(true);
		}
		priceResultGrid.resizeColumnWidth();
		
		refreshFunctionsLayout();
	}
	
	private void refreshFunctionsLayout(){
		boolean hasVisibleChild = false;
		for(Control control : bottomComposite.getChildren()){
			if(control.getVisible()){
				hasVisibleChild = true;
				break;
			}
		}
		
		// 如果按钮栏 没有一个可显示的按钮，则将按钮容器也隐藏
		WidgetUtils.setControlVisible(bottomComposite, hasVisibleChild);
		bottomComposite.layout();
		bottomComposite.getParent().layout();
	}

	private void refreshSupplierOpenBidResult(Supplier supplier, List<BidPriceResult> bidPriceResultList, GridItem gridItem) {
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
//		SupplierOpeningResult supplierOpeningResult = supplierOpeningResultService.getSupplierOpeningResult(tenderProject.getId(), supplier.getId());
//		if(null == supplierOpeningResult){
//			return;
//		}
		boolean isRevokeStatus = SupplierEnum.REVOKE_YES.equals(supplierOpeningResult.getRevokeStatus());
		if (isRevokeStatus) {
			gridItem.setForeground(ColorConstants.FONT_RED_COLOR);
			gridItem.setText(2, supplierOpeningResult.getRevokeStatusCN());
			gridItem.setImage(2, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/error_circle.png"));
		} else {
			refreshSupplierOpenbidStatus(gridItem, null != supplierOpeningResult ? supplierOpeningResult.getBidOpeningStatus() : null, 2);
		}
		
		
		if(null != bidPriceList && bidPriceList.size() > 0){
			
			//获取报价结果
//			List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(tenderProject.getId(), supplier.getId());
			if(null == bidPriceResultList || bidPriceResultList.size() == 0){
				bidPriceResultList = new ArrayList<BidPriceResult>();
				if(null != supplierOpeningResult){
					bidPriceResultList.add(supplierOpeningResult.getBidPriceResult(projectRule.getPriceUnitUseDefault(), projectRule.getCurrencyCode(), projectRule.getCurrencyName()));
				}
			}
			// 如果投标报价多于一个，则显示总投标报价
			for (BidPriceResult bidPriceResult : bidPriceResultList) {
				if(StringUtils.isEmpty(bidPriceResult.getBidPriceName())){
					continue;
				}
				int columnCount = 3;
				if(null != bidPriceTableTotalColumnMap.get(bidPriceResult.getBidPriceId())){
					columnCount = bidPriceTableTotalColumnMap.get(bidPriceResult.getBidPriceId());
					gridItem.setText(columnCount, bidPriceResult.getContentValue(projectRule.getPriceUnitUseDefault()));
					if(isAnonymous && StringUtils.hasLength(gridItem.getText(columnCount))){
						gridItem.setText(columnCount, "***");
					}
				}
			}
		}
	}


	/**
	 * @Description: 显示开标状态
	 * @author guoyr
	 * @param gridItem
	 * @param status
	 * @param index 
	 */
	private void refreshSupplierOpenbidStatus(GridItem gridItem, String status, int index){
		if(ObjectUtils.equals(status, SupplierEnum.OPENBID_SUCCESS)){
			gridItem.setImage(index, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/decSuccess.png"));
			gridItem.setForeground(index,SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
		}else if(ObjectUtils.equals(status, SupplierEnum.OPENBID_FIALE)){
			gridItem.setForeground(index,ColorConstants.FONT_RED_COLOR);
			gridItem.setImage(index, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/decFail.png"));
		}else {
			gridItem.setForeground(index,SWTResourceManager.getColor(SWT.COLOR_GRAY));
			gridItem.setImage(index, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/undec.png"));
		}
		gridItem.setText(index, SupplierOpeningResult.getBidOpeningStatusCN(status));
	}
	
	/**
	 * @Description: 重新开标
	 * @author guoyr
	 */
	private void reOpenbidAction(){
		if(!reOpenbidBtn.getEnabled())return;
		boolean isInEvaluationProgress = tenderProjectService.isInProgress(tenderProject.getId(), null);
		// 如果没有进入评审环节，则允许重新开标
		if(isInEvaluationProgress){
//			if(!MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, Messages.Tips_enteredEvaluation, new String[]{Messages.Button_forceOperation, Messages.Button_cancel})){
//				return;
//			}
			MessageDialog.openInformation(getShell(), Messages.Tips_enteredEvaluation);
			return;
		}
		
		if(MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, MessageFormat.format(Messages.Tips_confirmOperate, Messages.Button_reBidOpening), new String[]{Messages.Button_reBidOpening, Messages.Button_cancel})){
			tenderProject.setBusinessBidStatus(CommonEnum.NOT_START);
			tenderProject.setTechnologyBidStatus(CommonEnum.NOT_START);
			tenderProject.setPriceBidStatus(CommonEnum.NOT_START);
			tenderProject.setBidOpeningStatus(CommonEnum.NOT_START);
			tenderProject.setUploadOpeningResultStatus(null);//重置上传开标结果状态
			tenderProject.setUploadPriceOpeningResultStatus(null);
			tenderProject.setStartBidOpening(null);
			tenderProject.setStartPriceBidOpening(null);
			tenderProject.setBidOpeningFile(null);
			tenderProjectService.updateAssignProperty(tenderProject, new String[]{"id","bidOpeningStatus", "businessBidStatus", "technologyBidStatus", "priceBidStatus", "startBidOpening", "startBidOpening", "startPriceBidOpening", "uploadOpeningResultStatus", "uploadPriceOpeningResultStatus", "bidOpeningFile"});
			supplierList = supplierService.getSupplierOpenBidList(tenderProject.getId());
			if(null != supplierList && supplierList.size() > 0){
				List<SupplierOpeningResult> supplierOpeningResultList = new ArrayList<SupplierOpeningResult>();
				for(Supplier supplier : supplierList){
					SupplierOpeningResult openbidResult = supplier.getSupplierOpeningResult();
					
					if(null != openbidResult && StringUtils.isNotEmpty(openbidResult.getId())){
						openbidResult.setTenderId(tenderProject.getId());
						openbidResult.setSupplierId(supplier.getId());
						openbidResult.setBidOpeningStatus(null);
						openbidResult.setBusinessBidStatus(null);
						openbidResult.setTechnologyBidStatus(null);
						openbidResult.setPriceBidStatus(null);
						openbidResult.setRevokeStatus(SupplierEnum.REVOKE_NO);
						supplierOpeningResultList.add(openbidResult);
					}
				}
				if(MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, Messages.Tips_clearBidOpeningResult, new String[]{Messages.Button_clearResult, Messages.Button_keepResult})){
					ActionLogUtils.addServerLog(tenderProject.getId(),"开标结果界面重新开标", "清空结果");
					tenderProjectService.deleteBidOpeningResult(tenderProject.getId());
					supplierService.batchUpdateProperty(supplierList, new String[]{"signTime", "signPerson", "priceSignTime", "priceSignPerson"});
				}else {
					ActionLogUtils.addServerLog(tenderProject.getId(),"开标结果界面重新开标", "");
					if(supplierOpeningResultList.size() > 0){
						supplierOpeningResultService.batchSaveOrUpdate(supplierOpeningResultList, new String[]{"businessBidStatus", "technologyBidStatus", "priceBidStatus", "bidOpeningStatus", "revokeStatus"});
					}
				}
				refreshBidPriceTable();
			}
			encEnvelopeService.deleteTenderEnvelop(tenderProject.getId());
		}
	}	

	/**
	 * @Description: 完成开标
	 * @author guoyr
	 */
	private void complateAction(){
		if(!complateBtn.getEnabled()){
			return;
		}
		if(MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, MessageFormat.format(Messages.Tips_confirmOperate, Messages.Button_complateBidOpening), new String[]{Messages.Button_confirm, Messages.Button_cancel})){
			
			tenderProject.setBidOpeningStatus(CommonEnum.COMPLETE);
			tenderProject.setBusinessBidStatus(CommonEnum.COMPLETE);
			tenderProject.setTechnologyBidStatus(CommonEnum.COMPLETE);
			tenderProject.setPriceBidStatus(CommonEnum.COMPLETE);
			if(tenderProjectService.updateAssignProperty(tenderProject, new String[]{"id","bidOpeningStatus", "businessBidStatus", "technologyBidStatus", "priceBidStatus"})){
				ActionLogUtils.addServerLog(tenderProject.getId(),"完成开标", "开标结果界面完成开标");
				// 修改父级项目状态
				tenderProjectService.updateBidopeningStatus(tenderProject.getId(), tenderProject.getParentId(), CommonEnum.COMPLETE);
				
				List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultList(tenderProject.getId(), null);
				if(null != bidPriceResultList && bidPriceResultList.size() > 0){
					//进行汇率转换
					ExchangeRateUitls.exchangeRate(tenderProject, bidPriceResultList, (ExchangeRate)projectRule.getParamByKey(ProjectRuleEnum.EXCHANGE_RATE));
				}
				
				setComplateBidopening();
				refreshBidPriceTable();
				
				// 如果果远程类型的项目，需要上传开标结果 
				if(null != tenderProject.getTransactionServerId()){
					if(MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, Messages.Tips_complateBidOpening, new String[]{Messages.Button_uploadBidOpeningResult, Messages.Button_cancel})){
						// 上传开标结果
						uploadOpenbidResultAction();
					}
				}
			}else {
				MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_operateFail);
			}
		}
	}
	
	
	/**
	 * @Description: 上传开标结果
	 * @author guoyr
	 */
	private void uploadOpenbidResultAction(){
		if(!upload_result_btn.getEnabled()){
			return ;
		}
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("UPLOAD_SAME_DAY"))){
//			Calendar arg = Calendar.getInstance();
//			arg.setTime(projectRule.getBidOpeningStartTime());
//			arg.set(Calendar.HOUR_OF_DAY, 23);
//			arg.set(Calendar.MINUTE, 59);
//			arg.set(Calendar.SECOND, 59);
			if(NowTimeUtils.getNowDate().after(com.gx.utils.NowTimeUtils.getTomorrowDate(projectRule.getBidOpeningStartTime()))){
				if(UserEnum.ROLE_SUPER_MANAGER.equals(Constants.USER.getUserType())){
					if(!MessageDialog.openConfirm(getShell(), null, "只能在开标时间24小时内上传开标结果，确认要进行强制上传吗？", new String[]{Messages.Button_focusUpload, Messages.Button_cancel})){
						return ;
					}
				}else {
					
					MessageDialog.openWarning(getShell(), Messages.Tips_uploadBidOpeningOneDay);
					return ;
				}
			}
		}
		if(!ObjectUtils.equals(tenderProject.getBidOpeningStatus(), CommonEnum.COMPLETE)){
			MessageDialog.openInformation(getShell(), Messages.Tips_notComplateBidOpening);
			return;
		}
		UploadOpenBiddingResultAndFileDialog dialog = new UploadOpenBiddingResultAndFileDialog(getShell(), tenderProject);
		dialog.setTitle(Messages.Button_uploadBidOpeningResult);
		dialog.open();
	}
	
	/**
	 * @Description: 下载开标结果
	 * @author guoyr
	 */
	private void downloadOpenbidResultAction(){
		if(!download_result_btn.getEnabled()){
			return ;
		}
		boolean isInEvaluationProgress = tenderProjectService.isInProgress(tenderProject.getId(), null);
		// 如果没有进入评审环节，则允许重新开标
		if(isInEvaluationProgress){
			MessageDialog.openWarning(getShell(), Messages.Dialog_warmTips, Messages.Tips_enteredEvaluation);
			return;
		}else if(ObjectUtils.equals(tenderProject.getBidOpeningStatus(), CommonEnum.COMPLETE)){
			if(!MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, MessageFormat.format(Messages.Tips_confirmOperate, Messages.Button_downloadBidOpeningResult), new String[]{Messages.Button_confirm, Messages.Button_cancel})){
				return;
			}
		}
		
		MessageViewDialog dialog = new MessageViewDialog(getShell(), -1);
		new DownloadBidOpeningResultThread(tenderProject, true, dialog.getCallBack()).start();
		dialog.setTitle(Messages.Button_downloadBidOpeningResult);
		dialog.open();
		refreshBidPriceTable();
	}
	
	/**
	 * @Description: 保存开标结果
	 * @author guoyr
	 */
	private void saveOpenBidResult(){
		tenderProject.setBidOpeningOpinion(openBidResultText.getText().trim());
		tenderProjectService.updateAssignProperty(tenderProject, new String[]{"id","bidOpeningOpinion"});
		MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
	}
	
	private void supplierSupplierAction(){
		if(priceResultGrid.getSelectionCount() > 0){
			final GridItem gridItem = priceResultGrid.getSelection()[0];
			curSupplier = (Supplier) gridItem.getData("supplier");
			final SupplierOpeningResult openbidResult = curSupplier.getSupplierOpeningResult();
			
			boolean modifyBidPrice = true;
			if(null != openbidResult){
				// 已开标成功或已废标的不能补录
				if(null != openbidResult && StringUtils.equals(SupplierEnum.REVOKE_YES, openbidResult.getRevokeStatus())){
					modifyBidPrice = false;
				}else if(null != openbidResult.getPriceBidStatus() && openbidResult.getPriceBidStatus().equals(SupplierEnum.OPENBID_SUCCESS)){
					// 如果经济标有报价，则不允重补录
					if(null != openbidResult.getBidPrice() && openbidResult.getBidPrice().compareTo(BigDecimal.ZERO) > 0){
						modifyBidPrice = false;
					}
				}
			}
			editBidPriceBtn.setEnabled(modifyBidPrice);
		}
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		
		if(priceResultGrid.getSelectionCount() > 0){
			
			final EMenu gmenu = new EMenu(getShell());
			final GridItem gridItem = priceResultGrid.getSelection()[0];
			final Supplier supplier = (Supplier) gridItem.getData("supplier");
			final SupplierOpeningResult openbidResult = supplier.getSupplierOpeningResult();
			
			boolean modifyBidPrice = true;
			if(null != openbidResult){
				// 已开标成功或已废标的不能补录
				if(null != openbidResult && SupplierEnum.REVOKE_YES.equals(openbidResult.getRevokeStatus())){
					modifyBidPrice = false;
				}else if(SupplierEnum.OPENBID_SUCCESS.equals(openbidResult.getPriceBidStatus())){
					modifyBidPrice = false;
					// 如果没有报价也可以进行补录
					if(null == openbidResult.getBidPrice() || openbidResult.getBidPrice().compareTo(BigDecimal.ZERO) == 0){
						modifyBidPrice = true;
					}
				}
			}
			// TODO mazc如果可以重新开标，则认为可以修改开标一览表，如果是已经上传的，则修改完开标一览表要清空上传状态并做日志
			if(reOpenbidBtn.getVisible()){
				modifyBidPrice = true;
			}
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.FORCE_EDIT_BID_PRICE_TABLE))){
				modifyBidPrice = true;
			}
			if(SupplierEnum.REVOKE_YES.equals(openbidResult.getRevokeStatus())){
				gmenu.addMenuItem(Messages.Button_canceledBidBack, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/clear.png"), true,new EMenu.ClickListener() {
					public void click() { 
						revokeAction(supplier, gridItem);
					}
				});
			}else {
				gmenu.addMenuItem(Messages.Button_inputBidOpiningList, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"), modifyBidPrice, new EMenu.ClickListener() {
					public void click() { 
						SupplementBriceDialog dialog = new SupplementBriceDialog(getShell(), tenderProject, projectRule, supplier,menu);
						dialog.setTitle(Messages.Button_inputBidOpiningList);
						dialog.open();
						refreshBidPriceTable();
					}
				});
				
				gmenu.addMenuItem(Messages.Button_canceledBid, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/waste.png"), true,new EMenu.ClickListener() {
					public void click() { 
						revokeAction(supplier, gridItem);
					}
				});
			}
			gmenu.addMenuItem("设置固定行高", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"), true,new EMenu.ClickListener() {
				public void click() { 
					GridResizeDialog dialog = new GridResizeDialog(getShell(), priceResultGrid, 2, priceResultGrid.getColumnCount() -1);
					dialog.setShellTrim();
					dialog.open();
				}
			});
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("RESOLVER_PRICE_DETAIL"))){
				
				gmenu.addMenuItem("解析报价明细", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/waste.png"), true,new EMenu.ClickListener() {
					public void click() { 
						new Thread(new ParseBidPriceTableThread(tenderProject.getId(), supplier.getId())).start();
					}
				});
			}
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("VIEW_PRICE_DETAIL"))){
				gmenu.addMenuItem("查看报价明细", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/waste.png"), true,new EMenu.ClickListener() {
					public void click() { 
						PublicDialog dialog = new PublicDialog(getShell()) {
							public void init(Composite container) {
								BidPriceTableInfoListComposite bidPriceTableInfoListComposite = new BidPriceTableInfoListComposite(container, SWT.NONE);
								bidPriceTableInfoListComposite.refresh(tenderProject.getId(), supplier.getId());
							}
						};
						dialog.setTitle("查看报价明细");
						dialog.open();
					}
				});
			}
			gmenu.open();
			
		}
	}
	
	/**
	 * @Description: 设置将所有未开标的供应商的状态设置为开标成功
	 * @author guoyr 
	 */
	private void setComplateBidopening(){
		supplierList = supplierService.getSupplierOpenBidList(tenderProject.getId());
		if(null != supplierList && supplierList.size() > 0){
			Date nowDate = NowTimeUtils.getNowDate();
			List<SupplierOpeningResult> supplierOpeningResultList = new ArrayList<SupplierOpeningResult>();
			
			for(Supplier supplier : supplierList){
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				if(null == supplierOpeningResult || null == supplierOpeningResult.getId()){
					supplierOpeningResult = supplierOpeningResultService.getSupplierOpeningResult(tenderProject.getId(), supplier.getId());
					if(null == supplierOpeningResult){
						supplierOpeningResult = new SupplierOpeningResult();
					}
				}
				// 这里将没有废标的，并且没有开标状态的供应商设置为开标成功（主要用于不走开标流程）
				if(null != supplierOpeningResult.getRevokeStatus() && supplierOpeningResult.getRevokeStatus().equals(SupplierEnum.REVOKE_YES)){
					continue;
				}else {
					supplierOpeningResult.setRevokeStatus(SupplierEnum.REVOKE_NO);
				}
				if(null != supplierOpeningResult.getBidOpeningStatus()){
					continue;
				}
				supplierOpeningResult.setTenderId(tenderProject.getId());
				supplierOpeningResult.setSupplierId(supplier.getId());
//				supplierOpeningResult.setBidOpeningStatus(SupplierEnum.OPENBID_SUCCESS);
//				supplierOpeningResult.setBusinessBidStatus(SupplierEnum.OPENBID_SUCCESS);
//				supplierOpeningResult.setTechnologyBidStatus(SupplierEnum.OPENBID_SUCCESS);
//				supplierOpeningResult.setPriceBidStatus(SupplierEnum.OPENBID_SUCCESS);
				if(!(null != supplierOpeningResult.getRevokeStatus() && supplierOpeningResult.getRevokeStatus().equals(SupplierEnum.REVOKE_YES))){
					supplierOpeningResult.setRevokeStatus(SupplierEnum.REVOKE_NO);
				}
				if(null == supplierOpeningResult.getBidOpeningTime()){
					supplierOpeningResult.setBidOpeningTime(nowDate);
				}
				supplierOpeningResultList.add(supplierOpeningResult);
			}
			if(supplierOpeningResultList.size() > 0){
				supplierOpeningResultService.batchSaveOrUpdate(supplierOpeningResultList, new String[]{"bidOpeningStatus", "businessBidStatus", "technologyBidStatus", "priceBidStatus", "bidOpeningTime", "revokeStatus"});
			}
		}
	}
	
	private void reOpeningAction(Supplier supplier, GridItem gridItem, String bidopeningStage, String stageName){
		
		boolean isInEvaluationProgress = tenderProjectService.isInProgress(tenderProject.getId(), null);
		if(isInEvaluationProgress){
			if(MessageDialog.openConfirm(getShell(), stageName + "重新"+com.gx.obe.components.core.enumeration.TenderProjectEnum.getOpenBidEnum(tenderProject.getPhaseType()), Messages.Tips_enteredEvaluation, new String[]{Messages.Button_close, "强制操作"})){
				return;
			}
		}
		SupplierOpeningResult openbidResult = supplier.getSupplierOpeningResult();
		if(null == openbidResult){
			openbidResult = new SupplierOpeningResult();
		}
		List<String> updatePropertyList = new ArrayList<String>();
		if(null != bidopeningStage && bidopeningStage.equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC)){
			openbidResult.setBusinessBidStatus(null);
			openbidResult.setTechnologyBidStatus(null);
			supplierService.updateAssignProperty(supplier,new String[]{"signTime", "signPerson"});
			if(null != openbidResult.getId()){
				supplierOpeningResultService.updateAssignProperty(openbidResult,  new String[]{"businessBidStatus", "technologyBidStatus"});
			}
		}else if(null != bidopeningStage && bidopeningStage.equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_PRICE)){
			openbidResult.setPriceBidStatus(null);
			updatePropertyList.add("priceBidStatus");
			supplierService.updateAssignProperty(supplier, new String[]{"priceSignTime", "priceSignPerson"});
			if(null != openbidResult.getId()){
				supplierOpeningResultService.updateAssignProperty(openbidResult,  new String[]{"priceBidStatus"});
			}
		}else {
			openbidResult.setBidOpeningStatus(null);
			openbidResult.setBusinessBidStatus(null);
			openbidResult.setTechnologyBidStatus(null);
			openbidResult.setPriceBidStatus(null);
			if(null != openbidResult.getId()){
				supplierService.updateAssignProperty(supplier, new String[]{"signTime", "signPerson", "priceSignTime", "priceSignPerson"});
				supplierOpeningResultService.updateAssignProperty(openbidResult,  new String[]{"bidOpeningStatus", "businessBidStatus", "technologyBidStatus", "priceBidStatus"});
				
			}
		}
		if(null != openbidResult.getId()){
			supplier.setSupplierOpeningResult(openbidResult);
		}
		encEnvelopeService.deleteSupplierEnvelop(tenderProject.getId(), supplier.getId());
		//获取报价结果
		List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(tenderProject.getId(), supplier.getId());
		refreshSupplierOpenBidResult(supplier, bidPriceResultList, gridItem);
	}
	/**
	 * @Description: 解密开标
	 * @author guoyr
	 * @param supplier 
	 * @param gridItem 
	 */
	private void openbidAction(Supplier supplier, GridItem gridItem, String bidopeningStage){
		
		boolean isInEvaluationProgress = tenderProjectService.isInProgress(tenderProject.getId(), null);
		// 如果没有进入评审环节，则允许重新开标
		if(isInEvaluationProgress){
			if(MessageDialog.openConfirm(getShell(), "开标", Messages.Tips_enteredEvaluation, new String[]{Messages.Button_close, "强制操作"})){
				return;
			}
		}
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		if(null == supplierOpeningResult || null == supplierOpeningResult.getId()){
			supplierOpeningResult = supplierOpeningResultService.getSupplierOpeningResult(tenderProject.getId(), supplier.getId());
			if(null == supplierOpeningResult){
				supplierOpeningResult = new SupplierOpeningResult();
			}
		}
		List<String> updatePropertyList = new ArrayList<String>();
		updatePropertyList.add("id");
		
		supplierOpeningResult.setBidOpeningStatus(SupplierEnum.OPENBID_SUCCESS);
		updatePropertyList.add("bidOpeningStatus");
		supplierOpeningResult.setRevokeStatus(SupplierEnum.REVOKE_NO);
		updatePropertyList.add("revokeStatus");
		if(null != bidopeningStage && bidopeningStage.equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC)){
			if(null == supplierOpeningResult.getBidOpeningTime()){
				updatePropertyList.add("bidOpeningTime");
				supplierOpeningResult.setBidOpeningTime(NowTimeUtils.getNowDate());
			}
			supplierOpeningResult.setBusinessBidStatus(SupplierEnum.OPENBID_SUCCESS);
			supplierOpeningResult.setTechnologyBidStatus(SupplierEnum.OPENBID_SUCCESS);
			
		}else if(null != bidopeningStage && bidopeningStage.equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_PRICE)){
			supplierOpeningResult.setPriceBidStatus(SupplierEnum.OPENBID_SUCCESS);
			updatePropertyList.add("priceBidStatus");
			if(null == supplierOpeningResult.getPriceBidOpeningTime()){
				updatePropertyList.add("priceBidOpeningTime");
				supplierOpeningResult.setPriceBidOpeningTime(NowTimeUtils.getNowDate());
			}
			
		}else {
			if(null == supplierOpeningResult.getBidOpeningTime()){
				updatePropertyList.add("bidOpeningTime");
				supplierOpeningResult.setBidOpeningTime(NowTimeUtils.getNowDate());
			}
			if(null == supplierOpeningResult.getPriceBidOpeningTime()){
				updatePropertyList.add("priceBidOpeningTime");
				supplierOpeningResult.setPriceBidOpeningTime(NowTimeUtils.getNowDate());
			}
			supplierOpeningResult.setBusinessBidStatus(SupplierEnum.OPENBID_SUCCESS);
			supplierOpeningResult.setTechnologyBidStatus(SupplierEnum.OPENBID_SUCCESS);
			supplierOpeningResult.setPriceBidStatus(SupplierEnum.OPENBID_SUCCESS);
			updatePropertyList.add("businessBidStatus");
			updatePropertyList.add("technologyBidStatus");
			updatePropertyList.add("priceBidStatus");
		}
			
		boolean openBidSuccess = true;
		if(StringUtils.isEmpty(supplierOpeningResult.getId())){
			supplierOpeningResult.setTenderId(tenderProject.getId());
			supplierOpeningResult.setSupplierId(supplier.getId());
			supplierOpeningResult = supplierOpeningResultService.saveOrUpdateReturn(supplierOpeningResult);
			if(null == supplierOpeningResult){
				openBidSuccess = false;
			}
		}else {
			if(supplierOpeningResultService.updateAssignProperty(supplierOpeningResult, updatePropertyList.toArray(new String[updatePropertyList.size()]))){
				openBidSuccess = true;
			}else {
				openBidSuccess = false;
			}
		}
		if(openBidSuccess){
			supplier.setSupplierOpeningResult(supplierOpeningResult);
			if(!ObjectUtils.equals(tenderProject.getBidOpeningStatus(), CommonEnum.IN_PROGRESS) && !ObjectUtils.equals(tenderProject.getBidOpeningStatus(), CommonEnum.COMPLETE)){
				tenderProjectService.updateBidopeningStatus(tenderProject.getId(), tenderProject.getParentId(), CommonEnum.IN_PROGRESS);
			}
			MessageDialog.openShortMessage(com.gx.obe.components.core.enumeration.TenderProjectEnum.getOpenBidEnum(tenderProject.getPhaseType())+"成功！");
		}else {
			MessageDialog.openWarning(getShell(), com.gx.obe.components.core.enumeration.TenderProjectEnum.getOpenBidEnum(tenderProject.getPhaseType())+"失败！");
		}
		List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(tenderProject.getId(), supplier.getId());
		refreshSupplierOpenBidResult(supplier, bidPriceResultList, gridItem);
	}
	
	/**
	 * @Description: 废标
	 * @author guoyr
	 * @param supplier 
	 * @param gridItem 
	 */
    private void revokeAction(final Supplier supplier, final GridItem gridItem) {
        boolean isInEvaluationProgress = tenderProjectService.isInProgress(tenderProject.getId(), null);
        // 如果没有进入评审环节，则允许重新开标
        if (isInEvaluationProgress) {
            MessageDialog.openInformation(getShell(), Messages.Tips_enteredEvaluation);
            return;
        }
        final SupplierOpeningResult openbidResult = supplier.getSupplierOpeningResult();
        if (null != openbidResult.getRevokeStatus() && openbidResult.getRevokeStatus().equals(SupplierEnum.REVOKE_YES)) {
            if (MessageDialog.openConfirm(getShell(), "取消废标", supplier.getSupplierName() + "已废标\r\n废标原因：\r\n    " + ObjectUtils.getObjString(openbidResult.getRevokeReason()) + "\r\n\r\n确认要取消废标吗？", new String[]{Messages.Button_confirm, Messages.Button_cancel})) {
                openbidResult.setRevokeStatus(SupplierEnum.REVOKE_NO);
                openbidResult.setRevokeReason("");
                if (supplierOpeningResultService.updateAssignProperty(openbidResult, new String[] { "revokeStatus", "revokeReason", "id" })) {
                    MessageDialog.openShortMessage(supplier.getSupplierName() + "已取消废标！");
                    List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(tenderProject.getId(), supplier.getId());
                    refreshSupplierOpenBidResult(supplier, bidPriceResultList, gridItem);
                }
            }
        } else {
            final RevokeSupplierDialog dialog = new RevokeSupplierDialog(getShell(), tenderProject, supplier, new RevokeSupplierDialog.RevokeSupplierListener() {
                public void revoke(boolean revoke, SupplierOpeningResult supplierOpeningResult) {
                    supplier.setSupplierOpeningResult(supplierOpeningResult);
                    openbidResult.setRevokeStatus(supplierOpeningResult.getRevokeStatus());
                    List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(tenderProject.getId(), supplier.getId());
                    refreshSupplierOpenBidResult(supplier, bidPriceResultList, gridItem);
                }
                
            });
            dialog.open();
        }
    }
	
	/**
	 * @Description: 开标一览表管理
	 * @author guoyr 
	 */
	private void addSubbidPriceAction(){
		if(!addSubbidPriceBtn.getEnabled()){
			return;
		}
		BidPriceSubItemDialog subBidPriceDialog = new BidPriceSubItemDialog(getShell(), tenderProject, projectRule, menuFunctionUtils);
		subBidPriceDialog.setTitle(Messages.Button_configBidOpiningList);
		subBidPriceDialog.open();
		refreshBidPriceTable();
	}
	
	/**
	 * @Description: 补录开标一览表
	 * @author guoyr 
	 */
	private void editBidPriceTableAction(){
		if(!editBidPriceBtn.getEnabled()){
			return;
		}
		if(null == curSupplier){
			MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_pleaseSelect, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType())));
			return;
		}
		SupplementBriceDialog dialog = new SupplementBriceDialog(getShell(), tenderProject, projectRule, curSupplier,menu);
		dialog.open();
		refreshBidPriceTable();
	}
	
	/**
	 * @Description: 导出结果线程
	 * @author guoyr 
	 */
	private void exportOpenbidResultAction(){
		if(export_result_btn.getEnabled()){
			String outFilePath = FileDialogUtils.getFileSavePath("["+tenderProject.getTenderNo()+"]" + tenderProject.getTenderName()+com.gx.obe.components.core.enumeration.TenderProjectEnum.getOpenBidEnum(tenderProject.getPhaseType())+"结果", Messages.Button_saveAs, new String[]{"*.xml"}, new String[]{"xml文件(*.xml)"});
			if(null != outFilePath && outFilePath.trim().length() > 0){
				export_result_btn.setEnabled(false);
				ExportBidOpenResultThread thread = new ExportBidOpenResultThread(tenderProject, outFilePath, new CallBack() {
					public void after() {
						Display.getDefault().syncExec(new Runnable() {
							
							public void run() {
								MessageDialog.openInformation(getShell(), MessageFormat.format(Messages.Tips_exportSuccessFormat, Messages.BidOpeningResult));
								export_result_btn.setText(Messages.Button_exportBidOpeningResult);
								export_result_btn.setEnabled(true);
							}
						});
						
					}
					
					public void callBackError(String error) {
						MessageDialog.openError(getShell(), error);
						export_result_btn.setText(Messages.Button_exportBidOpeningResult);
						export_result_btn.setEnabled(true);
						
					}
				});
				thread.start();
			}
		}
		
	}
	
	/**
	 * @Description: 导入结果
	 * @author guoyr 
	 */
	private void importOpenbidResultAction(){
		if(import_result_btn.getEnabled()){
			importBidOpeningStage = com.gx.obe.components.core.enumeration.TenderProjectEnum.BID_OPENING_ONE_STAGE;
			if(null != projectRule.getBidOpeningStage() && projectRule.getBidOpeningStage().equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.BID_OPENING_TWO_STAGE)){
				SelectBidOpeningStageComfirmShell shell = new SelectBidOpeningStageComfirmShell(getShell(), tenderProject, new SelectBidOpeningStageListener() {
					public void selectBidOpeningStage(String bidOpeningStage) {
						importBidOpeningStage = bidOpeningStage;
						importBidOpenResult();
					}
				});
				shell.open();
			}else{
				importBidOpenResult();
			}
		}
	}
	
	/**
	 * @Description: 导入开标结果线程
	 * @author guoyr 
	 */
	private void importBidOpenResult(){
		String outFilePath = FileDialogUtils.getFileNames(SWT.SINGLE, "请选择开标结果", new String[]{"*.xml"});
		if(null != outFilePath && outFilePath.trim().length() > 0){
			import_result_btn.setEnabled(false);
			ImportBidOpenResultThread thread = new ImportBidOpenResultThread(tenderProject, outFilePath, importBidOpeningStage, new CallBack() {
				public void after() {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							MessageDialog.openShortMessage("导入成功！");
							import_result_btn.setEnabled(true);
							refreshBidPriceTable();
						}
					});
				}
				public void callBackError(final String error) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							MessageDialog.openError(getShell(), error);
							import_result_btn.setEnabled(true);
						}
					});
				}
				
			});
			thread.start();
		}
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	
}
