package com.gx.obe.common.composite;

import java.text.MessageFormat;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.common.widget.composite.TipsComposite;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningResutTips extends TipsComposite {

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningResutTips(Composite parent, int style) {
		super(parent, style);
		
	}

	public void refresh(TenderProjectEntity tenderProject, MenuFunctionUtils menuFunctionUtils){
		for(Control control : this.getTipsParent().getChildren()){
			control.dispose();
		}
		if(com.gx.obe.components.core.enumeration.TenderProjectEnum.REMOTE.equals(tenderProject.getRemoteStatus())){ 
			addTips(Messages.Tips_wholeProcessStep, null, SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
			StringBuilder tips = new StringBuilder();
			addTips(MessageFormat.format(Messages.Tips_wholeProcessStep_1, Messages.Terminal_bidopening));
			addTips(MessageFormat.format(Messages.Tips_wholeProcessStep_2, Messages.Terminal_management));
			addTips(tips.toString());
			addTips(MessageFormat.format(Messages.Tips_wholeProcess, Messages.Terminal_bidopening), ColorConstants.FONT_RED_COLOR, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		}else {
//		if(TenderProjectEnum.HALF_PROCESS.equals(tenderProject.getRemoteStatus())){
			addTips(Messages.Tips_halfProcessStep, null, SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
			StringBuilder tips = new StringBuilder();
			tips.append(MessageFormat.format(Messages.Tips_halfProcessStep_1, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType())));
			tips.append(Messages.Tips_halfProcessStep_2);
			tips.append(MessageFormat.format(Messages.Tips_halfProcessStep_3, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType())));
			tips.append(MessageFormat.format(Messages.Tips_halfProcessStep_4, Messages.Button_complateBidOpening));
			tips.append(MessageFormat.format(Messages.Tips_halfProcessStep_5, Messages.Button_uploadBidOpeningResult));
			tips.append(MessageFormat.format(Messages.Tips_halfProcessStep_6, Messages.Terminal_management));
			addTips(tips.toString());
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("UPLOAD_SAME_DAY"))){
				addTips(Messages.Tips_uploadBidOpeningResult, ColorConstants.FONT_RED_COLOR, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
			}
		} 
		
		Composite statusTips = new Composite(getTipsParent(), SWT.NONE); 
		GridLayout gridLayout = new GridLayout(4, false);
		gridLayout.marginWidth = 0;
		statusTips.setLayout(gridLayout);
		
		Label complateStatusTitle = new Label(statusTips, SWT.NONE);
		complateStatusTitle.setText(Messages.BidOpeningStatus +"：");
		complateStatusTitle.setForeground(ColorConstants.FONT_BLACK_COLOR);
		complateStatusTitle.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		Label complateStatus = new Label(statusTips, SWT.NONE);
		complateStatus.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		if(CommonEnum.COMPLETE.equals(tenderProject.getBidOpeningStatus())){
			complateStatus.setText(Messages.OpeningStatus_opend);
			complateStatus.setForeground(ColorConstants.FONT_BLUE_COLOR);
		}else if(CommonEnum.IN_PROGRESS.equals(tenderProject.getBidOpeningStatus())){
			complateStatus.setText(Messages.Progress_inProgress);
			complateStatus.setForeground(ColorConstants.FONT_BLUE_COLOR);
		}else {
			complateStatus.setText(Messages.OpeningStatus_none);
			complateStatus.setForeground(ColorConstants.FONT_BLACK_COLOR);
		}
		
		if(null != tenderProject.getTransactionServerId()){
			Label updateStatusTitle = new Label(statusTips, SWT.NONE);
			updateStatusTitle.setText("        "+Messages.BidOpeningResult);
			updateStatusTitle.setForeground(ColorConstants.FONT_BLACK_COLOR);
			updateStatusTitle.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
			
			CLabel uploadStatus = new CLabel(statusTips, SWT.NONE);
			uploadStatus.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
			if(CommonEnum.COMPLETE.equals(tenderProject.getUploadOpeningResultStatus())){
				uploadStatus.setText(Messages.UploadStatus_yes);
				uploadStatus.setForeground(ColorConstants.FONT_BLUE_COLOR);
			}else {
				uploadStatus.setText(Messages.UploadStatus_no);
				uploadStatus.setForeground(ColorConstants.FONT_RED_COLOR);
			}
		}
		layout();
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
