package com.gx.obe.common.composite;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 招标文件
 * @author guoyr
 */
public class BiddingFileComposite extends Composite {

	private Composite composite;
	private CLabel file_name;
	private ELink lblNewLabel_1;
	private Label lblNewLabel_2;
	private File file;
	private CallBack callBack;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BiddingFileComposite(Composite parent, int style, File file, Image fileIco, CallBack callBack) {
		super(parent, style);
		addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
		this.file = file;
		this.callBack = callBack;
//		setBackground(SWTResourceManager.getColor(192, 192, 192));
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		composite = new Composite(this, SWT.NONE);
		composite.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
		composite.setBackground(SWTResourceManager.getColor(255, 255, 255));
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		file_name = new CLabel(composite, SWT.NONE);
		file_name.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
		GridData gd_lblNewLabel = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		file_name.setImage(fileIco);
		file_name.setLayoutData(gd_lblNewLabel);
		file_name.setText("");
		
		lblNewLabel_2 = new Label(composite, SWT.NONE);
		lblNewLabel_2.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
		lblNewLabel_2.setText(FileUtils.getFileSize(file.length()));
		
		lblNewLabel_1 = new ELink(composite, SWT.NONE);
		lblNewLabel_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				deleteFile();
			}
		});
		lblNewLabel_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		lblNewLabel_1.setText(Messages.Button_delete);
		
	}

	/**
	 * 打开文件
	 */
	public void openFile(){
		RuntimeUtils.openFIle(file);
	}

	/**
	 * 文件删除操作
	 */
	public void deleteFile(){
		file.delete();
		callBack.after();
	}
	
	@Override
	protected void checkSubclass() {
	}

}
