package com.gx.obe.common.composite;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.answer.dialog.ImportAnswerQuestionDialog;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.common.file.adapter.ExportBidFileAdapter;
import com.gx.obe.common.file.dialog.BidFileLocalBorwseDialog;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.CollectionUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.expert.ExpertService;
import com.gx.tools.ca.CaInfo;
import com.gx.tools.ole.DocumentFactory;
import com.gx.tools.ole.DocumentLoader;
import com.gx.tools.utils.CaInfoUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 查看投标人投标文件
 * @author guoyr
 */
public class BrowseBidFileComposite extends Composite {

	private TenderProjectEntity tenderProject;
	private String bidFileType;
	private Composite evalContentComposite;
	private ImageResolver imageResolver = new ImageResolver();
	private SupplierService supplierService = new SupplierService();
	private ProjectRuleService projectRuleService ;
	private ExpertService expertService ;
	private SashForm sashForm;
	private Composite bidFileComposite;
	private Text supplierNameText;
	private Composite composite_10;
	private Composite rightComposite;
	private Composite composite_14;
	private List<Supplier> supplierList = new ArrayList<Supplier>();
	private CTabFolder bid_file_tabfolder;
	private String curSupplierId;
	private Composite composite_3;
	private Composite composite_5;
	private Composite supplierComposite;
	private Grid supplierGrid;
	private Composite supplierBidFileComposite;
	private Grid bidFileGrid;
	private Supplier selectSupplier;
	private int bidFileCacheCount = 5;
	private ELink viewInquireEnvelopLink;
	private boolean viewBidPrice = true;
	private boolean useSpecialPdf = true;
	private Expert expert;
	private List<BidFile> bidFileList;
	private Menu menu;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	
	{
		LogUtils.logClass(BrowseBidFileComposite.class);
	}
	
	/**
	 * @param parent
	 * @param style
	 */
	public BrowseBidFileComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		setLayout(gridLayout);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
				if(null != supplierList){
					supplierList.clear();
				}
			}
		});
		this.tenderProject = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		this.bidFileType = (String)parent.getData("bidFileType");
		this.menu = (Menu)parent.getData("menu");
		if (StringUtils.isEmpty(bidFileType)) {
			bidFileType = BidFile.PUBLIC_BID_FILE;
		}
		
		evalContentComposite = new Composite(this, SWT.NONE);
		evalContentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_evalContentComposite = new GridLayout(1, false);
		gl_evalContentComposite.verticalSpacing = 0;
		gl_evalContentComposite.horizontalSpacing = 0;
		gl_evalContentComposite.marginHeight = 0;
		gl_evalContentComposite.marginWidth = 0;
		evalContentComposite.setLayout(gl_evalContentComposite);
		
		composite_14 = new Composite(evalContentComposite, SWT.NONE);
		composite_14.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_14 = new GridLayout(1, false);
		gl_composite_14.verticalSpacing = 0;
		gl_composite_14.horizontalSpacing = 0;
		gl_composite_14.marginHeight = 0;
		gl_composite_14.marginWidth = 0;
		composite_14.setLayout(gl_composite_14);
		
		Composite composite_1 = new Composite(composite_14, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(3, false);
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		
		supplierNameText = new Text(composite_1, SWT.READ_ONLY);
		supplierNameText.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		supplierNameText.setText("");
		supplierNameText.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		supplierNameText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		viewInquireEnvelopLink = new ELink(composite_1, SWT.NONE);
		viewInquireEnvelopLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/question.png"));
		viewInquireEnvelopLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				viewInquireEnvelopAction();
			}
		});
		viewInquireEnvelopLink.setText("澄清答疑文件");
		
		ESepator topSep = new ESepator(composite_14, SWT.SEPARATOR | SWT.HORIZONTAL);
		topSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		topSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		sashForm = new SashForm(composite_14, SWT.NONE);
		sashForm.setSashWidth(0);
		sashForm.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		sashForm.setOrientation(SWT.VERTICAL);
		
		bidFileComposite = new Composite(sashForm, SWT.NONE);
		bidFileComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_bidFileComposite = new GridLayout(2, false);
		gl_bidFileComposite.verticalSpacing = 0;
		gl_bidFileComposite.horizontalSpacing = 0;
		gl_bidFileComposite.marginHeight = 0;
		gl_bidFileComposite.marginWidth = 0;
		bidFileComposite.setLayout(gl_bidFileComposite);
		
		composite_10 = new Composite(bidFileComposite, SWT.NONE);
		composite_10.setLayout(new FillLayout(SWT.HORIZONTAL));
		composite_10.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		bid_file_tabfolder = new CTabFolder(composite_10, SWT.FLAT);
		bid_file_tabfolder.setTabHeight(0);
		
		rightComposite = new Composite(bidFileComposite, SWT.NONE);
		GridData gd_rightComposite = new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1);
		gd_rightComposite.widthHint = 200;
		rightComposite.setLayoutData(gd_rightComposite);
		GridLayout gl_rightComposite = new GridLayout(2, false);
		gl_rightComposite.verticalSpacing = 0;
		gl_rightComposite.horizontalSpacing = 0;
		gl_rightComposite.marginWidth = 0;
		gl_rightComposite.marginHeight = 0;
		rightComposite.setLayout(gl_rightComposite);
		
		ESepator v_sep = new ESepator(rightComposite, SWT.SEPARATOR | SWT.VERTICAL);
		v_sep.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 3));
		v_sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		composite_3 = new Composite(rightComposite, SWT.NONE);
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 0;
		gl_composite_3.marginHeight = 0;
		gl_composite_3.marginWidth = 0;
		composite_3.setLayout(gl_composite_3);
		GridData gd_composite_3 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite_3.heightHint = 200;
		composite_3.setLayoutData(gd_composite_3);
		
		ImageButton supplierTitle = new ImageButton(composite_3, SWT.NONE);
		supplierTitle.setLeftMargin(10);
		supplierTitle.setRightMargin(10);
		supplierTitle.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		supplierTitle.setBackground(ColorConstants.SKIN_BG);
		supplierTitle.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		supplierTitle.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		supplierTitle.setText(com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType()));
		
		ESepator supplierTitleSep = new ESepator(composite_3, SWT.NONE);
		supplierTitleSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		supplierTitleSep.setBackground(ColorConstants.SKIN_BG);
		supplierTitleSep.setLineWidth(2);
		
		supplierComposite = new Composite(composite_3, SWT.NONE);
		supplierComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
		
		supplierGrid = new Grid(supplierComposite, SWT.V_SCROLL);
		
		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.NONE);
		gridColumn.setText("New Column");
		gridColumn.setWidth(150);
		gridColumn.setWordWrap(true);
		
		composite_5 = new Composite(rightComposite, SWT.NONE);
		GridLayout gl_composite_5 = new GridLayout(2, false);
		gl_composite_5.verticalSpacing = 0;
		gl_composite_5.marginHeight = 0;
		gl_composite_5.marginWidth = 0;
		composite_5.setLayout(gl_composite_5);
		GridData gd_composite_5 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite_5.heightHint = 200;
		composite_5.setLayoutData(gd_composite_5);
		sashForm.setWeights(new int[] {6});
		
		ImageButton bidFileTitle = new ImageButton(composite_5, SWT.NONE);
		bidFileTitle.setLeftMargin(10);
		bidFileTitle.setRightMargin(10);
		bidFileTitle.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		bidFileTitle.setBackground(ColorConstants.SKIN_BG);
		bidFileTitle.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		bidFileTitle.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		bidFileTitle.setText("投标分册");
		
		ELink moreTools = new ELink(composite_5, SWT.NONE);
		moreTools.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"));
		moreTools.setText("标书设置");
		moreTools.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				moreConfigAction();
			}
		});
		menuFunctionUtils.addFunction(moreTools, "BID_FILE_SITE");
		
		ESepator bidFileSep = new ESepator(composite_5, SWT.NONE);
		bidFileSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		bidFileSep.setBackground(ColorConstants.SKIN_BG);
		bidFileSep.setLineWidth(2);
		
		supplierBidFileComposite = new Composite(composite_5, SWT.NONE);
		supplierBidFileComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		supplierBidFileComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
		
		bidFileGrid = new Grid(supplierBidFileComposite, SWT.V_SCROLL);
		
		GridColumn gridColumn_1 = new GridColumn(bidFileGrid, SWT.NONE);
		gridColumn_1.setText("New Column");
		gridColumn_1.setWidth(150);
		gridColumn_1.setWordWrap(true);
		
		init();
	}

	/**
	 * @Description: 初始化界面数据
	 * @author guoyr
	 */
	private void init(){
		expertService = new ExpertService();
		projectRuleService = new ProjectRuleService();
		expert = expertService.getExpert(tenderProject.getId(), Constants.USER.getId());
		TenderProjectRuleEntity tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProject.getId());
		// 根据规则设置的查看价格相权限
		if(ObjectUtils.equals(tenderProjectRuleEntity.getViewBidPrice() , CommonEnum.NO)){
			viewBidPrice = false;
		}
		
		showSupplierList();
		
		//缓存5家供应商的标书文件
		try {
			bidFileCacheCount  = Integer.parseInt(PropertiesUtils.getProperty(ConfigConstants.BIDFILE_CACHE_COUNT, "5"));
			if(bidFileCacheCount < 1){
				bidFileCacheCount = 1;
			}
		} catch (NumberFormatException e) {
		}
		
		// 投标人
		supplierGrid.setAutoHeight(true);
		supplierGrid.addListener(SWT.Selection, new GridSelectionListener(){// 添选中事件和右键菜单事件
			@Override
			public void leftMouseButtonDown(GridItem item) {
				selectSupplierAction();
			}
			@Override
			public void rightMouseButtonDown(GridItem item) {
				mouseRightClickEventAction(selectSupplier, null);
			}
		});
		// 投标分册
		bidFileGrid.setAutoHeight(true);
		bidFileGrid.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void leftMouseButtonDown(GridItem item) {
				BidFile bidFile = (BidFile)item.getData("bidFile");
				String supplierId = null != selectSupplier ? ObjectUtils.getObjString(selectSupplier.getId()) : "";
				loadBidFileAction(supplierId, bidFile, "", "1");
			}
			@Override
			public void rightMouseButtonDown(GridItem item) {
				BidFile bidFile = (BidFile)item.getData("bidFile");
				mouseRightClickEventAction(selectSupplier, bidFile);
			}
		});
		menuFunctionUtils.initFunctionAuthority(menu);
	}
	
	/**
	 * @Description: 标书设置
	 * @author guoyr 
	 */
	private void moreConfigAction(){
		final ToolsShell moreToolsShell = new ToolsShell(getShell());
		Composite toolGroup = moreToolsShell.addToolBar(Messages.Title_bidFileLoadSetting, null, false);
		
		moreToolsShell.addTool(toolGroup, useSpecialPdf? Messages.Button_useUniversalControl : Messages.Button_useSpecialControl, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/pdf.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				useSpecialPdf = !useSpecialPdf;
				PropertiesUtils.saveProperty(ConfigConstants.USE_SPECIAL_PDF, useSpecialPdf ? "01" : "00");
				moreToolsShell.close();
				for(CTabItem tabItem : bid_file_tabfolder.getItems()){
					Control control  = tabItem.getControl();
					if(null != control && !control.isDisposed()){
						control.dispose();
					}
					bid_file_tabfolder.getItem(0).dispose();
				}
				selectSupplierAction();
			}
		});
		
		moreToolsShell.addTool(toolGroup, Messages.Button_viewLocalFiles, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/location.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				moreToolsShell.close();
				BidFileLocalBorwseDialog dialog = new BidFileLocalBorwseDialog(getShell(), tenderProject, selectSupplier, bidFileList, menuFunctionUtils);
				dialog.setTitle(selectSupplier.getSupplierName());
				dialog.open();
			}
		});
		moreToolsShell.setWidth(400);
		moreToolsShell.pack();
		moreToolsShell.open();
		SwtUtils.setCenter(moreToolsShell);
	}
	/**
	 * @Description: 右键点击事件
	 * @author guoyr
	 */
	private void mouseRightClickEventAction(Supplier supplier, File file){
		final EMenu gmenu = new EMenu(getShell());
		if(null != file) {
			if(null != menuFunctionUtils && MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.OPEN_BID_FILES_DIR))){
				gmenu.addMenuItem(Messages.Button_openDirectory, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/location.png"), null != file && file.isFile(), new EMenu.ClickListener() {
					public void click() { 
						RuntimeUtils.openDirectorAndSelect(file.getAbsolutePath());
					};
				});
			}
			gmenu.addMenuItem(Messages.Button_openFile, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/open.png"), null != file && file.isFile(), new EMenu.ClickListener() {
				public void click() { 
					if (Program.launch(file.getAbsolutePath())) {
					} else {
						RuntimeUtils.openFIle(file);
					}
				};
			});
		}
		gmenu.addMenuItem(Messages.Button_viewLocalFiles, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/location.png"), null != supplier, new EMenu.ClickListener() {
			public void click() {
				BidFileLocalBorwseDialog dialog = new BidFileLocalBorwseDialog(getShell(), tenderProject, supplier, bidFileList, menuFunctionUtils);
				dialog.setTitle(selectSupplier.getSupplierName());
				dialog.open();
			}
		});
		
		if(null != menuFunctionUtils && MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.EXPORT_BID_FILES))){
			gmenu.addMenuItem(Messages.Button_exportAll, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/open.png"), null != file && file.isFile(), new EMenu.ClickListener() {
				public void click() { 
					List<Supplier> supplierList = new ArrayList<Supplier>();
					supplierList.add(supplier);
					// 只导出当前投标人
					new ExportBidFileAdapter().exportFils(getShell(), tenderProject, supplierList);
				};
			});
		}
		
		gmenu.open();
	}
	
	/**
	 * @Description: 列出所有的投标人
	 * @author guoyr
	 */
	private void showSupplierList(){
		supplierNameText.setText("");
		supplierGrid.removeAll();
		supplierList.clear();
		// 获得开标成功的投标人列表
		supplierList = supplierService.getOpenBidSuccessSupplier(tenderProject.getId(), bidFileType);
		if(null != supplierList && supplierList.size() > 0){
			int supplierIndex = 1;
			for(final Supplier supplier : supplierList){
				GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setText(0, supplierIndex + "、" + ObjectUtils.getObjString(supplier.getSupplierName()));
				gridItem.setData("supplier", supplier);
				supplierIndex++;
			}
			supplierGrid.select(0);
		}
		selectSupplierAction();
	}

	/**
	 * @Description: 加载文件
	 * @author guoyr
	 * @param ID
	 * @param bidFile
	 * @param bookmark
	 * @param pageNumber
	 * @return
	 */
	private DocumentLoader loadBidFileAction(String ID, File bidFile, String bookmark, String pageNumber){
		CTabItem supplierTopTabItem = null;
		String pdfType = "";
		for(CTabItem item : bid_file_tabfolder.getItems()){
			if(ObjectUtils.equals(ID, (String)item.getData("ID"))){
				supplierTopTabItem = item;
				break;
			}
		}
		if(null == supplierTopTabItem){
			supplierTopTabItem = new CTabItem(bid_file_tabfolder, SWT.NONE);
			supplierTopTabItem.setText(ID);
			supplierTopTabItem.setData("ID", ID);
			Composite topFileContent = new Composite(bid_file_tabfolder, SWT.NONE);
			topFileContent.setLayout(new FillLayout(SWT.HORIZONTAL));
			supplierTopTabItem.setControl(topFileContent);
			CaInfo caInfo = CaInfoUtil.getCaType(tenderProject.getId(), ID);
			pdfType = caInfo.getPdfType();
			supplierTopTabItem.setData("pdfType", pdfType);
		}
		bid_file_tabfolder.setSelection(supplierTopTabItem);
		pdfType = (String)supplierTopTabItem.getData("pdfType");
		// 全部采用默认配置的PDF加载器加载
		pdfType = PropertiesUtils.getProperty(ConfigConstants.PDF_ACTIVE_TYPE, DocumentFactory.DEFAULT_PDF_TYPE);
		
		// 缓存5家供应商的标书文件
		if(bid_file_tabfolder.getItemCount() > bidFileCacheCount){
			Control control  = bid_file_tabfolder.getItem(0).getControl();
			if(null != control && !control.isDisposed()){
				control.dispose();
			}
			bid_file_tabfolder.getItem(0).dispose();
		}
		
		DocumentLoader documentLoader = null;
		// 如果存在分册
		if(null != bidFile && bidFile.exists() && bidFile.isFile()){
			CTabFolder supplierBidFileFolder = (CTabFolder)supplierTopTabItem.getData("supplierCTabFolder");
			if(null == supplierBidFileFolder){
				supplierBidFileFolder = new CTabFolder((Composite)supplierTopTabItem.getControl(), SWT.FLAT);
				supplierBidFileFolder.setTabHeight(0);
				supplierTopTabItem.setData("supplierCTabFolder", supplierBidFileFolder);
			}
			
			CTabItem supplierFileItem = null;
			for(CTabItem item : supplierBidFileFolder.getItems()){
				if(ObjectUtils.equals(bidFile.getAbsolutePath(), (String)item.getData("filePath"))){
					supplierFileItem = item;
					break;
				}
			}
			if(null == supplierFileItem){
				supplierFileItem = new CTabItem(supplierBidFileFolder, SWT.NONE);
				Composite bidFileTabItemContent = new Composite(supplierBidFileFolder, SWT.NONE);
				bidFileTabItemContent.setLayout(new FillLayout(SWT.HORIZONTAL));
				supplierFileItem.setControl(bidFileTabItemContent);
				supplierFileItem.setText(bidFile.getName());
				supplierFileItem.setData("filePath", bidFile.getAbsolutePath());
				documentLoader = DocumentFactory.getDocumentLoader(bidFile.getAbsolutePath(), useSpecialPdf ? pdfType : null);
				documentLoader.openDocument(bidFileTabItemContent, true);
				documentLoader.showOrHiddenToolBar(true);
				supplierFileItem.setData("documentLoader", documentLoader);
			}else {
				documentLoader = (DocumentLoader)supplierFileItem.getData("documentLoader");
			}
			supplierBidFileFolder.setSelection(supplierFileItem);
			supplierBidFileFolder.getParent().layout();
		}
		
		if(null != documentLoader){
			int page = 1;
			try {
				page = Integer.parseInt(pageNumber);
			} catch (NumberFormatException e) {
			}
			if(page < 1){
				page = 1;
			}
			if(null != bookmark){
				if(!documentLoader.bookmarkLocate(bookmark)){
					if(page > 0){
						documentLoader.gotoPage(page);
					}
				}
			}else {
				if(page > 0){
					documentLoader.gotoPage(page);
				}
			}
			documentLoader.activate();
		}
		
		return documentLoader;
	}
	
	/**
	 * @Description: 根据当前的投标人获得投标人的投标分册文件 ，并返回投标人的第一个分册
	 * @author guoyr
	 * @param supplier
	 */
	private void listSupplierBidFileAction(final Supplier supplier){
		if(ObjectUtils.equals(curSupplierId, supplier.getId())){
			return;
		}
		bidFileGrid.removeAll();
		bidFileList = BidFile.getBidFileExamineList(tenderProject.getId(), supplier.getId(), expert.getEvalBidTypeNotNull());
		
		CollectionUtils.filter(bidFileList, t -> {
			if (BidFile.PRIVATE_BID_FILE.equals(bidFileType)) {
				return t.isNotPublicBid();
			} else if (BidFile.PUBLIC_BID_FILE.equals(bidFileType)) {
				return !t.isNotPublicBid();
			}
			return false;
		});
		
		BidFile firstFile = null;
		int fileCount = 1;
		if(null != bidFileList && bidFileList.size() > 0){
			for (BidFile bidFile : bidFileList) {
				if (!viewBidPrice && BidFile.TYPE_BIDPRICE.equals(bidFile.getBidFileType())) {
					continue;
				}
				GridItem gridItem = new GridItem(bidFileGrid, SWT.NONE);
				gridItem.setText(fileCount + "、" + bidFile.getSimpleName());
				gridItem.setData("bidFile", bidFile);
				if (fileCount == 1) {
					firstFile = bidFile;
					bidFileGrid.setSelection(new GridItem[] { gridItem });
				}
				fileCount++;
			}
		}
		loadBidFileAction(supplier.getId(), firstFile, null, null);
	}
	
	
	/**
	 * @Description: 评审表格点击事件
	 * @author guoyr
	 */
	private void selectSupplierAction(){
		selectSupplier = null;
		if(null != supplierGrid && supplierGrid.getSelectionCount() > 0){
			selectSupplier = (Supplier)supplierGrid.getSelection()[0].getData("supplier");
			if(null != selectSupplier){
				supplierNameText.setText(ObjectUtils.getObjString(selectSupplier.getSupplierName()));
				listSupplierBidFileAction(selectSupplier);
			}
		}
	}
	
	/**
	 * @Description: 查看询标函
	 * @author guoyr 
	 */
	private void viewInquireEnvelopAction(){
//		InquireEnvelopListDialog dialog = new InquireEnvelopListDialog(Display.getDefault().getActiveShell(), tenderProjectEntity, selectSupplier, false);
//		dialog.setOperator(SWT.MAX | SWT.CLOSE);
//		dialog.setTitle("询标函－澄清通知");
//		dialog.open();
		
		ImportAnswerQuestionDialog dialog = new ImportAnswerQuestionDialog(getShell(), tenderProject, expert);
		dialog.setTitle("澄清答疑文件");
		dialog.open();
	}
	
	private void exportDecryptBidFileByProject() {
		new ExportBidFileAdapter().exportFils(getShell(), tenderProject, supplierList);
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
