/**  
 * Project Name:OBE-COMMON  
 * File Name:RoundPriceComposite.java  
 * Package Name:com.gx.obe.common.composite  
 * Date:Jun 23, 20184:27:49 PM  
 * Copyright (c) 2018, chenzhou1025@126.com All Rights Reserved.  
 *  
 */

package com.gx.obe.common.composite;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.tools.ole.DocumentFactory;
import com.gx.tools.ole.dianju.DianJuConstant;
import com.gx.tools.ole.jinge.JingeConstant;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description:指定供应商的澄清答复文件
 * @author wangxiang
 */
public class ClarifyAnswerComposite extends Composite {
	private Composite composite;
	private TenderProjectEntity tenderProjectEntity;
	private ELink questionFileNameLink;
	private ELink answerFileLink;
	private Label lastAnswerTimeLabel;
	private Label answerTimeTable;
	private Label answerTimeLabel;
	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 * @param roundNumMap 
	 */
	public ClarifyAnswerComposite(final Composite parent, int style) {
		super(parent, SWT.NONE);
//		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);

		composite = new Composite(this, SWT.NONE);
		
		GridLayout gl_composite = new GridLayout(4, false);
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Label label = new Label(composite, SWT.NONE);
		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		GridData gd_label = new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1);
		label.setLayoutData(gd_label);
		label.setText("澄清文件:");
		
		questionFileNameLink = new ELink(composite, SWT.NONE);
		questionFileNameLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		questionFileNameLink.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		questionFileNameLink.setText("");
		questionFileNameLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				openFile(questionFileNameLink);
			}
		});
		
		Label label_1 = new Label(composite, SWT.RIGHT);
		label_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		label_1.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label_1.setText("最晚答复时间:");
		
		lastAnswerTimeLabel = new Label(composite, SWT.NONE |SWT.LEFT);
		GridData gd_lastAnswerTimeLabel = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_lastAnswerTimeLabel.widthHint = 150;
		lastAnswerTimeLabel.setLayoutData(gd_lastAnswerTimeLabel);
		lastAnswerTimeLabel.setText("");
		
		Label label_3 = new Label(composite, SWT.NONE);
		label_3.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_3.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1));
		label_3.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_3.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label_3.setText("答复文件:");
		
		answerFileLink = new ELink(composite, SWT.NONE);
		answerFileLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		answerFileLink.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		answerFileLink.setText("");
		answerFileLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				openFile(answerFileLink);
			}
		});
		
		answerTimeTable = new Label(composite, SWT.RIGHT);
		answerTimeTable.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		answerTimeTable.setForeground(ColorConstants.FONT_BLACK_COLOR);
		answerTimeTable.setText("澄清答复时间:");
		
		answerTimeLabel = new Label(composite, SWT.NONE |SWT.LEFT);
		answerTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		GridData gd_answerTimeLabel = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_answerTimeLabel.widthHint = 150;
		answerTimeLabel.setLayoutData(gd_answerTimeLabel);
		answerTimeLabel.setText("");
		
		ESepator subLine = new ESepator(this, SWT.NONE);
		subLine.setBackground(ColorConstants.BORDER_LINE_COLOR);
		subLine.setLineStyle(SWT.LINE_DOT);
		subLine.setLineWidth(3);
		subLine.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		init();
	}

	/**
	 * @Description:初始化 
	 * @author wangxiang 
	 */
	private void init(){}
	

	/**
	 * @Description:刷新 
	 * @author wangxiang
	 * @param questionFileName
	 * @param lastAnswerTime
	 * @param questionFile
	 * @param answerStatues
	 * @param answerFileName
	 * @param answerTime
	 * @param answerFile 
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, String questionFileName, String lastAnswerTime, String questionFile, String answerStatues, String answerFileName, String answerTime, String answerFile) {
		this.tenderProjectEntity = tenderProjectEntity;
		questionFileNameLink.setText(questionFileName);
		questionFileNameLink.setData("file", questionFile);
		lastAnswerTimeLabel.setText(lastAnswerTime);
		if(CommonEnum.YES.equals(answerStatues)){
			answerFileLink.setText(answerFileName);
			answerFileLink.setData("file", answerFile);
			answerTimeLabel.setText(answerTime);
		}else{
			answerFileLink.setText("未答复");
			answerFileLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
			answerFileLink.setForeground(SWTResourceManager.getColor(255, 153, 0));
			answerTimeTable.setVisible(false);
		}
	}

	/**
	 * @Description: 打开文件
	 * @author wangxiang
	 * @param eLink 
	 */
	private void openFile(ELink eLink){
		String fileName = (String)eLink.getData("file");
		String answerQuestionFolder = FileConstants.getAnswerQuestionFilePath(tenderProjectEntity.getId()).concat(FileConstants.BID_FILE_FOLDER);
		if (null == fileName) {
			MessageDialog.openShortMessage("文件不存在");
			return;
		}
		File bidFile = new File(answerQuestionFolder.concat(File.separator).concat(fileName));
		if (!bidFile.exists()) {
			MessageDialog.openShortMessage("文件不存在");
			return;
		} else {
			if (bidFile.getName().endsWith(".pdf")) {
				String pdfExe = "explorer.exe";
				String pdfType = PropertiesUtils.getProperty(ConfigConstants.PDF_ACTIVE_TYPE, DocumentFactory.DEFAULT_PDF_TYPE);
				if (pdfType.equals(DianJuConstant.PDF_TYPE)) {
					pdfExe = DianJuConstant.EXE;
				} else if (pdfType.equals(JingeConstant.PDF_TYPE)) {
					pdfExe = JingeConstant.EXE;
				}
				RuntimeUtils.openFIle(bidFile, pdfExe);
			} else {
				RuntimeUtils.openFIle(bidFile);
			}
		}
		
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
