package com.gx.obe.common.composite;

import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.ColorConstants;
import com.gx.obe.web.entity.EvaluationFactorResult;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.BigDecimalUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.ExpertEvaluationResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.evaluation.EvaluationFactorResultService;
import com.gx.obe.web.service.evaluation.EvaluationFactorService;
import com.gx.obe.web.service.expert.ExpertEvaluationResultService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 
 * @author guoyr
 */
public class ComplianceFactorsComposite extends Composite {

	private Grid factors_grid;
	private GridColumn gridColumn;
	private ImageResolver imageResolver = new ImageResolver();
	private Image menuOpenImage;
	private Image menuImage;
	private EvaluationFactor curFactor;
	private TenderProjectEntity tenderProjectEntity;
	private ScrolledComposite scrolledComposite;
	private Composite scroContentComposite;
	private Composite composite_1;
	private EvaluationFactorService evaluationFactorService = new EvaluationFactorService();
	private ExpertEvaluationStepService expertEvaluationStepService ;;
	private EvaluationFactorResultService evaluationFactorResultService = new EvaluationFactorResultService();
	private ExpertEvaluationResultService expertEvaluationResultService;
	private AIScoreSingleEvaluationTableComposite aiScoreSingleEvaluationTableComposite;
	private EvaluationStep evaluationStep;
	private List<Supplier> supplierList;
	private AuthUser curUser;
	private boolean resultChanged = false;
	private List<EvaluationFactor> evaluationFactorList = new ArrayList<EvaluationFactor>();
	// 记录供应商每个指标的评审结果
	private Map<String, Map<String, EvaluationFactorResult>> supplierEvaluationFactorResultMap;
	// 记录专家对供应商的评审汇总结果
	private Map<String, ExpertEvaluationResult> expertEvaluationResultMap;
	private int maxLevel;
	private Composite composite_3;
	private Composite composite_4;
	private Composite composite_5;
	private Composite composite_6;
	private Composite composite_10;
	private EButton submit_result_btn;
	private Composite composite_2;
	private StyledText evaluation_factor_memo;
	private EButton close_btn;
	{
		LogUtils.logClass(ComplianceFactorsComposite.class);
	}
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public ComplianceFactorsComposite(Composite parent, int style) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gridLayout = new GridLayout(2, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 10;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
			}
		});
		
		composite_1 = new Composite(this, SWT.NONE);
		composite_1.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridData gd_composite_1 = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_composite_1.widthHint = 300;
		composite_1.setLayoutData(gd_composite_1);
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 0;
		gl_composite_1.marginHeight = 1;
		gl_composite_1.marginWidth = 1;
		composite_1.setLayout(gl_composite_1);

		Composite composite_8 = new Composite(composite_1, SWT.NONE);
		composite_8.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_8.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_8 = new GridLayout(1, false);
		gl_composite_8.verticalSpacing = 0;
		gl_composite_8.marginHeight = 0;
		gl_composite_8.marginWidth = 0;
		composite_8.setLayout(gl_composite_8);
		
		
		factors_grid = new Grid(composite_8, SWT.V_SCROLL);
		factors_grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		gridColumn = new GridColumn(factors_grid, SWT.NONE);
		gridColumn.setText("指标");
		gridColumn.setWidth(200);
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginHeight = 1;
		gl_composite.marginWidth = 1;
		gl_composite.verticalSpacing = 1;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		composite_2 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginHeight = 0;
		gl_composite_2.marginWidth = 0;
		composite_2.setLayout(gl_composite_2);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		CLabel factorLabel = new CLabel(composite_2, SWT.NONE);
		factorLabel.setBackground(ColorConstants.BORDER_LINE_COLOR);
		factorLabel.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, false, false, 1, 1));
		factorLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_blue.png"));
		
		evaluation_factor_memo = new StyledText(composite_2, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
		evaluation_factor_memo.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		evaluation_factor_memo.setText("");
		GridData gd_evaluation_factor_memo = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_evaluation_factor_memo.heightHint = 58;
		gd_evaluation_factor_memo.widthHint = 500;
		evaluation_factor_memo.setLayoutData(gd_evaluation_factor_memo);
		
		
		scrolledComposite = new ScrolledComposite(composite, SWT.V_SCROLL );
		scrolledComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
//		composite_4 = new Composite(scrolledComposite, SWT.NONE);
//		scrolledComposite.setContent(composite_4);
//		scrolledComposite.setMinSize(composite_4.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		scroContentComposite = new Composite(scrolledComposite, SWT.NONE);
		GridLayout gl_scroContentComposite = new GridLayout(1, false);
		gl_scroContentComposite.marginHeight = 1;
		gl_scroContentComposite.marginWidth = 1;
		scroContentComposite.setLayout(gl_scroContentComposite);
		aiScoreSingleEvaluationTableComposite = new AIScoreSingleEvaluationTableComposite(scroContentComposite, SWT.NONE);
		aiScoreSingleEvaluationTableComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		aiScoreSingleEvaluationTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		scroContentComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
		
//		composite_5 = new Composite(scroContentComposite, SWT.NONE);
//		
//		composite_6 = new Composite(scroContentComposite, SWT.NONE);
//		scroContentComposite.setLayout(new GridLayout(1, false));
		
//		composite_3 = new Composite(scroContentComposite, SWT.NONE);
//		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		scrolledComposite.setContent(scroContentComposite);
		scrolledComposite.setMinSize(scroContentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		Composite composite_bt = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_bt = new GridLayout(1, false);
		gl_composite_bt.marginHeight = 0;
		gl_composite_bt.marginWidth = 0;
		composite_bt.setLayout(gl_composite_bt);
		composite_bt.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		composite_bt.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		composite_10 = new Composite(composite_bt, SWT.NONE);
		composite_10.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_10.setLayout(new GridLayout(2, false));
		composite_10.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		EButton submit_result_btn = new EButton(composite_10, SWT.NONE | EButton.CSS_GREEN);
		GridData gd_submit_result_btn = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_submit_result_btn.heightHint = 30;
		gd_submit_result_btn.widthHint = 90;
		submit_result_btn.setLayoutData(gd_submit_result_btn);
		submit_result_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		submit_result_btn.setText(Messages.Button_confirm);
		submit_result_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/save.png"));
		submit_result_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveAction();
			}
		});
		
		EButton close_btn = new EButton(composite_10, SWT.NONE | EButton.CSS_GREEN);
		GridData gd_close_btn = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_close_btn.heightHint = 30;
		gd_close_btn.widthHint = 90;
		close_btn.setLayoutData(gd_close_btn);
		close_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		close_btn.setText(Messages.Button_return);
		close_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/back.png"));
		close_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		
		init();
	}
	/**
	 * @Description: 界面信息初始化
	 * @author guoyr 
	 */
	private void init(){
		expertEvaluationResultService = new ExpertEvaluationResultService();
		expertEvaluationStepService = new ExpertEvaluationStepService();
		factors_grid.setItemHeight(Constants.ROW_HIGHT);
		factors_grid.setLinesVisible(false);
		gridColumn.setShowTreeTogglePic(true);
		gridColumn.setTreeTogglePic(ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_expend.png"), ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_close.png"));
		gridColumn.setTree(true);
		menuOpenImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_parent.png");
		menuImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_item.png");
		// 添选中事件和右键菜单事件
		factors_grid.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void leftMouseButtonDown(GridItem item) {
				selectionFactorAction(false);
			}
			@Override
			public void rightMouseButtonDown(GridItem item) {
			}
		});
		
	}
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity projectRule1, AuthUser user, EvaluationStep evaluationStep, List<Supplier> supplierList){
			this.evaluationStep = evaluationStep;
			this.tenderProjectEntity = tenderProjectEntity;
			this.supplierList = supplierList;
			this.curUser = user;
			// 修改评标专家的评审记录
			expertEvaluationStepService.updateExpertEvaluationStatus(CommonEnum.IN_PROGRESS, tenderProjectEntity.getId(), evaluationStep, curUser.getId());
			initEvaluationResult();
			refreshFactorTree(null);
			
			if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)){
				resultChanged  = true;
			}
			
	}
	
	/**
	 * @Description: 刷新指标树
	 * @author guoyr
	 * @param factorId 
	 */
	public void refreshFactorTree(String factorId){
		factors_grid.removeAll();
		List<EvaluationFactor> evaluationFactorList = evaluationFactorService.getAllEvaluationFactorList(tenderProjectEntity.getId(), EvaluationFactorEnum.AUDIT_SCORE);
		if(null != evaluationFactorList && evaluationFactorList.size() > 0){
			for(EvaluationFactor factor : evaluationFactorList){
				GridItem gridItem = new GridItem(factors_grid, SWT.NONE);
				initChildGridItem(factor, gridItem, factorId);
			}
		}
		if(factors_grid.getSelectionCount() == 0){
			if(factors_grid.getItemCount() > 0){
				factors_grid.select(0);
			}
		}
		selectionFactorAction(true);
		Rectangle rectangle = factors_grid.getBounds();
		factors_grid.scroll(0, 0, 0, 0, rectangle.width, rectangle.height, true);
		factors_grid.getVerticalBar().setSelection(factors_grid.getSelectionIndex()- 5);
		factors_grid.getVerticalBar().notifyListeners(SWT.Selection, null);
	}
	
	/**
	 * @Description: 递归实现指标树
	 * @author guoyr
	 * @param factor
	 * @param parentGridItem
	 * @param selectId 
	 */
	private void initChildGridItem(EvaluationFactor factor, GridItem parentGridItem, String selectId){
		if(null != factor.getChildFactorList() && factor.getChildFactorList().size() > 0){
			for(EvaluationFactor childFactor : factor.getChildFactorList()){
				GridItem gridItem = new GridItem(parentGridItem, SWT.NONE);
				initChildGridItem(childFactor, gridItem, selectId);
			}
			parentGridItem.setExpanded(true);
			parentGridItem.setImage(0, menuOpenImage);
		}else {
			parentGridItem.setImage(0, menuImage);
		}
		setFactorItemContent(factor, parentGridItem, false);
		parentGridItem.setToolTipText(0, parentGridItem.getText());
		if(null != selectId && selectId.equals(factor.getId())){
			factors_grid.setSelection(new GridItem[]{parentGridItem});
		}
	}
	
	/**
	 * @Description: 选中指标
	 * @author guoyr 
	 */
	private void selectionFactorAction(boolean isInit){
		EvaluationFactor evaluationFactor = getSelectionEvaluationFactor();
		resultClickEventAction(evaluationFactor);
		if(isInit ){
			evaluationFactor = new EvaluationFactor();
			evaluationFactor.setId(UuidUtils.getUUID());
			evaluationFactor.setFactorCode("");
			evaluationFactor.setFactorName("");
		}else{
			if(evaluationFactor.getChildCount() > 0){
				evaluationFactor = new EvaluationFactor();
				evaluationFactor.setId(UuidUtils.getUUID());
				evaluationFactor.setFactorCode("");
				evaluationFactor.setFactorName("");
			}
		}
		aiScoreSingleEvaluationTableComposite.refresh(tenderProjectEntity, null, Constants.USER, evaluationStep, evaluationFactor, supplierList);
		scroContentComposite.layout();
		scrolledComposite.setMinSize(scroContentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		scrolledComposite.forceFocus();
	}

	
	/**
	 * @Description: 获得当前选中的指标
	 * @author guoyr
	 * @return 
	 */
	private EvaluationFactor getSelectionEvaluationFactor(){
		EvaluationFactor factor = null;
		if(factors_grid.getSelectionCount() > 0){
			factor = (EvaluationFactor)factors_grid.getSelection()[0].getData("evaluationFactor");
		}
		return factor;
	}
		
	/**
	 * @Description: 设置指标树的内容
	 * @author guoyr
	 * @param factor
	 * @param gridItem
	 * @param refresh 
	 */
	private void setFactorItemContent(EvaluationFactor factor, GridItem gridItem, boolean refresh){
		gridItem.setData("evaluationFactor", factor);
		gridItem.setText(0, factor.getFactorName());
		// 如果是客观项指标
		if(ObjectUtils.equals(factor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
			// 如果即是客观项指标，又是浮动指标
			if(null != factor.getContainFactor()){
				gridItem.setForeground(0,SWTResourceManager.getColor(SWT.COLOR_DARK_RED));
			}else {
				gridItem.setForeground(0,SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
			}
		}else if(null != factor.getContainFactor()){
			// 如果是浮动指标
			gridItem.setForeground(0,SWTResourceManager.getColor(SWT.COLOR_DARK_MAGENTA));
		}else if(refresh){
			gridItem.setForeground(0,null);
		}
	}
	/**
	 * @Description: 初始化评标结果
	 * @author guoyr 
	 */
	private void initEvaluationResult(){
		if(null == evaluationFactorList)evaluationFactorList = new ArrayList<EvaluationFactor>();
		initEvaluationStepFactor();
		
		// 记录供应商每个指标的评审结果
		supplierEvaluationFactorResultMap = new HashMap<String, Map<String, EvaluationFactorResult>>();
		// 记录专家对供应商的评审汇总结果
		expertEvaluationResultMap = new HashMap<String, ExpertEvaluationResult>();
		
		// 评审当前评标专家所有的评标结果
		List<EvaluationFactorResult> memberEvaluateFactorResultList = evaluationFactorResultService.getExpertEvaluationFactorResult(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId(), null);
		List<ExpertEvaluationResult> queryExpertEvaluationResultList = expertEvaluationResultService.getExpertStepAllSupplierEvaluationResultList(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId());

		Supplier firstSupplier = null;
		EvaluationFactor firstEvaluationFactor = null;
		EvaluationFactorResult firstEvaluationFactorResult = null;
		
		for(Supplier supplier : supplierList){
			// 获取评标专家对投标人的评审记录
			ExpertEvaluationResult expertEvaluationResult = null;
			if(null != queryExpertEvaluationResultList && queryExpertEvaluationResultList.size() > 0){
				for(ExpertEvaluationResult queryExpertEvaluationResult : queryExpertEvaluationResultList){
					if(ObjectUtils.equals(queryExpertEvaluationResult.getSupplierId(), supplier.getId())){
						expertEvaluationResult = queryExpertEvaluationResult;
					}
				}
			}
			if(null == expertEvaluationResult){
				expertEvaluationResult = new ExpertEvaluationResult();
				expertEvaluationResult.setTenderId(tenderProjectEntity.getId());
				expertEvaluationResult.setStepId(evaluationStep.getId());
				expertEvaluationResult.setUserId(curUser.getId());
				expertEvaluationResult.setSupplierId(supplier.getId());
			}
			
			Map<String, EvaluationFactorResult> evaluationFactorResultMap = new HashMap<String, EvaluationFactorResult>();
			int evalPassNoCount = 0;
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				
				// 获得已评审的结果
				EvaluationFactorResult  evalFactorResult = null;
				if(null != memberEvaluateFactorResultList && memberEvaluateFactorResultList.size() > 0){
					for(EvaluationFactorResult factorResult : memberEvaluateFactorResultList){
						if(ObjectUtils.equals(supplier.getId(), factorResult.getSupplierId()) && ObjectUtils.equals(evaluationFactor.getId(), factorResult.getFactorId())){
							evalFactorResult = factorResult;
							break;
						}
					}
				}
				if(null == evalFactorResult){
					evalFactorResult = new EvaluationFactorResult();
					evalFactorResult.setTenderId(tenderProjectEntity.getId());
					evalFactorResult.setStepId(evaluationStep.getId());
					evalFactorResult.setUserId(curUser.getId());
					evalFactorResult.setSupplierId(supplier.getId());
					evalFactorResult.setFactorId(evaluationFactor.getId());
					evalFactorResult.setFactorName(evaluationFactor.getFactorName());
					evalFactorResult.setId(UuidUtils.getUUID());
				}
				if(null != evalFactorResult.getEvaluationResult() && evalFactorResult.getEvaluationResult().equals(EvaluationFactorEnum.UNCONFORM)){
					evalPassNoCount ++;
				}
				evaluationFactorResultMap.put(evaluationFactor.getId(), evalFactorResult);
				
//				// 如果是客观项，检查所有评标专家的评标结果是否相同
//				if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
//					checklObjectiveFactorResult(evalFactorResult, supplier.getId(), evaluationFactor.getId());
//				}
				if(null == firstEvaluationFactor){
					firstEvaluationFactor = evaluationFactor;
				}
				if(null == firstEvaluationFactorResult){
					firstEvaluationFactorResult = evalFactorResult;
				}
			}
			
			if(evalPassNoCount > 0){
				expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
			}
			if(null == firstSupplier){
				firstSupplier = supplier;
			}
			
			expertEvaluationResultMap.put(supplier.getId(), expertEvaluationResult);
			supplierEvaluationFactorResultMap.put(supplier.getId(), evaluationFactorResultMap);
		}
	}
	/**
	 * @Description: 初始化当前评标步骤的评审指标
	 * @author guoyr
	 */
	private void initEvaluationStepFactor(){
		evaluationFactorList.clear();
		maxLevel = 1;
		List<EvaluationFactor> evaluationTopFactorList = evaluationFactorService.getEvaluationStepFactorTreeList(tenderProjectEntity.getId(), evaluationStep);
		if(null != evaluationTopFactorList && evaluationTopFactorList.size() > 0){
			for(EvaluationFactor topFactor : evaluationTopFactorList){
				initAddChildEvaluationFactor(topFactor);
			}
		}
	}
	/**
	 * @Description: 递归获取所有的评审叶子指标
	 * @author guoyr
	 * @param evalFactor
	 */
	private void initAddChildEvaluationFactor(EvaluationFactor evalFactor){
		if(null != evalFactor.getChildFactorList() && evalFactor.getChildFactorList().size() > 0){
			for(EvaluationFactor childFactor : evalFactor.getChildFactorList()){
				childFactor.setLevel(evalFactor.getLevel() + 1);
				initAddChildEvaluationFactor(childFactor);
			}
		}else {
			maxLevel = Math.max(maxLevel, evalFactor.getLevel());
			evaluationFactorList.add(evalFactor);
		}
	}
	
	/**
	 * @Description: 评审表格点击事件
	 * @author guoyr
	 * @param row
	 * @param col
	 */
	private void resultClickEventAction(EvaluationFactor evaluationFactor){
		
		if(null != evaluationFactor){
			StringBuilder evaluationFactorMemo = new StringBuilder();
			evaluationFactorMemo.append("分值范围：[").append(NumberFormat.getInstance().format(evaluationFactor.getFactorMinScore())).append("-").append(NumberFormat.getInstance().format(evaluationFactor.getFactorMaxScore())).append("分]");
			if(null != evaluationFactor.getFactorWeight()){
				evaluationFactorMemo.append("(权重").append(BigDecimalUtils.round(evaluationFactor.getFactorWeight(), 2).toString()).append("%)");
			}
			StyleRange styleScoreRange = new StyleRange(); 
			styleScoreRange.start = 5; 
			styleScoreRange.length = evaluationFactorMemo.length() - 5; 
			styleScoreRange.foreground = SWTResourceManager.getColor(77, 163, 19); 
			styleScoreRange.fontStyle = SWT.BOLD; 
			evaluationFactorMemo.append("   ");
			
			int startIndex = evaluationFactorMemo.length();
			StyleRange factorNameTitleStyleRange = getTitleStyleRange(startIndex, 5);
			
			StyleRange styleFactorNameRange = new StyleRange(); 
			styleFactorNameRange.start = startIndex + 5; 
			styleFactorNameRange.length = evaluationFactor.getFactorName().length(); 
			styleFactorNameRange.foreground = SWTResourceManager.getColor(20, 20, 20); 
			styleFactorNameRange.fontStyle = SWT.NORMAL; 
			
			evaluationFactorMemo.append("评审指标：").append(evaluationFactor.getFactorName());
			
			StyleRange factorMemoTitleStyleRange = null;
			StyleRange styleFactorMemoRange = null;
			if(null != evaluationFactor.getMemo() && evaluationFactor.getMemo().length() > 0){
				evaluationFactorMemo.append("\r\n");
				startIndex = evaluationFactorMemo.length();
				factorMemoTitleStyleRange = getTitleStyleRange(startIndex, 5);
				evaluationFactorMemo.append("评分细则：").append(evaluationFactor.getMemo());
				styleFactorMemoRange = new StyleRange(); 
				styleFactorMemoRange.start = startIndex + 5; 
				styleFactorMemoRange.length = evaluationFactor.getMemo().length(); 
				styleFactorMemoRange.foreground = SWTResourceManager.getColor(100, 100, 100); 
				styleFactorMemoRange.fontStyle = SWT.NORMAL; 
			}
			evaluation_factor_memo.setText(evaluationFactorMemo.toString());
			evaluation_factor_memo.setStyleRange(getTitleStyleRange(0, 5));
			evaluation_factor_memo.setStyleRange(styleScoreRange);
			evaluation_factor_memo.setStyleRange(factorNameTitleStyleRange);
			evaluation_factor_memo.setStyleRange(styleFactorNameRange);
			if(null != factorMemoTitleStyleRange){
				evaluation_factor_memo.setStyleRange(factorMemoTitleStyleRange);
				evaluation_factor_memo.setStyleRange(styleFactorMemoRange);
			}
		}
	}
	

	private StyleRange getTitleStyleRange(int start, int length){
		StyleRange styleRange = new StyleRange(); 
		styleRange.start = start; 
		styleRange.length = length; 
//		styleRange.foreground = SWTResourceManager.getColor(SWT.COLOR_WHITE); 
		styleRange.foreground = SWTResourceManager.getColor(SWT.COLOR_BLUE);
		styleRange.fontStyle = SWT.BOLD; 
		return styleRange;
	}
	
	/**
	 * @Description: 保存动作
	 * @author guoyr 
	 */
	private void saveAction(){
		if(aiScoreSingleEvaluationTableComposite.saveEvaluationFactorResult()){
			MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
		}else{
			MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
		}
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
