package com.gx.obe.common.composite;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.common.dialog.EvaluationOpinionInputDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.InputDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.obe.web.entity.EvaluationFactorResult;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationFactor;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.ExpertEvaluationResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.evaluation.EvaluationFactorResultService;
import com.gx.obe.web.service.expert.ExpertEvaluationResultService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.KTableCellMouseRightAdapter;
import de.kupzog.ktable.KTableCellSelectionAdapter;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.editors.KTableCellEditorGRadio;
import de.kupzog.ktable.model.CommonKtableCModel;
import de.kupzog.ktable.renderers.CellAlignmentRender;
import de.kupzog.ktable.renderers.CellBackgroundRender;
import de.kupzog.ktable.renderers.CellContentRender;
import de.kupzog.ktable.renderers.CellEditContentRender;
import de.kupzog.ktable.renderers.CellEditorRender;
import de.kupzog.ktable.renderers.CellForegroundRender;
import de.kupzog.ktable.renderers.CellRender;
import de.kupzog.ktable.renderers.CellTooltipRender;
import de.kupzog.ktable.renderers.FixedWrapCellRenderer;
import de.kupzog.ktable.renderers.TextWrapCellRenderer;

/**
 * @Description: 符合性评审面板
 * @author guoyr
 */
public class ComplianceSingleFactorComposite extends Composite{

	private TenderProjectEntity tenderProjectEntity;
	private EvaluationStep evaluationStep;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private ImageResolver imageResolver = new ImageResolver();
	private ExpertEvaluationStepService expertEvaluationStepService ;;
	private EvaluationFactorResultService evaluationFactorResultService = new EvaluationFactorResultService();
	private ExpertEvaluationResultService expertEvaluationResultService;
	private Composite evaluationComposite;
	private Composite evaluationTableComposite;
	private List<EvaluationFactor> evaluationFactorList = new ArrayList<EvaluationFactor>();
	private int maxLevel = 1;
	private List<Supplier> supplierList;
	private KTable resultKTable;
	private CommonKtableCModel commKTableModel;
	private int curRow = 0;
	private int curCol = 0;
	private boolean resultChanged = false;
//	private String supplierName;
	private Color importColor = SWTResourceManager.getColor(SWT.COLOR_BLUE);
	private Color rightBgColor = SWTResourceManager.getColor(194, 236, 150);
	private Color errorBgColor = SWTResourceManager.getColor(255, 153, 153);
	private Map<String, Color> contentBackgroundMap = new HashMap<String, Color>();
	private Map<String, Color> contentForegroundMap = new HashMap<String, Color>();
	// 记录供应商每个指标的评审结果
	private Map<String, Map<String, EvaluationFactorResult>> supplierEvaluationFactorResultMap;
	// 记录专家对供应商的评审汇总结果
	private Map<String, ExpertEvaluationResult> expertEvaluationResultMap;
	private AuthUser curUser;
	private String EVAL_ACCESSMENT_YES = Messages.Qualified;
	private String EVAL_ACCESSMENT_NO = Messages.Unqualified;
	private int fontSize = 9;
	private boolean indexIsBidNumber = false;
	private int maxFactorNameLength = -1;
	private boolean isScoreByQualified = false;//是否通过性打分
	private EvaluationFactor evaluationFactor;
	private String FACTOR_MEMO = "factorMemo";
	private String FACTOR_RESPONSE = "factorresponse";
	private String FACTOR_SCORE = "factorscore";
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public ComplianceSingleFactorComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		evaluationComposite = new Composite(this, SWT.NONE);
		evaluationComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		evaluationComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_evaluationComposite = new GridLayout(1, false);
		gl_evaluationComposite.verticalSpacing = 0;
		gl_evaluationComposite.horizontalSpacing = 0;
		gl_evaluationComposite.marginHeight = 0;
		gl_evaluationComposite.marginWidth = 0;
		evaluationComposite.setLayout(gl_evaluationComposite);
		evaluationTableComposite = new Composite(evaluationComposite, SWT.NONE);
		evaluationTableComposite.setLayout(new FillLayout(SWT.HORIZONTAL));
		evaluationTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		expertEvaluationStepService = new ExpertEvaluationStepService();
		expertEvaluationResultService = new ExpertEvaluationResultService();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, AuthUser user, EvaluationStep evaluationStep, EvaluationFactor evaluationFactor, List<Supplier> supplierList){
		this.tenderProjectEntity = tenderProjectEntity;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.curUser = user;
		this.evaluationStep = evaluationStep;
		this.evaluationFactor = evaluationFactor;
//		supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		this.supplierList = supplierList;
		curRow = 0;
		curCol = 0;
		// 修改评标专家的评审记录
		ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "进入" + evaluationStep.getStepName(), Constants.USER.getUserName());
		expertEvaluationStepService.updateExpertEvaluationStatus(CommonEnum.IN_PROGRESS, tenderProjectEntity.getId(), evaluationStep, curUser.getId());
		String indexIsBidNumberObj = evaluationStep.getEvaluationParamByKey(com.gx.obe.components.core.enumeration.EvaluationStepEnum.PARAM_INDEX_IS_BIDNUMBER);
		indexIsBidNumber  = CommonEnum.YES.equals(indexIsBidNumberObj);
		if(null != evaluationStep.getSummaryType() && evaluationStep.getSummaryType().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.SUMMARY_SCORE_BY_QUALIFIED)){
			isScoreByQualified = true;
			EVAL_ACCESSMENT_YES = "通过";
			EVAL_ACCESSMENT_NO = "不通过";
		}
		initEvaluationResult();
		drawLeftSupplierEvaluationTable();
		if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)){
			resultChanged = true;
		}
	}
	
	/**
	 * @Description: 设置表格中的字体大小
	 * @author guoyr
	 * @param fontSize 
	 */
	public void setTableFontSize(int fontSize){
		this.fontSize = fontSize;
		resultKTable.redraw();
	}
	
	
	/**
	 * @Description: 初始化当前评标步骤的评审指标
	 * @author guoyr
	 */
	private void initEvaluationStepFactor(){
		evaluationFactorList.clear();
		maxLevel = 1;
//		maxLevel = Math.max(maxLevel, evaluationFactor.getLevel());
//		evaluationFactorList.add(evaluationFactor);
		
		maxLevel = Math.max(maxLevel, evaluationFactor.getLevel());
		EvaluationFactor factor1 = new EvaluationFactor();
		EvaluationFactor factor2 = new EvaluationFactor();
		
		factor1.setParentFactor(evaluationFactor.getParentFactor());
		factor2.setParentFactor(evaluationFactor.getParentFactor());
		factor1.setFactorName(evaluationFactor.getFactorName());
		factor2.setFactorName("");
		factor1.setFactorCode("");
		factor2.setFactorCode("");
		factor1.setId("");
		factor2.setFactorCode(evaluationFactor.getId());
		factor1.setParentId(evaluationFactor.getParentFactor().getId());
		factor2.setParentId(evaluationFactor.getParentFactor().getId());
		factor1.setLevel(evaluationFactor.getLevel());
		evaluationFactor.setFactorType(FACTOR_SCORE);
		factor1.setFactorType(FACTOR_MEMO);
		factor2.setFactorType(FACTOR_RESPONSE);
		factor2.setLevel(evaluationFactor.getLevel());
		factor1.setChildFactorList(new ArrayList<EvaluationFactor>());
		factor2.setChildFactorList(new ArrayList<EvaluationFactor>());
		factor1.setMemo(evaluationFactor.getMemo());
//		evalFactor.getParentFactor().addChild(factor1);
//		evalFactor.getParentFactor().addChild(factor2);
		evaluationFactorList.add(factor1);
		evaluationFactorList.add(factor2);
		evaluationFactorList.add(evaluationFactor);
	}
	
	/** 
	 * @Description: 关闭编辑器
	 * @author guoyr 
	 */
	public void closeCellEditor(){
		if(null != resultKTable){
			resultKTable.closeCellEditor();
		}
	}
	
	/**
	 * @Description: 切换评分面板
	 * @author guoyr
	 */
	public void switchCoordinateAction(){
		if(null != resultKTable && !resultKTable.isDisposed()){
			resultKTable.dispose();
		}
		Constants.FACTOR_IS_HORIZONTAL = !Constants.FACTOR_IS_HORIZONTAL;
		drawLeftSupplierEvaluationTable();
		evaluationTableComposite.layout();
	}
	/**
	 * @Description: 评审表格鼠标右键点击事件
	 * @author guoyr
	 * @param row
	 * @param col
	 */
	private void resultMouseRightClickEventAction(final Supplier supplier, final EvaluationFactor evaluationFactor, final ExpertEvaluationResult expertEvaluationResult, final EvaluationFactorResult  evalFactorResult){
		final EMenu gmenu = new EMenu(getShell());
		if(curRow >= commKTableModel.getFixedRowCount()){
			
			gmenu.addMenuItem((resultKTable.isLockedRow(curRow)?Messages.Button_unlockRow:Messages.Button_lockRow), imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/my-account.png"), null != supplier, new EMenu.ClickListener() {
				public void click() {
					if(resultKTable.isLockedRow(curRow)){
						resultKTable.releaseLockRow(curRow);
					}else {
						resultKTable.addLockedRow(curRow);
					}
					resultKTable.refreshRowResize(curRow);
				}
			});
		}
		gmenu.addSeparator();
		gmenu.addMenuItem(Messages.Button_setMaxFactorNameLength, null, true, new EMenu.ClickListener() {
			public void click() {
				InputDialog dialog = new InputDialog(getShell(), Messages.Button_setMaxFactorNameLength, maxFactorNameLength > 0 ? maxFactorNameLength + "" : "");
				dialog.open();
				String pageSizeStr = dialog.getInputValue();
				try {
					int length = Integer.parseInt(pageSizeStr);
					maxFactorNameLength = Math.max(5, length);
				} catch (NumberFormatException e) {
					maxFactorNameLength = -1;
				}finally{
					drawLeftSupplierEvaluationTable();
				}
			}
		});
		gmenu.addMenuItem(Messages.Button_enlargeColumnWidth, null, true, new EMenu.ClickListener() {
			public void click() {
				resultKTable.fillColumnWidth();
				for(int i = 0; i < commKTableModel.getFixedRowCount(); i++){
					resultKTable.refreshRowResize(i);
				}
			}
		});
		gmenu.addMenuItem(Messages.Button_reducedColumnWidth, null, true, new EMenu.ClickListener() {
			public void click() {
				resizeColumn(110);
			}
		});
		gmenu.open();
	}
	
	/**
	 * @Description: 递归获取当前指标指定上级如果上级为空则为本身
	 * @author guoyr
	 * @param factor
	 * @param row
	 * @return
	 */
	private EvaluationFactor getParentFactor(EvaluationFactor evaluationFactor, int level){
		EvaluationFactor parent = evaluationFactor.getParentFactor();
		if(null != parent){
			if(parent.getLevel() == level){
				return parent;
			}else if(parent.getLevel() > level) {
				return getParentFactor(parent, level);
			}else {
				return evaluationFactor;
			}
		}
		return parent;
	}
	
	/**
	 * @Description: 递归获取当前指标的所有下级指标的个数
	 * @author guoyr
	 * @param factor
	 * @return
	 */
	private int getChildCount(EvaluationFactor evaluationFactor){
		List<EvaluationFactor> childrenList = evaluationFactor.getChildFactorList();
		int childCount = null != childrenList?childrenList.size():0;
		if(childCount > 0){
			for(EvaluationFactor childrenFactor : childrenList){
				List<EvaluationFactor> subChildrenList = childrenFactor.getChildFactorList();
				if(null != subChildrenList && subChildrenList.size() > 0){
					childCount--;
					childCount += getChildCount(childrenFactor);
				}
			}
		}
		return childCount;
	}
	
	/**
	 * @Description: 检查观项指标的结果是否一致
	 * @author guoyr
	 * @param evaluationFactorResult
	 * @param supplierId
	 * @param factorId 
	 */
	private void checklObjectiveFactorResult(EvaluationFactorResult evaluationFactorResult, String supplierId, String factorId){
		Color bgColor = null;
		String passType = evaluationFactorResult.getEvaluationResult();
		if(null != passType){
			boolean equalsResult = true;
			List<String> evaluationResultList = evaluationFactorResultService.checklObjectiveFactorResult(
                    tenderProjectEntity.getId(), 
                    evaluationStep.getId(), 
                    supplierId, 
                    factorId, 
                    curUser.getId()
                );
			if(null != evaluationResultList){
				for(String evaluationResult : evaluationResultList){
					if(null != evaluationResult && !evaluationResult.equals(passType)){
						equalsResult = false;
						break;
					}
				}
			}
			if(equalsResult){
				bgColor = rightBgColor;
			}else {
				bgColor = errorBgColor;
			}
		}else {
			bgColor = rightBgColor;
		}
		contentBackgroundMap.put(evaluationFactorResult.getId(), bgColor);
	}
	
	/**
	 * @Description: 初始化评标结果
	 * @author guoyr 
	 */
	private void initEvaluationResult(){
		if(null == evaluationFactorList)evaluationFactorList = new ArrayList<EvaluationFactor>();
		initEvaluationStepFactor();
		
		// 记录供应商每个指标的评审结果
		supplierEvaluationFactorResultMap = new HashMap<String, Map<String, EvaluationFactorResult>>();
		// 记录专家对供应商的评审汇总结果
		expertEvaluationResultMap = new HashMap<String, ExpertEvaluationResult>();
		
		// 评审当前评标专家所有的评标结果
		List<EvaluationFactorResult> memberEvaluateFactorResultList = evaluationFactorResultService.getExpertEvaluationFactorResult(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId(), null);
		List<ExpertEvaluationResult> queryExpertEvaluationResultList = expertEvaluationResultService.getExpertStepAllSupplierEvaluationResultList(tenderProjectEntity.getId(), evaluationStep.getId(), curUser.getId());
		contentBackgroundMap.clear();
		contentForegroundMap.clear();

		Supplier firstSupplier = null;
		EvaluationFactor firstEvaluationFactor = null;
		EvaluationFactorResult firstEvaluationFactorResult = null;
		
		for(Supplier supplier : supplierList){
			// 获取评标专家对投标人的评审记录
			ExpertEvaluationResult expertEvaluationResult = null;
			if(null != queryExpertEvaluationResultList && queryExpertEvaluationResultList.size() > 0){
				for(ExpertEvaluationResult queryExpertEvaluationResult : queryExpertEvaluationResultList){
					if(ObjectUtils.equals(queryExpertEvaluationResult.getSupplierId(), supplier.getId())){
						expertEvaluationResult = queryExpertEvaluationResult;
					}
				}
			}
			if(null == expertEvaluationResult){
				expertEvaluationResult = new ExpertEvaluationResult();
				expertEvaluationResult.setTenderId(tenderProjectEntity.getId());
				expertEvaluationResult.setStepId(evaluationStep.getId());
				expertEvaluationResult.setUserId(curUser.getId());
				expertEvaluationResult.setSupplierId(supplier.getId());
			}
			
			Map<String, EvaluationFactorResult> evaluationFactorResultMap = new HashMap<String, EvaluationFactorResult>();
			int evalPassNoCount = 0;
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				
				// 获得已评审的结果
				EvaluationFactorResult  evalFactorResult = null;
				if(null != memberEvaluateFactorResultList && memberEvaluateFactorResultList.size() > 0){
					for(EvaluationFactorResult factorResult : memberEvaluateFactorResultList){
						if(ObjectUtils.equals(supplier.getId(), factorResult.getSupplierId()) && ObjectUtils.equals(evaluationFactor.getId(), factorResult.getFactorId())){
							evalFactorResult = factorResult;
							break;
						}
					}
				}
				if(null == evalFactorResult){
					evalFactorResult = new EvaluationFactorResult();
					evalFactorResult.setTenderId(tenderProjectEntity.getId());
					evalFactorResult.setStepId(evaluationStep.getId());
					evalFactorResult.setUserId(curUser.getId());
					evalFactorResult.setSupplierId(supplier.getId());
					evalFactorResult.setFactorId(evaluationFactor.getId());
					evalFactorResult.setFactorName(evaluationFactor.getFactorName());
					evalFactorResult.setId(UuidUtils.getUUID());
				}
				if(null != evalFactorResult.getEvaluationResult() && evalFactorResult.getEvaluationResult().equals(EvaluationFactorEnum.UNCONFORM)){
					evalPassNoCount ++;
				}
				evaluationFactorResultMap.put(evaluationFactor.getId(), evalFactorResult);
				
				// 如果是客观项，检查所有评标专家的评标结果是否相同
				if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
					checklObjectiveFactorResult(evalFactorResult, supplier.getId(), evaluationFactor.getId());
				}
				if(null == firstEvaluationFactor){
					firstEvaluationFactor = evaluationFactor;
				}
				if(null == firstEvaluationFactorResult){
					firstEvaluationFactorResult = evalFactorResult;
				}
			}
			
			if(evalPassNoCount > 0){
				expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
			}
			if(null == firstSupplier){
				firstSupplier = supplier;
			}
			
			expertEvaluationResultMap.put(supplier.getId(), expertEvaluationResult);
			supplierEvaluationFactorResultMap.put(supplier.getId(), evaluationFactorResultMap);
			if(indexIsBidNumber && (null == supplier.getBidNumber() || "".equals(supplier.getBidNumber()))){
				indexIsBidNumber = false;
			}
		}
	}
	
	/**
	 * @Description: 左边是供应商表格
	 * @author guoyr 
	 */
	private void drawLeftSupplierEvaluationTable(){
		if(null == evaluationFactorList)evaluationFactorList = new ArrayList<EvaluationFactor>();
		if(null != resultKTable && !resultKTable.isDisposed()){
			resultKTable.dispose();
		}
		
		resultKTable = new KTable(evaluationTableComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.EDIT_ON_KEY);
		commKTableModel = new CommonKtableCModel(resultKTable, maxLevel, 1, supplierList.size(), evaluationFactorList.size() + 1);
		commKTableModel.addRowSpan(0, 0, commKTableModel.getFixedRowCount());
		commKTableModel.addRowSpan(0, commKTableModel.getColCount() -1, commKTableModel.getFixedRowCount());
		
		commKTableModel.setColumnMinWidth(0, 100);
		commKTableModel.setColumnWidth(commKTableModel.getColCount() -1, isScoreByQualified ? 110 : 50);
		final Map<String, String> tableTitleMap = new HashMap<String, String>();
		for(int row = 0; row < maxLevel; row++){
			int childCount = 0;
			String parentId = "";
			tableTitleMap.put(row+"_0", MessageFormat.format(Messages.Supplier, Messages.Name));
			tableTitleMap.put(row+"_"+(commKTableModel.getColCount() -1), "结论");
			int col = commKTableModel.getFixedColumnCount();
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				EvaluationFactor parentFactor = getParentFactor(evaluationFactor, row + 1 );
				if(null != parentFactor && StringUtils.isNotEmpty(parentFactor.getId())){
					if(!parentId.equals(parentFactor.getId())){
						childCount = 0;
					}
					if(childCount++ == 0){
						commKTableModel.addColSpan(row, col, getChildCount(parentFactor));
					}
					tableTitleMap.put(row+"_"+col, maxFactorNameLength > 0 ?  parentFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, parentFactor.getFactorName().length())) : parentFactor.getFactorName());
					parentId = parentFactor.getId();
				}else {
					childCount = 0;
					tableTitleMap.put(row+"_"+col, maxFactorNameLength > 0 ? evaluationFactor.getFactorName().substring(0, Math.min(maxFactorNameLength, evaluationFactor.getFactorName().length())) : evaluationFactor.getFactorName());
				}
				if(row + 1 == evaluationFactor.getLevel()){
					commKTableModel.addRowSpan(row, col, commKTableModel.getFixedRowCount() - row);
				}
				commKTableModel.setColumnWidth(col, 110);
				commKTableModel.setColumnMinWidth(col, 110);
				col ++;
			}
		}
		
		// 设置单元格内容
		CellContentRender contentRender = new CellContentRender(){
			public Object receiveContent(int row, int col) {
				// 表头
				if(row < commKTableModel.getHeadRow()){
					if(null != tableTitleMap.get(row+"_"+col)){
						return tableTitleMap.get(row+"_"+col);
					}else {
						return "";
					}
				}else {
					int supplierIndex = row - commKTableModel.getFixedRowCount();
					Supplier supplier = supplierList.get(supplierIndex);
					if(col < commKTableModel.getFixedColumnCount()){
						if(col == 0){
							if(resultKTable.isLockedRow(row)){
								return (indexIsBidNumber ? supplier.getBidNumber() : (supplierIndex + 1))+"、"+supplier.getSupplierName() + "[已锁定]";
							}else {
								return (indexIsBidNumber ? supplier.getBidNumber() : (supplierIndex + 1))+"、"+supplier.getSupplierName();
							}
						}
					}else if(col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
						EvaluationFactorResult evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
						return evalFactorResult.getEvalPassTypeCN(evaluationFactor.getEvalContent());
					}else if(col == commKTableModel.getColCount() -1){
						ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
						if(null != expertEvaluationResult && null != expertEvaluationResult.getAccessment()){
							if(expertEvaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED)){
								return EVAL_ACCESSMENT_YES;
							}else if(expertEvaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED)){
								return EVAL_ACCESSMENT_NO;
							}
						}
					}
				}
				return "";
		}};
		commKTableModel.setCellContentRender(contentRender);
		
		// 设置单元格渲染器
		final FixedWrapCellRenderer fixedWrapCellRenderer = new FixedWrapCellRenderer();
		final TextWrapCellRenderer textWrapCellRenderer = new TextWrapCellRenderer();
		CellRender cellRender = new CellRender(){

			public Object receiveCellRender(int row, int col) {
				if(commKTableModel.isFixedCell(col, row)){
					fixedWrapCellRenderer.setFont(SWTResourceManager.getFont("微软雅黑", fontSize, SWT.NORMAL));
					return fixedWrapCellRenderer;
				}else{
					textWrapCellRenderer.setFont(SWTResourceManager.getFont("微软雅黑", fontSize, SWT.NORMAL));
					return textWrapCellRenderer;
				}
		}};
		commKTableModel.setCellRender(cellRender);
		
		// 设置单元格编辑器
		final KTableCellEditorGRadio radio = new KTableCellEditorGRadio();
        radio.setSingleClickEdit(true);
        radio.addItem(EvaluationFactorEnum.getEvalPassTypeCN(EvaluationFactorEnum.CONFORM), EvaluationFactorEnum.CONFORM);
        radio.addItem(EvaluationFactorEnum.getEvalPassTypeCN(EvaluationFactorEnum.UNCONFORM), EvaluationFactorEnum.UNCONFORM);
		CellEditorRender cellEditorRender = new CellEditorRender(){
			public Object receiveCellEditor(int row, int col) {
				if(row >= commKTableModel.getFixedRowCount()){
					if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
						if(null != evaluationFactor && null != evaluationFactor.getEvalContent()){
							String[] evalContent = evaluationFactor.getEvalContent().split(",");
							if(evalContent.length == 2){
								radio.setItem(0, evalContent[0], EvaluationFactorEnum.CONFORM);
								radio.setItem(1, evalContent[1], EvaluationFactorEnum.UNCONFORM);
							}
						}else if(isScoreByQualified){
							radio.setItem(0, EvaluationFactorEnum.getEvalPassTypeCN(EvaluationFactorEnum.CONFORM), EvaluationFactorEnum.CONFORM);
							radio.setItem(1, EvaluationFactorEnum.getEvalPassTypeCN(EvaluationFactorEnum.UNCONFORM), EvaluationFactorEnum.UNCONFORM);
						}
						return radio;
					} else if(isScoreByQualified && col == commKTableModel.getColCount() -1){
						radio.setItem(0, EVAL_ACCESSMENT_YES, com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
						radio.setItem(1, EVAL_ACCESSMENT_NO, com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
						return radio;
					}
				}
				return null;
			}};
		commKTableModel.setCellEditorRender(cellEditorRender);
		
		// 编辑单元格内容
		CellEditContentRender editContentRender = new CellEditContentRender(){
			public void receiveContent(int row, int col, Object content) {
				if(row >= commKTableModel.getFixedRowCount()){
					if(null == content)return;
					resultChanged = true;
					if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
						Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
						EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
						ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
						Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
						EvaluationFactorResult evalFactorResult = supplierFactorResultMap.get(evaluationFactor.getId());
						evalFactorResult.setEvaluationResult(content.toString());
						if(evalFactorResult.getEvaluationResult().equals(EvaluationFactorEnum.UNCONFORM)){
							EvaluationOpinionInputDialog evaluationOpinionDialog = new EvaluationOpinionInputDialog(getShell(), evaluationFactor, evalFactorResult);
							evaluationOpinionDialog.setTitle("请输入评审意见");
							evaluationOpinionDialog.open();
							evalFactorResult.setEvaluationOpinion(evaluationOpinionDialog.getEvaluationOpinion());
						}
						// 如果是客观项，检查所有评标专家的评标结果是否相同
						if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
							checklObjectiveFactorResult(evalFactorResult, evalFactorResult.getSupplierId(), evaluationFactor.getId());
						}
						contentForegroundMap.put(evalFactorResult.getId(), null);
						
						expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
						for(Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()){
							EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
							if(null != evaluationFactorResult.getEvaluationResult() && evaluationFactorResult.getEvaluationResult().equals(EvaluationFactorEnum.UNCONFORM)){
								expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
							}
						}
					}else if(isScoreByQualified && col == commKTableModel.getColCount() -1){
						Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
						ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
						if(null != expertEvaluationResult){
							if(content.toString().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED)){
								expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
							}else if(content.toString().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED)){
								expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
							}
						}
					}
				}
			}
		};
		commKTableModel.setCellEditContentRender(editContentRender);
		
		// 编辑单元格对齐方式
		CellAlignmentRender cellAlignmentRender = new CellAlignmentRender(){
			public int receiveCellAlignment(int row, int col) {
				if(col < commKTableModel.getFixedColumnCount() && row >= commKTableModel.getFixedRowCount()){
					if(col == 0){
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					}else {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
					}
				}
				return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
			}
		};
		commKTableModel.setCellAlignmentRender(cellAlignmentRender);
		
		// 设置单元格前景颜色
		CellForegroundRender cellForegroundRender = new CellForegroundRender(){
			public Color receiveCellForeground(int row, int col) {
				if(row >= commKTableModel.getFixedRowCount()){
					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
					if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
						EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
						EvaluationFactorResult  evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
						Color foreColor = contentForegroundMap.get(evalFactorResult.getId());
						if(null != foreColor){
							return foreColor;
						}else{
							if(ObjectUtils.equals(evalFactorResult.getEvaluationResult(), EvaluationFactorEnum.CONFORM)){
								return SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN);
							}else if(ObjectUtils.equals(evalFactorResult.getEvaluationResult(), EvaluationFactorEnum.UNCONFORM)){
								return SWTResourceManager.getColor(SWT.COLOR_RED);
							}
						}
					}else if(col == commKTableModel.getColCount() -1){
						if(null != expertEvaluationResult && null != expertEvaluationResult.getAccessment()){
							if(expertEvaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED)){
								return SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN);
							}else if(expertEvaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED)){
								return SWTResourceManager.getColor(SWT.COLOR_RED);
							}
						}
					}
				}
				return null;
		}};
		commKTableModel.setCellForegroundRender(cellForegroundRender);
		
		// 设置单元格背景颜色
		CellBackgroundRender cellBackgroundRender = new CellBackgroundRender(){
			public Color receiveCellBackground(int row, int col) {
				if(row >= commKTableModel.getFixedRowCount() && col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
					EvaluationFactorResult  evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
//					ExpertEvaluationResult expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
					if(null != evalFactorResult){
						Color bgColor = contentBackgroundMap.get(evalFactorResult.getId());
						if(null != bgColor){
							return bgColor;
						}
					}
				}
				return null;
			}
		};
		commKTableModel.setCellBackgroundRender(cellBackgroundRender);
		// 设置单元格提示内容
		CellTooltipRender cellTooltipRender = new CellTooltipRender(){
			public String receiveCellTooltip(int row, int col) {
				Supplier supplier = null;
				if(row >= commKTableModel.getFixedRowCount()){
					supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
				}
				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
					EvaluationFactor evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
					if(null != supplier){
						EvaluationFactorResult  evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
						if(null != evalFactorResult && null != evalFactorResult.getEvaluationOpinion()){
							return evalFactorResult.getEvaluationOpinion();
						}
					}
					if(null != evaluationFactor && null != evaluationFactor.getMemo() && evaluationFactor.getMemo().length() > 0){
						return Messages.EvalExplain + "：\r\n"+evaluationFactor.getMemo();
					}
				}
				return Messages.Tips_selectMoreActions;
			}
		};	
		commKTableModel.setCellTooltipRender(cellTooltipRender);
		resultKTable.addCellSelectionListener(new KTableCellSelectionAdapter(){
			@Override
			public void cellSelected(int col, int row, int statemask) {
				if(curCol == col && curRow == row){
					return;
				}
				curCol = col; 
				curRow = row;
//				Supplier supplier = null;
//				EvaluationFactor evaluationFactor = null;
//				EvaluationFactorResult  evalFactorResult = null;
//				ExpertEvaluationResult expertEvaluationResult = null;
				
//				if(row >= commKTableModel.getFixedRowCount()){
//					supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
//					expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
//				}
//				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
//					evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
//				}
//				if(null != supplier && null != evaluationFactor){
//					evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
//				}
//				return;
			}
			@Override
			public void fixedCellSelected(int col, int row, int statemask) {
			}
		});
		
		resultKTable.addCellMouseRightListener(new KTableCellMouseRightAdapter(){
		
			public void cellMouseRightClick(int col, int row, Rectangle rectangle) {
				curCol = col; 
				curRow = row;
				Supplier supplier = null;
				EvaluationFactor evaluationFactor = null;
				EvaluationFactorResult  evalFactorResult = null;
				ExpertEvaluationResult expertEvaluationResult = null;
				if(row >= commKTableModel.getFixedRowCount()){
					supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
					expertEvaluationResult  = expertEvaluationResultMap.get(supplier.getId());
				}
				if(col >= commKTableModel.getFixedColumnCount() && col < commKTableModel.getFixedColumnCount() + evaluationFactorList.size()){
					evaluationFactor = evaluationFactorList.get(col - commKTableModel.getFixedColumnCount());
				}
				if(null != supplier && null != evaluationFactor){
					evalFactorResult = supplierEvaluationFactorResultMap.get(supplier.getId()).get(evaluationFactor.getId());
				}
				resultMouseRightClickEventAction(supplier, evaluationFactor, expertEvaluationResult, evalFactorResult);
			}
		});
		resultKTable.setModel(commKTableModel);
		evaluationTableComposite.layout();
	}
	
	
	

	public void resizeColumn(int width){
		for(int i = commKTableModel.getFixedColumnCount(); i < commKTableModel.getColCount(); i++){
			commKTableModel.setColumnWidth(i, width);
		}
		resultKTable.autoComputerColumnWidth();
	}
	

	/**
	 * @Description: 全部符合
	 * @author guoyr
	 */
	public void initDefaultFactorResult(){
		if(!MessageDialog.openConfirm(getShell(), MessageFormat.format(Messages.Tips_setQuickEvaluation, EvaluationFactorEnum.getEvalPassTypeCN(EvaluationFactorEnum.CONFORM)))){
			return;
		}
		resultKTable.closeCellEditor();
		
		for(Supplier supplier : supplierList){
			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplier.getId());
			// 当前供应商的所有评审结果
			Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
			int evalPassNoCount = 0;
			for(EvaluationFactor evaluationFactor : evaluationFactorList){
				EvaluationFactorResult evaluationFactorResult = supplierFactorResultMap.get(evaluationFactor.getId());
				if(null == evaluationFactorResult.getEvaluationResult()){
					evaluationFactorResult.setEvaluationResult(EvaluationFactorEnum.CONFORM);
					contentForegroundMap.put(evaluationFactorResult.getId(), importColor);// 设置为非自己录入的颜色
					resultChanged = true;
				}
				
				// 如果是客观项，检查所有评标专家的评标结果是否相同
				if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
					checklObjectiveFactorResult(evaluationFactorResult, evaluationFactorResult.getSupplierId(), evaluationFactor.getId());
				}
				if(null != evaluationFactorResult.getEvaluationResult() && evaluationFactorResult.getEvaluationResult().equals(EvaluationFactorEnum.UNCONFORM)){
					evalPassNoCount ++;
				}
			}
			if(evalPassNoCount > 0){
				expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
			}else {
				expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
			}
		}
		resultKTable.redraw();
	}
	
//	private ImportEvaluationResultListener createImportEvaluationResultListener(){
//		return new ImportEvaluationResultListener(){
//			public void importEvalResult(Map<String, Map<String, EvaluationFactorResult>> importSupplierResult) {
//				for(Supplier supplier : supplierList){
//					ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplier.getId());
//					// 当前供应商的所有评审结果
//					Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
//					Map<String, EvaluationFactorResult> supplierSupplierResultMap = importSupplierResult.get(supplier.getId());
//
//					int importCount = 0;
//					int evalPassNoCount = 0;
//					for(EvaluationFactor evaluationFactor : evaluationFactorList){
//						EvaluationFactorResult evaluationFactorResult = supplierFactorResultMap.get(evaluationFactor.getId());
//						if(null != evaluationFactorResult){
//							if(null != supplierSupplierResultMap){
//								EvaluationFactorResult importEvaluationResult = supplierSupplierResultMap.get(evaluationFactor.getId());
//								if(null != importEvaluationResult && null != importEvaluationResult.getEvaluationResult()){
//									evaluationFactorResult.setEvaluationResult(importEvaluationResult.getEvaluationResult());
//									evaluationFactorResult.setEvaluationOpinion(importEvaluationResult.getEvaluationOpinion());
//									// 设置为非自己录入的颜色
//									contentForegroundMap.put(evaluationFactorResult.getId(), importColor);
//									resultChanged = true;
//									
//									// 如果是客观项，检查所有评标专家的评标结果是否相同
//									if(ObjectUtils.equals(evaluationFactor.getObjective(), EvaluationFactorEnum.OBJECTIVE_YES)){
//										checklObjectiveFactorResult(evaluationFactorResult, evaluationFactorResult.getSupplierId(), evaluationFactor.getId());
//									}
//								}
//							}
//							if(null != evaluationFactorResult.getEvaluationResult() && evaluationFactorResult.getEvaluationResult().equals(EvaluationFactorEnum.UNCONFORM)){
//								evalPassNoCount ++;
//							}
//							importCount ++;
//						}
//					}
//					if(evalPassNoCount > 0){
//						expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED);
//					}else if(importCount > 0){
//						expertEvaluationResult.setAccessment(com.gx.obe.components.core.enumeration.EvaluationStepEnum.QUALIFIED);
//					}
//				}
//				resultChanged = true;
//				resultKTable.redraw();
//			}
//		};
//	}
	
	/**
	 * @Description: 保存评审结果
	 * @author guoyr
	 * @return 
	 */
	public boolean saveEvaluationFactorResult(){
		boolean saveSuccess = true;
		// 如果修改了结果，才保存结果
		if(resultChanged){
			saveSuccess = expertEvaluationStepService.saveEvaluationResult(tenderProjectEntity.getId(), curUser.getId(), evaluationStep, expertEvaluationResultMap, supplierEvaluationFactorResultMap);
			if(saveSuccess){
				resultChanged = false;
			}else {
				resultChanged = true;
			}
		}
		return saveSuccess;
	}
	
	/**
	 * @Description: 检查是否可以提交
	 * @author guoyr
	 * @return 
	 */
	public String checkSubmit(){
		for(Supplier supplier : supplierList){
			Map<String, EvaluationFactorResult> supplierFactorResultMap = supplierEvaluationFactorResultMap.get(supplier.getId());
//			ExpertEvaluationResult expertEvaluationResult = expertEvaluationResultMap.get(supplier.getId());
			for(Entry<String, EvaluationFactorResult> factorResultEntry : supplierFactorResultMap.entrySet()){
				EvaluationFactorResult evaluationFactorResult = factorResultEntry.getValue();
				if(null == evaluationFactorResult.getEvaluationResult()){
					return supplier.getSupplierName().concat("存在未评审完成的指标，请检查并对所有指标进行评审！");
				}
			}
		}
		return null;
	}
	/** 
	 * @Description: 提交评审结果
	 * @author guoyr
	 * @return 
	 */
	public boolean submitEvaluationFactorResult() {
		return expertEvaluationStepService.submitEvaluationResult(tenderProjectEntity.getId(),tenderProjectRuleEntity, curUser.getId(), evaluationStep, supplierList);
	}

	/** 
	 * @Description: 释放资源
	 * @author guoyr 
	 */
	public void dispose() {
		imageResolver.disposite();
		evaluationFactorList.clear();
		evaluationFactorList = null;
		super.dispose();
	}
	@Override
	
	protected void checkSubclass() {
	}
	
}
