package com.gx.obe.common.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.common.file.entity.BidFile;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.shell.FileDownloadShell;
import com.gx.obe.common.file.thread.CheckHttpBidFileThread;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.TransactionServer;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.TransactionServerService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 解密投标文件下载
 * @author chenxw
 */
public class DecryptBidFileDownloadBySupplierComposite extends Composite {

	private TenderProjectEntity tenderProjectEntity;
	private String supplierName = Messages.Supplier;
	private Composite bidOpeningStageComposite;
	private SupplierService supplierService = new SupplierService();
	private ProjectRuleService projectRuleService;
	private TenderProjectService tenderProjectService ;
	private TransactionServerService transactionServerService = new TransactionServerService();
	private List<Supplier> supplierList;
	private Grid supplierGrid;
	private BigButton download_btn;
	private ImageButton bidOpeningButton;
	private String BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_ALL;
	private ExecutorService httpExecutorService;
	private ExecutorService localExecutorService;
	private TitleComposite titleComposite;
	private Menu menu;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 * @param tenderProjectEntity
	 */
	public DecryptBidFileDownloadBySupplierComposite(Composite parent, TenderProjectEntity tenderProjectEntity) {
		super(parent, SWT.NONE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		setBackgroundMode(SWT.INHERIT_FORCE);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				shutdownNow();
			}
		});

		this.tenderProjectEntity = tenderProjectEntity;
		this.menu = (Menu)parent.getData("menu");
		this.supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());

		bidOpeningStageComposite = new Composite(this, SWT.NONE);
		bidOpeningStageComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_top = new GridLayout(2, false);
		gl_composite_top.horizontalSpacing = 1;
		gl_composite_top.verticalSpacing = 0;
		gl_composite_top.marginHeight = 0;
		gl_composite_top.marginWidth = 0;
		bidOpeningStageComposite.setLayout(gl_composite_top);
		bidOpeningStageComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		Composite supplierBidFileDownloadcomposite = new Composite(this, SWT.NONE);
		GridLayout gl_supplierBidFileDownloadcomposite = new GridLayout(1, false);
		gl_supplierBidFileDownloadcomposite.verticalSpacing = 0;
		gl_supplierBidFileDownloadcomposite.horizontalSpacing = 0;
		gl_supplierBidFileDownloadcomposite.marginHeight = 0;
		gl_supplierBidFileDownloadcomposite.marginWidth = 0;
		supplierBidFileDownloadcomposite.setLayout(gl_supplierBidFileDownloadcomposite);
		supplierBidFileDownloadcomposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		titleComposite = new TitleComposite(supplierBidFileDownloadcomposite, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		titleComposite.setTitle(Messages.Tips_downDecryptBidFile);

		ELink selectionAllBtn = titleComposite.addELink("SELECT_ALL");
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllBtn.setText(Messages.Button_selectAll);
		selectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});

		ELink selectionInvertBtn = titleComposite.addELink("SELECT_INVERT");
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});

		ELink selectionNoBtn = titleComposite.addELink("DISSELECT");
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_cancel);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite bidFileDownloadcomposite = new Composite(supplierBidFileDownloadcomposite, SWT.NONE);
		bidFileDownloadcomposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_GRAY));
		GridLayout gl_bidFileDownloadcomposite = new GridLayout(1, false);
		gl_bidFileDownloadcomposite.verticalSpacing = 1;
		gl_bidFileDownloadcomposite.horizontalSpacing = 1;
		gl_bidFileDownloadcomposite.marginHeight = 1;
		gl_bidFileDownloadcomposite.marginWidth = 1;
		bidFileDownloadcomposite.setLayout(gl_bidFileDownloadcomposite);
		bidFileDownloadcomposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		Composite supplierGridComposite = new Composite(bidFileDownloadcomposite, SWT.NONE);
		supplierGridComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_supplierGridComposite = new GridLayout(1, false);
		gl_supplierGridComposite.verticalSpacing = 0;
		gl_supplierGridComposite.horizontalSpacing = 0;
		gl_supplierGridComposite.marginHeight = 0;
		gl_supplierGridComposite.marginWidth = 0;
		supplierGridComposite.setLayout(gl_supplierGridComposite);
		supplierGridComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		supplierGrid = new Grid(supplierGridComposite, SWT.V_SCROLL);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);

		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CHECK);
		gridColumn.setText(supplierName);
		gridColumn.setWidth(250);

		GridColumn gridColumn_1 = new GridColumn(supplierGrid, SWT.NONE);
		gridColumn_1.setText(Messages.ServerFileInfo);
		gridColumn_1.setWidth(200);
		gridColumn_1.setAlignment(SWT.CENTER);

		GridColumn gridColumn_2 = new GridColumn(supplierGrid, SWT.NONE);
		gridColumn_2.setText(Messages.StateOfLocalFile);
		gridColumn_2.setWidth(200);
		gridColumn_2.setAlignment(SWT.CENTER);

		Composite downloadComposite = new Composite(bidFileDownloadcomposite, SWT.NONE);
		downloadComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_downloadComposite = new GridLayout(1, false);
		gl_downloadComposite.marginWidth = 0;
		downloadComposite.setLayout(gl_downloadComposite);
		downloadComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));

		download_btn = new BigButton(downloadComposite, SWT.NONE);
		download_btn.setBackground(ColorConstants.SKIN_BG);
		download_btn.setForeground(ColorConstants.SKIN_FOREGROUND);
		download_btn.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		download_btn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		download_btn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		download_btn.setArcWidth(6);
		download_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
		download_btn.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, false, false, 1, 1));
		download_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				downloadAction();
			}
		});
		download_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
//		gd_savebutton_1.heightHint = 35;
//		gd_savebutton_1.widthHint = 200;
		download_btn.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
		download_btn.setText(Messages.Button_downloadDecBidFile);

		init();
	}

	/**
	 * @Description: 初始化
	 * @author chenxw
	 */
	private void init() {
		projectRuleService = new ProjectRuleService();
		tenderProjectService = new TenderProjectService();
		menuFunctionUtils.initFunctionAuthority(menu, titleComposite.getFunctionComposite());
		
		bidOpeningStageRefresh();
		drawSuzpplierGrid();
		// 右键菜单
		supplierGrid.addListener(SWT.Selection, new GridSelectionListener() {
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
		});
		// 双击打开
		supplierGrid.addSelectionListener(new SelectionAdapter() {
			public void widgetDefaultSelected(SelectionEvent e) {
				GridItem[] items = supplierGrid.getSelection();
				if (null != items && items.length > 0) {
					Supplier supplier = (Supplier) items[0].getData("supplier");
					if (null != supplier) {
						final String bidFilePath = FileConstants.getBidFilePath(tenderProjectEntity.getId(), supplier.getId());
						final File bidFile = new File(bidFilePath);
						if (!bidFile.exists()) {
							bidFile.mkdirs();
						}
						RuntimeUtils.openDirector(bidFilePath);
					}
				}
			}
		});
	}

	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType
	 */
	private void selectionAction(int selectionType) {
		for (GridItem gridItem : supplierGrid.getItems()) {
			if (selectionType == 1) {
				if (gridItem.getCheckable(0)) {
					gridItem.setChecked(0, true);
				}
			} else if (selectionType == -1) {
				if (gridItem.getChecked(0)) {
					gridItem.setChecked(0, false);
				} else if (gridItem.getCheckable(0)) {
					gridItem.setChecked(0, true);
				}
			} else {
				gridItem.setChecked(0, false);
			}
		}
	}

	/**
	 * @Description: 显示供应商列表
	 * @author chenxw
	 */
	private void drawSuzpplierGrid() {
		shutdownNow();
		supplierGrid.removeAll();
		supplierList = supplierService.getSupplierList(tenderProjectEntity.getId());
		if (null != supplierList && supplierList.size() > 0) {
			// 如果匿名显示
			boolean isAnonymous = false;
			// 如果显示匿名，验证是否要匿名
			if (Constants.SHOW_ANONYMOUS) {
				isAnonymous = projectRuleService.isAnonymous(tenderProjectEntity.getId());
			}
			TenderProjectEntity parentProject = tenderProjectService.getById(tenderProjectEntity.getParentId());
			TransactionServer transactionServer = HttpUtils.getTransactionServer(tenderProjectEntity.getTransactionServerId());
			httpExecutorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			localExecutorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			int index = 1;
			for (final Supplier supplier : supplierList) {
				// 设置匿名和序号
				supplier.setAnonymous(isAnonymous, index);
				GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
				gridItem.setText(0, index + "、" + supplier.getSupplierName());
				gridItem.setToolTipText(0, Messages.Tips_openDirectory);
				gridItem.setCheckable(0, false);
				gridItem.setGrayed(0, true);
				gridItem.setData("supplier", supplier);
				httpExecutorService.submit(getHttpBidFileInfoThread(parentProject, transactionServer, supplier, gridItem));
				localExecutorService.submit(getLocalBidFileInfoThread(tenderProjectEntity, supplier, BIDOPENING_STAGE, gridItem));
				index++;
			}
			httpExecutorService.shutdown();
			localExecutorService.shutdown();
		}
	}

	private void shutdownNow() {
		if (null != httpExecutorService) {
			httpExecutorService.shutdownNow();
		}
		if (null != localExecutorService) {
			localExecutorService.shutdownNow();
		}
	}

	/**
	 * @Description: 获得网络标书文件信息线程
	 * @author chenxw
	 * @param parentProject
	 * @param transactionServer
	 * @param supplier
	 * @param gridItem
	 * @return
	 */
	private Runnable getHttpBidFileInfoThread(final TenderProjectEntity parentProject, final TransactionServer transactionServer, final Supplier supplier, final GridItem gridItem) {
		gridItem.setText(1, Messages.Tips_gettingDecryptedBidInfo);
		CheckHttpBidFileThread bidFileThread = new CheckHttpBidFileThread(transactionServer, parentProject, tenderProjectEntity, supplier, true, BIDOPENING_STAGE, new CheckHttpBidFileThread.CheckCallBack() {

			public void callBackString(final String returnMessage) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!gridItem.isDisposed()) {
							gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
							gridItem.setText(1, returnMessage);
						}
					}
				});
			}

			public void bidFile(boolean hasbidFile, Date tenderTime, final long bidFileSize, String downUrl) {
				if (hasbidFile) {
					// 临时将下载地址放入申请地址，申请地址已不使用
					supplier.setApplyUrl(downUrl);
					supplier.setTenderTime(tenderTime);
					supplier.setFileSize(bidFileSize);
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setCheckable(0, true);
								gridItem.setGrayed(0, false);
								gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
								gridItem.setText(1, FileUtils.getFileSize(bidFileSize));
							}
						}
					});
				} else {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!gridItem.isDisposed()) {
								gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
								gridItem.setText(1, Messages.Tips_noDecryptedFilesDetected);
							}
						}
					});
				}
			}
		});
		return bidFileThread;
	}

	/**
	 * @Description: 获取本地文件状态线程
	 * @author chenxw
	 * @param tenderProjectEntity
	 * @param supplier
	 * @param BIDOPENING_STAGE
	 * @param gridItem
	 * @return 
	 */
	private Runnable getLocalBidFileInfoThread(final TenderProjectEntity tenderProjectEntity, final Supplier supplier, final String BIDOPENING_STAGE, final GridItem gridItem) {
		gridItem.setText(2, Messages.Tips_obtainingDownloadedTenderInfo);
		return new Runnable() {
			public void run() {
				final boolean isExists = BidFile.checkBidFileExists(FileConstants.getBidFilePath(tenderProjectEntity.getId(), supplier.getId()), BIDOPENING_STAGE);
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!gridItem.isDisposed()) {
							if (isExists) {
								gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
								gridItem.setText(2, Messages.Exist);
							} else {
								gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
								gridItem.setText(2, Messages.NotExist);
							}
						}
					}
				});
			}
		};
	}

	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction() {
		final EMenu gmenu = new EMenu(getShell());
		GridItem[] items = supplierGrid.getSelection();
		if (null != items && items.length > 0) {
			Supplier supplier = (Supplier) items[0].getData("supplier");
			if (null != supplier) {
				final String bidFilePath = FileConstants.getBidFilePath(tenderProjectEntity.getId(), supplier.getId());
				final File bidFile = new File(bidFilePath);
				gmenu.addMenuItem(Messages.Button_openDirectory, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
					public void click() {
						if (!bidFile.exists()) {
							bidFile.mkdirs();
						}
						RuntimeUtils.openDirector(bidFilePath);
					}
				});
				gmenu.open();
			}
		}
	}

	/**
	 * @Description: 下载事件
	 * @author chenxw
	 */
	private void downloadAction() {
		if (download_btn.getEnabled()) {
			List<Supplier> selectSupplierList = GridUtils.getCheckedValues(supplierGrid, 0, "supplier");
			if (selectSupplierList.size() > 0) {
				for (Supplier supplier : selectSupplierList) {
					FileDownloadShell.getInstance().httpBidDownload(tenderProjectEntity, supplier, BIDOPENING_STAGE);
				}
			} else {
				MessageDialog.openInformation(getShell(), MessageFormat.format(Messages.Tips_pleaseSelectDownloadFormat, Messages.BidDocument));
			}
		}
	}

	/**
	 * @Description: 开标阶段刷新
	 * @author chenxw
	 */
	private void bidOpeningStageRefresh() {
		TenderProjectRuleEntity tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		if (null != tenderProjectRuleEntity.getBidOpeningStage() && tenderProjectRuleEntity.getBidOpeningStage().equals(com.gx.obe.components.core.enumeration.TenderProjectEnum.BID_OPENING_TWO_STAGE)) {
			bidOpeningButton = createBidOpeningStageBtn(Messages.BusinessTechnologyBid, com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC);
			createBidOpeningStageBtn(Messages.EconomicBid, com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_PRICE);
			BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_BUS_TEC;
			bidOpeningButton.setSelection(true);
			ESepator label = new ESepator(bidOpeningStageComposite, SWT.NONE);
			label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 8, 1));
			label.setBackground(ColorConstants.SKIN_BG);
			label.setLineWidth(3);
		} else {
			bidOpeningStageComposite.dispose();
			BIDOPENING_STAGE = com.gx.obe.components.core.enumeration.TenderProjectEnum.STAGE_ALL;
		}
		tenderProjectEntity = tenderProjectService.getById(tenderProjectEntity.getId());
	}

	/**
	 * @Description: 新增开标阶段按钮
	 * @author chenxw
	 * @param stageName
	 * @param stageType
	 * @return
	 */
	private ImageButton createBidOpeningStageBtn(String stageName, final String stageType) {
		final ImageButton bidOpeningTitle = new ImageButton(bidOpeningStageComposite, SWT.NONE);
		bidOpeningTitle.setRightMargin(10);
		bidOpeningTitle.setLeftMargin(10);
		bidOpeningTitle.setTopMargin(5);
		bidOpeningTitle.setBottomMargin(5);
		bidOpeningTitle.setRightMargin(10);
		bidOpeningTitle.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		bidOpeningTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		bidOpeningTitle.setBackgroundColor(SWTResourceManager.getColor(245, 245, 245));
		bidOpeningTitle.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		bidOpeningTitle.setActiveBackgroundColor(ColorConstants.SKIN_ACTIVE_BG);
		bidOpeningTitle.setSelectionForeground(ColorConstants.SKIN_SELECTOIN_FOREGROUND);
		bidOpeningTitle.setSelectionBgColor(ColorConstants.SKIN_BG);
		bidOpeningTitle.setText(stageName);
		bidOpeningTitle.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				BIDOPENING_STAGE = stageType;
				if (null != bidOpeningButton && !bidOpeningButton.isDisposed()) {
					bidOpeningButton.setSelection(false);
				}
				bidOpeningButton = bidOpeningTitle;
				bidOpeningButton.setSelection(true);
				drawSuzpplierGrid();
			}
		});
		return bidOpeningTitle;
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
