package com.gx.obe.common.composite;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.Platform;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.dialog.EnvironmentTestDialog;
import com.gx.obe.common.file.download.infer.DownloadFileAdapter;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.software.entity.Software;
import com.gx.obe.software.utils.SoftwareUtils;
import com.gx.obe.thread.SyncThreadSet;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.NetWorkUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.pdf.utils.transfer.TransferUtils;
import com.gx.tools.ole.DocumentFactory;
import com.gx.tools.ole.DocumentLoader;
import com.gx.tools.ole.guoxin.GuoxinPdfLoaderImpl;
import com.gx.tools.tts.ITTS;
import com.gx.tools.tts.TTSEnginUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class EnvironmentComposite extends Composite{

	
	private Composite baseEnviromentComposite;
	private ImageButton mgbtnOffice;
	private Composite softComposite;
	private Composite otherEnviromentComposite;
	private Label videoCheckMessageLabel;
//	private Label caTestMessage;
	private Label handSignStatusLabel;
//	private ELink caTestLink;
	private ELink handSignOpLink;
	private Label officeCheckMessageLabel;
	private Label netCheckMessageLabel;
	private ELink testVideoLink;
	private ImageButton officeCheckBtn;
//	private ImageButton caTestBtn;
	private ImageButton handSignBtn;
	private ImageButton videoTestBtn;
	private ImageButton caSignBtn;
	private Label caSignStatusLabel;
	//拖动窗口 必须在最上层控件上添加
	private ImageButton netTestBtn;
	private Logger LOG = Logger.getLogger(EnvironmentTestDialog.class);
	private ImageButton pdfLoadBtn;
	private Color BULE_COLOR = SWTResourceManager.getColor(17, 131, 229);
	private Label pdfLoadStatusLabel;
	private ImageButton saomaSignBtn;
	private Label saomaSignStatusLabel;
	private ELink saomaSignOpLink;
	private ELink pdfLoadOpLink;
	private ELink openLink;
	private ELink officeOpLink;
	private ELink caSignOpLink;
	private ImageButton ocxBtn;
	private Label ocxStatusLabel;
	private ELink ocxOpLink;
	private ImageButton excelChangePdfBtn;
	private Label excelChangePdfStatus;
	private ELink excelChangePdfOpLink;
	private ImageButton wordlChangePdfBtn;
	private Label wordChangePdfStatus;
	private ELink wordChangePdfOpLink;
	private static String INSTRALL_PATH;
	private List<String> installSoftCode = null;
	private SyncThreadSet myThreadSet;
		
	static {
		INSTRALL_PATH = Platform.getInstallLocation().getURL().getPath();
	}
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public EnvironmentComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		Composite composite_2 = new Composite(this, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_2.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.marginLeft = 10;
		gl_composite_2.marginWidth = 0;
		gl_composite_2.horizontalSpacing = 0;
		composite_2.setLayout(gl_composite_2);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		CLabel baseEnvTitleLabel = new CLabel(composite_2, SWT.NONE);
		baseEnvTitleLabel.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		baseEnvTitleLabel.setText("基础环境检测");
		baseEnvTitleLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		baseEnvTitleLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		baseEnvTitleLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		ESepator baseSep = new ESepator(composite_2, SWT.NONE);
		baseSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		baseSep.setLineStyle(SWT.LINE_DOT);
		baseSep.setLineWidth(2);
		baseSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		baseEnviromentComposite = new Composite(composite_2, SWT.NONE);
		GridLayout gl_baseEnviromentComposite = new GridLayout(3, false);
		gl_baseEnviromentComposite.marginWidth = 20;
		baseEnviromentComposite.setLayout(gl_baseEnviromentComposite);
		baseEnviromentComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		netTestBtn = addTitleButton(baseEnviromentComposite, "网络连接");
		
		netCheckMessageLabel = new Label(baseEnviromentComposite, SWT.NONE);
		netCheckMessageLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		netCheckMessageLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		netCheckMessageLabel.setText("未检测");
		netCheckMessageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		
		openLink = new ELink(baseEnviromentComposite, SWT.RIGHT);
		openLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		openLink.setText("打开网页");
		openLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if(openLink.getVisible()) {
					RuntimeUtils.openBrowser(PropertiesUtils.getProperty(ConfigConstants.SERVER_URL, "https://www.baidu.com"));
				}
			}
		});
		
		videoTestBtn = addTitleButton(baseEnviromentComposite, "TTS语音包");
		
		videoCheckMessageLabel = new Label(baseEnviromentComposite, SWT.NONE);
		videoCheckMessageLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		videoCheckMessageLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		videoCheckMessageLabel.setText("未检测");
		videoCheckMessageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		testVideoLink = new ELink(baseEnviromentComposite, SWT.RIGHT);
		testVideoLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		testVideoLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				try {
					testsound();
				} catch (IOException e1) {
				}
			}
		});
		testVideoLink.setText("语音测试");
		testVideoLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		mgbtnOffice = new ImageButton(composite_2, SWT.NONE);
		mgbtnOffice.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		mgbtnOffice.setText("Office环境检测");
		mgbtnOffice.setForeground(ColorConstants.FONT_BLACK_COLOR);
		mgbtnOffice.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		
		ESepator sepator = new ESepator(composite_2, SWT.NONE);
		sepator.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		sepator.setLineWidth(2);
		sepator.setLineStyle(SWT.LINE_DOT);
		sepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		softComposite = new Composite(composite_2, SWT.NONE);
		softComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_softComposite = new GridLayout(3, false);
		gl_softComposite.marginWidth = 20;
		softComposite.setLayout(gl_softComposite);
		softComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		officeCheckBtn= addTitleButton(softComposite, "office");
		
		officeCheckMessageLabel = new Label(softComposite, SWT.NONE);
		officeCheckMessageLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		officeCheckMessageLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		officeCheckMessageLabel.setText("未检测");
		officeCheckMessageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		officeOpLink = new ELink(softComposite, SWT.RIGHT);
		officeOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		excelChangePdfBtn= addTitleButton(softComposite, "excel转pdf");
		
		excelChangePdfStatus = new Label(softComposite, SWT.NONE);
		excelChangePdfStatus.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		excelChangePdfStatus.setForeground(SWTResourceManager.getColor(200, 200, 200));
		excelChangePdfStatus.setText("未检测");
		excelChangePdfStatus.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		excelChangePdfOpLink = new ELink(softComposite, SWT.RIGHT);
		excelChangePdfOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		wordlChangePdfBtn= addTitleButton(softComposite, "word转pdf");
		
		wordChangePdfStatus = new Label(softComposite, SWT.NONE);
		wordChangePdfStatus.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		wordChangePdfStatus.setForeground(SWTResourceManager.getColor(200, 200, 200));
		wordChangePdfStatus.setText("未检测");
		wordChangePdfStatus.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		wordChangePdfOpLink = new ELink(softComposite, SWT.RIGHT);
		wordChangePdfOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		
		CLabel otherTitle = new CLabel(composite_2, SWT.NONE);
		otherTitle.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		otherTitle.setText("第三方环境检测");
		otherTitle.setForeground(ColorConstants.FONT_BLACK_COLOR);
		otherTitle.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		
		ESepator sepator_1 = new ESepator(composite_2, SWT.NONE);
		sepator_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		sepator_1.setLineWidth(2);
		sepator_1.setLineStyle(SWT.LINE_DOT);
		sepator_1.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		otherEnviromentComposite = new Composite(composite_2, SWT.NONE);
		otherEnviromentComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_otherEnviromentComposite = new GridLayout(3, false);
		gl_otherEnviromentComposite.marginWidth = 20;
		otherEnviromentComposite.setLayout(gl_otherEnviromentComposite);
		otherEnviromentComposite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		handSignBtn = addTitleButton(otherEnviromentComposite, "手写签名控件");
		
		handSignStatusLabel = new Label(otherEnviromentComposite, SWT.NONE);
		handSignStatusLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		handSignStatusLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		handSignStatusLabel.setText("未检测");
		handSignStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		handSignOpLink = new ELink(otherEnviromentComposite, SWT.RIGHT);
		handSignOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		handSignOpLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				installDriverAction(handSignOpLink, PropertiesUtils.getProperty(ConfigConstants.HAND_SIGNATURE_PDF, ""));
			}
		});
		handSignOpLink.setText("安装驱动");
		handSignOpLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		saomaSignBtn = addTitleButton(otherEnviromentComposite, "扫码签名控件");
		
		saomaSignStatusLabel = new Label(otherEnviromentComposite, SWT.NONE);
		saomaSignStatusLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		saomaSignStatusLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		saomaSignStatusLabel.setText("未检测");
		saomaSignStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		
		saomaSignOpLink = new ELink(otherEnviromentComposite, SWT.RIGHT);
		saomaSignOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		saomaSignOpLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				installDriverAction(saomaSignOpLink, PropertiesUtils.getProperty(ConfigConstants.SAOMA_SIGNATURE_PDF, ""));
			}
		});
		saomaSignOpLink.setText("安装驱动");
		saomaSignOpLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		caSignBtn = addTitleButton(otherEnviromentComposite, "CA签章控件");
		
		caSignStatusLabel = new Label(otherEnviromentComposite, SWT.NONE);
		caSignStatusLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		caSignStatusLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		caSignStatusLabel.setText("未检测");
		caSignStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		caSignOpLink = new ELink(otherEnviromentComposite, SWT.RIGHT);
		caSignOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		pdfLoadBtn= addTitleButton(otherEnviromentComposite, "PDF加载控件");
		
		pdfLoadStatusLabel = new Label(otherEnviromentComposite, SWT.NONE);
		pdfLoadStatusLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		pdfLoadStatusLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		pdfLoadStatusLabel.setText("未检测");
		pdfLoadStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		pdfLoadOpLink = new ELink(otherEnviromentComposite, SWT.RIGHT);
		pdfLoadOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		pdfLoadOpLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		pdfLoadOpLink.setText("安装驱动");
		pdfLoadOpLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				installDriverAction(pdfLoadOpLink, PropertiesUtils.getProperty(ConfigConstants.PDF_ACTIVE_TYPE, DocumentFactory.DEFAULT_PDF_TYPE));
			}
		});
		
		ocxBtn= addTitleButton(otherEnviromentComposite, "ocx控件注册");
		
		ocxStatusLabel = new Label(otherEnviromentComposite, SWT.NONE);
		ocxStatusLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		ocxStatusLabel.setForeground(SWTResourceManager.getColor(200, 200, 200));
		ocxStatusLabel.setText("未检测");
		ocxStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		ocxOpLink = new ELink(otherEnviromentComposite, SWT.RIGHT);
		ocxOpLink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		ocxOpLink.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		ocxOpLink.setText("注册控件");
		ocxOpLink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				installDriverAction(ocxOpLink, ConfigConstants.OCX_REGSVR);
//				installOcxAction();
			}
		});
		
		init();
	}
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		
		 String caSignaturePdf = PropertiesUtils.getProperty(ConfigConstants.CA_SIGNATURE_PDF, "");
	     String handSignaturePdf = PropertiesUtils.getProperty(ConfigConstants.HAND_SIGNATURE_PDF, "");
	     String saomaSignaturePdf = PropertiesUtils.getProperty(ConfigConstants.SAOMA_SIGNATURE_PDF, "");
	     
	     if(StringUtils.isEmpty(handSignaturePdf)) {
	    	 WidgetUtils.setControlVisible(handSignBtn, false);
	    	 WidgetUtils.setControlVisible(handSignStatusLabel, false);
	    	 WidgetUtils.setControlVisible(handSignOpLink, false);
	     }
	     if(StringUtils.isEmpty(saomaSignaturePdf)) {
	    	 WidgetUtils.setControlVisible(saomaSignBtn, false);
	    	 WidgetUtils.setControlVisible(saomaSignStatusLabel, false);
	    	 WidgetUtils.setControlVisible(saomaSignOpLink, false);
	     }
	     if(StringUtils.isEmpty(caSignaturePdf)) {
	    	 WidgetUtils.setControlVisible(caSignBtn, false);
	    	 WidgetUtils.setControlVisible(caSignStatusLabel, false);
	    	 WidgetUtils.setControlVisible(caSignOpLink, false);
	     }
	     refresh();
	}
	
	/**
	 * @Description: 刷新
	 * @author guoyr
	 * @param arges 
	 */
	public void refresh() {
		
		checkOnline();
		//检测语音安装包安装状态
		checkTTSVideo();
		
		checkOfficeVersion();
		
		changeExcel2Pdf();
		
		changeWord2Pdf();
		
		checkDriver(true);
	}
	
	/**
	 * @Description: 检查驱动
	 * @author guoyr
	 * @param autoInstall 
	 */
	public void checkDriver(boolean autoInstall) {
		
		if(null != myThreadSet) {
			myThreadSet.stop();
		}
		if(null == installSoftCode) {
			installSoftCode = new ArrayList<String>();
		}else {
			installSoftCode.clear();
		}
		myThreadSet = new SyncThreadSet(new SyncThreadSet.Runnable() {
			public void run() {
				PropertiesUtils.saveProperty("ENVIRONMENT", "01");
				if(installSoftCode.size() > 0 && autoInstall) {
					Display.getDefault().syncExec(() -> {
						if(!baseEnviromentComposite.isDisposed()) {
							ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, "当前系统环境下还有未安装的驱动程序！", null);
							confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
							confirmDialog.addButton("一键安装", "01");
							confirmDialog.addCancel("手动安装", null);
							confirmDialog.open();
							if("01".equals(confirmDialog.getClickStatus())) {
								doInstallDriverAction(installSoftCode);
							}
						}
					});
				}
			}
		});
		
		if(saomaSignBtn.getVisible()) {
			checkSinatureDocumentLoaderDriver(saomaSignBtn, saomaSignStatusLabel, saomaSignOpLink, PropertiesUtils.getProperty(ConfigConstants.SAOMA_SIGNATURE_PDF, ""));
		}
		
		if(caSignBtn.getVisible()) {
			checkSinatureDocumentLoaderDriver(caSignBtn, caSignStatusLabel, caSignOpLink, PropertiesUtils.getProperty(ConfigConstants.CA_SIGNATURE_PDF, ""));
		}
		
		if(handSignBtn.getVisible()) {
			checkSinatureDocumentLoaderDriver(handSignBtn, handSignStatusLabel, handSignOpLink, PropertiesUtils.getProperty(ConfigConstants.HAND_SIGNATURE_PDF, ""));
		}
		
		// PDF阅读器
		checkSinatureDocumentLoaderDriver(pdfLoadBtn, pdfLoadStatusLabel, pdfLoadOpLink, PropertiesUtils.getProperty(ConfigConstants.PDF_ACTIVE_TYPE, DocumentFactory.DEFAULT_PDF_TYPE));
		
		checkOcxDriver(ocxBtn, ocxStatusLabel, ocxOpLink);
		myThreadSet.start();
	}

	
	/**
	 * @Description: 检测项标题
	 * @author guoyr
	 * @param parent
	 * @param title
	 * @return 
	 */
	private ImageButton addTitleButton(Composite parent, String title){
		ImageButton titleLabel = new ImageButton(parent, SWT.NONE | SWT.LEFT);
		GridData gd_title = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_title.widthHint = 250;
		titleLabel.setLayoutData(gd_title);
		titleLabel.setTopMargin(3);
		titleLabel.setBottomMargin(3);
		titleLabel.setLeftMargin(5);
		titleLabel.setRightMargin(5);
		titleLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		titleLabel.setSurroundMargin(5);
		titleLabel.setSurroundBorder(2);
		titleLabel.setFillSurround(false);
		titleLabel.setGAP(3);
		titleLabel.setSurroundColor(BULE_COLOR);
		titleLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/about.png"));
		titleLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		titleLabel.setText(title);
		return titleLabel;
	}



    /**
     * @Description: 检测本机联网状态
     * @author guoyr
     * @param checkFlagBtn
     * @param checkResultLabel 
     */
    private void checkOnline(){
    	openLink.setVisible(false);
    	onCheckEnviroment(netTestBtn, netCheckMessageLabel);
    	// 检测本机联网状态
    	new Thread(new Runnable(){
    		public void run() {
    			if(NetWorkUtils.isConnNet()){
					showCheckResult(true, "已连接到网络", netTestBtn, netCheckMessageLabel);
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!openLink.isDisposed()){
								openLink.setVisible(true);
							}
						}
					});
				}else {
					showCheckResult(false, "未连接到网络", netTestBtn, netCheckMessageLabel);
				}
    		}
    	}).start();
    }
	
 
	
	/**
	 * @Description: 检测office版本
	 * @author guoyr
	 * @param checkFlagBtn
	 * @param checkResultLabel 
	 */
	private void checkOfficeVersion(){
		onCheckEnviroment(officeCheckBtn, officeCheckMessageLabel);
		// 检测Office控件注册状态
		new Thread(new Runnable(){
			public void run() {
				int officeVersion = 0;
				try {  
					Process ps = null;  
					ps = Runtime.getRuntime().exec("reg query HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Office");  
					ps.getOutputStream().close();  
					InputStreamReader i = new InputStreamReader(ps.getInputStream());  
					String line;  
					BufferedReader ir = new BufferedReader(i);  
					while ((line = ir.readLine()) != null) { 
						if(line.length()>47){
							line = line.substring(45,47);
							if(isInteger(line)){
								if(Integer.parseInt(line)> officeVersion){
									officeVersion = Integer.parseInt(line);
								}
							}
						}
					} 
				} catch (IOException e) {  
					LOG.error("未安装 MicroSoft Office", e);
				}  
				if(officeVersion != 0){
					showCheckResult(true, "MicroSoft Office", officeCheckBtn, officeCheckMessageLabel);
//					showCheckResult(true, "MicroSoft Office 20" + officeVersion, officeCheckBtn, officeCheckMessageLabel);
				}else {
					showCheckResult(false, "未安装 MicroSoft Office", officeCheckBtn, officeCheckMessageLabel);
				}
			}
		}).start();
	}
	
	private void changeExcel2Pdf(){
		onCheckEnviroment(excelChangePdfBtn, excelChangePdfStatus);
		new Thread(new Runnable(){
			public void run() {
				File testFile = FileConstants.getResourceFile("TEST.xlsx");
				if(testFile.exists()) {
					File tempFile = new File(FileConstants.TEMP_FOLDER.concat(UuidUtils.getUUID()).concat(testFile.getName()));
					FileUtils.copy(testFile.getAbsolutePath(), tempFile.getAbsolutePath());
					File pdfFile = new File(FileConstants.TEMP_FOLDER.concat(tempFile.getName()).concat(".pdf"));
					pdfFile = TransferUtils.convert2PDF(tempFile.getAbsolutePath(), pdfFile.getAbsolutePath());
					if(null != pdfFile && pdfFile.exists()){
						showCheckResult(true, "可转换", excelChangePdfBtn, excelChangePdfStatus);
						if(!tempFile.delete()) {
							tempFile.deleteOnExit();
						}
						if(!pdfFile.delete()) {
							pdfFile.deleteOnExit();
						}
					}else {
						showCheckResult(false, "不可转换（尝试整安装并激活office或手动另存为pdf）", excelChangePdfBtn, excelChangePdfStatus);
					}
				}else {
					showCheckResult(false, "未检测", excelChangePdfBtn, excelChangePdfStatus);
				}
			}
		}).start();
	
	}
	private void changeWord2Pdf(){
		onCheckEnviroment(wordlChangePdfBtn, wordChangePdfStatus);
		new Thread(new Runnable(){
			public void run() {
				File testFile = FileConstants.getResourceFile("TEST.docx");
				if(testFile.exists()) {
					File tempFile = new File(FileConstants.TEMP_FOLDER.concat(UuidUtils.getUUID()).concat(testFile.getName()));
					FileUtils.copy(testFile.getAbsolutePath(), tempFile.getAbsolutePath());
					File pdfFile = new File(FileConstants.TEMP_FOLDER.concat(tempFile.getName()).concat(".pdf"));
					pdfFile = TransferUtils.convert2PDF(tempFile.getAbsolutePath(), pdfFile.getAbsolutePath());
					if(null != pdfFile && pdfFile.exists()){
						showCheckResult(true, "可转换", wordlChangePdfBtn, wordChangePdfStatus);
						if(!tempFile.delete()) {
							tempFile.deleteOnExit();
						}
						if(!pdfFile.delete()) {
							pdfFile.deleteOnExit();
						}
					}else {
						showCheckResult(false, "不可转换（尝试整安装并激活office或手动另存为pdf）", wordlChangePdfBtn, wordChangePdfStatus);
					}
				}else {
					showCheckResult(false, "未检测", wordlChangePdfBtn, wordChangePdfStatus);
				}
			}
		}).start();
		
	}
	
	/**
	 * @Description: 检测签章控件驱动
	 * @author guoyr
	 * @param checkBtn
	 * @param checkStatusLabel
	 * @param checkOpELink
	 * @param signatureType 
	 */
	private void checkSinatureDocumentLoaderDriver(final ImageButton checkBtn, final Label checkStatusLabel, final ELink checkOpELink, String signatureType) {
		checkOpELink.setVisible(true);
		onCheckEnviroment(checkBtn, checkStatusLabel);
		myThreadSet.addSyncExec(new SyncThread(signatureType, new SyncThread.Runnable() {
			public void run() {
				File reviewDisciplineFile = FileConstants.getResourceFile(FileConstants.REVIEW_DISCIPLINE_FILE+".pdf");
				DocumentLoader documentLoader = DocumentFactory.getDocumentLoader(reviewDisciplineFile.getAbsolutePath(), signatureType);
				final boolean isDrived = documentLoader.isDrived();
				if(isDrived){
					showCheckResult(true, "驱动已安装" , checkBtn, checkStatusLabel);
				}else {
					installSoftCode.add(signatureType);
					showCheckResult(false, "驱动未安装" , checkBtn, checkStatusLabel);
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!checkOpELink.isDisposed()){
							checkOpELink.setVisible(true);
							if(isDrived) {
								checkOpELink.setText("（卸载）重新安装驱动");
							}else {
								checkOpELink.setText("安装驱动");
							}
							checkOpELink.getParent().layout();
						}
					}
				});
			
			}
		}));
	}
	
	/**
	 * @Description: TTS语音包检测
	 * @author guoyr
	 * @param checkFlagBtn
	 * @param checkResultLabel 
	 */
	private void checkTTSVideo(){
		onCheckEnviroment(videoTestBtn, videoCheckMessageLabel);
		testVideoLink.setVisible(false);
		new Thread(new Runnable(){
			public void run() {
				ITTS tts = TTSEnginUtil.getTTSEngin();
				if(tts.isDrived() && tts.init()){
					showCheckResult(true, "TTS语音正常" , videoTestBtn, videoCheckMessageLabel);
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!testVideoLink.isDisposed()){
								testVideoLink.setVisible(true);
							}
						}
					});
				}else{
					showCheckResult(true, "TTS语音异常" ,videoTestBtn, videoCheckMessageLabel);
				}
			}
		}).start();
	}

    /**  
    * testsound:语音播报<br/>  
    * @author wangxiang  
    * @throws IOException  
    */
   private void testsound()throws IOException {
	   if(testVideoLink.getEnabled()){
		   TTSEnginUtil.getTTSEngin().speak("欢迎使用，" + PropertiesUtils.getProperty(ConfigConstants.SERVER_NAME, "") + ":" +com.gx.obe.components.core.I18N.getString("productName"));
	   }
   }
   
	/**
	 * @Description: 检测插件注册
	 * @author guoyr
	 * @param checkBtn
	 * @param checkStatusLabel
	 * @param checkOpELink 
	 */
	private void checkOcxDriver(final ImageButton checkBtn, final Label checkStatusLabel, final ELink checkOpELink) {
		checkOpELink.setVisible(true);
		onCheckEnviroment(checkBtn, checkStatusLabel);
		myThreadSet.addSyncExec(new SyncThread("插件注册", new SyncThread.Runnable() {
			public void run() {
//				VeryPdfLoaderImpl documentLoader = new VeryPdfLoaderImpl();
				GuoxinPdfLoaderImpl documentLoader = new GuoxinPdfLoaderImpl("");
				final boolean isDrived = documentLoader.isDrived();
				if(isDrived){
					showCheckResult(true, "控件已注册" , checkBtn, checkStatusLabel);
				}else {
					installSoftCode.add(ConfigConstants.OCX_REGSVR);
					showCheckResult(false, "控件未注册" , checkBtn, checkStatusLabel);
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!checkOpELink.isDisposed()){
							checkOpELink.setVisible(true);
							if(isDrived) {
								checkOpELink.setText("重新注册控件");
							}else {
								checkOpELink.setText("注册控件");
							}
							checkOpELink.getParent().layout();
						}
					}
				});
			}
		}));
	
	}
   
	/**
	 * @Description: 开始检测环境
	 * @author guoyr
	 * @param checkFlagBtn
	 * @param checkResultLabel 
	 */
	private void onCheckEnviroment(ImageButton checkFlagBtn, Label checkResultLabel){
		checkFlagBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/hourglass.png"));
		checkResultLabel.setText("正在检测...");
		checkFlagBtn.setSurroundColor(BULE_COLOR);
		checkFlagBtn.setFillSurround(false);
		checkResultLabel.setForeground(BULE_COLOR);
	}
	
	/**
	 * @Description: 设置检测结果
	 * @author guoyr
	 * @param flag
	 * @param message
	 * @param checkFlagBtn
	 * @param checkResultLabel 
	 */
	private void showCheckResult(final boolean flag, final String message, final ImageButton checkFlagBtn, final Label checkResultLabel){
		Display.getDefault().syncExec(new Runnable(){
			public void run() {
				if(!checkResultLabel.isDisposed()){
					checkResultLabel.setText(message);
					if(flag){
//						checkResultLabel.setForeground(SWTResourceManager.getColor(77, 163, 19));
						checkFlagBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
						checkResultLabel.setForeground(BULE_COLOR);
					}else {
						checkResultLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
						checkFlagBtn.setFillSurround(true);
						checkFlagBtn.setSurroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
						checkFlagBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/close.png"));
					}
				}
				
			}
		});
		
	}
	
	private void installDriverAction(final ELink opLink, String softType) {
		if(!opLink.getEnabled())return;
		List<String> softCodeList = new ArrayList<>();
		softCodeList.add(softType);
		doInstallDriverAction(softCodeList);
	}
	
	private void doInstallDriverAction(List<String> softCodeList) {
		
		ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(() -> {
					if(!baseEnviromentComposite.isDisposed()) {
						checkDriver(false);
					}
				});
			}
		});
		messageProgress.setTitle("正在安装驱动...");
		messageProgress.setOperateVisible(false);
		messageProgress.setForceClose(true);
		messageProgress.setCountDownTime(3);
		new Thread(()->{
			int successCount = 0;
			int faildCount = 0;
			for(String softCode : softCodeList) {
				Software software = SoftwareUtils.getSoftwareByCode(softCode); 
				if(null != software) {
					messageProgress.message("正在下载" + software.getSoftwareName(), 0);
					SoftwareUtils.downloadDownload(software, new DownloadFileAdapter() {
						public void progress(int percent) {
						};
						public void complate(boolean flag) {
							if(flag) {
								messageProgress.message("已下载" + software.getSoftwareName(), 1);
							}else {
								messageProgress.message(software.getSoftwareName() + "下载失败！" , -1);
							}
						}
					});
					File installFile = SoftwareUtils.getSoftwareInstallFile(software);
					if(installFile.exists()) {
						messageProgress.message("正在安装" + software.getSoftwareName(), 0);
						if(RuntimeUtils.execFile(installFile.getAbsolutePath())) {
							successCount ++;
						}else {
							RuntimeUtils.openFIle(installFile);
							successCount ++;
						}
					}else {
						faildCount ++;
						messageProgress.message("未找到安装文件！", -1);
					}
				}else {
					faildCount ++;
					messageProgress.message("未找到安装文件！", -1);
				}
			}
			messageProgress.finish(successCount > 0 && faildCount == 0);
		}).start();
		messageProgress.open();
	}
	
	private void installOcxAction() {
		if(!ocxOpLink.getEnabled())return;
		final File ocxBatFile = new File(INSTRALL_PATH.concat(File.separator).concat("ocx_files").concat(File.separator).concat("注册插件.bat"));
		if(null != ocxBatFile && ocxBatFile.exists()) {
			ProgressMessageDialog progressDialog = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
				@Override
				public void finish(boolean flag) {
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if(!ocxOpLink.isDisposed()) {
								ocxOpLink.setEnabled(true);
							}
						}
					});
				}
				
			});
			new Thread(new Runnable() {
				public void run() {
					RuntimeUtils.execFile(ocxBatFile.getAbsolutePath());
					progressDialog.finish(true);
				}
			}).start();
			progressDialog.setTitle("正在注册控件...");
			progressDialog.open();
		}else {
			MessageDialog.openShortMessage("未找到控件注册文件！");
		}
	}
	
	/*
     * 判断是否为整数 
     * @param str 传入的字符串 
     * @return 是整数返回true,否则返回false 
   */
     public static boolean isInteger(String str) {  
           Pattern pattern = Pattern.compile("^[-\\+]?[\\d]*$");  
           return pattern.matcher(str).matches();  
     }
     
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}


}
