package com.gx.obe.common.composite;

import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierEvaluationResult;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.expert.ExpertEvaluationResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierEvaluationResultService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.UserService;
import com.gx.obe.web.service.expert.ExpertEvaluationResultService;
import com.swtdesigner.SWTResourceManager;

public class EvaluactionOpinionComposite extends Composite {
	private SupplierService supplierService = new SupplierService();
	private TenderProjectEntity tenderProjectEntity;
	private Composite parentComposite;
	private ScrolledComposite scrolledComposite;
	private Composite composite_2;
	private Composite supplierListComposite;
	private Grid grid;
	private Label label;
	private Text supplierEvaluactionOpinion;
	private EButton submit_result_btn;
//	private Composite labelComposite;
	private ESepator sepator;
	private Label label_1;
	private ExpertEvaluationResultService expertEvaluationResultService;
	private UserService userService;
	private SupplierEvaluationResultService supplierEvaluationResultService;
//	private EvaluationFactorResultService evaluationFactorResultService = new EvaluationFactorResultService();
	private Composite childListComposite;
	private Composite composite_4;
	private Composite composite_5;
	private SupplierEvaluationResult supplierEvaluationResult;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public EvaluactionOpinionComposite(Composite parent, int style) {
		super(parent, style);
		this.tenderProjectEntity = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		GridLayout gridLayout = new GridLayout(3, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		composite_2 = new Composite(this, SWT.NONE);
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.marginHeight = 0;
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginWidth = 0;
		composite_2.setLayout(gl_composite_2);
		GridData gd_composite_2 = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
		gd_composite_2.widthHint = 300;
		composite_2.setLayoutData(gd_composite_2);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		supplierListComposite = new Composite(composite_2, SWT.NONE);
		supplierListComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.verticalSpacing = 0;
		gl_composite_4.horizontalSpacing = 0;
		gl_composite_4.marginHeight = 0;
		gl_composite_4.marginWidth = 0;
		supplierListComposite.setLayout(gl_composite_4);
		supplierListComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		grid = new Grid(supplierListComposite, SWT.BORDER | SWT.V_SCROLL);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		GridColumn column = new GridColumn(grid, SWT.NONE);
//		column.setText("供应商名称");
		grid.setItemHeaderWidth(30);
		grid.setHeaderVisible(true);
		grid.setItemHeight(35);
		grid.setAutoWidth(true);
		
		
		GridColumn gridColumn_num = new GridColumn(grid, SWT.LEFT);
		gridColumn_num.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		gridColumn_num.setText("供应商名称");
		gridColumn_num.setWidth(300);
		gridColumn_num.setMaxmumWidth(300);
		
		ESepator factor_sep = new ESepator(this, SWT.HORIZONTAL);
		factor_sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 0;
		gl_composite_1.horizontalSpacing = 0;
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite = new Composite(composite_1, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		label_1 = new Label(composite, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label_1.setText("专家评审意见");
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		label_1.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		ESepator upSepator = new ESepator(composite_1, SWT.VIRTUAL);
		upSepator.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		upSepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		scrolledComposite = new ScrolledComposite(composite_1, SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		parentComposite = new Composite(scrolledComposite, SWT.NONE);
		GridData gd_signatureUser_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_signatureUser_composite.widthHint = 400;
		parentComposite.setLayoutData(gd_signatureUser_composite);
		parentComposite.setLayout(new GridLayout(1, false));
		
		childListComposite = new Composite(parentComposite, SWT.NONE);
		GridLayout gl_childListComposite = new GridLayout(3, false);
		gl_childListComposite.horizontalSpacing = 20;
		childListComposite.setLayout(gl_childListComposite);
		childListComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setContent(parentComposite);
		scrolledComposite.setMinSize(parentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		sepator = new ESepator(composite_1, SWT.VIRTUAL);
		sepator.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		sepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		
		Composite composite_3 = new Composite(composite_1, SWT.NONE);
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 0;
		gl_composite_3.horizontalSpacing = 0;
		gl_composite_3.marginHeight = 0;
		gl_composite_3.marginWidth = 0;
		composite_3.setLayout(gl_composite_3);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		
		composite_4 = new Composite(composite_3, SWT.NONE);
		composite_4.setLayout(new GridLayout(1, false));
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		label = new Label(composite_4, SWT.NONE);
		label.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, false, 1, 1));
		label.setText("评（废）标意见");
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		ESepator downSepator = new ESepator(composite_3, SWT.VIRTUAL);
		downSepator.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		downSepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
	
		supplierEvaluactionOpinion = new Text(composite_3, SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
//		text.setForeground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
//		text.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
//		text.setToolTipText("请输入评（废）标意见");
		GridData gd_text = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_text.heightHint = 150;
		supplierEvaluactionOpinion.setLayoutData(gd_text);
		supplierEvaluactionOpinion.setTextLimit(1000);
		
		ESepator bottonSepator = new ESepator(composite_3, SWT.VIRTUAL);
		bottonSepator.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		bottonSepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		composite_5 = new Composite(composite_3, SWT.NONE);
		composite_5.setLayout(new GridLayout(1, false));
		composite_5.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
		
		submit_result_btn = new EButton(composite_5, EButton.CSS_GREEN);
		submit_result_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveSupplierEvaluactionOpinion();
			}
		});
		submit_result_btn.setEnabled(false);
		
		submit_result_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_signBtn = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_signBtn.heightHint = 35;
		gd_signBtn.widthHint = 200;
		submit_result_btn.setLayoutData(gd_signBtn);
		
		submit_result_btn.setText(Messages.Button_save);
		init();
	}
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		expertEvaluationResultService = new ExpertEvaluationResultService();
		supplierEvaluationResultService = new SupplierEvaluationResultService();
		
		grid.addListener(SWT.Selection, new GridSelectionListener(){

			@Override
			public void leftMouseButtonDown(GridItem item) {
				Supplier supplier  = (Supplier)item.getData("supplier");
				if(null != supplier){
					supplierSelect(supplier);
				}
			}
		});
		List<Supplier> supplierList = supplierService.getAllSupplierList(tenderProjectEntity.getId());
		if(null != supplierList && supplierList.size() > 0 ){
			for(Supplier supplier : supplierList){
				GridItem item = new GridItem(grid, SWT.NONE);
				item.setText(0, supplier.getSupplierName());
				item.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
				item.setData("supplier", supplier);
			}
			grid.setSelection(0);
			supplierSelect(supplierList.get(0));
		}
	}
	
	
	/**
	 * @Description: 选择供应商事件
	 * @author guoyr
	 * @param supplier 
	 */
	private void supplierSelect(Supplier supplier){
		submit_result_btn.setEnabled(true);
		for(Control control : childListComposite.getChildren()){
			control.dispose();
		}
		List<ExpertEvaluationResult> expertEvaluationResultList = expertEvaluationResultService.getSupplierAllEvaluationResultList(tenderProjectEntity.getId(),supplier.getId());
		if(null != expertEvaluationResultList && expertEvaluationResultList.size() > 0){
			for(ExpertEvaluationResult expertEvaluationResult : expertEvaluationResultList){
				if(null != expertEvaluationResult.getAccessment() && expertEvaluationResult.getAccessment().equals(com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED)){
					if(null == userService){
						userService = new UserService();
					}
					AuthUser user = userService.findById(expertEvaluationResult.getUserId());
					if(null != user && null != user.getUserName()){
						EvaluactionOpinionItem item = new EvaluactionOpinionItem(childListComposite, SWT.NONE);
						item.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
						item.reflashData(user.getUserName(), null != expertEvaluationResult.getSupplierOpinion() ? expertEvaluationResult.getSupplierOpinion() : "");
					}
				}
			}
		}
 
		supplierEvaluationResult =	supplierEvaluationResultService.getSupplierEvaluationResultByTenderIdAndSupplierId(tenderProjectEntity.getId(),supplier.getId());
		if(null == supplierEvaluationResult){
			supplierEvaluationResult = new SupplierEvaluationResult();
			supplierEvaluationResult.setTenderId(tenderProjectEntity.getId());
			supplierEvaluationResult.setSupplierId(supplier.getId());
		}
		supplierEvaluactionOpinion.setText(null != supplierEvaluationResult.getEvaluationOpinion() ? supplierEvaluationResult.getEvaluationOpinion() : "");
		parentComposite.layout();
		scrolledComposite.setContent(parentComposite);
		scrolledComposite.setMinSize(parentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));	
	}
	
	/**
	 * @Description: 保存操作
	 * @author guoyr 
	 */
	private void saveSupplierEvaluactionOpinion(){
		if(submit_result_btn.getEnabled()){
			if(supplierEvaluactionOpinion.getText().trim().length() > 0){
				if(null != supplierEvaluationResult){
					supplierEvaluationResult.setEvaluationOpinion(supplierEvaluactionOpinion.getText().trim());
					boolean result = supplierEvaluationResultService.saveOrUpdate(supplierEvaluationResult);
					if(result){
						MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
					}else{
						MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
					}
				}
			}else{
				MessageDialog.openShortMessage( "请输入评（废）标意见！");
			}
			
		}
	}
	@Override
	protected void checkSubclass() {
	}
}
