package com.gx.obe.common.composite;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.swtdesigner.SWTResourceManager;

public class EvaluactionOpinionItem extends Composite {

	private Label expertName;
	private Text lblOpinion;
	private Composite composite_1;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public EvaluactionOpinionItem(Composite parent, int style) {
		super(parent, style);
		setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 1;
		gridLayout.horizontalSpacing = 1;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		composite_1 = new Composite(this, SWT.NONE);
		composite_1.setLayout(new GridLayout(1, false));
		composite_1.setBackground(SWTResourceManager.getColor(247,247,247));
		GridData gd_composite_1 = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_composite_1.heightHint = 40;
		composite_1.setLayoutData(gd_composite_1);
		expertName = new Label(composite_1, SWT.NONE);
		expertName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		expertName.setBackground(SWTResourceManager.getColor(247,247,247));
		//		expertName.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		expertName.setAlignment(SWT.CENTER);
		expertName.setText("专家1");
		expertName.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		expertName.setForeground(ColorConstants.FONT_BLACK_COLOR);
				
		
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginWidth = 0;
		gl_composite.marginHeight = 0;
		composite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.heightHint = 200;
//		gd_composite.widthHint = 250;
		composite.setLayoutData(gd_composite);
		
		lblOpinion = new Text(composite, SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
		lblOpinion.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		lblOpinion.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridData gd_lblOpinion = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_lblOpinion.widthHint = 100;
		lblOpinion.setLayoutData(gd_lblOpinion);
//		lblOpinion.setText("婴儿容易发生缺钙的现象,然而若父母不了解宝宝缺钙时的表现,在宝宝可能已经缺钙的时候仍熟视无睹,宝宝可能会因此而发展成重度缺钙,而引起佝偻病等问题。因此,了解...");

	}
	/**
	 * @Description: 设置界面内容
	 * @author guoyr
	 * @param name
	 * @param opinion 
	 */
	public void reflashData(String name, String opinion){
		expertName.setText(name);
		lblOpinion.setText(opinion);
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
