package com.gx.obe.common.composite;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.poi.ss.usermodel.CellStyle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.common.dialog.EditPriceDialog;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.listener.CorrectPriceListener;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.util.MoneyUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.report.poi.Excel;
import com.gx.obe.report.poi.ExcelRow;
import com.gx.obe.report.poi.ExcelStyle;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.price.BidPrice;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.SupplierOpeningResultService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.KTableCellSelectionAdapter;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.editors.KTableCellEditorLink;
import de.kupzog.ktable.editors.KTableCellEditorText;
import de.kupzog.ktable.model.CommonKtableCModel;
import de.kupzog.ktable.renderers.CellAlignmentRender;
import de.kupzog.ktable.renderers.CellContentRender;
import de.kupzog.ktable.renderers.CellEditorRender;
import de.kupzog.ktable.renderers.CellEventActionRender;
import de.kupzog.ktable.renderers.CellForegroundRender;
import de.kupzog.ktable.renderers.CellImageRender;
import de.kupzog.ktable.renderers.CellRender;
import de.kupzog.ktable.renderers.FixedCellRenderer;
import de.kupzog.ktable.renderers.LinkCellRenderer;
import de.kupzog.ktable.renderers.TextCellRenderer;
/**
 * @Description: 
 * @author guoyr
 */
public class EvaluationPriceTableComposite extends Composite implements IEvaluationPriceTable{
	
	private SupplierOpeningResultService supplierOpeningResultService = new SupplierOpeningResultService();
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private List<Supplier> supplierList = new ArrayList<Supplier>();
	private KTable resultKTable;
	private CommonKtableCModel commKTableModel;
	private Composite contentComposite;
	private Composite composite_1;
	private int curCol;
	private int curRow;
	private String EVAL_PRICE = Messages.EvaluationPrice;
	private Supplier supplier;
	private boolean editable;
	static{
		
		/**
		 * 第三层验证
		 * **/
		try {
			// 这是公钥
			String publicKey = "308201b83082012c06072a8648ce3804013082011f02818100fd7f53811d75122952d" +
					"f4a9c2eece4e7f611b7523cef4400c31e3f80b6512669455d402251fb593d8d58fabfc5f5ba30f6cb9b5" +
					"56cd7813b801d346ff26660b76b9950a5a49f9fe8047b1022c24fbba9d7feb7c61bf83b57e7c6a8a6150f" +
					"04fb83f6d3c51ec3023554135a169132f675f3ae2b61d72aeff22203199dd14801c70215009760508f15230" +
					"bccb292b982a2eb840bf0581cf502818100f7e1a085d69b3ddecbbcab5c36b857b97994afbbfa3aea82f957" +
					"4c0b3d0782675159578ebad4594fe67107108180b449167123e84c281613b7cf09328cc8a6e13c167a8b54" +
					"7c8d28e0a3ae1e2bb3a675916ea37f0bfa213562f1fb627a01243bcca4f1bea8519089a883dfe15ae59f06928" +
					"b665e807b552564014c3bfecf492a0381850002818100def368b8757ce205e46b76640e4886cbd1604753a90" +
					"cb07527b834a65e83b4f21b97ef443097e882e7c18dea3daea499e31201fa8e4df0f36b0cc00a64a01ccdd831" +
					"f2856b7549f0eae5d7150fe5800e40bb3b25e3b2a38c51b3f07edd6c90b6f3db70ac12bc11d480cbcaa23a9f30" +
					"f4db77c0928f3faf477f5e672f43a42a73";
			byte pub[] = com.gx.security.CertUtil.decodeHex(publicKey);
			java.security.spec.X509EncodedKeySpec pubKeySpec = new java.security.spec.X509EncodedKeySpec(pub);
			java.security.KeyFactory keyFactory = java.security.KeyFactory.getInstance(com.gx.security.CertEnum.KEY_INIT_CODE);
			java.security.PublicKey pubKey = keyFactory.generatePublic(pubKeySpec);
			java.security.Signature sig = java.security.Signature.getInstance(com.gx.security.CertEnum.SIGN_RNG_NAME);/* 建立一个签名并用公共密钥初始化 */
			sig.initVerify(pubKey);
			// 这里指定license文件
			File licenseFile = new File(FileConstants.PRODUCT_ROOT + com.gx.security.CertValidator.getInstance().getSequence()+".cer");
			BufferedReader in = new BufferedReader(new FileReader(licenseFile));
			String certificateXml = com.gx.security.CertUtil.decodeBase64(in.readLine());// 解码
			in.close();
			com.gx.security.Cert certificate = com.gx.security.CertUtil.fromXML(certificateXml);// 从xml读取license
			sig.update(certificate.getSignnatureData());/* 更新并校验数据 */
			boolean flag = sig.verify(com.gx.security.CertUtil.decodeHex(certificate.getSignature()));
			if(!flag){
				throw new com.gx.security.SecurityRuntimeException("您的授权证书无效 ，请与"+certificate.getIssuer()+"联系。");
			}
			if (certificate.getExpiresDate().before(com.gx.security.NowTimeUtils.getNowDate())) {
				throw new com.gx.security.SecurityRuntimeException("您的授权证书已过期，请与"+certificate.getIssuer()+"联系。");
			}
			boolean valMac = true;
			// 如果是试用版本则不需要验证mac
			if(certificate.getCertType().getType().equals(com.gx.security.Cert.CertType.TRIAL.getType())){
				valMac = false;
			}
			if (valMac && null != certificate.getMotherBoardSN()) {
				if (!certificate.getMotherBoardSN().contains(com.gx.security.CertValidator.getInstance().getMotherBoardSN())) {
					throw new com.gx.security.SecurityRuntimeException("不是当前设备SN的授权文件，请与"+certificate.getIssuer()+"联系。");
				}
			}
			if (valMac && null != certificate.getMac()) {
				if (!certificate.getMac().contains(com.gx.security.CertValidator.getInstance().getMac())) {
					throw new com.gx.security.SecurityRuntimeException("不是当前设备的授权文件，请与"+certificate.getIssuer()+"联系。");
				}
			}
		} catch (Exception e) {
			throw new com.gx.security.SecurityRuntimeException(e);
		}
	}
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public EvaluationPriceTableComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		this.tenderProjectEntity = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		
		composite_1 = new Composite(this, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_1.setBackground(SWTResourceManager.getColor(211, 211, 211));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 1;
		gl_composite_1.marginWidth = 1;
		composite_1.setLayout(gl_composite_1);
		
		contentComposite = new Composite(composite_1, SWT.NONE);
		contentComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		contentComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		contentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_contentComposite = new GridLayout(1, false);
		gl_contentComposite.verticalSpacing = 0;
		gl_contentComposite.horizontalSpacing = 0;
		gl_contentComposite.marginHeight = 0;
		gl_contentComposite.marginWidth = 0;
		contentComposite.setLayout(gl_contentComposite);
		
		resultKTable = new KTable(contentComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.EDIT_ON_KEY | SWTX.FILL_WITH_LASTCOL);
		resultKTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		resultKTable.addCellSelectionListener(new KTableCellSelectionAdapter(){
			public void cellSelected(int col, int row, int statemask) {
				if(row >= commKTableModel.getFixedRowCount()){
					supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
				}
			}
		});
		resultKTable.setModel(commKTableModel);
	}
	
	/**
	 * @Description: 修正评标价
	 * @author chenxw
	 */
	public void editBidPriceAction() {
		if (null == supplier) {
			return;
		}
		final SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		EditPriceDialog dialog = new EditPriceDialog(getShell(), 
				supplier.getSupplierName(), 
				supplierOpeningResult.getBidPrice(), 
				supplierOpeningResult.getEvaluationPrice(), 
				tenderProjectRuleEntity.getEvalPriceUnit(), 
				supplierOpeningResult.getModifyReason());
		dialog.setTitle("修正"+EVAL_PRICE);
		dialog.addCorrectPriceListener(new CorrectPriceListener() {
			public void correctedPrice(BigDecimal correctedPrice, String modifyReason) {
				supplierOpeningResult.setEvaluationPrice(correctedPrice);
				supplierOpeningResult.setModifyReason(modifyReason);
				supplierOpeningResultService.updateAssignProperty(supplierOpeningResult, new String[]{"id","evaluationPrice", "modifyReason"});
			}
		});
		dialog.open();
		resultKTable.redraw();
		commKTableModel.setChanged(true);
	}
	
	/**
	 * @Description: 刷新评标价
	 * @author guoyr
	 * @param tenderProjectEntity
	 * @param tenderProjectRuleEntity
	 * @param supplierList
	 * @param bidPriceList 
	 */
	public void refreshEvaluationPrice(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, List<Supplier> supplierList, List<BidPrice> bidPriceList, boolean editable){
		this.tenderProjectEntity = tenderProjectEntity;
		this.tenderProjectRuleEntity = null == tenderProjectRuleEntity ? new TenderProjectRuleEntity() : tenderProjectRuleEntity;
		this.supplierList = supplierList;
		this.editable = editable;

		refreshEvaluationPriceTable();
	}
	
	private void refreshEvaluationPriceTable() {
		final int sequencecol = 0;
		final int supplierNamecol = 1;
		final int bidPrciecol = 2;
		final int evaluationPricecol = 3;
		final int reasoncol = 4;
		final int actioncol = editable ? 5 : -1;
		
		resultKTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		commKTableModel = new CommonKtableCModel(resultKTable, 1, 0, supplierList.size(), editable ? 7 : 6);
		resultKTable.setAutoComputerSurplusWidth(false);
		
		
		commKTableModel.setContentRowHeight(Constants.ROW_HIGHT);
		commKTableModel.setColumnWidth(sequencecol, 50);
		commKTableModel.setColumnMaxWidth(sequencecol, 50);
		commKTableModel.setColumnWidth(supplierNamecol, 200);
		commKTableModel.setColumnWidth(bidPrciecol, 200);
		commKTableModel.setColumnWidth(evaluationPricecol, 200);
		commKTableModel.setColumnWidth(reasoncol, 400);
		if(actioncol > 0){
			commKTableModel.setColumnWidth(actioncol, 100);
		}
		
		// 设置单元格内容
		CellContentRender contentRender = new CellContentRender(){
			public Object receiveContent(int row, int col) {
				
				if(row < commKTableModel.getFixedRowCount()){
					if(col == sequencecol){
						return Messages.Num;
					}else if(col == supplierNamecol){
						return MessageFormat.format(Messages.NameFormat, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType()));
					}else if(col == bidPrciecol){
						return Messages.BidPrice;
					}else if(col == evaluationPricecol){
						return Messages.EvaluationPrice;
					}else if(col == reasoncol){
						return Messages.CorrectReason;
					}else if(col == actioncol){
						return Messages.Operation;
					}
				}else {
					// 序号
					if(col == sequencecol){
						return row;
					}else{
						Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
						if(col == supplierNamecol){
							return supplier.getSupplierName();
						}else {
							SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
							if (null != supplierOpeningResult) {
								if (col == bidPrciecol && null != supplierOpeningResult.getBidPrice()) {
									return supplierOpeningResult.getBidPriceWithUnit(tenderProjectRuleEntity.getPriceUnitUseDefault());
								} else if (col == evaluationPricecol && null != supplierOpeningResult.getEvaluationPrice()) {
									return supplierOpeningResult.getEvaluationPriceWithUnit(tenderProjectRuleEntity.getEvalPriceUnit());
								}else if (col == reasoncol && null != supplierOpeningResult.getModifyReason()) {
									return supplierOpeningResult.getModifyReason();
								}else if(col == actioncol){
									return Messages.Button_correctionBidPrice;
								}
							}
						}
					}
				}
				return "";
			}
		};
		commKTableModel.setCellContentRender(contentRender);
		
		// 设置单元格渲染器
		final LinkCellRenderer linkCellRenderer = new LinkCellRenderer();
//		final ButtonCellRenderer buttonCellRenderer = new ButtonCellRenderer();
		CellRender cellRender = new CellRender(){
			public Object receiveCellRender(int row, int col) {
				if(commKTableModel.isFixedCell(col, row)){
					return new FixedCellRenderer();
				}else if(col == evaluationPricecol){
					return new TextCellRenderer();
				}else if(col == actioncol){
					return linkCellRenderer;
				}
				return null;
			}
		};
		commKTableModel.setCellRender(cellRender);
		// 设置单元格编辑器
		if(editable){
			final KTableCellEditorText text = new KTableCellEditorText();
			final KTableCellEditorText reasonText = new KTableCellEditorText();
			text.setSingleClickEdit(false);
			CellEditorRender cellEditorRender = new CellEditorRender(){
				public Object receiveCellEditor(int row, int col) {
//					if(row >= commKTableModel.getFixedRowCount() && col == evaluationPricecol){
//						return text;
//					}
					if(col == reasoncol){
//						return reasonText;
					}else if(col == actioncol){
						return new KTableCellEditorLink(resultKTable, new CellEventActionRender() {
							public void receiveAction(int row, int col) {
								supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
								SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
								openEditPriceDialog(supplierOpeningResult);
							}
						});
					}
					return null;
				}
			};
			commKTableModel.setCellEditorRender(cellEditorRender);
			
			final Image editImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png");
			// 设置单元格图片
			CellImageRender cellImageRender = new CellImageRender() {
				public Image receiveCellImage(int row, int col) {
					if(row >= commKTableModel.getFixedRowCount() && col == actioncol){
						return editImage;
					}
					return null;
				}
			};
			commKTableModel.setCellImageRender(cellImageRender);
		}
		
		// 编辑单元格内容
//		CellEditContentRender editContentRender = new CellEditContentRender(){
//			public void receiveContent(int row, int col, Object content) {
//				if(null == content)return;
//				if(row >= commKTableModel.getFixedRowCount() && col == evaluationPricecol){
//					String priceUnitCN = tenderProjectRuleEntity.getPriceUintCN();
//					
//					BigDecimal evaluationPriceMoney = null;
//					int index = content.toString().lastIndexOf(priceUnitCN);
//					if (index == -1) {
//						evaluationPriceMoney = ObjectUtils.getObjBigDecimal(content);
//					} else {
//						evaluationPriceMoney = ObjectUtils.getObjBigDecimal(content.toString().substring(0, index));
//					}
//					if(null != evaluationPriceMoney && priceUnitCN.startsWith("万")){
//						evaluationPriceMoney = BigDecimalUtils.mul(evaluationPriceMoney, new BigDecimal(10000));
//					}
//					
//					Supplier supplier = supplierList.get(row - commKTableModel.getFixedRowCount());
//					SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
//					
//					if(null == supplierOpeningResult.getBidPrice()){
//						supplierOpeningResult.setBidPrice(evaluationPriceMoney);
//					}
//					supplierOpeningResult.setEvaluationPrice(evaluationPriceMoney);
//					commKTableModel.setChanged(true);
//				}
//			}
//		};
//		commKTableModel.setCellEditContentRender(editContentRender);
		
		// 编辑单元格对齐方式
		CellAlignmentRender cellAlignmentRender = new CellAlignmentRender(){
			public int receiveCellAlignment(int row, int col) {
				if(row < commKTableModel.getFixedRowCount()){
					return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
				}else{
					if(col == sequencecol){
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
					}else if(col == supplierNamecol){
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					}else if(col == reasoncol){
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					}else{
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_RIGHT;
					}
				}
			}
		};
		commKTableModel.setCellAlignmentRender(cellAlignmentRender);
		
		CellForegroundRender cellForegroundRender = new CellForegroundRender() {

			public Color receiveCellForeground(int row, int col) {
				if (col == 5) {
					return SWTResourceManager.getColor(SWT.COLOR_BLUE);
				}else {
					return null;
				}
			}
		};
		commKTableModel.setCellForegroundRender(cellForegroundRender);
		
		resultKTable.setModel(commKTableModel);
	}
	
	/**
	 * @Description: 保存
	 * @author guoyr
	 */
	public boolean saveEvaluationPrice(){
		resultKTable.closeCellEditor();
		if(null != supplierList && supplierList.size() > 0){
			List<SupplierOpeningResult> supplierOpeningResultList = new ArrayList<SupplierOpeningResult>();
			for(Supplier supplier : supplierList){
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				if(null == supplierOpeningResult.getBidPrice()){
					supplierOpeningResult.setBidPrice(supplierOpeningResult.getEvaluationPrice());
				}
				supplierOpeningResultList.add(supplierOpeningResult);
			}
			if(supplierOpeningResultService.batchSaveOrUpdate(supplierOpeningResultList, new String[]{"id","bidPrice", "evaluationPrice"})>0){
				commKTableModel.setChanged(false);
				return true;
			}
		}
		return false;
	}
	
	/**
	 * @Description: 设置Excel行内容
	 * @author guoyr
	 * @param excel
	 * @return
	 */
	private Map<String, SupplierOpeningResult> setExcelRowContent(Excel excel){
		// 存储开标结果(key：投标人名称；value：开标结果)
		Map<String, SupplierOpeningResult> openBidResultMap = new HashMap<String, SupplierOpeningResult>();
		if(null != supplierList && supplierList.size() > 0){
			// 遍历投标人集合
			for(Supplier supplier : supplierList){
				// 创建Excel行
				ExcelRow supplierRow = excel.addRow();
				// 设置行高
				supplierRow.setHeight(25);
				
				// 投标人开标结果
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				// 最终报价
				String evaluationPrice = "";
				if(null != supplierOpeningResult){
					// 根据价格单位，格式化数值。
					evaluationPrice = supplierOpeningResult.getFormatEvaluatoinPriceByUnit(tenderProjectRuleEntity.getEvalPriceUnit());
				}else {
					supplierOpeningResult = new SupplierOpeningResult();
					supplierOpeningResult.setTenderId(tenderProjectEntity.getId());// 项目Id
					supplierOpeningResult.setSupplierId(supplier.getId());// 投标人Id
				}
				
				// 投标人名称列
				supplierRow.addCell().setValue(ObjectUtils.getObjString(supplier.getSupplierName()))
					.setProperty("supplierName").setWidth(300).setHead(true).setCellStyle(ExcelStyle.getInstents(ExcelStyle.R_HEAD).setBorder(CellStyle.BORDER_THIN));
				// 最终报价列
				supplierRow.addCell().setValue(evaluationPrice).setProperty("evaluationPrice").setWidth(200).setHead(false);
				openBidResultMap.put(supplier.getSupplierName(), supplierOpeningResult);
			}
		}
		return openBidResultMap;
	}
	
	/**
	 * @Description: 导入线程
	 * @author guoyr
	 */
	class ImportEvaluationPriceThread implements Runnable{
		
		private Thread thread;
		private List<Map<String, Object>> excelDataList;
		private Map<String, SupplierOpeningResult> openBidResultMap;
		private CallBack callBack;
		
		
		public ImportEvaluationPriceThread(List<Map<String, Object>> excelDataList, Map<String, SupplierOpeningResult> openBidResultMap, CallBack callBack){
			this.excelDataList = excelDataList;
			this.openBidResultMap = openBidResultMap;
			this.callBack = callBack;
		}
		
		public void start(){
			thread = new Thread(this);
			thread.setName("导入评标价线程");
			thread.start();
		}
		
		public void stop(){
			thread = null;
		}
		
		public void run() {
			String SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
			if(null != excelDataList && excelDataList.size() > 0){
				callBackMsg("获得"+excelDataList.size()+Messages.SupplierCouns+SUPPLIER_NAME+"的"+EVAL_PRICE+"！");
				List<SupplierOpeningResult> openBidResultList = new ArrayList<SupplierOpeningResult>();
				for(Map<String, Object> excelDataMap : excelDataList){
					String supplierName = ObjectUtils.getObjString(excelDataMap.get("supplierName"));
					SupplierOpeningResult supplierOpeningResult = null != openBidResultMap ? openBidResultMap.get(supplierName) : null;
					if(null != supplierOpeningResult){
						callBackMsg("√【"+supplierName+"】的"+EVAL_PRICE+"导入成功！");
						BigDecimal evaluationPrice = MoneyUtils.getMoneyFromText((String)excelDataMap.get("evaluationPrice"), tenderProjectRuleEntity.getEvalPriceUnit());
						if(null == supplierOpeningResult.getBidPrice()){
							supplierOpeningResult.setBidPrice(evaluationPrice);
						}
						supplierOpeningResult.setEvaluationPrice(evaluationPrice);
						openBidResultList.add(supplierOpeningResult);
					}else {
						callBackMsg("×【"+supplierName+"】Excel数据转换实体对象失败！");
					}
				}
				if(null != openBidResultList && openBidResultList.size() > 0){
					if(supplierOpeningResultService.batchSaveOrUpdate(openBidResultList,null) > 0){
						callBackMsg("\r\n√此次成功导入"+openBidResultList.size()+Messages.SupplierCouns+SUPPLIER_NAME+"的"+EVAL_PRICE+"！");
					}else {
						callBackMsg("\r\n×"+SUPPLIER_NAME+"的"+EVAL_PRICE+"导入失败！");
					}
				}
			}else {
				callBackMsg("×未检测到有效"+SUPPLIER_NAME+"的"+EVAL_PRICE+"！");
			}
			callBackMsg("导入"+EVAL_PRICE+"结束！");
			if(null != callBack){
				callBack.after();
			}
		}
		
		private void callBackMsg(String msg){
			if(null != callBack){
				callBack.callBackString(msg);
			}
		}
	}
	
	/**
	 * @Description: 打开修正评标价
	 * @author wangxiang
	 * @param supplierOpeningResult 
	 */
	private void openEditPriceDialog(final SupplierOpeningResult supplierOpeningResult) {
		EditPriceDialog dialog = new EditPriceDialog(getShell(), supplier.getSupplierName(), supplierOpeningResult.getBidPrice(), supplierOpeningResult.getEvaluationPrice(), tenderProjectRuleEntity.getEvalPriceUnit(), supplierOpeningResult.getModifyReason());
		dialog.setTitle("修正" + EVAL_PRICE);
		dialog.addCorrectPriceListener(new CorrectPriceListener() {
			public void correctedPrice(BigDecimal correctedPrice, String modifyReason) {
				supplierOpeningResult.setEvaluationPrice(correctedPrice);
				supplierOpeningResult.setModifyReason(modifyReason);
				if(null == supplierOpeningResult.getBidPrice()){
					supplierOpeningResult.setBidPrice(correctedPrice);
					supplierOpeningResultService.updateAssignProperty(supplierOpeningResult, new String[]{"id","bidPrice", "evaluationPrice", "modifyReason"});
				}else {
					
					supplierOpeningResultService.updateAssignProperty(supplierOpeningResult, new String[]{"id","evaluationPrice", "modifyReason"});
				}
			}
		});
		dialog.open();
		resultKTable.redraw(curCol, curRow, 1, 1);
	}
	
	@Override
	protected void checkSubclass() {
	}
}
