package com.gx.obe.common.composite;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.business.entity.Machine;
import com.gx.obe.business.entity.Supervise;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.dialog.EditSuperviseDialog;
import com.gx.obe.common.dialog.ImportSuperviseFromTenderProjectDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.auth.AuthLoginRecordEntity;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SuperviseService;
import com.gx.obe.web.service.UserLoginRecordService;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 监督人小组管理
 * @author guoyr
 */
public class EvaluationSuperviseManagerComposite extends Composite {
	
//	private SashForm sashForm;
	private ELink addNewSuperviseBtn;
	private ELink importSuperviseBtn;
	private ELink updateSuperviseBtn;
	private ELink delSuperviseBtn;
	private TenderProjectEntity tenderProjectEntity;
	private ImageResolver imageResolver = new ImageResolver();
	private Grid superviseGrid;
	private UserLoginRecordService loginRecordService;
	private SuperviseService superviseService ;
//	private UserService userService;
	private Map<String, AuthLoginRecordEntity> loginRecordMap = new HashMap<String, AuthLoginRecordEntity>();
	private Map<String, Machine> machineMap = new HashMap<String, Machine>();
	
	{
		LogUtils.logClass(EvaluationSuperviseManagerComposite.class);
	}
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public EvaluationSuperviseManagerComposite(Composite parent, int style) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(255, 255, 255));
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				imageResolver.disposite();
				machineMap.clear();
				loginRecordMap.clear();
			}
		});
		this.tenderProjectEntity = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		Composite composite_2 = new Composite(this, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_2 = new GridLayout(7, false);
		composite_2.setLayout(gl_composite_2);
		
		ELink button_1 = new ELink(composite_2, SWT.NONE);
		button_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		button_1.setText(Messages.Button_refresh);
		button_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"));
		button_1.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				refreshAllSupervise();
			}
		});

		
		importSuperviseBtn = new ELink(composite_2, SWT.NONE);
		importSuperviseBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				importSuperviseFromProjectAction();
			}
		});
		importSuperviseBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		importSuperviseBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		importSuperviseBtn.setText("导入监督人");
		
		addNewSuperviseBtn = new ELink(composite_2, SWT.NONE);
		addNewSuperviseBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				createSuperviseAction();
			}
		});
		addNewSuperviseBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		addNewSuperviseBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/add.png"));
		addNewSuperviseBtn.setText(Messages.Button_add);
		
		
		
		updateSuperviseBtn = new ELink(composite_2, SWT.NONE);
		updateSuperviseBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		updateSuperviseBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				updateSuperviseAction();
			}
		});
		updateSuperviseBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		updateSuperviseBtn.setText(Messages.Button_modify);
		
		delSuperviseBtn = new ELink(composite_2, SWT.NONE);
		delSuperviseBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		delSuperviseBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				delSuperviseAction();
			}
		});
		delSuperviseBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		delSuperviseBtn.setText(Messages.Button_delete);
		
		Composite composite_8 = new Composite(this, SWT.NONE);
		composite_8.setBackground(SWTResourceManager.getColor(211, 211, 211));
		composite_8.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_8 = new GridLayout(1, false);
		gl_composite_8.verticalSpacing = 1;
		gl_composite_8.horizontalSpacing = 1;
		gl_composite_8.marginHeight = 1;
		gl_composite_8.marginWidth = 1;
		composite_8.setLayout(gl_composite_8);
		
		Composite composite = new Composite(composite_8, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 1;
		gl_composite.marginHeight = 1;
		gl_composite.marginWidth = 1;
		composite.setLayout(gl_composite);
		superviseGrid = new Grid(composite, SWT.H_SCROLL | SWT.V_SCROLL);
		superviseGrid.setHeaderVisible(true);
		superviseGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn gridNumColumn = new GridColumn(superviseGrid, SWT.CENTER);
		gridNumColumn.setText(Messages.Num);
		gridNumColumn.setWidth(40);
		gridNumColumn.setMaxmumWidth(50);
		
		GridColumn gridColumn = new GridColumn(superviseGrid, SWT.CENTER);
		gridColumn.setText(Messages.FullName);
		gridColumn.setWidth(80);
		
		GridColumn accountColumn = new GridColumn(superviseGrid, SWT.CENTER);
		accountColumn.setText(Messages.Account);
		accountColumn.setWidth(80);
		
		
		GridColumn ipColumn = new GridColumn(superviseGrid, SWT.CENTER);
		ipColumn.setText(Messages.Login_ip);
		ipColumn.setWidth(80);
		
		GridColumn macColumn = new GridColumn(superviseGrid, SWT.CENTER);
		macColumn.setText(Messages.MachineMark);
		macColumn.setWidth(100);
		
		GridColumn loginStatusColumn = new GridColumn(superviseGrid, SWT.CENTER);
		loginStatusColumn.setText(Messages.Login_status);
		loginStatusColumn.setWidth(55);
		
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		superviseService = new SuperviseService();
		loginRecordService = new UserLoginRecordService();
		superviseGrid.setItemHeight(Constants.ROW_HIGHT);
		// 添选中事件和右键菜单事件
		superviseGrid.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void leftMouseButtonDown(GridItem item) {
//				selectSuperviseAction();
			}
			@Override
			public void rightMouseButtonDown(GridItem item) {
				mouseRightClickAction();
			}
		});
		refreshAllSupervise();
		superviseGrid.resizeColumnWidth();
	}

	/**
	 * @Description: 显示所有监督人成员列表
	 * @author guoyr 
	 */
	private void refreshAllSupervise(){
		superviseGrid.removeAll();
		List<Supervise> superviseList = superviseService.getSuperviseList(tenderProjectEntity.getId());
		if(null != superviseList && superviseList.size() >0){
			initLoginRecord(superviseList);
			int index = 1;
			for(Supervise member : superviseList){
				AuthUser user = member.getUser();
				if(null == user)continue;
				GridItem gridItem = new GridItem(superviseGrid, SWT.NONE);
				gridItem.setText(0, (index ++) + "");
				setSuperviseItemInfo(gridItem, member);
			}
		}
		if(superviseGrid.getItemCount() > 0 && superviseGrid.getSelectionCount() == 0){
			superviseGrid.setSelection(0);
		}
		superviseGrid.resizeColumnWidth();
	}
	
	private void initLoginRecord(List<Supervise> superviseList){
		loginRecordMap.clear();
		List<AuthLoginRecordEntity> loginRecordList = loginRecordService.getLoginRecordByEvalBidRoomId(null);
		if(null == loginRecordList || loginRecordList.size() == 0){
			loginRecordList = loginRecordService.getLoginRecordAllList();
		}
		
		List<String> userIdList = new ArrayList<String>();
		for(Supervise member : superviseList){
			userIdList.add(member.getUserId());
		}
		if(null != loginRecordList && loginRecordList.size() > 0){
			Date effectiveTime = DateUtils.add(NowTimeUtils.getNowDate(), DateUtils.DAY, -1);
			if(null != loginRecordList && loginRecordList.size() > 0){
				for(AuthLoginRecordEntity authLoginRecordEntity : loginRecordList){
					if(null!= authLoginRecordEntity.getUserId() && authLoginRecordEntity.getLoginTime().after(effectiveTime)){
						loginRecordMap.put(authLoginRecordEntity.getUserId(), authLoginRecordEntity);
					}
				}
			}
		}
	}
	
	/**
	 * @Description: 设置监督人的信息
	 * @author guoyr
	 * @param gridItem
	 * @param Supervise 
	 */
	private void setSuperviseItemInfo(GridItem gridItem, Supervise supervise){
		AuthUser user = supervise.getUser();
		gridItem.setText(1,user.getUserName());
		gridItem.setText(2,user.getUserAccount());
		AuthLoginRecordEntity authLoginRecordEntity = loginRecordMap.get(supervise.getUserId());
		if(null != authLoginRecordEntity){
			gridItem.setText(3, ObjectUtils.getObjString(authLoginRecordEntity.getIp()));
			gridItem.setText(4, ObjectUtils.getObjString(authLoginRecordEntity.getMac()));
			gridItem.setText(5, "已登录");
		}else {
			gridItem.setText(3, "");
			gridItem.setText(4, "");
			gridItem.setText(5, "未登录");
		}
		gridItem.setData("supervise", supervise);
	}


	/**
	 * @Description: 获得选中的监督人
	 * @author guoyr
	 * @return 
	 */
	private Supervise getSelectionSupervise(){
		Supervise selectSupervise = null;
		if(superviseGrid.getSelectionCount() >0){
			selectSupervise = (Supervise)superviseGrid.getSelection()[0].getData("supervise");
		}
		return selectSupervise;
	}
	
	/**
	 * @Description: 删除监督人
	 * @author guoyr 
	 */
	private void delSuperviseAction(){
		if(delSuperviseBtn.getEnabled()){
			Supervise selectSupervise = getSelectionSupervise();
			if(null != selectSupervise && MessageDialog.openConfirm(getShell(), "确认要删除["+(ObjectUtils.getObjString(selectSupervise.getUser().getUserName()))+"]吗？")){
				if(superviseService.deleteSupervise(tenderProjectEntity.getId(), selectSupervise.getUserId())){
					
					int selectIndex = superviseGrid.getSelectionIndex();
					superviseGrid.getSelection()[0].dispose();
					if(superviseGrid.getItemCount() > 0){
						if(superviseGrid.getItemCount() > selectIndex){
							superviseGrid.setSelection(selectIndex);
							for(int i = selectIndex; i < superviseGrid.getItemCount(); i ++){
								GridItem gridItem = superviseGrid.getItem(i);
								gridItem.setText(0, (i + 1) + "");
							}
						}else {
							superviseGrid.setSelection(selectIndex - 1);
						}
					}
				}else {
					MessageDialog.openWarning(getShell(), "删除失败！");
				}
				refreshAllSupervise();
			}
		}
	}
	
	/**
	 * @Description: 新增监督人
	 * @author guoyr 
	 */
	private void createSuperviseAction(){
		if(addNewSuperviseBtn.getEnabled()){
			final EditSuperviseDialog dialog = new EditSuperviseDialog(getShell(), tenderProjectEntity,null, null);
			dialog.setCallBack(new CallBack(){
				public void callBackObject(Object obj) {
					Supervise selectEvalSupervise = null != obj ? (Supervise)obj : null;
					if(null != selectEvalSupervise){
						GridItem gridItem = new GridItem(superviseGrid, SWT.NONE);
						gridItem.setText(0, ObjectUtils.getObjString(superviseGrid.getItemCount()));
						gridItem.setData("Supervise", selectEvalSupervise);
						setSuperviseItemInfo(gridItem, selectEvalSupervise);
						superviseGrid.setSelection(new GridItem[]{gridItem});
					}
				}
			});
			dialog.open();
		}
	}
	
	/**
	 * @Description: 修改监督人
	 * @author guoyr 
	 */
	private void updateSuperviseAction(){
		if(updateSuperviseBtn.getEnabled()){
			final Supervise selectSupervise = getSelectionSupervise();
			final EditSuperviseDialog dialog = new EditSuperviseDialog(getShell(), tenderProjectEntity,null, null);
//			final EditSuperviseDialog dialog = new EditSuperviseDialog(getShell(), tenderProjectEntity, selectSupervise);
			dialog.setCallBack(new CallBack(){
				public void callBackObject(Object obj) {
					Supervise selectEvalSupervise = null != obj ? (Supervise) obj : null;
					if(null != selectEvalSupervise){
						GridItem selectItem = superviseGrid.getSelection()[0];
						selectItem.setData("Supervise", selectEvalSupervise);
					}
				}
			});
			dialog.open();
		}
		refreshAllSupervise();
	}
	
	
	
	/**
	 * @Description: 右键菜单
	 * @author guoyr 
	 */
	private void mouseRightClickAction(){
		final EMenu gmenu = new EMenu(getShell());
		// 新增
		gmenu.addMenuItem(addNewSuperviseBtn);
		// 修改
		gmenu.addMenuItem(updateSuperviseBtn);
		// 删除
		gmenu.addMenuItem(delSuperviseBtn);
		// 全部删除
//		gmenu.addMenuItem(Messages.Button_deleteAll, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"), true, new EMenu.ClickListener() {
//			public void click() { 
//				delAllSuperviseAction();
//			}
//		});
		gmenu.addSeparator();
		// 导入
//		gmenu.addMenuItem(importSuperviseBtn);
		// 导出
//		gmenu.addMenuItem("导出监督人", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
//			public void click() { 
//				exportSuperviseAction();
//			}
//		});
		gmenu.addSeparator();
		
		gmenu.open();
	}
	
	/**
	 * @Description: 导入监督人
	 * @author guoyr 
	 */
	private void importSuperviseFromProjectAction() {
		if(importSuperviseBtn.isEnabled()){
			ImportSuperviseFromTenderProjectDialog importSuperviseFromTenderProjectDialog = new ImportSuperviseFromTenderProjectDialog(getShell(), tenderProjectEntity,null);
			importSuperviseFromTenderProjectDialog.open();
			refreshAllSupervise();
		}
	}
//	/**
//	 * @Description: 删除监督人
//	 * @author guoyr
//	 */
//	private void delAllSuperviseAction(){
//		if(MessageDialog.openConfirm(getShell(), "确定要删除全部监督人吗？")){
//			QueryWrapper wrapper = new QueryWrapper(Supervise.class);
//			wrapper.setWhereParam("tenderId", tenderProjectEntity.getId());
////			if(superviseService.delete(tenderProjectEntity.getId()) > 0){
////				SuperviseGrid.removeAll();
////			}
//		}
//	}
//	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
