package com.gx.obe.common.composite;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.ExpertEvaluationStep;
import com.gx.obe.business.enumeration.UserEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.StepProgressButton;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.EvaluationFactorEnum;
import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
import com.gx.obe.components.core.enumeration.ExpertEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.listener.EvaluationRoomListener;
import com.gx.obe.message.Messages;
import com.gx.obe.step.dialog.ReEvaluationConfirmDialog;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.expert.Expert;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.evaluation.EvaluationGroupService;
import com.gx.obe.web.service.evaluation.EvaluationStepExpertService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.service.expert.ExpertEvaluationStepService;
import com.gx.obe.web.service.expert.ExpertService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 
 * @author guoyr
 */
public class ExpertEvlauationProgressComposite extends Composite implements EvaluationRoomListener{
	
	private EvaluationStepService evaluationStepService = new EvaluationStepService();
	private EvaluationGroupService evaluationGroupService;
	private ExpertEvaluationStepService expertEvaluationStepService ;
	private ExpertService expertService;
	private EvaluationStepExpertService evaluationStepExpertService;
	private ProjectRuleService projectRuleService ;
	private List<EvaluationStep> evaluationStepList ;
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Composite expert_progress_content;
	private Composite expert_progress;
	private ScrolledComposite scrolledComposite;
	private Composite composite;
	private Composite top_composite;
	private boolean needReback = true;
	
	{
		LogUtils.logClass(ExpertEvlauationProgressComposite.class);
	}
	
	/**
	 * Create the progressComposite.
	 * @param parent
	 * @param style
	 */
	public ExpertEvlauationProgressComposite(Composite parent, int style) {
		super(parent, SWT.NONE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		this.tenderProjectEntity = (TenderProjectEntity)parent.getData("tenderProjectEntity");

		top_composite = new Composite(this, SWT.NONE);
		GridLayout gl_top_composite = new GridLayout(1, false);
		gl_top_composite.verticalSpacing = 0;
		gl_top_composite.horizontalSpacing = 0;
		gl_top_composite.marginHeight = 0;
		gl_top_composite.marginWidth = 0;
		top_composite.setLayout(gl_top_composite);
		top_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		scrolledComposite = new ScrolledComposite(top_composite, SWT.H_SCROLL | SWT.V_SCROLL);
		GridData gd_scrolledComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_scrolledComposite.heightHint = 200;
		scrolledComposite.setLayoutData(gd_scrolledComposite);
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		composite = new Composite(scrolledComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		
		Composite total_progress_composite = new Composite(composite, SWT.NONE);
		total_progress_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_titleComposite = new GridLayout(2, false);
		gl_titleComposite.verticalSpacing = 0;
		gl_titleComposite.horizontalSpacing = 0;
		gl_titleComposite.marginHeight = 0;
		gl_titleComposite.marginWidth = 0;
		total_progress_composite.setLayout(gl_titleComposite);
		
		Composite total_progress_title = new Composite(total_progress_composite, SWT.NONE);
		GridData gd_progressTitleComposite = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_progressTitleComposite.heightHint = 45;
		gd_progressTitleComposite.widthHint = 130;
		total_progress_title.setLayoutData(gd_progressTitleComposite);
		total_progress_title.setLayout(new GridLayout(1, false));
		
		Label total_name = new Label(total_progress_title, SWT.NONE);
		total_name.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		total_name.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		total_name.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		total_name.setText(Messages.Button_progressOverall + "：");
		
		expert_progress_content = new Composite(total_progress_composite, SWT.NONE);
		expert_progress_content.setLayout(new RowLayout(SWT.HORIZONTAL));
		expert_progress_content.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		ELabel label = new ELabel(expert_progress_content, SWT.BORDER|SWT.SELECTED);
		label.setBackground(SWTResourceManager.getColor(SWT.COLOR_GREEN));
		label.setAlpha(255);
		label.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		label.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		label.setText("");
		
		ESepator sep = new ESepator(composite, SWT.NONE);
		sep.setForeground(ColorConstants.SEP_LIGHT_COLOR);
		sep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		expert_progress = new Composite(composite, SWT.NONE);
		GridLayout gl_expert_progressComposite = new GridLayout(1, false);
		gl_expert_progressComposite.verticalSpacing = 0;
		gl_expert_progressComposite.horizontalSpacing = 0;
		gl_expert_progressComposite.marginHeight = 0;
		gl_expert_progressComposite.marginWidth = 0;
		expert_progress.setLayout(gl_expert_progressComposite);
		expert_progress.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Composite expert_composite = new Composite(expert_progress, SWT.NONE);
		expert_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_expert_composite = new GridLayout(2, false);
		gl_expert_composite.horizontalSpacing = 0;
		gl_expert_composite.marginHeight = 0;
		gl_expert_composite.marginWidth = 0;
		expert_composite.setLayout(gl_expert_composite);
		
		Composite expert_title = new Composite(expert_composite, SWT.NONE);
		GridData gd_expert_title_composite = new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1);
		gd_expert_title_composite.widthHint = 130;
		expert_title.setLayoutData(gd_expert_title_composite);
		GridLayout gl_memberComposite = new GridLayout(1, false);
		gl_memberComposite.marginHeight = 0;
		gl_memberComposite.verticalSpacing = 0;
		gl_memberComposite.horizontalSpacing = 0;
		expert_title.setLayout(gl_memberComposite);
		
		Label expert_progress = new Label(expert_title, SWT.WRAP);
		expert_progress.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		expert_progress.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		expert_progress.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		expert_progress.setText("郭永荣：");
		
		Composite memberNodeComposite = new Composite(expert_composite, SWT.NONE);
		memberNodeComposite.setLayout(new RowLayout(SWT.HORIZONTAL));
		memberNodeComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		ELabel member_step = new ELabel(memberNodeComposite, SWT.BORDER|SWT.SELECTED);
		member_step.setText(Messages.Step_signIn);
		scrolledComposite.setContent(composite);
		scrolledComposite.setMinSize(composite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		{
			
			ESepator splabel = new ESepator(top_composite, SWT.SEPARATOR | SWT.HORIZONTAL);
			splabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			splabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		}
	
		Composite composite_1 = new Composite(top_composite, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_composite_1 = new GridLayout(10, false);
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		CLabel label_7 = new CLabel(composite_1, SWT.NONE);
		label_7.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_blue.png"));
		label_7.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_7.setText("");
		
		StepProgressButton complate_step = new StepProgressButton(composite_1, SWT.NONE);
		GridData gd_complate_step = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_complate_step.widthHint = 50;
		complate_step.setLayoutData(gd_complate_step);
		complate_step.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		complate_step.setText("");
		complate_step.setBackground(StepProgressButton.COMPLATE_COLOR);
		
		Label label2 = new Label(composite_1, SWT.NONE);
		label2.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label2.setText(Messages.Progress_complate + "    ");
		label2.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		
		StepProgressButton in_progress_step = new StepProgressButton(composite_1, SWT.NONE);
		GridData gd_in_progress_step = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_in_progress_step.widthHint = 50;
		in_progress_step.setLayoutData(gd_in_progress_step);
		in_progress_step.setBackground(StepProgressButton.IN_PROGRESS_COLOR);
		in_progress_step.setText("");
		in_progress_step.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		
		Label label_inprgs = new Label(composite_1, SWT.NONE);
		label_inprgs.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label_inprgs.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label_inprgs.setText(Messages.Progress_inProgress + "    ");
		
		StepProgressButton no_start = new StepProgressButton(composite_1, SWT.NONE);
		GridData gd_no_start = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_no_start.widthHint = 50;
		no_start.setLayoutData(gd_no_start);
		no_start.setBackground(StepProgressButton.NO_START_COLOR);
		no_start.setText("");
		no_start.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		
		Label label_nostart = new Label(composite_1, SWT.NONE);
		label_nostart.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label_nostart.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label_nostart.setText(Messages.Progress_noStart + "    ");
		
		StepProgressButton re_author = new StepProgressButton(composite_1, SWT.NONE);
		GridData gd_re_author = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_re_author.widthHint = 50;
		re_author.setLayoutData(gd_re_author);
		re_author.setBackground(StepProgressButton.RE_AUTHORIZATION_COLOR);
		re_author.setText("");
		re_author.setFont(SWTResourceManager.getFont("宋体", 9, SWT.BOLD));
		
		Label label_re_author = new Label(composite_1, SWT.NONE);
		label_re_author.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label_re_author.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		label_re_author.setText(Messages.Progress_reBack);

		
//		ImageButton refresh_btn = new ImageButton(composite_1, SWT.NONE);
//		refresh_btn.setArcWidth(50);
//		refresh_btn.setLeftMargin(10);
//		refresh_btn.setRightMargin(10);
//		refresh_btn.setTopMargin(2);
//		refresh_btn.setBottomMargin(2);
//		refresh_btn.setBackground(ColorConstants.SKIN_BG);
//		refresh_btn.setForeground(ColorColorConstants.SKIN_FOREGROUND);
//		refresh_btn.setActiveBackgroundColor(ColorConstants.SKIN_ACTIVE_BG);
//		refresh_btn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
//		refresh_btn.addMouseListener(new MouseAdapter() {
//			public void mouseUp(MouseEvent e) {
//				refreshAction();
//			}
//		});
//		refresh_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
//		GridData gd_close_btn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
//		refresh_btn.setLayoutData(gd_close_btn);
//		refresh_btn.setText(Messages.Button_refresh);
		
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		expertEvaluationStepService = new ExpertEvaluationStepService();
		expertService = new ExpertService();
		evaluationGroupService = new EvaluationGroupService();
		evaluationStepExpertService = new EvaluationStepExpertService();
		loadTenderPackMan(tenderProjectEntity);
		needReback = PropertiesUtils.getProperty(ConfigConstants.REBACK_EVALUATION, "01").equals("01");
		refreshAction();
	}
	
	private void loadTenderPackMan(TenderProjectEntity tenderProjectEntity){
		this.tenderProjectEntity = tenderProjectEntity;
		refreshAction();
	}
	/**
	 * @Description: 刷新进度
	 * @author guoyr 
	 */
	private void refreshAction(){
		if(null == projectRuleService){
			projectRuleService = new ProjectRuleService();
		}
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		showTotalProgress();
		showExpertProgress();
		composite.layout();
		scrolledComposite.setMinHeight(composite.computeSize(SWT.DEFAULT, SWT.DEFAULT).y);
	}
	
	
	/**
	 * @Description: 刷新评标步骤
	 * @author guoyr
	 */
	private void showTotalProgress(){
		
		evaluationStepList = evaluationStepService.getEvaluationStepList(tenderProjectEntity.getId());
		for(Control control : expert_progress_content.getChildren()){
			control.dispose();
		}
		if(null != evaluationStepList && evaluationStepList.size() > 0){
			for(int nodeCount = 0; nodeCount < evaluationStepList.size(); nodeCount ++){
				final EvaluationStep evaluationStep = evaluationStepList.get(nodeCount);
				
				final StepProgressButton totalProgress = new StepProgressButton(expert_progress_content, SWT.NONE|SWT.SELECTED);
				totalProgress.setText((nodeCount+1)+"、"+evaluationStep.getStepName()+" >>");
				
//				ExpertEvaluationStep operatorEvaluationStep = null;
				if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.COMPLETE)){
					totalProgress.setBackground(StepProgressButton.COMPLATE_COLOR);
//					if(ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.OPERATOR)){
//						operatorEvaluationStep = expertEvaluationStepService.getExpertEvaluationStep(tenderProjectEntity.getId(), evaluationStep.getId(), ExpertEnum.COMMON_EXPERT);
//						if(null != operatorEvaluationStep){
//							if(null != operatorEvaluationStep.getApplyStatus() && operatorEvaluationStep.getApplyStatus().equals(CommonEnum.YES)){
//								totalProgress.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/hand.png"));
//							}else {
//								totalProgress.setImage(null);
//							}
//						}
//					}
				}else if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)){
					totalProgress.setBackground(StepProgressButton.RE_AUTHORIZATION_COLOR);
				}else if(ObjectUtils.equals(evaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS)){
					totalProgress.setBackground(SWTResourceManager.getColor(60, 138, 226));
				}else {
					totalProgress.setBackground(StepProgressButton.NO_START_COLOR);
				}
			}
		}
		
		expert_progress_content.layout();
	}
	
	/**
	 * @Description: 刷新评标步骤
	 * @author guoyr
	 */
	private void showExpertProgress(){
		for(Control control : expert_progress.getChildren()){
			control.dispose();
		}
		// 获得专家登录记录数据
		List<Expert> expertList = expertService.getExpertList(tenderProjectEntity.getId(), null);
		if(null != expertList && expertList.size() > 0){
			int memberCount = 0;
			for(final Expert expert : expertList){
				Map<String, ExpertEvaluationStep> expertStepMap = new HashMap<String, ExpertEvaluationStep>();
				List<ExpertEvaluationStep> expertEvaluationStepList = expertEvaluationStepService.getExpertEvaluationStepList(tenderProjectEntity.getId(), expert.getUserId());
				
				if(null != expertEvaluationStepList && expertEvaluationStepList.size() > 0){
					for(ExpertEvaluationStep expertStep : expertEvaluationStepList){
						expertStepMap.put(expertStep.getStepId(), expertStep);
					}
				}
				
				Composite expert_composite = new Composite(expert_progress, SWT.NONE);
				expert_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
				GridLayout gl_expert_composite = new GridLayout(2, false);
				gl_expert_composite.marginHeight = 0;
				gl_expert_composite.marginWidth = 0;
				gl_expert_composite.horizontalSpacing = 0;
				expert_composite.setLayout(gl_expert_composite);
				expert_composite.setBackgroundMode(SWT.INHERIT_FORCE);
				
				Composite member_name_composite = new Composite(expert_composite, SWT.NONE);
				GridData gd_memberComposite = new GridData(SWT.RIGHT, SWT.FILL, false, false, 1, 1);
				gd_memberComposite.widthHint = 130;
				member_name_composite.setLayoutData(gd_memberComposite);
				GridLayout gl_expert_name_composite = new GridLayout(1, false);
				gl_expert_name_composite.verticalSpacing = 0;
				gl_expert_name_composite.horizontalSpacing = 0;
				gl_expert_name_composite.marginHeight = 0;
				member_name_composite.setLayout(gl_expert_name_composite);
				member_name_composite.setLayoutData(gd_memberComposite);
				member_name_composite.setLayout(new GridLayout(1, false));
				
				ImageButton expert_name = new ImageButton(member_name_composite, SWT.NONE);
				expert_name.setForeground(ColorConstants.NOTE_TIPS_COLOR);
				expert_name.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
				expert_name.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
				expert_name.setText(Messages.Expert+(memberCount+1)+"：");
				boolean isExpertLeader = ExpertEnum.LEADER_YES.equals(expert.getIsLeader());
				if(null != expert.getUser()){
					if(null != expert.getUser().getGender() && expert.getUser().getGender().equals(UserEnum.FEMALE)){
						expert_name.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/female_48.png"), 30, 30);
					}else {
						expert_name.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/male_48.png"), 30, 30);
					}
					if(null != expert.getUser().getUserName()){
						expert_name.setText(expert.getUser().getUserName()+"：");
					}else if(null != expert.getUser().getUserAccount()){
						expert_name.setText(expert.getUser().getUserAccount()+"：");
					}
					if(isExpertLeader) {
						expert_name.setSubTextFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
						expert_name.setSubTextVerAlign(SWT.BOTTOM);
						expert_name.setSubTextSurroundAlpha(200);
						expert_name.setSubTextRightMargin(2);
						expert_name.setSubText("组长");
					}
				}
				
				Composite memberNodeComposite = new Composite(expert_composite, SWT.NONE);
				memberNodeComposite.setLayout(new RowLayout(SWT.HORIZONTAL));
				GridData gd_memberNodeComposite = new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1);
				memberNodeComposite.setLayoutData(gd_memberNodeComposite);
				
				int nodeCount = 0;
				boolean isNeedCorrectAndConfirmEvalPrice = false;
				// 获得当前专家指定评审的评标步骤
				List<String> customStepList = null;
				List<String> evalGroupStepList = null;
				for(final EvaluationStep evaluationStep : evaluationStepList){
					
					// 如果当前节点是价格节点，且需要进行修正报价和确认修正报价
					if(!isNeedCorrectAndConfirmEvalPrice && ObjectUtils.equals(evaluationStep.getStepType(), EvaluationStepEnum.PRICE) && ObjectUtils.equals(tenderProjectRuleEntity.getCorrectPrice(), CommonEnum.YES) && ObjectUtils.equals(tenderProjectRuleEntity.getConfirmPrice(), CommonEnum.YES)){
						isNeedCorrectAndConfirmEvalPrice = true;
						if(isConfirmEvalPrice(evaluationStep, isExpertLeader)){
							evaluationStep.setStepName(Messages.Button_confirm+Messages.EvaluationPrice);
						}
					} else if (ObjectUtils.equals(evaluationStep.getStepType(), EvaluationStepEnum.PRE_EVALUATION)) {
						if (!evaluationGroupService.isHasEvaluationGroupByUserId(tenderProjectEntity.getId(), expert.getUserId(), evaluationStep.getId())) {
							continue;
						}
					}else{
						if(ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EXPERT_LEADER)){
							if(!ObjectUtils.equals(expert.getIsLeader(), ExpertEnum.LEADER_YES)){
								continue;
							}
						}else if(ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.OPERATOR)){
							continue;
						}else if(ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.CUSTOM)){
							if(null == customStepList){
								customStepList = evaluationStepExpertService.finStepIdByTenderIdAndUserId(tenderProjectEntity.getId(),Constants.USER.getId());
							}
							
							// 如果该专家没有指定评标步骤或，在当前评标步骤没有指定给该专家
							if (null == customStepList || !customStepList.contains(evaluationStep.getId())) {
								continue;
							}
						} else if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EVAL_BID_TYPE)) {
							if (null != evaluationStep.getEvalBidType() && evaluationStep.getEvalBidType().equals(EvaluationFactorEnum.EVAL_BID_BUS)) {
								if ((expert.getEvalBidTypeNotNull() & ExpertEnum.EXPERT_BUS) == 0) {
									continue;
								}
							} else if (null != evaluationStep.getEvalBidType() && evaluationStep.getEvalBidType().equals(EvaluationFactorEnum.EVAL_BID_TEC)) {
								if ((expert.getEvalBidTypeNotNull() & ExpertEnum.EXPERT_TEC) == 0) {
									continue;
								}
							} else if (null != evaluationStep.getEvalBidType() && evaluationStep.getEvalBidType().equals(EvaluationFactorEnum.EVAL_BID_DETAIL)) {
								if ((expert.getEvalBidTypeNotNull() & (ExpertEnum.EXPERT_BUS | ExpertEnum.EXPERT_TEC)) == 0) {
									continue;
								}
							}
						}else if (ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EVAL_GROUP)) {
							if(null == expert.getEvalGroup()){
								continue;
							}
							if(null == evalGroupStepList){
								evalGroupStepList = evaluationStepService.getEvalGroupEvalStepList(tenderProjectEntity.getId(), expert.getEvalGroup());
							}
							if (null == evalGroupStepList || !evalGroupStepList.contains(evaluationStep.getId())) {
								continue;
							}
						}
					}
						
					final StepProgressButton stepProgress= new StepProgressButton(memberNodeComposite, SWT.NONE);
					stepProgress.setText((nodeCount+1)+"、"+evaluationStep.getStepName()+" >>");
					
					// 专家在当前评标步骤的状态
					final ExpertEvaluationStep expertEvaluationStep = null != expertStepMap.get(evaluationStep.getId())? expertStepMap.get(evaluationStep.getId()) : new ExpertEvaluationStep();
					boolean canReOperator = false;
					if(StringUtils.isEmpty(expertEvaluationStep.getStepStatus())){
						if(ObjectUtils.equals(evaluationStep.getStepType(), EvaluationStepEnum.SIGIN) && StringUtils.isNotEmpty(expert.getSignType())){
							stepProgress.setBackground(StepProgressButton.COMPLATE_COLOR);
							canReOperator = true;
						}else {
							stepProgress.setBackground(StepProgressButton.NO_START_COLOR);
						}
					}else if(ObjectUtils.equals(expertEvaluationStep.getStepStatus(), CommonEnum.COMPLETE)){
						if(null != expertEvaluationStep.getApplyStatus() && expertEvaluationStep.getApplyStatus().equals(CommonEnum.YES)){
							stepProgress.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/hand.png"));
						}else {
							stepProgress.setImage(null);
						}
						stepProgress.setBackground(StepProgressButton.COMPLATE_COLOR);
						stepProgress.setActiveBackgroundColor(StepProgressButton.RE_AUTHORIZATION_COLOR);
						stepProgress.setActiveBorderColor(StepProgressButton.RE_AUTHORIZATION_COLOR);
						canReOperator = true;
					}else if(ObjectUtils.equals(expertEvaluationStep.getStepStatus(), CommonEnum.IN_EXPERT_REVIEW) 
							|| ObjectUtils.equals(expertEvaluationStep.getStepStatus(), CommonEnum.IN_MANAGER_REVIEW)){
						stepProgress.setBackground(StepProgressButton.IN_PROGRESS_COLOR);
					}else if(ObjectUtils.equals(expertEvaluationStep.getStepStatus(), CommonEnum.IN_PROGRESS)){
						stepProgress.setBackground(StepProgressButton.IN_PROGRESS_COLOR);
					}else if(ObjectUtils.equals(expertEvaluationStep.getStepStatus(), CommonEnum.RE_OPERATOR)){
						stepProgress.setBackground(StepProgressButton.RE_AUTHORIZATION_COLOR);
					}else {
						stepProgress.setBackground(StepProgressButton.NO_START_COLOR);
					}
					Expert leaderExpert = expertService.getExpertLeader(tenderProjectEntity.getId());
					if (needReback && canReOperator && null != leaderExpert && Constants.USER.getId().equals(leaderExpert.getUserId())) {
						stepProgress.addMouseListener(new MouseAdapter() {
							public void mouseUp(MouseEvent e) {
								rebackExperEvaluationStepAction(evaluationStep, expertEvaluationStep);
							}
						});
					}
					nodeCount ++;
				}
				
				memberCount++;
			}
		}
		expert_progress.layout();
		new Thread(new Runnable() {
			public void run() {
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
				}
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!composite.isDisposed()) {
							composite.layout();
							scrolledComposite.setMinSize(composite.computeSize(scrolledComposite.getBounds().width -20, SWT.DEFAULT));
						}
					}
				});
			}
		}).start();;
	}
	
	/**
	 * @Description: 回退评标专家的评标步骤操作
	 * @author guoyr
	 */
	private void rebackExperEvaluationStepAction(EvaluationStep evaluationStep, ExpertEvaluationStep expertEvaluationStep){
		ReEvaluationConfirmDialog reEvaluationConfirmDialog = new ReEvaluationConfirmDialog(getShell(), evaluationStep, expertEvaluationStep);
		reEvaluationConfirmDialog.open();
		if(reEvaluationConfirmDialog.isConfirmReback()){
			if(ObjectUtils.equals(evaluationStep.getStepType(), EvaluationStepEnum.SIGIN)){
				String userId = null ;
				if(null != expertEvaluationStep){
					userId = expertEvaluationStep.getUserId();
				}
				expertService.updateSignTypeByTenderIdOrUserId(null,tenderProjectEntity.getId(),userId);
			}
			refreshAction();
		}
	}
	
	/**
	 * @Description: 是否确认修正评标价
	 * @author guoyr
	 * @param evaluationStep
	 * @return
	 */
	private boolean isConfirmEvalPrice(EvaluationStep evaluationStep, boolean isExpertLeader){
		boolean isConfirmEvalPrice = false;
		// 如果价格评审是由项目经理评审，则说明所有专家进行评标价修正确认
		if(ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.OPERATOR)){
			
			isConfirmEvalPrice = true;
		}else if(ObjectUtils.equals(evaluationStep.getRoleType(), EvaluationStepEnum.EXPERT_LEADER) && isExpertLeader){
			// 专家组长进行价格评审
			isConfirmEvalPrice = false;
		}else {
			// 其他专家确认修正报价
			isConfirmEvalPrice = true;
		}
		return isConfirmEvalPrice;
	}
	
	/**
	 * @Description: 回退评标专家的评标步骤操作
	 * @author guoyr
	 */

	protected void checkSubclass() {}
	@Override
	public void refresh(TenderProjectEntity tenderProjectEntity) {
		this.tenderProjectEntity = tenderProjectEntity;
		refreshAction();
	}
}
