package com.gx.obe.common.composite;

import java.io.File;
import java.io.IOException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.dialog.QklOpenFileDialog;
import com.gx.obe.common.widget.dialog.ProgressDialog;
import com.gx.obe.webservice.HttpDownFile;
import com.swtdesigner.SWTResourceManager;

public class FileHashComposite extends Composite {
	private Label fileCodeLabel;
	private ImageButton openFileBtn;
	private Label fileNameLabel;
	private String urlPath;
	private String filePath;
	private ProgressDialog synchShellInfo;
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public FileHashComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(3, false);
		gridLayout.horizontalSpacing = 10;
		setLayout(gridLayout);
		
		this.urlPath = (String)parent.getData("urlPath");
		this.filePath = (String)parent.getData("filePath");
		
		fileNameLabel = new Label(this, SWT.NONE);
		fileNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		GridData gd_fileNameLabel = new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1);
		gd_fileNameLabel.widthHint = 100;
//		gd_fileNameLabel.widthHint = 200;
		fileNameLabel.setLayoutData(gd_fileNameLabel);
		fileNameLabel.setText("文件名称：");
		
		fileCodeLabel = new Label(this, SWT.NONE);
		fileCodeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		GridData gd_fileCodeLabel = new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1);
		gd_fileCodeLabel.widthHint = 200;
		fileCodeLabel.setLayoutData(gd_fileCodeLabel);
		fileCodeLabel.setText("文件标识");
		
		openFileBtn = new EButton(this, SWT.NONE);
		GridData gd_openFileBtn = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_openFileBtn.minimumWidth = 100;
		openFileBtn.setLayoutData(gd_openFileBtn);
		openFileBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				openFileAction();
			}
		});
		openFileBtn.setText("查看文件");
		openFileBtn.setFont(SWTResourceManager.getFont("宋体", 9, SWT.NORMAL));
		openFileBtn.setForeground(ColorConstants.FONT_BLUE_COLOR);
		openFileBtn.setArcWidth(6);
		
	}
	
	/**
	 * @Description: 打开文件
	 * @author wangxiang 
	 */
	private void openFileAction() {
		if(null != urlPath){
			synchShellInfo = new ProgressDialog(getShell(), "正在下载区块链文件...");
			//评标结果查询
			Thread mythread = new Thread(new Runnable() {
				public void run() {
					File file = new File(filePath);
					if(file.exists()){
						file.delete();
					}
					try {
						HttpDownFile.downLoadFromUrl(urlPath,filePath);
					} catch (IOException e) {
					}
					if(file.exists()){
						Display.getDefault().syncExec(new Runnable() {
							public void run() {
								if(null != synchShellInfo){
									synchShellInfo.close();
								}
								//根据2.0去公共服务查询附件
								QklOpenFileDialog qklOpenFileDialog = new QklOpenFileDialog(getShell(),urlPath,filePath);	
								qklOpenFileDialog.open();
							}
						});
					}else{
						Display.getDefault().syncExec(new Runnable() {
							public void run() {
								if(null != synchShellInfo){
									synchShellInfo.close();
								}
								MessageDialog.openMessage(getShell(), "文件下载失败！");
							}
						});
					}
				}
			});
			mythread.start();
			synchShellInfo.open();
		}else{
			MessageDialog.openMessage(getShell(), "文件地址错误！");
		}
	}

	public void refrash(String attachmentFileName, String attachmentCode) {
		fileNameLabel.setText(attachmentFileName+"：");
		fileNameLabel.setToolTipText(attachmentFileName);
		fileCodeLabel.setText(attachmentCode);
		fileCodeLabel.setToolTipText(attachmentCode);
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	
}
