package com.gx.obe.common.composite;

import java.util.List;

import com.gx.obe.listener.EvaluationSupplierFactorListener;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.AuthUser;
import com.gx.obe.web.entity.evaluation.EvaluationStep;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;


public interface IEvaluationTable{
	
	/**
	 * @Description: 刷新评标界面
	 * @author guoyr
	 * @param tenderProjectEntity
	 * @param tenderProjectRuleEntity
	 * @param user
	 * @param evaluationStep
	 * @param supplierList
	 * @param evaluationSupplierFactorListener 
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, AuthUser user, EvaluationStep evaluationStep, List<Supplier> supplierList, EvaluationSupplierFactorListener evaluationSupplierFactorListener);
	
	/**
	 * @Description: 设置默认指标结果
	 * @author guoyr 
	 */
	public void initDefaultFactorResult();
	
	/**
	 * @Description: 导入其他专家的评审结果
	 * @author guoyr 
	 */
	public void importOtherExpertResult();
	
	/**
	 * @Description: 切换坐标
	 * @author guoyr 
	 */
	public void switchCoordinateAction();
	
	/**
	 * @Description: 保存评标结果
	 * @author guoyr
	 * @return 
	 */
	public boolean saveEvaluationFactorResult();
	
	/**
	 * @Description: 提交评标结果
	 * @author guoyr
	 * @return 
	 */
	public boolean submitEvaluationFactorResult();
	
	

}
