package com.gx.obe.common.composite;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Tips;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.util.utils.UuidUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import org.eclipse.swt.core.utils.GridUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 导入 投标人界面
 * @author guoyr
 */
public class ImportSupplierComposite extends Composite {
	
	private ProjectRuleService projectRuleService ;
	private SupplierService supplierService = new SupplierService();
	private TenderProjectEntity tenderProjectEntity;
	private List<Supplier> curSupplierList;
	private Map<String, Supplier> curSupplierMap = new HashMap<String, Supplier>();
	private String SUPPLIER_NAME;
	private SelectTenderProjectComposite selectTenderProjectComposite;
	private Grid supplierGrid;
	private ELink selectAllBtn;
	private ELink selectBackBtn;
	private Tips messageLabel;
	private EButton importSupplierBtn;
	
	/**
	 * @param parent
	 * @param style
	 * @param tenderProjectEntity
	 */
	public ImportSupplierComposite(Composite parent, int style, TenderProjectEntity tenderProjectEntity) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginWidth = 0;
		gridLayout.marginHeight = 0;
		setLayout(gridLayout);
		this.tenderProjectEntity = tenderProjectEntity;
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		
		messageLabel = new Tips(this, SWT.WRAP);
		messageLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		messageLabel.setText("选中的投标人将导入当前项目");
		
		Composite parentComposite = new Composite(this, SWT.NONE);
		parentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_parentComposite = new GridLayout(1, false);
		gl_parentComposite.verticalSpacing = 0;
		gl_parentComposite.horizontalSpacing = 0;
		gl_parentComposite.marginHeight = 1;
		gl_parentComposite.marginWidth = 1;
		parentComposite.setLayout(gl_parentComposite);
		parentComposite.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		SashForm sashForm = new SashForm(parentComposite, SWT.SMOOTH);
		sashForm.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		sashForm.setSashWidth(1);
		
		sashForm.setData("tenderProjectEntity", tenderProjectEntity);
		sashForm.setLayout(new FillLayout(SWT.HORIZONTAL));
		selectTenderProjectComposite = new SelectTenderProjectComposite(sashForm, SWT.NONE);
		selectTenderProjectComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite composite_1 = new Composite(sashForm, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.horizontalSpacing = 0;
		gl_composite_1.marginWidth = 0;
		gl_composite_1.verticalSpacing = 0;
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		
		Composite composite_4 = new Composite(composite_1, SWT.NONE);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		composite_4.setLayout(new GridLayout(3, false));
		
		Label label = new Label(composite_4, SWT.NONE);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label.setText(SUPPLIER_NAME);
		label.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		selectAllBtn = new ELink(composite_4, SWT.NONE);
		selectAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectAllBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				selectSupplierAction(1);
			}
		});
		GridData gd_selectAllBtn = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		selectAllBtn.setLayoutData(gd_selectAllBtn);
		selectAllBtn.setText(Messages.Button_selectAll);
		
		selectBackBtn = new ELink(composite_4, SWT.NONE);
		selectBackBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				selectSupplierAction(-1);
			}
		});
		GridData gd_selectBackBtn = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		selectBackBtn.setLayoutData(gd_selectBackBtn);
		selectBackBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectBackBtn.setText(Messages.Button_selectInvert);
		
		ESepator sepator = new ESepator(composite_1, SWT.NONE);
		sepator.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		sepator.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		supplierGrid = new Grid(composite_1, SWT.V_SCROLL);
		supplierGrid.setHeaderVisible(false);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn gridColumn_1 = new GridColumn(supplierGrid, SWT.CHECK);
		gridColumn_1.setText(MessageFormat.format(Messages.NameFormat, SUPPLIER_NAME));
		gridColumn_1.setWidth(150);
		sashForm.setWeights(new int[] {6, 4});
		
		Composite composite = new Composite(this, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		importSupplierBtn = new EButton(composite, SWT.NONE);
		importSupplierBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		importSupplierBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				importSupplierAction();
			}
		});
		GridData gd_importSupplier = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		importSupplierBtn.setLayoutData(gd_importSupplier);
		importSupplierBtn.setText(Messages.Button_import);
		
		EButton cancel_btn = new EButton(composite, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_cancelBtn = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		cancel_btn.setLayoutData(gd_cancelBtn);
		cancel_btn.setText(Messages.Button_close);
		
		init();
	}
	
	/**
	 * @Description: 初始化界面数据
	 * @author guoyr
	 */
	private void init(){
		projectRuleService = new ProjectRuleService();
		supplierGrid.setItemHeight(30);
		supplierGrid.setAutoWidth(true);
		// 添加选中监听事件
		supplierGrid.addListener(SWT.Selection, new Listener(){
			public void handleEvent(Event event) {
				// 选中了复选框事件
				if(event.detail == SWT.CHECK){
					GridItem item = (GridItem)event.item;
					if(item.getGrayed(0)){
						item.setChecked(0, false);
					}
				}
			}
		});
		// 选取出当前项目下的投标人
//		QueryWrapper queryWrapper = new QueryWrapper(Supplier.class);
//		queryWrapper.setWhereParam("tenderId", tenderProjectEntity.getId());
//		queryWrapper.setWhereParam("useStatus", CommonEnum.REAL_STATUS);
		curSupplierList = supplierService.getSupplierList(tenderProjectEntity.getId());
		if(null != curSupplierList){
			for(Supplier supplier : curSupplierList){
				curSupplierMap.put(supplier.getOrgCode(), supplier);
			}
		}
		selectTenderProjectComposite.setCallBack(new CallBack(){
			@Override
			public void callBackObject(Object obj) {
				refreshSupplierGrid((TenderProjectEntity)obj);
			}
		});
		messageLabel.setText("请选择要参与["+tenderProjectEntity.getTenderNo()+"]"+tenderProjectEntity.getTenderName()+"的"+SUPPLIER_NAME+"。");
	}
	
	/**
	 * @Description: 刷新投标人列表
	 * @author guoyr
	 */
	private void refreshSupplierGrid(TenderProjectEntity tenderProjectEntity){
		supplierGrid.removeAll();
		importSupplierBtn.setEnabled(false);
		selectAllBtn.setEnabled(false);
		selectBackBtn.setEnabled(false);
		
		String tenderId = null != tenderProjectEntity ? tenderProjectEntity.getId() : null;
		if(StringUtils.isNotEmpty(tenderId)){
			// 获得项目下的投标人
			List<Supplier> supplierList = null;
			if(tenderProjectEntity.getChildrenCountIntValue() > 0){// 获得项目下所有包件的投标人集合
				supplierList = supplierService.getSupplierListByTenderProject(tenderId);
			}else {// 获得项目或包件的投标人集合
				supplierList = supplierService.getAllSupplierList(tenderId);
			}
			if(null != supplierList && supplierList.size() > 0){
				// 如果匿名显示
				boolean isAnonymous = false;
				// 如果显示匿名，验证是否要匿名
				if(Constants.SHOW_ANONYMOUS){
					isAnonymous = projectRuleService.isAnonymous(tenderId);
				}
				// 设置匿名和序号
				int checkCount = 0;
				int index = 1;
				// 遍历投标人
				for(Supplier supplier : supplierList){
					supplier.setAnonymous(isAnonymous, index ++);
					GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
					gridItem.setData("supplier", supplier);
					gridItem.setText(0, supplier.getSupplierName());
					
					Supplier existSupplier = curSupplierMap.get(supplier.getOrgCode());
					// 判断投标人是否存在，存在则不显示多选框，不让用户选中操作。
					if(null != existSupplier && existSupplier.getOrgCode().equals(supplier.getOrgCode())){
						gridItem.setCheckVisible(0, false);
						gridItem.setText(0, "[已存在]"+supplier.getSupplierName());
					}else {
						// 如果匿名显示，则不显示多选框
						if(isAnonymous){
							gridItem.setCheckVisible(0, false);
						}else{
							checkCount ++;
						}
					}
				}
				selectAllBtn.setEnabled(true);
				selectBackBtn.setEnabled(true);
				if(checkCount > 0){
					importSupplierBtn.setEnabled(true);
				}
			}
		}
	}
	
	/**
	 * @Description: 全选或反选
	 * @author guoyr
	 * @param selectType 1全选，-1反选
	 */
	private void selectSupplierAction(int selectType){
		for(GridItem gridItem : supplierGrid.getItems()){
			if(gridItem.getCheckVisible(0)){
				if(selectType == 1){
					gridItem.setChecked(0, true);
				}else {
					gridItem.setChecked(0, !gridItem.getChecked(0));
				}
			}
		}
	}
	
	/**
	 * @Description: 导入投标人
	 * @author guoyr
	 */
	private void importSupplierAction(){
		if(!importSupplierBtn.getEnabled()){
			return ;
		}
		// 获得投标人的最大序号 
		int importCont = supplierService.getMaxSupplierSortNo(tenderProjectEntity.getId());
		List<Supplier> importSupplierList = new ArrayList<Supplier>();
		for(GridItem gridItem : GridUtils.getCheckedItems(supplierGrid, 0, true)){
			Supplier supplier = (Supplier)gridItem.getData("supplier");
			if(null != supplier){
				supplier.setId(UuidUtils.getUUID());
				supplier.setTenderId(tenderProjectEntity.getId());
				supplier.setUseStatus(CommonEnum.REAL_STATUS);
				supplier.setBidBond(null);// 保证金设为空
				supplier.setTenderFee(null);// 标书费设为空
				supplier.setSignFile(null);
				supplier.setSignPerson(null);
				supplier.setSignPersonCard(null);
				supplier.setSignPersonTel(null);
				supplier.setSignTime(null);
				supplier.setSignType(null);
				
				supplier.setSortNo(++importCont);
				
				importSupplierList.add(supplier);
			}
		}
		if(null != importSupplierList && importSupplierList.size() > 0){
			if(supplierService.batchSave(importSupplierList) > 0){
				cancelAction();
			}
		}else {
			MessageDialog.openInformation(getShell(), "请先选择要导入的"+SUPPLIER_NAME+"！");
		}
	}
	
	/**
	 * @Description: 取消
	 * @author guoyr
	 */
	private void cancelAction(){
		getShell().close();
	}
	
	@Override
	protected void checkSubclass() {
	}
}
