package com.gx.obe.common.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.poi.ss.usermodel.Sheet;
import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.SupplierEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.report.poi.ExcelPoi;
import com.gx.obe.thread.LimitBidRecommendThread;
import com.gx.obe.thread.LimitBidRecommendThread.FinishListener;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierEvaluationResult;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierEvaluationResultService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.utils.TableExcelUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import de.kupzog.ktable.KTable;
import de.kupzog.ktable.SWTX;
import de.kupzog.ktable.model.CommonKtableCModel;
import de.kupzog.ktable.renderers.CellAlignmentRender;
import de.kupzog.ktable.renderers.CellContentRender;
import de.kupzog.ktable.renderers.CellForegroundRender;
import de.kupzog.ktable.renderers.CellRender;
import de.kupzog.ktable.renderers.FixedWrapCellRenderer;
import de.kupzog.ktable.renderers.TextWrapCellRenderer;

public class LimitBidRecommendComposite extends Composite {

	private Composite originalTableComposite;
	private Composite limitBid;
	private Map<String, List<Supplier>> beforeTenderPackSupplierListMap;
	private Map<String, List<Supplier>> limitTenderPackSupplierListMap;
	private Map<String, List<Supplier>> afterLimitTenderPackSupplierListMap;
	private Composite center_composite;
	private Label curPurcategoryNamesLabel;
	private List<TenderProjectEntity> allTenderPackList;
	private EButton save_btn;
	private List<TenderProjectEntity> disComplateTenderPackList;
	private List<TenderProjectEntity> limitTenderPackList;
	private List<TenderProjectEntity> beforeTenderPackList;
	private String tenderName;
	private CommonKtableCModel originalCommKTableModel;
	private CommonKtableCModel limitBidCommKTableModel;
	private int maxSupplierCount = 0;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private int recommendNumber = 3;
	private String EMPTY_PURCATEGORY = "未分类";
	private Composite limitConfigComposite;
	private Composite limitBidTitle;
	private Composite reLimitBidComposite;
	
	private TenderProjectService tenderProjectService;
	private ProjectRuleService projectRuleService ;
	private SupplierService supplierService = new SupplierService();
	private SupplierEvaluationResultService supplierEvaluationResultService ;
	
	private Composite left_composite;
	private Grid purchategoryGrid;
	private CLabel hideOrShowSupplier_btn;
	
	private TenderProjectEntity tenderProjectEntity;
	private boolean isHideOrShowSupplier;
	private String curPurcategoryName;
	private int limitBidNumber = 1;
	
	private Set<String> purcategoryNamesSet;
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public LimitBidRecommendComposite(Composite parent, int style) {
		super(parent, style);
		tenderProjectService = new TenderProjectService();
		tenderProjectEntity = (TenderProjectEntity) parent.getData("tenderProjectEntity");
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.verticalSpacing = 0;
		gl_container.horizontalSpacing = 0;
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		setLayout(gl_container);
		
		Composite sashForm = new Composite(this, SWT.NONE);
		sashForm.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_sashForm = new GridLayout(3, false);
		gl_sashForm.marginWidth = 0;
		gl_sashForm.marginHeight = 0;
		gl_sashForm.verticalSpacing = 0;
		gl_sashForm.horizontalSpacing = 0;
		sashForm.setLayout(gl_sashForm);
		
		left_composite = new Composite(sashForm, SWT.NONE);
		GridLayout gl_left_composite = new GridLayout(1, false);
		gl_left_composite.verticalSpacing = 1;
		gl_left_composite.horizontalSpacing = 1;
		gl_left_composite.marginHeight = 1;
		gl_left_composite.marginWidth = 1;
		left_composite.setLayout(gl_left_composite);
		left_composite.addPaintListener(new RoundBorderLineListener(ColorConstants.BORDER_LINE_COLOR));
		GridData gd_left_composite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_left_composite.widthHint = 200;
		left_composite.setLayoutData(gd_left_composite);
		
		purchategoryGrid = new Grid(left_composite, SWT.V_SCROLL);
		purchategoryGrid.addListener(SWT.Selection, new GridSelectionListener() {
			public void leftMouseButtonDown(GridItem item) {
				selectPurchaseAction();
			}
		});
		purchategoryGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		purchategoryGrid.setAutoWidth(true);
		purchategoryGrid.setItemHeight(Constants.ROW_HIGHT);
		purchategoryGrid.setAutoHeight(true);
		purchategoryGrid.setHeaderVisible(true);
		
		GridColumn gridColumn = new GridColumn(purchategoryGrid, SWT.LEFT);
		gridColumn.setText("限中物资");
		gridColumn.setWordWrap(true);
		
		center_composite = new Composite(sashForm, SWT.NONE);
		center_composite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, false, true, 1, 1));
		GridLayout gl_center_composite = new GridLayout(1, false);
		gl_center_composite.marginWidth = 0;
		gl_center_composite.marginHeight = 0;
		center_composite.setLayout(gl_center_composite);
		
		hideOrShowSupplier_btn = new CLabel(center_composite, SWT.NONE);
		hideOrShowSupplier_btn.setRightMargin(0);
		hideOrShowSupplier_btn.setLeftMargin(0);
		hideOrShowSupplier_btn.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, false, true, 1, 1));
		hideOrShowSupplier_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				isHideOrShowSupplier = !isHideOrShowSupplier;
				hideOrShowSupplierAction();
				drawOriginalTable();
				drawLimitBidTable();
			}
		});
		hideOrShowSupplier_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/left_arrow.png"));
		
		Composite right_omposite = new Composite(sashForm, SWT.NONE);
		FillLayout fl_right_omposite = new FillLayout(SWT.VERTICAL);
		fl_right_omposite.spacing = 5;
		right_omposite.setLayout(fl_right_omposite);
		right_omposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite originalComposite = new Composite(right_omposite, SWT.NONE);
		originalComposite.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gl_originalComposite = new GridLayout(1, false);
		gl_originalComposite.horizontalSpacing = 0;
		gl_originalComposite.verticalSpacing = 1;
		gl_originalComposite.marginHeight = 1;
		gl_originalComposite.marginWidth = 1;
		originalComposite.setLayout(gl_originalComposite);
		
		TitleComposite titleComposite = new TitleComposite(originalComposite, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		titleComposite.setTitle("评标推荐结果");
		
		ELink createOriginalExcel_btn = titleComposite.addELink();
		createOriginalExcel_btn.setText("导出excel");
		createOriginalExcel_btn.setToolTipText("生成选中的模板");
		createOriginalExcel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/excel.png"));
		createOriginalExcel_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				generateReport(originalCommKTableModel);
			}
		});
		
		originalTableComposite = new Composite(originalComposite, SWT.NONE);
		originalTableComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_original = new GridLayout(1, false);
		gl_original.verticalSpacing = 0;
		gl_original.horizontalSpacing = 0;
		gl_original.marginHeight = 0;
		gl_original.marginWidth = 0;
		originalTableComposite.setLayout(gl_original);
		originalTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite limitBidComposite = new Composite(right_omposite, SWT.NONE);
		limitBidComposite.setBackground(ColorConstants.BORDER_LINE_COLOR);
		GridLayout gl_limitBidComposite = new GridLayout(1, false);
		gl_limitBidComposite.marginWidth = 1;
		gl_limitBidComposite.horizontalSpacing = 0;
		gl_limitBidComposite.verticalSpacing = 1;
		gl_limitBidComposite.marginHeight = 1;
		limitBidComposite.setLayout(gl_limitBidComposite);
		
		limitConfigComposite = new Composite(limitBidComposite, SWT.NONE);
		limitConfigComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_limitConfig = new GridLayout(4, false);
		gl_limitConfig.verticalSpacing = 0;
		gl_limitConfig.horizontalSpacing = 0;
		gl_limitConfig.marginHeight = 0;
		limitConfigComposite.setLayout(gl_limitConfig);
		limitConfigComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		curPurcategoryNamesLabel = new Label(limitConfigComposite, SWT.NONE);
		curPurcategoryNamesLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		curPurcategoryNamesLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		curPurcategoryNamesLabel.setForeground(ColorConstants.FONT_BLUE_COLOR);
		
		limitBidTitle = new Composite(limitConfigComposite, SWT.NONE);
		limitBidTitle.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_limitBidTitle = new GridLayout(7, false);
		gl_limitBidTitle.verticalSpacing = 0;
		gl_limitBidTitle.horizontalSpacing = 5;
		limitBidTitle.setLayout(gl_limitBidTitle);
		limitBidTitle.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		Label limitBidLabel = new Label(limitBidTitle, SWT.NONE);
		limitBidLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		limitBidLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		limitBidLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		limitBidLabel.setText("投标人限中");
		
		final Text limitBidText = new Text(limitBidTitle, SWT.CENTER | SWT.BORDER);
		limitBidText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		GridData gd_text = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_text.widthHint = 50;
		limitBidText.setLayoutData(gd_text);
		limitBidText.setText("1");
		limitBidText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent arg0) {
				limitBidNumber = ObjectUtils.getIntValue(limitBidText.getText().trim(), 0);
				limitBidRecommentSort(true);
			}
		});
		
		Label label_1 = new Label(limitBidTitle, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_1.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label_1.setText("标段，每标段推荐");
		
		final Text recommendText = new Text(limitBidTitle, SWT.CENTER | SWT.BORDER);
		recommendText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		GridData gd_recommendtText = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_recommendtText.widthHint = 50;
		recommendText.setLayoutData(gd_recommendtText);
		recommendText.setText("3");
		recommendText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent arg0) {
				recommendNumber = ObjectUtils.getIntValue(recommendText.getText().trim(), 0);
				drawLimitBidTable();
			}
		});
		
		Label label_2 = new Label(limitBidTitle, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label_2.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_2.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label_2.setText("名中标候选人（仅对已完成推荐的" + com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType()) + "进行限中）");
		
		reLimitBidComposite = new Composite(limitConfigComposite, SWT.NONE);
		reLimitBidComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_reLimitBidComposite = new GridLayout(2, false);
		gl_reLimitBidComposite.verticalSpacing = 0;
		gl_reLimitBidComposite.horizontalSpacing = 0;
		reLimitBidComposite.setLayout(gl_reLimitBidComposite);
		reLimitBidComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		Label label_3 = new Label(reLimitBidComposite, SWT.NONE);
		label_3.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_3.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label_3.setText("已经进行过推荐候选人限中操作，如需重新限中，请点击");
		
		ELink reLimitBidRecommoned_btn = new ELink(reLimitBidComposite, SWT.BOLD);
		reLimitBidRecommoned_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		reLimitBidRecommoned_btn.setText("重新限中");
		reLimitBidRecommoned_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				limitBidRecommentSort(true);
			}
		});
		
		ELink createLimitBidExcel_btn = new ELink(limitConfigComposite, SWT.NONE);
		createLimitBidExcel_btn.setText(Messages.Button_export);
		createLimitBidExcel_btn.setShowSubLine(false);
		createLimitBidExcel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/excel.png"));
		createLimitBidExcel_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				generateReport(limitBidCommKTableModel);
			}
		});
		
		limitBid = new Composite(limitBidComposite, SWT.NONE);
		limitBid.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_limitBid = new GridLayout(1, false);
		gl_limitBid.verticalSpacing = 0;
		gl_limitBid.horizontalSpacing = 0;
		gl_limitBid.marginHeight = 0;
		gl_limitBid.marginWidth = 0;
		limitBid.setLayout(gl_limitBid);
		limitBid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		
		Composite buttonComposite = new Composite(this, SWT.NONE);
		buttonComposite.setLayout(new GridLayout(1, false));
		buttonComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		save_btn = new EButton(buttonComposite, SWT.NONE);
		save_btn.setBackground(ColorConstants.SKIN_BG);
		save_btn.setForeground(ColorConstants.SKIN_FOREGROUND);
		save_btn.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		save_btn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		save_btn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		save_btn.setArcWidth(6);
		save_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				if (save_btn.getEnabled()) {
					saveAction();
				}
			}
		});
		save_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_savebutton_1 = new GridData(SWT.RIGHT, SWT.FILL, true, true, 1, 1);
		gd_savebutton_1.heightHint = 35;
		gd_savebutton_1.widthHint = 200;
		save_btn.setLayoutData(gd_savebutton_1);
		save_btn.setText("确认限中标推荐结果");
		
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author chenxw
	 */
	private void init() {
		supplierEvaluationResultService = new SupplierEvaluationResultService();
		projectRuleService = new ProjectRuleService();
		save_btn.setEnabled(false);
		tenderName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());
		
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		if (null == tenderProjectRuleEntity) tenderProjectRuleEntity = new TenderProjectRuleEntity();
		
		curPurcategoryName = tenderProjectEntity.getPurcategoryNames();
		if (StringUtils.isEmpty(curPurcategoryName)) curPurcategoryName = EMPTY_PURCATEGORY;
		
		showPurcategoryList();
		
	}
	
	/**
	 * @Description: 生成左侧列表
	 * @author chenxw
	 */
	private void showPurcategoryList() {
		
		allTenderPackList = tenderProjectService.getSubPackageList(tenderProjectEntity.getParentId());
		if(null == allTenderPackList){
			allTenderPackList = new ArrayList<TenderProjectEntity>();
		}
		
		purcategoryNamesSet = new HashSet<String>();
		for (TenderProjectEntity tenderProjectEntity : allTenderPackList) {
			String purcategoryNames = tenderProjectEntity.getPurcategoryNames();
			if (StringUtils.isEmpty(purcategoryNames)) purcategoryNames = EMPTY_PURCATEGORY;
			purcategoryNamesSet.add(purcategoryNames);
		}
		
		for (String purcategoryName : purcategoryNamesSet) {
			GridItem gridItem = new GridItem(purchategoryGrid, SWT.NONE);
			gridItem.setText(0, purcategoryName);
			gridItem.setData("purcategoryName", purcategoryName);
			if (purcategoryName.equals(curPurcategoryName)) {
				purchategoryGrid.setSelection(new GridItem[] { gridItem });
			}
		}
		
		isHideOrShowSupplier = purcategoryNamesSet.size() < 2;
		hideOrShowSupplierAction();
		
		selectPurchaseAction();
	}
	
	/**
	 * @Description: 左侧列表按钮点击事件
	 * @author chenxw
	 * @param purcategoryName
	 * @param purchategoryBtn
	 */
	private void selectPurchaseAction() {
		if(purchategoryGrid.getSelectionCount() > 0){
			curPurcategoryName = (String) purchategoryGrid.getSelection()[0].getData("purcategoryName");
		}else {
			curPurcategoryName = "";
		}
		curPurcategoryNamesLabel.setText("[" + curPurcategoryName + "]");
		curPurcategoryNamesLabel.getParent().layout();
		limitBidRecommentSort(false);
	}
	
	/**
	 * @Description: 刷新表格
	 * @author chenxw
	 */
	private void limitBidRecommentSort(boolean createNewLimitBidRecommoned) {
		
		// 未完成评审包件
		disComplateTenderPackList = new ArrayList<TenderProjectEntity>();
		
		// 对应限中物资包件
		limitTenderPackList = new ArrayList<TenderProjectEntity>();
		beforeTenderPackList = new ArrayList<TenderProjectEntity>();
		
		// 初始评标结果
		limitTenderPackSupplierListMap = new HashMap<String, List<Supplier>>();
		beforeTenderPackSupplierListMap = new HashMap<String, List<Supplier>>();
		
		// 标识当前物次是否做过限中
		boolean hasLimitRecommoned = false;
		
		for (TenderProjectEntity tenderPack : allTenderPackList) {
			
			if (TenderProjectEnum.EFFECTIVE_NO.equals(tenderPack.getEffectiveType())) continue;
			
			String purcategoryNames = tenderPack.getPurcategoryNames();
			if (StringUtils.isEmpty(purcategoryNames)) purcategoryNames = EMPTY_PURCATEGORY;
			
			// 排除不属于当前限中物资
			if (!curPurcategoryName.equals(purcategoryNames)) continue;
			
			beforeTenderPackList.add(tenderPack);
			// 排除未完成评审
			if (null == tenderPack.getComplateStatus() || !tenderPack.getComplateStatus().equals(CommonEnum.COMPLETE)) {
				disComplateTenderPackList.add(tenderPack);
				beforeTenderPackSupplierListMap.put(tenderPack.getId(), null);
				continue;
			}
			
			String tenderPackId = tenderPack.getId();
			List<Supplier> supplierList = supplierService.getSupplierOpenbidAndEvaluateResultList(tenderPackId);
			if (null == supplierList) supplierList = new ArrayList<Supplier>();
			
			List<Supplier> removeSupplierList = new ArrayList<Supplier>();
			for (Supplier supplier : supplierList) {
				SupplierOpeningResult openingResult = supplier.getSupplierOpeningResult();
				SupplierEvaluationResult evaluationResult = supplier.getSupplierEvaluationResult();
				if (SupplierEnum.REVOKE_YES.equals(openingResult.getRevokeStatus()) || !SupplierEnum.OPENBID_SUCCESS.equals(openingResult.getBidOpeningStatus()) || com.gx.obe.components.core.enumeration.EvaluationStepEnum.UNQUALIFIED.equals(evaluationResult.getAccessment())) {
					removeSupplierList.add(supplier);
				}
				if (!createNewLimitBidRecommoned) {
					if (!hasLimitRecommoned && evaluationResult.getWinBidSortNo() > 0 && null != evaluationResult.getWinBidRecommend() && evaluationResult.getWinBidRecommend().length() == 2) {
						hasLimitRecommoned = true;
					}
				}
			}
			if (removeSupplierList.size() > 0) {
				supplierList.removeAll(removeSupplierList);
			}
			limitTenderPackList.add(tenderPack);
			
			limitTenderPackSupplierListMap.put(tenderPackId, supplierList);
			beforeTenderPackSupplierListMap.put(tenderPackId, supplierList);
		}
		
		// 获得所有包件当中最多供应商数量
		maxSupplierCount = 1;
		for (String key : limitTenderPackSupplierListMap.keySet()) {
			List<Supplier> list = limitTenderPackSupplierListMap.get(key);
			if (list.size() > maxSupplierCount) {
				maxSupplierCount = list.size();
			}
		}
		
		drawOriginalTable();
		
		((GridData) reLimitBidComposite.getLayoutData()).exclude = !hasLimitRecommoned;
		reLimitBidComposite.setVisible(hasLimitRecommoned);
		((GridData) limitBidTitle.getLayoutData()).exclude = hasLimitRecommoned;
		limitBidTitle.setVisible(!hasLimitRecommoned);
		limitConfigComposite.layout();
		
		
		save_btn.setEnabled(false);
		
		// 启动计算线程
		final boolean _hasLimitRecommoned = hasLimitRecommoned;
		LimitBidRecommendThread thread = new LimitBidRecommendThread(limitTenderPackSupplierListMap, limitBidNumber, hasLimitRecommoned);
		thread.addFinishListener(new FinishListener() {
			public void finish(final Map<String, List<Supplier>> newSupplierListMap) {
				// 限中推荐结果
				afterLimitTenderPackSupplierListMap = newSupplierListMap;
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (EMPTY_PURCATEGORY.equals(curPurcategoryName) && purcategoryNamesSet.size() > 1) afterLimitTenderPackSupplierListMap.clear();
						if (afterLimitTenderPackSupplierListMap.size() > 1 && !_hasLimitRecommoned) save_btn.setEnabled(true);
						drawLimitBidTable();
//						if (curOldSupplierListMap.size() > limitBidNumber && curNewSupplierListMap.size() > 0) {
					}
				});
			}
		});
		thread.start();
	}
	
	/**
	 * @Description: 生成excel
	 * @author chenxw
	 * @param commKTableModel
	 */
	private void generateReport(CommonKtableCModel commKTableModel) {
		if (commKTableModel.getRowCount() == 1) {
			MessageDialog.openShortMessage("没有可导出的记录！");
			return;
		}
		ExcelPoi excelPoi = TableExcelUtils.createTableExcel(commKTableModel);
		Sheet sheet = excelPoi.getActiveSheet();
		sheet.getWorkbook().setSheetName(sheet.getWorkbook().getSheetIndex(sheet), curPurcategoryName);
		String fileName = curPurcategoryName + "-" + commKTableModel.getData("name") + "-" + limitBidNumber;
		String saveFileName = FileDialogUtils.getFileSavePath(fileName, Messages.Button_saveAs, new String[] { "*.xls;*.xlsx" });
		if (StringUtils.isNotEmpty(saveFileName)) {
			File file = new File(saveFileName);
			if (file.exists()) {
				if (MessageDialog.openConfirm(getShell(), Messages.Button_export, MessageFormat.format(Messages.Tips_alreadyExistAndCover, fileName), new String[]{Messages.Button_overwrite, Messages.Button_cancel})) {
					file.delete();
				} else {
					return;
				}
			}
			if (excelPoi.save(saveFileName)) {
				if (MessageDialog.openConfirm(getShell(), Messages.Button_openFile, "生成excel成功，请确认是否打开文件？", new String[]{Messages.Button_confirm, Messages.Button_cancel})) {
					RuntimeUtils.openFIle(new File(saveFileName));
				}
			} else {
				MessageDialog.openError(getShell(), "生成excel失败！");
			}
		}
	}
	
	/**
	 * @Description: 保存限中推荐结果
	 * @author chenxw
	 */
	private void saveAction() {
		String message = "是否确认限中推荐候选人结果？";
		if (disComplateTenderPackList.size() > 0) {
			StringBuffer buffer = new StringBuffer();
			buffer.append("当前限中物资下");
			for (TenderProjectEntity tenderProjectEntity : disComplateTenderPackList) {
				buffer.append("“").append(tenderProjectEntity.getTenderName()).append("”、");
			}
			buffer.delete(buffer.length() - 1, buffer.length());
			buffer.append("没有完成评审，请确认是否进行限中推荐候选人？");
			message = buffer.toString();
		}
		if (!MessageDialog.openConfirm(getShell(), "确认限中推荐候选人", message, new String[]{Messages.Button_confirm, Messages.Button_cancel})) {
			return;
		}
		List<SupplierEvaluationResult> list = new ArrayList<SupplierEvaluationResult>();
		for (String tenderId : limitTenderPackSupplierListMap.keySet()) {
			Iterator<Supplier> iterator = limitTenderPackSupplierListMap.get(tenderId).iterator();
			while (iterator.hasNext()) {
				SupplierEvaluationResult result = iterator.next().getSupplierEvaluationResult();
				result.setWinBidSortNo(0);
				result.setWinBidRecommend(SupplierEnum.LIMIT_BID);
				list.add(result);
			}
		}
		supplierEvaluationResultService.batchUpdateProperty(list, new String[] {"id", "winBidSortNo", "winBidRecommend" });
		list.clear();
		for (String tenderId : afterLimitTenderPackSupplierListMap.keySet()) {
			Iterator<Supplier> iterator = afterLimitTenderPackSupplierListMap.get(tenderId).iterator();
			int winBidSortNo = 1;
			while (iterator.hasNext()) {
				SupplierEvaluationResult result = iterator.next().getSupplierEvaluationResult();
				if (winBidSortNo > recommendNumber) {
					result.setWinBidRecommend(SupplierEnum.RECOMMONED_NO);
				} else {
					result.setWinBidRecommend(SupplierEnum.RECOMMONED_YES);
				}
				result.setWinBidSortNo(winBidSortNo++);
				list.add(result);
			}
		}
		supplierEvaluationResultService.batchUpdateProperty(list, new String[] {"id", "winBidSortNo", "winBidRecommend" });
		MessageDialog.openShortMessage("操作成功");
		limitBidRecommentSort(false);
	}
	
	/**
	 * @Description: 隐藏显示左侧列表
	 * @author chenxw
	 */
	private void hideOrShowSupplierAction() {
		((GridData) left_composite.getLayoutData()).exclude = isHideOrShowSupplier;
		if (isHideOrShowSupplier) {
			hideOrShowSupplier_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/right_arrow.png"));
		} else {
			hideOrShowSupplier_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/left_arrow.png"));
		}
		left_composite.setVisible(!isHideOrShowSupplier);
		left_composite.getParent().layout();
	}
	
	/**
	 * @Description: 绘制初始评审表格
	 * @author chenxw
	 */
	private void drawOriginalTable() {
		for (Control control : originalTableComposite.getChildren()) {
			control.dispose();
		}
		KTable resultKTable = new KTable(originalTableComposite, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.FILL_WITH_LASTCOL | SWTX.EDIT_ON_KEY);
		resultKTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		originalCommKTableModel = new CommonKtableCModel(resultKTable, 1, 1, beforeTenderPackSupplierListMap.size(), maxSupplierCount * 2);
		originalCommKTableModel.setData("name", "评标结果");
		// 设置列宽
		originalCommKTableModel.setColumnMaxWidth(0, 200);
		originalCommKTableModel.setColumnMinWidth(0, 150);
		for (int i = originalCommKTableModel.getFixedColumnCount(); i < originalCommKTableModel.getColCount(); i++) {
			int supplierStartIndex = i - originalCommKTableModel.getFixedColumnCount();
			if (supplierStartIndex % 2 == 0) {
				originalCommKTableModel.setColumnMinWidth(i, 100);
				originalCommKTableModel.setColumnMinWidth(i, 200);
			} else {
				originalCommKTableModel.setColumnMinWidth(i, 100);
				originalCommKTableModel.setColumnMaxWidth(i, 150);
			}
		}
		// 设置单元格内容
		CellContentRender contentRender = new CellContentRender() {
			public Object receiveContent(int row, int col) {
				if (row < originalCommKTableModel.getFixedHeaderRowCount()) {
					if (0 == col) {
						return tenderName;
					} else {
						int supplierStartIndex = col - originalCommKTableModel.getFixedHeaderColumnCount();
						if (supplierStartIndex % 2 == 0) {
							return "第 " + (col / 2 + 1) + " 名";
						} else {
							return "投标报价（" + tenderProjectRuleEntity.getPriceUnitUseDefault() + "）";
						}
					}
				} else {
					TenderProjectEntity tenderPack = beforeTenderPackList.get(row - originalCommKTableModel.getFixedHeaderRowCount());
					List<Supplier> supplierList = limitTenderPackSupplierListMap.get(tenderPack.getId());
					if (0 == col) {
						return "[" + tenderPack.getTenderNo() + "]" + tenderPack.getTenderName();
					} else if (null != supplierList) {
						int supplierStartIndex = col - 1;
						if (supplierStartIndex / 2 < supplierList.size()) {
							Supplier supplier = supplierList.get(supplierStartIndex / 2);
							if (0 == supplierStartIndex % 2) {
								return supplier.getSupplierName();
							} else {
								SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
								if (null != supplierOpeningResult && null != supplierOpeningResult.getEvaluationPrice()) {
									return supplierOpeningResult.getFormatEvaluatoinPriceByUnit(tenderProjectRuleEntity.getEvalPriceUnit());
								}
							}
						}
					}
					return "";
				}
			}
		};
		originalCommKTableModel.setCellContentRender(contentRender);
		// 设置单元格字体颜色
		CellForegroundRender cellForegroundRender = new CellForegroundRender() {
			public Color receiveCellForeground(int row, int col) {
				if (row >= originalCommKTableModel.getFixedHeaderRowCount()) {
					if (0 != col) {
						int supplierStartIndex = col - originalCommKTableModel.getFixedHeaderColumnCount();
						if (supplierStartIndex % 2 != 0) {
							return ColorConstants.SKIN_BG;
						}
					}
				}
				return null;
			}
		};
		originalCommKTableModel.setCellForegroundRender(cellForegroundRender);
		// 设置单元格渲染器
		CellRender cellRender = new CellRender() {
			public Object receiveCellRender(int row, int col) {
				if (originalCommKTableModel.isFixedCell(col, row)) {
					return new FixedWrapCellRenderer();
				} else {
					return new TextWrapCellRenderer();
				}
			}
		};
		originalCommKTableModel.setCellRender(cellRender);
		// 编辑单元格对齐方式
		CellAlignmentRender cellAlignmentRender = new CellAlignmentRender() {
			public int receiveCellAlignment(int row, int col) {
				if (row >= originalCommKTableModel.getFixedHeaderRowCount()) {
					if (col >= originalCommKTableModel.getFixedColumnCount()) {
						int supplierStartIndex = col - originalCommKTableModel.getFixedHeaderColumnCount();
						if (supplierStartIndex % 2 == 0) {
							return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
						} else {
							return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_RIGHT;
						}
					} else {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					}
				}
				return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
			}
		};
		originalCommKTableModel.setCellAlignmentRender(cellAlignmentRender);
		resultKTable.setModel(originalCommKTableModel);
		originalTableComposite.layout();
	}
	
	/**
	 * @Description: 绘制限中评审表格
	 * @author chenxw
	 */
	private void drawLimitBidTable() {
		for (Control control : limitBid.getChildren()) {
			control.dispose();
		}
		KTable resultKTable = new KTable(limitBid, SWTX.AUTO_SCROLL | SWT.FULL_SELECTION | SWTX.FILL_WITH_LASTCOL | SWTX.EDIT_ON_KEY);
		resultKTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		limitBidCommKTableModel = new CommonKtableCModel(resultKTable, 1, 1, limitTenderPackSupplierListMap.size(), maxSupplierCount * 2);
		limitBidCommKTableModel.setData("name", "限中推荐");
		// 设置列宽
		limitBidCommKTableModel.setColumnMaxWidth(0, 200);
		limitBidCommKTableModel.setColumnMinWidth(0, 150);
		for (int i = limitBidCommKTableModel.getFixedColumnCount(); i < limitBidCommKTableModel.getColCount(); i++) {
			int supplierStartIndex = i - limitBidCommKTableModel.getFixedColumnCount();
			if (supplierStartIndex % 2 == 0) {
				limitBidCommKTableModel.setColumnMinWidth(i, 100);
				limitBidCommKTableModel.setColumnMinWidth(i, 200);
			} else {
				limitBidCommKTableModel.setColumnMinWidth(i, 100);
				limitBidCommKTableModel.setColumnMaxWidth(i, 150);
			}
		}
		// 设置单元格内容
		CellContentRender contentRender = new CellContentRender() {
			public Object receiveContent(int row, int col) {
				if (row < limitBidCommKTableModel.getFixedHeaderRowCount()) {
					if (0 == col) {
						return tenderName;
					} else {
						int supplierStartIndex = col - limitBidCommKTableModel.getFixedHeaderColumnCount();
						if (supplierStartIndex % 2 == 0) {
							return "第 " + (col / 2 + 1) + " 名";
						} else {
							return "投标报价（" + tenderProjectRuleEntity.getPriceUnitUseDefault() + "）";
						}
					}
				} else {
					TenderProjectEntity tenderPack = limitTenderPackList.get(row - limitBidCommKTableModel.getFixedHeaderRowCount());
					if (0 == col) {
						return "[" + tenderPack.getTenderNo() + "]" + tenderPack.getTenderName();
					} else {
						int supplierStartIndex = col - 1;
						if (afterLimitTenderPackSupplierListMap.containsKey(tenderPack.getId())) {
							List<Supplier> supplierList = afterLimitTenderPackSupplierListMap.get(tenderPack.getId());
							if (supplierStartIndex / 2 < supplierList.size()) {
								Supplier supplier = supplierList.get(supplierStartIndex / 2);
								if (0 == supplierStartIndex % 2) {
									return supplier.getSupplierName();
								} else {
									SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
									if (null != supplierOpeningResult && null != supplierOpeningResult.getEvaluationPrice()) {
										return supplierOpeningResult.getFormatEvaluatoinPriceByUnit(tenderProjectRuleEntity.getEvalPriceUnit());
									}
								}
							}
						}
						return "";
					}
				}
			}
		};
		limitBidCommKTableModel.setCellContentRender(contentRender);
		// 设置单元格字体颜色
		CellForegroundRender cellForegroundRender = new CellForegroundRender() {
			public Color receiveCellForeground(int row, int col) {
				if (row >= limitBidCommKTableModel.getFixedHeaderRowCount()) {
					if (0 != col) {
						if ((col - 1) / 2 + 1 > recommendNumber) {
							return ColorConstants.NOTE_TIPS_COLOR;
						}
						
						int supplierStartIndex = col - limitBidCommKTableModel.getFixedHeaderColumnCount();
						if (supplierStartIndex % 2 != 0) {
							return ColorConstants.SKIN_BG;
						}
					}
				}
				return null;
			}
		};
		limitBidCommKTableModel.setCellForegroundRender(cellForegroundRender);
		// 设置单元格渲染器
		CellRender cellRender = new CellRender() {
			public Object receiveCellRender(int row, int col) {
				if (limitBidCommKTableModel.isFixedCell(col, row)) {
					return new FixedWrapCellRenderer();
				} else {
					return new TextWrapCellRenderer();
				}
			}
		};
		limitBidCommKTableModel.setCellRender(cellRender);
		// 编辑单元格对齐方式
		CellAlignmentRender cellAlignmentRender = new CellAlignmentRender() {
			public int receiveCellAlignment(int row, int col) {
				if (row >= limitBidCommKTableModel.getFixedHeaderRowCount()) {
					if (col >= limitBidCommKTableModel.getFixedColumnCount()) {
						int supplierStartIndex = col - limitBidCommKTableModel.getFixedHeaderColumnCount();
						if (supplierStartIndex % 2 == 0) {
							return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
						} else {
							return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_RIGHT;
						}
					} else {
						return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_LEFT;
					}
				}
				return SWTX.ALIGN_VERTICAL_CENTER | SWTX.ALIGN_HORIZONTAL_CENTER;
			}
		};
		limitBidCommKTableModel.setCellAlignmentRender(cellAlignmentRender);
		resultKTable.setModel(limitBidCommKTableModel);
		limitBid.layout();
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
