package com.gx.obe.common.composite;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.action.bean.Action;
import com.gx.obe.common.dialog.TenderProjectDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.components.core.util.MoneyUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.thread.NewUpdateTenderProjectInfoThread;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.listener.TenderProjectListener;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class ParentProjectBaseInfoComposite extends Composite {
//	private TenderProjectService tenderProjectService = ServiceFactory.getInstance("tenderProjectService", TenderProjectService.class);
//	private ProjectRuleService projectRuleService = ServiceFactory.getInstance("projectRuleService", ProjectRuleService.class);
	private Composite tenderProjectComposite;
	private Label managerName;
	private Label tenderTypeCombo;
	private Label tenderMethodCombo;
	private Label evalMethodTypeLabel;
	private Label evalMethodTypeCombo;
	private Label purchaserName;
	private Label bidOpeningTimeText;
	private Label evalBidTimeText;
	private Label bidOpeningRoomCombo;
	private Label budgetMoneyLabel;
	private Label budgetMoneyText;
//	private Text tenderContent;
//	private Text tenderSummary;
	private Label openbidLabel;

//	private Composite composite;
	private ELink updateProjectInfo;
//	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private ELink editButton;
	private Label priceOpeningTimeText;
	private Composite priceOpeningTimeNameComposite;
	private Composite priceOpeningTimeComposite;
	private Composite bidOpeningRoomComposite;
	private Label isPack_btn;
	private TitleComposite titleComposite;
	private Menu menu;
	
	private TenderProjectRuleEntity projectRule;
	private TenderProjectEntity tenderProject;
	private Action projectAction;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public ParentProjectBaseInfoComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		this.projectAction = projectAction;
		
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		setLayout(gridLayout);
		
//		composite = new Composite(this, SWT.NONE);
//		composite.setBackgroundMode(SWT.INHERIT_FORCE);
//		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
////		composite.setBackgroundImage(ResourceManager.getPluginImage(SWTCoreActivator.COMMON_PLUGIN_ID, "icons/title_bg.png"));
//		composite.setLayout(new GridLayout(3, false));
		
		
		titleComposite = new TitleComposite(this, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
//		label = new Label(titleComposite, SWT.WRAP);
//		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
//		label.setText("项目信息");
		
		updateProjectInfo = titleComposite.addELink("REFRESH");
		updateProjectInfo.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				updateTenderProjectAction();
			}
		});
		updateProjectInfo.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/update.png"));
		updateProjectInfo.setText(Messages.Button_refreshNew);
		
		editButton = titleComposite.addELink("EDIT");
		editButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				updateProjectAction();
			}
		});
		editButton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		editButton.setText(Messages.Button_modify);
		
		tenderProjectComposite = new Composite(this, SWT.NONE);
		tenderProjectComposite.setBackground(SWTResourceManager.getColor(220, 220, 220));
		tenderProjectComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_tenderProjectComposite = new GridLayout(4, false);
		gl_tenderProjectComposite.marginHeight = 1;
		gl_tenderProjectComposite.horizontalSpacing = 1;
		gl_tenderProjectComposite.verticalSpacing = 1;
		gl_tenderProjectComposite.marginWidth = 1;
		tenderProjectComposite.setLayout(gl_tenderProjectComposite);
		
		Composite composite_2 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(240, 240, 240));
		GridData gd_composite_2 = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_composite_2.widthHint = 100;
		composite_2.setLayoutData(gd_composite_2);
		composite_2.setLayout(new GridLayout(1, false));
		
		Label tenderTypeLabel = new Label(composite_2, SWT.NONE);
		tenderTypeLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		tenderTypeLabel.setText(Messages.TenderType + ":");
		
		Composite composite_13 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_13.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridData gd_composite_13 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite_13.widthHint = 150;
		composite_13.setLayoutData(gd_composite_13);
		GridLayout gl_composite_13 = new GridLayout(1, false);
		gl_composite_13.marginHeight = 0;
		composite_13.setLayout(gl_composite_13);
		
		tenderTypeCombo = new Label(composite_13, SWT.READ_ONLY);
		tenderTypeCombo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		
		Composite composite_9 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_9.setBackground(SWTResourceManager.getColor(240, 240, 240));
		GridData gd_composite_9 = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_composite_9.widthHint = 100;
		composite_9.setLayoutData(gd_composite_9);
		composite_9.setLayout(new GridLayout(1, false));
		
		Label label_5 = new Label(composite_9, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		label_5.setText(Messages.TenderMethod + "：");
		
		Composite composite_14 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_14.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridData gd_composite_14 = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_composite_14.widthHint = 150;
		composite_14.setLayoutData(gd_composite_14);
		composite_14.setLayout(new GridLayout(1, false));
		
		tenderMethodCombo = new Label(composite_14, SWT.READ_ONLY);
		tenderMethodCombo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		
		Composite composite_3 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_3.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_3.setLayout(new GridLayout(1, false));
		
		evalMethodTypeLabel = new Label(composite_3, SWT.NONE);
		evalMethodTypeLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		evalMethodTypeLabel.setText(Messages.EvalMethod + "：");
		
		Composite composite_15 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_15.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_15.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_15.setLayout(new GridLayout(1, false));
		
		evalMethodTypeCombo = new Label(composite_15, SWT.READ_ONLY);
		evalMethodTypeCombo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		evalMethodTypeCombo.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite composite_10 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_10.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_10.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_10.setLayout(new GridLayout(1, false));
		
		Label label_2 = new Label(composite_10, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		label_2.setText(Messages.ProjectManager + "：");
		
		Composite composite_1 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_1.setLayout(new GridLayout(1, false));
		
		managerName = new Label(composite_1, SWT.NONE | SWT.READ_ONLY);
		managerName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		managerName.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite composite_4 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_4.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_4.setLayout(new GridLayout(1, false));
		
		Label requsterLabel = new Label(composite_4, SWT.NONE);
		requsterLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		requsterLabel.setText(Messages.ProjectRequster + ": ");
		
		Composite composite_16 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_16.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_16.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_16.setLayout(new GridLayout(1, false));
		
		purchaserName = new Label(composite_16, SWT.NONE | SWT.WRAP);
		purchaserName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		purchaserName.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		
		
		Composite composite_w4 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_w4.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_w4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_w4.setLayout(new GridLayout(1, false));
		
		Label isPack_Label = new Label(composite_w4, SWT.NONE);
		isPack_Label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		isPack_Label.setText(Messages.ProjectHasPack+": ");
		
		Composite composite_w6 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_w6.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_w6.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_w6.setLayout(new GridLayout(1, false));
		
		isPack_btn = new Label(composite_w6, SWT.NONE);
		isPack_btn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, true, 1, 1));
		isPack_btn.setText(Messages.Yes);
		
		
		Composite composite_11 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_11.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_11.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_11.setLayout(new GridLayout(1, false));
		
		budgetMoneyLabel = new Label(composite_11, SWT.NONE);
		budgetMoneyLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		budgetMoneyLabel.setText(Messages.BudgetMoney + ": ");
		
		Composite composite_17 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_17.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_17.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_17.setLayout(new GridLayout(1, false));
		
		budgetMoneyText = new Label(composite_17, SWT.NONE);
		budgetMoneyText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		budgetMoneyText.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite composite_5 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_5.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_5.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_5.setLayout(new GridLayout(1, false));
		
		openbidLabel = new Label(composite_5, SWT.NONE);
		openbidLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		openbidLabel.setText(Messages.BidOpeningTime + ": ");
		
		Composite composite_18 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_18.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_18.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_18.setLayout(new GridLayout(1, false));
		
		bidOpeningTimeText = new Label(composite_18, SWT.NONE);
		bidOpeningTimeText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		bidOpeningTimeText.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite composite_12 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_12.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_12.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_12.setLayout(new GridLayout(1, false));
		
		Label label_8 = new Label(composite_12, SWT.NONE);
		label_8.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		label_8.setText(Messages.EvaluationTime + ": ");
		
		Composite composite_19 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_19.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_19.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite_19.setLayout(new GridLayout(1, false));
		
		evalBidTimeText = new Label(composite_19, SWT.NONE | SWT.READ_ONLY);
		evalBidTimeText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		evalBidTimeText.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		priceOpeningTimeNameComposite = new Composite(tenderProjectComposite, SWT.NONE);
		priceOpeningTimeNameComposite.setBackground(SWTResourceManager.getColor(240, 240, 240));
		priceOpeningTimeNameComposite.setLayout(new GridLayout(1, false));
		priceOpeningTimeNameComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		
		Label label_1 = new Label(priceOpeningTimeNameComposite, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		label_1.setText(Messages.PriceBidOpeningTime + "：");
		
		priceOpeningTimeComposite = new Composite(tenderProjectComposite, SWT.NONE);
		priceOpeningTimeComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		priceOpeningTimeComposite.setLayout(new GridLayout(1, false));
		priceOpeningTimeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		
		priceOpeningTimeText = new Label(priceOpeningTimeComposite, SWT.NONE);
		priceOpeningTimeText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		priceOpeningTimeText.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		Composite composite_6 = new Composite(tenderProjectComposite, SWT.NONE);
		composite_6.setBackground(SWTResourceManager.getColor(240, 240, 240));
		composite_6.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite_6.setLayout(new GridLayout(1, false));
		
		Label label_9 = new Label(composite_6, SWT.NONE);
		label_9.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1));
		label_9.setText(Messages.BidOpeningRoom + "：");
		
		bidOpeningRoomComposite = new Composite(tenderProjectComposite, SWT.NONE);
		bidOpeningRoomComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		bidOpeningRoomComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		bidOpeningRoomComposite.setLayout(new GridLayout(1, false));
		
		bidOpeningRoomCombo = new Label(bidOpeningRoomComposite, SWT.WRAP);
		bidOpeningRoomCombo.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
		bidOpeningRoomCombo.setBackground(SWTResourceManager.getColor(240, 240, 240));
		
//		Composite composite_7 = new Composite(tenderProjectComposite, SWT.NONE);
//		composite_7.setBackground(SWTResourceManager.getColor(240, 240, 240));
//		GridData gd_composite_7 = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
//		gd_composite_7.heightHint = 100;
//		composite_7.setLayoutData(gd_composite_7);
//		composite_7.setLayout(new GridLayout(1, false));
		
//		CLabel label_10 = new CLabel(composite_7, SWT.NONE);
//		label_10.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, true, false, 1, 1));
//		label_10.setText("采购内容：");
		
//		Composite composite_20 = new Composite(tenderProjectComposite, SWT.NONE);
//		composite_20.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		composite_20.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 3, 1));
//		composite_20.setLayout(new GridLayout(1, false));
		
//		tenderContent = new Text(composite_20, SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
//		tenderContent.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		tenderContent.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
//		Composite composite_8 = new Composite(tenderProjectComposite, SWT.NONE);
//		composite_8.setBackground(SWTResourceManager.getColor(240, 240, 240));
//		GridData gd_composite_8 = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
//		gd_composite_8.heightHint = 100;
//		composite_8.setLayoutData(gd_composite_8);
//		composite_8.setLayout(new GridLayout(1, false));
//		
//		CLabel label_11 = new CLabel(composite_8, SWT.NONE);
//		label_11.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, true, false, 1, 1));
//		label_11.setText("摘    要：");
		
//		Composite composite_21 = new Composite(tenderProjectComposite, SWT.NONE);
//		composite_21.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		composite_21.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 3, 1));
//		composite_21.setLayout(new GridLayout(1, false));
//		
//		tenderSummary = new Text(composite_21, SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL | SWT.MULTI);
//		tenderSummary.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		tenderSummary.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		Composite statusComposite = new Composite(this, SWT.NONE);
//		GridData gd_statusComposite = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
//		gd_statusComposite.heightHint = 100;
//		statusComposite.setLayoutData(gd_statusComposite);
		init();
	}

	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		
		this.menu = projectAction.getMenu();
		tenderProject = projectAction.refreshTenderProject();
		projectRule = projectAction.refreshTenderProjectRule();
		menuFunctionUtils.initFunctionAuthority(menu, titleComposite.getFunctionComposite());
		if(TenderProjectEnum.LOCAL.equals(tenderProject.getRemoteStatus())){
			WidgetUtils.setControlVisible(editButton, true);
		}
		refreshProjectInfoForm();
	}
	
	private void refreshProjectInfoForm(){
		if(null == budgetMoneyLabel && budgetMoneyLabel.isDisposed()){
			return ;
		}
		
		if(StringUtils.isNotEmpty(tenderProject.getUserId())){
			if(StringUtils.isNotEmpty(tenderProject.getProjectManager())){
				tenderProject.setManagerName(tenderProject.getProjectManager());
			}
			managerName.setText(ObjectUtils.getObjString(tenderProject.getManagerName()));
		}else {
			managerName.setText("");
		}
		
		purchaserName.setText(ObjectUtils.getObjString(tenderProject.getPurchaserName()));
		
//		tenderContent.setText(ObjectUtils.getObjString(tenderProjectEntity.getTenderContent()));
		if(StringUtils.isEmpty(tenderProject.getTenderMethod())){
			tenderProject.setTenderMethod(TenderProjectEnum.GKZB);
		}
		isPack_btn.setText(CommonEnum.YES.equals(tenderProject.getIsPack()) ? Messages.Yes : Messages.No);
		tenderMethodCombo.setText(TenderProjectEnum.getTenderMethodCN(tenderProject.getTenderMethod()));
		bidOpeningRoomCombo.setText(ObjectUtils.getObjString(tenderProject.getOpeningAddress()));
		// 采购预算
		if(null != tenderProject.getBudgetMoney()){
			budgetMoneyText.setText(MoneyUtils.getMoneyWidthUnit(tenderProject.getBudgetMoney(), null != projectRule ? projectRule.getEvalPriceUnit() : ""));
		}else{
			budgetMoneyText.setText("");
		}
		// 项目类型
		tenderTypeCombo.setText(TenderProjectEnum.getProjectTypeCN(tenderProject.getTenderType()));
		// 采购方式
		tenderMethodCombo.setText(TenderProjectEnum.getTenderMethodCN(tenderProject.getTenderMethod()));
		// 评标办法
		if(null != projectRule){
			if (null != projectRule.getBidOpeningStage() && projectRule.getBidOpeningStage().equals(TenderProjectEnum.BID_OPENING_TWO_STAGE)) {
				//两步开标
				((GridData) priceOpeningTimeNameComposite.getLayoutData()).exclude = false;
				priceOpeningTimeNameComposite.setVisible(true);
				((GridData) priceOpeningTimeComposite.getLayoutData()).exclude = false;
				priceOpeningTimeComposite.setVisible(true);
				bidOpeningRoomComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 3, 1));
				bidOpeningRoomComposite.layout();
				
				//商务、技术开标时间
				openbidLabel.setText(Messages.BusTecBidOpeningTime);
				//价格开标时间
				priceOpeningTimeText.setText(ObjectUtils.getObjString(DateUtils.getTimestampFormat(projectRule.getPriceBidOpeningTime())));
			} else {
				//一步开标
				((GridData) priceOpeningTimeNameComposite.getLayoutData()).exclude = true;
				priceOpeningTimeNameComposite.setVisible(false);
				((GridData) priceOpeningTimeComposite.getLayoutData()).exclude = true;
				priceOpeningTimeComposite.setVisible(false);
				bidOpeningRoomComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
				bidOpeningRoomComposite.layout();
			}
			//开标时间
			bidOpeningTimeText.setText(ObjectUtils.getObjString(DateUtils.getTimestampFormat(projectRule.getBidOpeningStartTime())));
			evalBidTimeText.setText(ObjectUtils.getObjString(DateUtils.getTimestampFormat(projectRule.getBidEvaluationStartTime())));
			evalMethodTypeCombo.setText(ObjectUtils.getObjString(projectRule.getEvalMethodName()));
		} else {
			bidOpeningTimeText.setText("");
			evalBidTimeText.setText("");
		}
		//开标室
		bidOpeningRoomCombo.setText(ObjectUtils.getObjString(tenderProject.getOpeningAddress()));
		tenderProjectComposite.layout();
	}

	
	/**
	 * @Description: 远程下载项目
	 * @author guoyr
	 */
	private void updateTenderProjectAction(){
		if(updateProjectInfo.getEnabled()){
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
				public void finish(boolean flag) {
					Display.getDefault().syncExec(() -> {
						if(!tenderProjectComposite.isDisposed()) {
							refreshProjectInfoForm();
						}
					});
				}
			});
			messageProgress.setTitle(Messages.Button_updateProject);
			messageProgress.setOperateVisible(false);
			new NewUpdateTenderProjectInfoThread(tenderProject, messageProgress).start();
			messageProgress.open();
		}
	}

	/**
	 * @Description: 修改项目信息
	 * @author guoyr
	 * @param tenderProjectEntity
	 * @param evaluationStep
	 */
	private void updateProjectAction(){
		if(!editButton.getEnabled()){
			return ;
		}

		TenderProjectDialog tenderProjectDialog = new TenderProjectDialog(getShell(), tenderProject);
		tenderProjectDialog.addTenderProjectListener(new TenderProjectListener(){
			public void updateTenderProject(TenderProjectEntity _tenderProject) {
				tenderProject = _tenderProject;
				refreshProjectInfoForm();
			}
			
		});
		tenderProjectDialog.open();
	
		
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	
	
}
