package com.gx.obe.common.composite;

import java.text.MessageFormat;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.action.bean.Action;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.swtdesigner.SWTResourceManager;

/**
 * 父项目投标单位列表界面
 */
public class ParentSupplierManagerComposite extends Composite {

	private ImageResolver imageResolver = new ImageResolver();
	private Grid supplierGrid;
	private GridColumn gridColumn_9;
	private SupplierService supplierService = new SupplierService();
	private ProjectRuleService projectRuleService ;
	private TenderProjectEntity tenderProjectEntity;
	private List<Map<String,Object>> supplierList;
	private String SUPPLIER_NAME = "投标人";
	private Composite composite;
	private Composite composite_1;
	private boolean isAnonymous = false;
//	private Menu menu;
//	private Map<String, String> menuFunctionMap;
//	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private TitleComposite titleComposite;
	private Action projectAction;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public ParentSupplierManagerComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		this.projectAction = projectAction;
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);

		titleComposite = new TitleComposite(this, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(211, 211, 211));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginHeight = 1;
		gl_composite.marginWidth = 1;
		composite.setLayout(gl_composite);
		
		composite_1 = new Composite(composite, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(255, 255, 255));
		composite_1.setLayout(new FillLayout(SWT.HORIZONTAL));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		supplierGrid = new Grid(composite_1, SWT.H_SCROLL | SWT.V_SCROLL);
		supplierGrid.setItemHeaderWidth(30);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setItemHeight(35);
		supplierGrid.setAutoWidth(true);
		
		GridColumn gridColumn_num = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_num.setText(Messages.Num);
		gridColumn_num.setWidth(50);
		gridColumn_num.setMaxmumWidth(50);
		
		gridColumn_9 = new GridColumn(supplierGrid, SWT.NONE);
		gridColumn_9.setText(Messages.Name);
		gridColumn_9.setWidth(200);
		
		GridColumn gridColumn_8 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_8.setText(Messages.Linker);
		gridColumn_8.setWidth(70);
		
		GridColumn gridColumn_10 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_10.setText(Messages.LinkerTel);
		gridColumn_10.setWidth(100);
		
		GridColumn gridColumn_11 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_11.setText(Messages.PackagesNum);
		gridColumn_11.setWidth(120);
		
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		projectRuleService = new ProjectRuleService();
		tenderProjectEntity = projectAction.getTenderProject();
		// 如果匿名显示
		isAnonymous  = projectRuleService.isAnonymous(tenderProjectEntity.getId());
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		titleComposite.setTitle(MessageFormat.format(Messages.Title_signupSupplierList, SUPPLIER_NAME));
		refreshSupplier(null);
		// 添加投标人表格的选中事件和右键菜单事件
//		supplierGrid.addListener(SWT.Selection, new GridSelectionListener(){
//			public void rightMouseButtonDown(GridItem item) {
//				supplierMenuDetectAction();
//			}
//		});
	}
	
	/**
	 * @Description: 刷新投标人列表
	 * @author guoyr
	 */
	private void refreshSupplier(String supplierId){

		supplierGrid.removeAll();
		if(null != supplierList){
			supplierList.clear();
			supplierList = null;
		}
		SyncThread syncThread = new SyncThread(new SyncThread.Runnable() {
			public void run() {
				supplierList = supplierService.getparentSupplierByParentTenderId(tenderProjectEntity.getId());
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!supplierGrid.isDisposed()){
							drawSupplierTable();
						}
					}
				});
			}
		});
		syncThread.start();
	
		
		supplierGrid.removeAll();
		if(null != supplierList){
			supplierList.clear();
			supplierList = null;
		}

		if(null != supplierList && supplierList.size() > 0){}
	}
	private void drawSupplierTable(){
		if(null != supplierList && supplierList.size() > 0){
			
			// 设置匿名和序号
			int index = 1;
			for(Map<String, Object> supplier : supplierList){
				supplier.put("isAnonymous", isAnonymous);
				supplier.put("index", index);
				GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				setSupplierInfo(gridItem, index, supplier);
				index ++;
			}
		}
	}
	

	/**
	 * @Description: 设置投标人信息
	 * @author guoyr
	 * @param gridItem
	 * @param supplier
	 */
	public void setSupplierInfo(GridItem gridItem, int index, Map<String, Object> supplier){
		// 如果未到开标时间，并且开标规则设置未到开标时间前隐然投标人信息
		gridItem.setText(0, index + "");
		boolean isAnonymous = (Boolean) supplier.get("isAnonymous");
		if(isAnonymous){
			gridItem.setText(1, "***");
			gridItem.setText(2, "***");
			gridItem.setText(3, "***");
		}else {
			gridItem.setText(1, ObjectUtils.getObjString(supplier.get("SUPPLIER_NAME")));
			gridItem.setText(2, ObjectUtils.getObjString(supplier.get("LINKER")));
			gridItem.setText(3, ObjectUtils.getObjString(supplier.get("LINKER_TEL")));
			gridItem.setText(4, ObjectUtils.getObjString((supplier.get("SUPPLIER_COUNT"))));
		}
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
//	private void supplierMenuDetectAction(){
//		if(supplierGrid.getSelectionCount() > 0){
//			final EMenu gmenu = new EMenu(getShell());
//			GridItem seletItem = supplierGrid.getSelection()[0];
//			final Supplier supplier =  new Supplier();
//			supplier.setSupplierName(seletItem.getText(1));
//			// 如果未到开标时间，并且隐藏投标人信息。则导出投标人功能不可操作。
//			gmenu.addMenuItem("导入LOGO", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"), null != supplier, new EMenu.ClickListener() {
//				public void click() {
//					ImportSupplierLogoDialog importSupplierLogoDialog = new ImportSupplierLogoDialog(getShell(), supplier);
//					importSupplierLogoDialog.open();
//				}
//			});
//			gmenu.open();
//		}
//	}
	
	protected void checkSubclass() {}

	@Override
	public void dispose() {
		imageResolver.disposite();
		super.dispose();
	}

}
