package com.gx.obe.common.composite;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.common.widget.button.FileButton;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 模板库模板面板类
 * @author guoyr
 */
public class QueryAnswerFileComposite extends Composite {

	private Composite composite;
//	private Label templateNameLabel;
//	private Label templateOperatorLabel;
	private FileButton file_name;
	private File file;
	private CallBack callBack;
	private ELink delete_btn;
	{
		LogUtils.logClass(QueryAnswerFileComposite.class);
	}
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public QueryAnswerFileComposite(Composite parent, int style, File file, Image fileIco, CallBack callBack) {
		super(parent, style);
		this.file = file;
		this.callBack = callBack;
		addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
//		setBackground(SWTResourceManager.getColor(192, 192, 192));
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		composite = new Composite(this, SWT.NONE);
		composite.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
		composite.setBackground(SWTResourceManager.getColor(255, 255, 255));
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		file_name = new FileButton(composite, SWT.NONE);
		file_name.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				openFile();
			}
		});
		file_name.setImage(fileIco);
		GridData gd_file_name = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_file_name.widthHint = 90;
		file_name.setLayoutData(gd_file_name);
		file_name.setText(file.getName());
		
		delete_btn = new ELink(composite, SWT.CENTER);
		delete_btn.addMouseTrackListener(new MouseTrackAdapter() {
			@Override
			public void mouseEnter(MouseEvent e) {
				file_name.notifyListeners(SWT.MouseEnter, null);
			}
			@Override
			public void mouseExit(MouseEvent e) {
				file_name.notifyListeners(SWT.MouseExit, null);
			}
		});
		delete_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				deleteFile();
			}
		});
		delete_btn.setForeground(SWTResourceManager.getColor(0, 0, 255));
		delete_btn.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		delete_btn.setText(Messages.Button_delete);
	}

	/**
	 * 双击打开文件
	 */
	public void openFile(){
		RuntimeUtils.openFIle(file);
	}

	/**
	 * 文件删除操作
	 */
	public void deleteFile(){
//		if(){}
		file.delete();
		callBack.after();
	}
	
	@Override
	protected void checkSubclass() {
	}

}
