package com.gx.obe.common.composite;

import java.text.MessageFormat;
import java.util.List;

import org.apache.log4j.Logger;
import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import com.gx.obe.action.bean.Action;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.tools.ole.DocumentLoader;
import com.gx.tools.ole.bjca.BJCASaomaCircleSignatureComposite;
import com.gx.tools.ole.cfca.CFCASaoMaLoaderImpl;
import com.gx.tools.ole.cfca.CFCASaomaCircleSignatureComposite;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 按项目下载解密投标文件
 * @author chenxw
 */
public class SignReportFileComposite extends Composite {
	private TenderProjectEntity tenderProjectEntity;
	private Composite packListTableComposite;
	private Composite contentComposite;
	private Grid tenderPackGrid;
	private String subPackAge;
	private TenderProjectService tenderProjectService ;
//	private EvaluationReportComposite bidFileDownloadBySupplierComposite;
	private Composite composite;
	
	private boolean isHeadSign = true;
	private DocumentLoader documentLoader;
//	private int signatureCount = 0;
//	private EButton complateSignature_btn;
//	private Map<String, File> signPdfMap = new HashMap<String, File>();
//	private Set<String> signFinishSet = new HashSet<String>();
//	private File curFile;
//	private String modifyName;
	private TenderProjectEntity tempPack;

	private Logger logger = Logger.getLogger(SignReportFileComposite.class);
	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 */
	public SignReportFileComposite(Composite parent, Action action, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		tenderProjectService = new TenderProjectService();
		tenderProjectEntity = action.getParentProject();
		subPackAge = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());

		contentComposite = new Composite(this, SWT.NONE);
		contentComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_contentComposite = new GridLayout(3, false);
		gl_contentComposite.verticalSpacing = 0;
		gl_contentComposite.marginHeight = 0;
		gl_contentComposite.marginWidth = 0;
		contentComposite.setLayout(gl_contentComposite);
		contentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite packListComposite = new Composite(contentComposite, SWT.NONE);
		packListComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_GRAY));
		GridLayout compositeLayout = new GridLayout(1, false);
		compositeLayout.verticalSpacing = 0;
		compositeLayout.horizontalSpacing = 0;
		compositeLayout.marginHeight = 1;
		compositeLayout.marginWidth = 1;
		packListComposite.setLayout(compositeLayout);
		GridData compositeData = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		compositeData.widthHint = 300;
		packListComposite.setLayoutData(compositeData);

		packListTableComposite = new Composite(packListComposite, SWT.NONE);
		packListTableComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
			GridLayout gl_packListTablecomposite = new GridLayout(1, false);
			gl_packListTablecomposite.verticalSpacing = 0;
			gl_packListTablecomposite.horizontalSpacing = 0;
			gl_packListTablecomposite.marginHeight = 0;
			gl_packListTablecomposite.marginWidth = 0;
			packListTableComposite.setLayout(gl_packListTablecomposite);
			packListTableComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		tenderPackGrid = new Grid(packListTableComposite, SWT.V_SCROLL);
		tenderPackGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tenderPackGrid.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				tenderPackSelectAction();
			}
		});

		GridColumn gridColumn = new GridColumn(tenderPackGrid, SWT.NONE);
		gridColumn.setText(MessageFormat.format(Messages.Title_name, subPackAge));
		gridColumn.setWidth(200);
		gridColumn.setWordWrap(true);
		
		composite = new Composite(contentComposite, SWT.NONE);
		composite.setLayout(new FillLayout(SWT.HORIZONTAL));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		init();
	}

	/**
	 * @Description: 初始化
	 * @author chenxw
	 */
	private void init() {
		//加载左侧包件列表
		if (null == tenderProjectEntity) {
			tenderProjectEntity = new TenderProjectEntity();
		}
		List<TenderProjectEntity> tenderPackList = tenderProjectService.getSubPackageList(tenderProjectEntity.getId());
		drawTenderPackTable(tenderPackList);
		tenderPackGrid.setHeaderVisible(true);
		tenderPackGrid.setShowEvenBackground(false);
		tenderPackGrid.setLinesVisible(true);
		tenderPackGrid.setAutoHeight(true);
		tenderPackGrid.setItemHeight(50);
		tenderPackGrid.getVerticalBar().setSelection(tenderPackGrid.getSelectionIndex());
		tenderPackGrid.getVerticalBar().notifyListeners(SWT.Selection, null);
		
		tenderPackSelectAction();
//		content.layout();
//		composite.layout();
	}

	/**
	 * @Description: 显示包件列表
	 * @author chenxw
	 * @param tenderPackList
	 */
	private void drawTenderPackTable(final List<TenderProjectEntity> tenderPackList) {
		tenderPackGrid.removeAll();
		if (null != tenderPackList && tenderPackList.size() > 0) {
			for (TenderProjectEntity tenderPack : tenderPackList) {
				GridItem gridItem = new GridItem(tenderPackGrid, SWT.NONE);
				gridItem.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
				gridItem.setText(0, "[" + tenderPack.getTenderNo() + "]" + tenderPack.getTenderName());
				gridItem.setData("tenderPack", tenderPack);
			}
		}
		tenderPackGrid.setSelection(0);
	}

	/**
	 * @Description: 选择包件事件
	 * @author chenxw
	 */
	private void tenderPackSelectAction() {
		if (tenderPackGrid.getSelectionCount() > 0) {
			GridItem selectGridItem = tenderPackGrid.getSelection()[0];
			tenderPackGrid.setFocusItem(selectGridItem);
			TenderProjectEntity tenderPack = (TenderProjectEntity) selectGridItem.getData("tenderPack");
			if (null != tenderPack) {
//				if (null != bidFileDownloadBySupplierComposite && !bidFileDownloadBySupplierComposite.isDisposed()) {
//					bidFileDownloadBySupplierComposite.dispose();
//				}
				tempPack = tenderPack;
				loadSignatureAction(tenderPack);
			}
			contentComposite.layout();
		}
	}
	
	
	private void loadSignatureAction(TenderProjectEntity tenderPack){
		for(Control control : composite.getChildren()) {
			control.dispose();
		}
		 final String signaturePdfvalue = PropertiesUtils.getProperty(ConfigConstants.SAOMA_SIGNATURE_PDF, "");
		// CFCA 中招扫码app
     	if(CFCASaoMaLoaderImpl.PDF_TYPE.equals(signaturePdfvalue)) {
     		CFCASaomaCircleSignatureComposite signatureComposite= new CFCASaomaCircleSignatureComposite(composite, SWT.NONE);
     		signatureComposite.refreshSignatureFiles(tenderPack, Constants.USER);
     	}else {
     		// 北京CA扫码签章
     		BJCASaomaCircleSignatureComposite signatureComposite= new BJCASaomaCircleSignatureComposite(composite, SWT.NONE);
     		signatureComposite.refreshSignatureFiles(tenderPack, Constants.USER);
     	}
     	composite.layout();
	}
	
	/**
	 * @Description: 刷新状态
	 * @author guoyr
	 * @param flag 
	 */
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
