package com.gx.obe.common.composite;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Set;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.common.dialog.ImportSupplierDialog;
import com.gx.obe.common.dialog.MeetingTitleEditDialog;
import com.gx.obe.common.dialog.SupplierBatchOrderDialog;
import com.gx.obe.common.dialog.SupplierDialog;
import com.gx.obe.common.dialog.SupplierEmportOrderDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.thread.SyncThread;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.I18N;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.SupplierEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.thread.ExportSupplierThread;
import com.gx.obe.thread.InvitationSupplierThread;
import com.gx.obe.thread.RefreshProjectSupplierTenderInfoThread;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class SupplierManagerComposite extends Composite {

	private ImageResolver imageResolver = new ImageResolver();
	private ELink up_btn;
	private ELink down_btn;
	private ELink editSortNo_btn;
	private ELink add_supplier_btn;
	private ELink edit_supplier_btn;
	private ELink delSupplierBtn;
	private Grid supplier_gird;
	private GridColumn gridColumn_9;
	private SupplierService supplierService = new SupplierService();
	private ProjectRuleService projectRuleService = new ProjectRuleService();
	private TenderProjectService tenderProjectService = new TenderProjectService();
//	private TenderProjectEntity tenderProjectEntity;
	private List<Supplier> supplierList;
	private String SUPPLIER_NAME = "投标人";
	private Composite composite;
	private Composite composite_1;
	private boolean isAnonymous = false;
	private ELink label_down_load;
	private ELink import_btn;
	private GridColumn sealedBidCodeColumn;
	private TitleComposite titleComposite;
	private Menu menu;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private ELink creatDarkCodebtn;
	private boolean sealedBidCode;
	private TenderProjectEntity tenderProject;
	private Action projectAction;
	private GridColumn tenderNumberColumn;
	private ELink invitationButton;
	private GridColumn meetingInvitationColumn;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public SupplierManagerComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		this.projectAction = projectAction;
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);

		titleComposite = new TitleComposite(this, SWT.NONE);
		GridLayout gridLayout_1 = (GridLayout) titleComposite.getLayout();
		gridLayout_1.numColumns = 3;
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		up_btn = titleComposite.addELink("UP");
		up_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				upOrDownSupplier(-1);
			}
		});
		up_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/up.png"));
		up_btn.setText(Messages.Button_moveUp);
		
		down_btn = titleComposite.addELink("DOWN");
		down_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/down.png"));
		down_btn.setText(Messages.Button_moveDown);
		down_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				upOrDownSupplier(1);
			}
		});
		
		label_down_load = titleComposite.addELink("DOWNLOAD");
		label_down_load.setText(Messages.Button_download);
		label_down_load.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				downLoadSupplier();
			}
		});
		label_down_load.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/download.png"));
		
		
		import_btn = titleComposite.addELink("IMPORT");
		import_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		import_btn.setText(Messages.Button_import);
		import_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				importSupplierAction();
			}
		});
		
		add_supplier_btn = titleComposite.addELink("ADD");
		add_supplier_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/add.png"));
		add_supplier_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				addNewSupplierAction();
			}
		});
		add_supplier_btn.setText(Messages.Button_add);
		
		edit_supplier_btn = titleComposite.addELink("EDIT");
		edit_supplier_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		edit_supplier_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				editSupplierAction();
			}
		});
		edit_supplier_btn.setText(Messages.Button_modify);
		
		delSupplierBtn = titleComposite.addELink("DEL");
		delSupplierBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		delSupplierBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				delSupplierAction();
			}
		});
		delSupplierBtn.setText(Messages.Button_delete);
		
		invitationButton = titleComposite.addELink("APPLY_VIDEO");
		invitationButton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/send.png"));
		invitationButton.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				invitationMeetingAction();
			}
		});
//		invitationButton.addSelectionListener(new SelectionAdapter() {
//			public void widgetSelected(SelectionEvent e) {
//				invitationMeetingAction();
//			}
//		});
		invitationButton.setText(Messages.Button_sendVideoMeetingVnvitation);
		
		editSortNo_btn = titleComposite.addELink("BATCH_SORT");
		editSortNo_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		editSortNo_btn.setText(Messages.Button_batchSort);
		editSortNo_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				editSortNoAction();
			}
		});
		
		ELink randomSortNo_btn = titleComposite.addELink("RANDOM_SORT");
		randomSortNo_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"));
		randomSortNo_btn.setText(Messages.Button_randomSort); 
		randomSortNo_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				randomSortNoAction();
			}
		});
		
		creatDarkCodebtn = titleComposite.addELink("CREAT_DARKCODE");
		creatDarkCodebtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		creatDarkCodebtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				creatDarkCodeAction();
			}
		});
		creatDarkCodebtn.setText(Messages.Button_createSealedCode);
		
		composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(211, 211, 211));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite1 = new GridLayout(1, false);
		gl_composite1.marginHeight = 1;
		gl_composite1.marginWidth = 1;
		composite.setLayout(gl_composite1);
		
		composite_1 = new Composite(composite, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(255, 255, 255));
		composite_1.setLayout(new FillLayout(SWT.HORIZONTAL));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		supplier_gird = new Grid(composite_1, SWT.H_SCROLL | SWT.V_SCROLL);
		supplier_gird.setItemHeaderWidth(30);
		supplier_gird.setHeaderVisible(true);
		supplier_gird.setItemHeight(35);
		supplier_gird.setAutoWidth(true);
		
		GridColumn gridColumn_num = new GridColumn(supplier_gird, SWT.CENTER);
		gridColumn_num.setText(Messages.Num);
		gridColumn_num.setWidth(50);
		gridColumn_num.setMaxmumWidth(50);
		
		gridColumn_9 = new GridColumn(supplier_gird, SWT.NONE);
		gridColumn_9.setText(Messages.Name);
		gridColumn_9.setWidth(200);
		
		GridColumn gridColumn_8 = new GridColumn(supplier_gird, SWT.CENTER);
		gridColumn_8.setText(Messages.Linker);
		gridColumn_8.setWidth(70);
		gridColumn_8.setMaxmumWidth(150);
		
		GridColumn gridColumn_10 = new GridColumn(supplier_gird, SWT.CENTER);
		gridColumn_10.setText(Messages.Tel);
		gridColumn_10.setWidth(100);
		gridColumn_10.setMaxmumWidth(150);
		
		GridColumn gridColumn_12 = new GridColumn(supplier_gird, SWT.CENTER);
		gridColumn_12.setText(Messages.TenderTime);
		gridColumn_12.setWidth(100);
		gridColumn_12.setMaxmumWidth(150);
		
		meetingInvitationColumn = new GridColumn(supplier_gird, SWT.CENTER);
		meetingInvitationColumn.setText(Messages.VideoMeeting);
		meetingInvitationColumn.setWidth(50);
		
		sealedBidCodeColumn = new GridColumn(supplier_gird, SWT.CENTER);
		sealedBidCodeColumn.setText(Messages.SealedCode);
		sealedBidCodeColumn.setWidth(50);
		
		tenderNumberColumn = new GridColumn(supplier_gird, SWT.CENTER);
		tenderNumberColumn.setText(Messages.TenderNumber);
		tenderNumberColumn.setWidth(50);
		
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init(){
		this.menu = projectAction.getMenu();
		tenderProject = projectAction.getTenderProject();
		projectRuleService = new ProjectRuleService();
		

		if(StringUtils.isEmpty(tenderProject.getTransactionServerId())){
//			WidgetUtils.setControlVisible(label_down_load, false);
			label_down_load.setEnabled(false);
		}
		
		SUPPLIER_NAME = I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
		titleComposite.setTitle(MessageFormat.format(Messages.Title_list, SUPPLIER_NAME));
		
		menuFunctionUtils.initFunctionAuthority(menu, titleComposite.getFunctionComposite());
		// 远程项目不能导入供应商
		if(TenderProjectEnum.REMOTE.equals(tenderProject.getRemoteStatus())){
			WidgetUtils.setControlVisible(import_btn, false);
			WidgetUtils.setControlVisible(add_supplier_btn, false);
		}else if(TenderProjectEnum.LOCAL.equals(tenderProject.getRemoteStatus())){
			WidgetUtils.setControlVisible(add_supplier_btn, true);
			WidgetUtils.setControlVisible(edit_supplier_btn, true);
			WidgetUtils.setControlVisible(delSupplierBtn, true);
		}
		if(MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("APPLY_VIDEO"))){
			meetingInvitationColumn.setVisible(false);
		}
		if(MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("DARKCODE_COLUMN"))){
			sealedBidCodeColumn.setVisible(false);
		}
		if(MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("TENDER_NUMBER_COLUMN"))){
			tenderNumberColumn.setVisible(false);
		}
    	// 如果没有获取过最新投标信息，则自动下载供应商
		if(!tenderProjectService.isGetLatestBidinfo(tenderProject.getId())){
			autoDownloadSupplier(false);
		}
		titleComposite.layout();
		refreshSupplier(null);
		// 添加投标人表格的选中事件和右键菜单事件
		supplier_gird.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void leftMouseButtonDown(GridItem item) {
				selectSupplierActdion();
			}
			
			@Override
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
		});
	}
	
	/**
	 * @Description: 刷新投标人列表
	 * @author guoyr
	 */
	private void refreshSupplier(final String supplierId){
		supplier_gird.removeAll();
		if(null != supplierList){
			supplierList.clear();
			supplierList = null;
		}
		SyncThread syncThread = new SyncThread(new SyncThread.Runnable() {
			public void run() {
				isAnonymous  = projectRuleService.isAnonymous(tenderProject.getId());
				supplierList = supplierService.getSupplierList(tenderProject.getId());
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!supplier_gird.isDisposed()){
							drawSupplierTable(supplierId);
						}
					}
				});
			}
		});
		syncThread.start();
	}

	private void drawSupplierTable(String supplierId){
		if(null != supplierList && supplierList.size() > 0){
			sealedBidCode = false;
			// 设置匿名和序号
			int index = 1;
			for(Supplier supplier : supplierList){
				supplier.setAnonymous(isAnonymous, index);
				GridItem gridItem = new GridItem(supplier_gird, SWT.NONE);
				setSupplierInfo(gridItem, index, supplier);
				if(null != supplierId && supplierId.equals(supplier.getId())){
					supplier_gird.setSelection(new GridItem[]{gridItem});
				}
				if(!sealedBidCode && StringUtils.isNotEmpty(supplier.getSealedBidCode())){
					sealedBidCode = true;
				}
				index ++;
			}
			
			// 如果有暗标编号，则显示这一列
			if(sealedBidCode){
				sealedBidCodeColumn.setVisible(true);
			}
			editSortNo_btn.setEnabled(true);
		}else {
			editSortNo_btn.setEnabled(false);
		}
//		supplier_gird.resizeColumnWidth(supplier_gird.getColumnCount()-1);
		selectSupplierActdion();
	}
	/**
	 * @Description: 设置投标人信息
	 * @author guoyr
	 * @param gridItem
	 * @param supplier
	 */
	public void setSupplierInfo(GridItem gridItem, int index, Supplier supplier){
		gridItem.setText(0, index + "");
		if(supplier.isAnonymous()){
			gridItem.setText(1, "***");
			gridItem.setText(2, "***");
			gridItem.setText(3, "***");
		}else {
			gridItem.setText(1, ObjectUtils.getObjString(supplier.getSupplierName()));
			gridItem.setText(2, ObjectUtils.getObjString(supplier.getLinker()));
			gridItem.setText(3, ObjectUtils.getObjString(supplier.getLinkerTel()));
//			gridItem.setText(4, ObjectUtils.getObjString(DateUtils.getTimestampFormat(supplier.getApplyTime())));
			if(null != supplier.getTenderTime()){
				gridItem.setText(4, DateUtils.getTimestampFormat(supplier.getTenderTime()));
//				gridItem.setText(4, SupplierEnum.getSupplierTenderType(supplier.getBidFileType()));
			}else {
				gridItem.setForeground(4, ColorConstants.FONT_RED_COLOR);
				gridItem.setText(4, Messages.Status_noTender);
			}
			gridItem.setText(5, ObjectUtils.getObjString(SupplierEnum.getInvitationStatusCN(supplier.getInvitationStatus())));
			gridItem.setText(6, ObjectUtils.getObjString(supplier.getSealedBidCode()));
			gridItem.setText(7, ObjectUtils.getObjString(supplier.getBidNumber()));
		}
	}

	/**
	 * @Description: 导入供应商
	 * @author guoyr 
	 */
	private void importSupplierAction(){
		if(!import_btn.getEnabled())return;
		if(isComplateOpenbid())return;
		ImportSupplierDialog importSupplierDialog = new ImportSupplierDialog(getShell(), tenderProject);
		importSupplierDialog.open();
		refreshSupplier(null);
	}
	/**
	 * @Description: 新增投标人
	 * @author guoyr
	 */
	private void addNewSupplierAction(){
		if(!add_supplier_btn.getEnabled())return;
		if(isComplateOpenbid())return;
		createOrUpdateSupplier(null);
	}
	
	/**
	 * @Description: 修改投标人
	 * @author guoyr
	 */
	private void editSupplierAction(){
		if(edit_supplier_btn.getEnabled() && supplier_gird.getSelectionCount() > 0){
			Supplier supplier =  supplierList.get(supplier_gird.getSelectionIndex());
			
			if(isAnonymous){
				MessageDialog.openWarning(getShell(), Messages.Tips_itIsNotTimeToOperate);
				return;
			}
			if(null != supplier){
				createOrUpdateSupplier(supplier.getId());
			}
		}
	}
	
	/**
	 * @Description: 新增或修改投标人
	 * @author guoyr
	 * @param supplierId
	 */
	private void createOrUpdateSupplier(String supplierId){
		boolean isView = TenderProjectEnum.REMOTE.equals(tenderProject.getRemoteStatus());
		SupplierDialog supplierDialog = new SupplierDialog(getShell(), isView);
		supplierDialog.setSupplierId(supplierId);
		supplierDialog.setTenderId(tenderProject.getId());
		if(isView){
			supplierDialog.setTitle(MessageFormat.format(Messages.Title_view,  SUPPLIER_NAME));
		}else {
			supplierDialog.setTitle(MessageFormat.format(StringUtils.isEmpty(supplierId)? Messages.Title_create : Messages.Title_edit,  SUPPLIER_NAME));
		}
		supplierDialog.setCallBack(new CallBack() {
			@Override
			public void callBackObject(Object obj) {
				Supplier supplier = (Supplier) obj;
				if(null != supplier){
					refreshSupplier(supplier.getId());
				}
			}
		});
		supplierDialog.open();
	}
	
	/**
	 * @Description: 删除投标人（假删除）
	 * @author guoyr
	 */
	private void delSupplierAction(){
		if(isComplateOpenbid())return;
		if(delSupplierBtn.getEnabled()){
			Supplier supplier =  supplierList.get(supplier_gird.getSelectionIndex());
			if(null != supplier){
				if (MessageDialog.openConfirm(null, MessageFormat.format(Messages.Tips_deleteObj, supplier.getSupplierName()))) {
					if(supplierService.removeSupplier(tenderProject.getId(), supplier.getId())){
						refreshSupplier(supplier.getId());
					}
				}
			}
		}
	}
	
	/**
	 * @Description: 生成暗标编码
	 * @author wx
	 */
	private void creatDarkCodeAction(){
		if(sealedBidCode){
			if(!MessageDialog.openConfirm(getShell(), Messages.Dialog_warmTips, Messages.Tips_reCreateSealedCode, new String[] {Messages.Button_confirm, Messages.Button_cancel })){
				return;
			}
		}
		Set<String> drakCodeSet = new HashSet<String>();
		if(null != supplierList && supplierList.size() > 0){
			for(Supplier supplier :supplierList){
				boolean hasStr = false;
				while(!hasStr){
					String darkCode = getStringRandom();
					hasStr = drakCodeSet.add(darkCode);
					if(hasStr){
						supplier.setSealedBidCode(darkCode);
					}
				}
			}
			if(supplierService.batchUpdateProperty(supplierList, new String[]{"sealedBidCode"}) > 0){
				sealedBidCode = true;
				refreshSupplier(null);
			}
		}
	}
	
    /**
     * @Description: 生成6位随机数字和字母
	 * @author wx 
     */
    public String getStringRandom() {  
        String value = "";  
        Random random = new Random();        
        for(int i = 0; i < 6; i++) {          
            String charOrNum = random.nextInt(2) % 2 == 0 ? "char" : "num";  
            //输出字母还是数字  
            if( "char".equalsIgnoreCase(charOrNum) ) {  
            	value += (char)(random.nextInt(26) + 97);  
            } else if( "num".equalsIgnoreCase(charOrNum) ) {  
            	value += String.valueOf(random.nextInt(10));  
            }  
        }  
        return value;  
    } 
	
	/**
	 * @Description: 选中投标人
	 * @author guoyr
	 */
	private void selectSupplierActdion(){
		if(supplier_gird.getSelectionCount() > 0){
			edit_supplier_btn.setEnabled(true);
			delSupplierBtn.setEnabled(true);
			// 如果显示匿名，则不需要移动
			if(isAnonymous){
				up_btn.setEnabled(false);
				down_btn.setEnabled(false);
				return;
			}
			if(supplier_gird.getItemCount() > 1){
				up_btn.setEnabled(true);
				down_btn.setEnabled(true);
				if(supplier_gird.getSelectionIndex() == 0){
					up_btn.setEnabled(false);
				}
				if(supplier_gird.getSelectionIndex() == supplier_gird.getItemCount() -1){
					down_btn.setEnabled(false);
				}
			}else {
				up_btn.setEnabled(false);
				down_btn.setEnabled(false);
			}
		}else {
			edit_supplier_btn.setEnabled(false);
			delSupplierBtn.setEnabled(false);
			up_btn.setEnabled(false);
			down_btn.setEnabled(false);
		}
		if(supplier_gird.getSelectionCount() >0){
			int index = supplier_gird.getSelectionIndex();
			Supplier supplier = supplierList.get(index);
			if(null != supplier){
				if(SupplierEnum.INVITATION_YES.equals(supplier.getInvitationStatus())) {
					invitationButton.setText(Messages.Button_cancelVideoMeetingVnvitation);
				}else {
					invitationButton.setText(Messages.Button_sendVideoMeetingVnvitation);
				}
			}
		}
	}

	/**
	 * @Description: 上移或下移投标人
	 * @author guoyr
	 * @param upOrDown upOrDown 1下移 -1上移
	 */
	private void upOrDownSupplier(int upOrDown){
		
		if(supplier_gird.getSelectionCount() > 0){
			GridItem selectItem = supplier_gird.getSelection()[0];
			int selectIndex = supplier_gird.getSelectionIndex();
			Supplier supplier =  supplierList.get(selectIndex);
			if(null != supplier){
				if(upOrDown > 0){// 如果是下移
					if(selectIndex == supplier_gird.getItemCount()-1 || !down_btn.getEnabled()){
						return ;
					}
				}else if(upOrDown < 0){// 如果是上移
					if(selectIndex == 0 || !up_btn.getEnabled()){
						return ;
					}
				}
				String supplierId = supplier.getId();
				int supplierSortNo = supplier.getSortNo() > 0?supplier.getSortNo():(selectIndex + 1);
				int targetIndex = selectIndex + upOrDown;
				GridItem targetSupplierItem = supplier_gird.getItem(selectIndex + upOrDown);
				Supplier targetSupplier =  supplierList.get(targetIndex);
				if(null != targetSupplier){
					String targetSupplierId = targetSupplier.getId();
					int targetSupplierSortNo = targetSupplier.getSortNo() > 0?targetSupplier.getSortNo():(targetIndex + 1);
					List<Supplier> sortSupplierList = new ArrayList<Supplier>();
					Supplier source = new Supplier();
					source.setId(supplierId);
					source.setSortNo(targetSupplierSortNo);
					supplier.setSortNo(targetSupplierSortNo);
					Supplier target = new Supplier();
					target.setId(targetSupplierId);
					target.setSortNo(supplierSortNo);
					targetSupplier.setSortNo(supplierSortNo);
					sortSupplierList.add(source);
					sortSupplierList.add(target);
					if(supplierService.batchUpdateProperty(sortSupplierList, new String[]{"sortNo"}) > 0){
						
//						refreshSupplier(supplierId);
						supplierList.set(selectIndex, targetSupplier);
						supplierList.set(targetIndex, supplier);
						supplier.setSortNo(targetSupplierSortNo);
						targetSupplier.setSortNo(supplierSortNo);
						setSupplierInfo(targetSupplierItem, selectIndex + upOrDown + 1, supplier);
						setSupplierInfo(selectItem, selectIndex + 1, targetSupplier);
						supplier_gird.setSelection(selectIndex + upOrDown);
						selectSupplierActdion();
					}
				}
			}
		}
	}
	
	/**
	 * @Description: 批量编辑
	 * @author guoyr 
	 */
	private void editSortNoAction(){
		if(editSortNo_btn.getEnabled()){
			SupplierBatchOrderDialog dialog = new SupplierBatchOrderDialog(getShell(),supplierList, new CallBack(){
				public void callBack() {
					refreshSupplier(null);
				}
			});
			dialog.open();
		}
	}
	
	/**
	 * @Description: 抽取随机顺序
	 * @author guoyr 
	 */
	private void randomSortNoAction(){
		SupplierEmportOrderDialog dialog = new SupplierEmportOrderDialog(getShell(),tenderProject, supplierList, new CallBack(){
			public void callBack() {
				refreshSupplier(null);
			}
		});
		dialog.open();
	}
	
	/**
	 * @Description: 导出投标人
	 * @author guoyr
	 */
	private void exportSupplierAction(){
		String projName = "["+tenderProject.getTenderNo()+"]" + tenderProject.getTenderName()+"_"+SUPPLIER_NAME;
		String saveFilePath = FileDialogUtils.getFileSavePath(projName, Messages.Button_save, new String[]{"*.xml"}, new String[]{"XML(*.xml)"});
		if(StringUtils.isNotEmpty(saveFilePath)){
			MessageViewDialog messageDialog = new MessageViewDialog(getShell(),-1);
			new ExportSupplierThread(tenderProject, saveFilePath, messageDialog.getCallBack()).start();
			messageDialog.setTitle(MessageFormat.format(Messages.Button_export, SUPPLIER_NAME));
			messageDialog.open();
		}
	}
	
	/**
	 * @Description: 删除所有未投标的投标人
	 * @author guoyr
	 */
	private void delAllUnTenderSupplierAction(){
		if(MessageDialog.openConfirm(getShell(), MessageFormat.format(Messages.Tips_deleteAllNotTenderSupplier, SUPPLIER_NAME))) {
			List<Supplier> supplierList = supplierService.getAllUnTenderSupplierList(tenderProject.getId());
			if(supplierService.batchDeleteSupplierList(supplierList)){
				supplier_gird.removeAll();
				refreshSupplier(null);
			}
		}
	}
	
	/**
	 * @Description: 删除全部投标人
	 * @author guoyr
	 */
	private void delAllSupplierAction(){
		if(isComplateOpenbid()){
			return ;
		}
		
		if(MessageDialog.openConfirm(getShell(), MessageFormat.format(Messages.Tips_deleteAllObject, SUPPLIER_NAME))) {
			if(supplierService.batchDeleteSupplierList(supplierList)){
				supplier_gird.removeAll();
			}
		}
	}

	/**
	 * @Description: 验证是否已经完成开标
	 * @author guoyr
	 * @return
	 */
	private boolean isComplateOpenbid(){
		if(tenderProjectService.isBidOpeningComplate(tenderProject.getId())){
			MessageDialog.openInformation(getShell(), Messages.Tips_finishBidOpening);
			return true;
		}
		return false;
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		
		final EMenu gmenu = new EMenu(getShell());
		gmenu.addMenuItem(up_btn);
		gmenu.addMenuItem(down_btn);
		gmenu.addMenuItem(editSortNo_btn);
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("SORT_BY_SIGN"))){
			gmenu.addMenuItem(Messages.Button_sortBySignTimeAsc,imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/down.png"),up_btn.getEnabled() || down_btn.getEnabled(), new EMenu.ClickListener() {
				public void click() {
					supplierService.sortSupplierBySignTime(tenderProject.getId(), false);
					MessageDialog.openShortMessage(Messages.Tips_operateSuccess);
					refreshSupplier(null);
				}
			});
			gmenu.addMenuItem(Messages.Button_sortBySignTimeDesc,imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/up.png"),up_btn.getEnabled() || down_btn.getEnabled(), new EMenu.ClickListener() {
				public void click() {
					supplierService.sortSupplierBySignTime(tenderProject.getId(), true);
					MessageDialog.openShortMessage(Messages.Tips_operateSuccess);
					refreshSupplier(null);
				}
			});
		}
		gmenu.addSeparator();
//		gmenu.addMenuItem(import_btn);
		gmenu.addMenuItem(add_supplier_btn);
		gmenu.addMenuItem(edit_supplier_btn);
		gmenu.addMenuItem(delSupplierBtn);
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("DELETE_ALL"))){
			gmenu.addMenuItem(Messages.Button_deleteAll, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"), true, new EMenu.ClickListener() {
				public void click() {
					delAllSupplierAction();
				}
			});
		}
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("DELETE_ALL_UNTENDER"))){
			gmenu.addMenuItem(MessageFormat.format(Messages.Button_deleteAllNoTenderSupplier, SUPPLIER_NAME), ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"), true, new EMenu.ClickListener() {
				public void click() {
					delAllUnTenderSupplierAction();
				}
			});
		}
		gmenu.addSeparator();
		// 如果未到开标时间，并且隐藏投标人信息。则导出投标人功能不可操作。
		gmenu.addMenuItem(Messages.Button_export, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), !isAnonymous, new EMenu.ClickListener() {
			public void click() {
				exportSupplierAction();
			}
		});
		
		gmenu.open();
	}
	
	private void invitationMeetingAction(){
		if(supplier_gird.getSelectionCount() >0){
			int index = supplier_gird.getSelectionIndex();
			Supplier supplier = supplierList.get(index);
			if(null != supplier) {
				if(SupplierEnum.INVITATION_YES.equals(supplier.getInvitationStatus())){
					ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, MessageFormat.format(Messages.Tips_confirmOperate, Messages.Button_cancelVideoMeetingVnvitation), null);
					confirmDialog.addButton(Messages.Button_confirm, "01", SWTResourceManager.getColor(77, 163, 19));
					confirmDialog.addCancel(Messages.Button_cancel, null);
					confirmDialog.open();
					if("01".equals(confirmDialog.getClickStatus())){
						ProgressMessageDialog messageDialog = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
							public void finish(boolean flag) {
								if(flag) {
									Display.getDefault().syncExec(new Runnable() {
										public void run() {
											if(!supplier_gird.isDisposed()) {
												refreshSupplier(supplier.getId());
											}
										}
									});
								}
							}
						});
						InvitationSupplierThread invitationSupplierThread = new InvitationSupplierThread(tenderProject, supplier, SupplierEnum.INVITATION_CANCEL, "", getShell(), messageDialog);
						invitationSupplierThread.start();
						messageDialog.setCountDownTime(3);
						messageDialog.setTitle(Messages.Button_cancelVideoMeetingVnvitation);
						messageDialog.open();
					}
				}else {
					MeetingTitleEditDialog dialog = new MeetingTitleEditDialog(getShell(), tenderProject, supplier, SupplierEnum.INVITATION_YES, new LoadingAdatper() {
						public void finish(boolean flag) {
							if(flag) {
								Display.getDefault().syncExec(new Runnable() {
									public void run() {
										if(!supplier_gird.isDisposed()) {
											refreshSupplier(supplier.getId());
										}
									}
								});
							}
						}
					});
					dialog.open();
				}
			}
		}else{
			MessageDialog.openError(getShell(), MessageFormat.format(Messages.Tips_pleaseSelect, SUPPLIER_NAME));
		}
	}
	
	/**
	 * @Description: 下载投标单位
	 * @author guoyr 
	 */
	public void downLoadSupplier(){
		if(label_down_load.getEnabled()){
			if(isComplateOpenbid()){
				return ;
			}
			autoDownloadSupplier(true);
		}
	}
	
	/**
	 * @Description: 正动下载投标人信息
	 * @author guoyr
	 * @param visible 
	 */
	private void autoDownloadSupplier(boolean visible) {
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!supplier_gird.isDisposed()) {
							refreshSupplier(null);
						}
					}
				});
			}
			
		});
		messageProgress.setCountDownTime(3);
		new RefreshProjectSupplierTenderInfoThread(tenderProject, messageProgress).start();
//		new NewDownloadSupplierThread(tenderProject, messageProgress).start();
		messageProgress.setTitle(MessageFormat.format(Messages.Button_downloadFormat, SUPPLIER_NAME));
		messageProgress.open();
		messageProgress.setVisible(visible);
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	@Override
	public void dispose() {
		imageResolver.disposite();
		super.dispose();
	}

}
