package com.gx.obe.common.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.action.bean.Action;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.common.dialog.SupplierBatchOrderDialog;
import com.gx.obe.common.dialog.SupplierSignInDialog;
import com.gx.obe.common.dialog.SupplierSignResultDialog;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.message.menu.MenuMessages;
import com.gx.obe.thread.RefreshProjectSupplierTenderInfoThread;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 项目经理辅助签到界面
 * @author guoyr 
 */
public class SupplierSignManagerComposite extends Composite {

	private Grid supplierGrid;
	private List<Supplier> supplierList;
	private SupplierService supplierService = new SupplierService();
	private TenderProjectService tenderProjectService = new TenderProjectService();
	private TenderProjectEntity tenderProject;
	private ProjectRuleService projectRuleService;
	private ELink signBtn;
	private ELink viewSignResult;
//	private ELink supplierSignBtn;
	private String SUPPLIER_NAME = Messages.Supplier;
	private ELink sortBySignTime;
	private ELink sortBySignTimeDesc;
	private Supplier selectionSupplier;
	private ELink editSortNo_btn; 
	private TitleComposite titleComposite;
	private Action projectAction;
	private Menu menu;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private boolean isAnonymous;
	private GridColumn supplierNameColumn;
	/** 
	 * @author guoyr
	 * @param parent
	 * @param style 
	 */
	public SupplierSignManagerComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		this.projectAction = projectAction;
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		titleComposite = new TitleComposite(this, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Composite parentComposite = new Composite(this, SWT.NONE);
		GridLayout gl_parentComposite = new GridLayout(1, false);
		gl_parentComposite.marginHeight = 1;
		gl_parentComposite.marginWidth = 1;
		parentComposite.setLayout(gl_parentComposite);
		parentComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
	
		parentComposite.setBackground(SWTResourceManager.getColor(211, 211, 211));
		
//		supplierSignBtn = new ELink(composite, SWT.NONE);
//		supplierSignBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
//		supplierSignBtn.addMouseListener(new MouseAdapter() {
//			public void mouseUp(MouseEvent e) {
//				supplierSignAction();
//			}
//		});
//		supplierSignBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/location.png"));
//		supplierSignBtn.setText(SUPPLIER_NAME+"签到");
		
		signBtn = titleComposite.addELink("SIGN");
		signBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				signIn();
			}
		});
		signBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/location.png"));
		signBtn.setText(Messages.AuxiliarySign);
		
		
		viewSignResult = titleComposite.addELink("VIEW_RESULT");
		viewSignResult.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/view.png"));
		viewSignResult.setText(Messages.CheckSignResult);
		viewSignResult.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				viewSignResultAction();
			}
		});
		viewSignResult.setEnabled(false);
		
		editSortNo_btn = titleComposite.addELink("BATCH_SORT");
		editSortNo_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		editSortNo_btn.setText(Messages.Button_batchSort);
		editSortNo_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				editSortNoAction();
			}
		});
		
		sortBySignTime = titleComposite.addELink("SORT_BY_SIGN");
		sortBySignTime.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/down.png"));
		sortBySignTime.setText(Messages.Button_sortBySignTime);
		sortBySignTime.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				supplierService.sortSupplierBySignTime(tenderProject.getId(), false);
				MessageDialog.openShortMessage(Messages.Tips_sortBySignTime);
				refreshSupplier(null);
			}
		});
		
		sortBySignTimeDesc = titleComposite.addELink("SORT_BY_SIGN");
		sortBySignTimeDesc.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/up.png"));
		sortBySignTimeDesc.setText(Messages.Button_sortBySignTimeReverse);
		sortBySignTimeDesc.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				supplierService.sortSupplierBySignTime(tenderProject.getId(), true);
				MessageDialog.openShortMessage(Messages.Tips_sortBySignTimeReverse);
				refreshSupplier(null);
			}
		});
		
		
		Composite gridComposite = new Composite(parentComposite, SWT.NONE);
		gridComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		gridComposite.setBackground(SWTResourceManager.getColor(211, 211, 211));
		gridComposite.setBackground(SWTResourceManager.getColor(192, 192, 192));
		
		GridLayout gl_gridComposite = new GridLayout(1, false);
		gl_gridComposite.marginHeight = 0;
		gl_gridComposite.marginWidth = 0;
		gridComposite.setLayout(gl_gridComposite);
		
		Composite composite_1 = new Composite(gridComposite, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayout(new FillLayout(SWT.HORIZONTAL));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		supplierGrid = new Grid(composite_1, SWT.H_SCROLL | SWT.V_SCROLL);
		supplierGrid.setItemHeaderWidth(Constants.ROW_HIGHT);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);
		supplierGrid.setAutoWidth(true);
		
		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn.setWidth(40);
		gridColumn.setMaxmumWidth(50);
		gridColumn.setText(Messages.Num);
		
		supplierNameColumn = new GridColumn(supplierGrid, SWT.NONE);
		supplierNameColumn.setText(SUPPLIER_NAME);
		supplierNameColumn.setWidth(200);
		
		GridColumn gridColumn_13 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_13.setText(Messages.SignPerSon + Messages.FullName);
		gridColumn_13.setWidth(120);
		
		GridColumn gridColumn_14 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_14.setText(Messages.SignPerSon + Messages.Telephone);
		gridColumn_14.setWidth(120);
		
		GridColumn gridColumn_15 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_15.setText(Messages.SignPerSon + Messages.Email);
		gridColumn_15.setWidth(120);
		
		GridColumn gridColumn_16 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_16.setText(Messages.CheckInTime);
		gridColumn_16.setWidth(120);
		init();
	}

    /**
     * @Description: 初始化界面 
     * @author guoyr 
     */
    private void init(){
    	projectRuleService = new ProjectRuleService();
    	tenderProject = projectAction.getTenderProject();
		this.menu = projectAction.getMenu();
		titleComposite.setTitle(ObjectUtils.getObjString(MenuMessages.getValue(menu.getLanguageCode(), menu.getMenuShortName())));
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
		supplierNameColumn.setText(SUPPLIER_NAME);
		menuFunctionUtils.initFunctionAuthority(menu, titleComposite.getFunctionComposite());
    	supplierGrid.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void leftMouseButtonDown(GridItem item) {
				selectSupplierActdion();//鼠标左键事件
			}
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuRightctAction();
			}
		});
    	// 如果没有获取过最新投标信息，则自动下载供应商
    	if(!tenderProjectService.isGetLatestBidinfo(tenderProject.getId())){
    		autoDownloadSupplier();
    	}
    	// 如果匿名显示
		isAnonymous  = projectRuleService.isAnonymous(tenderProject.getId());
    	refreshSupplier(null);//表格数据 加载
    } 

	/**
	 * @Description: 加载“重新签到”按钮
	 * @author guoyr 
	 */
	public void supplierMenuRightctAction(){
		final EMenu gmenu = new EMenu(getShell());
		if(supplierGrid.getSelectionCount() > 0){
			selectionSupplier =  supplierList.get(supplierGrid.getSelectionIndex());
			if(null != selectionSupplier){
				if(null != selectionSupplier.getSignTime()){
					if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("RE_SIGN"))){
						gmenu.addMenuItem(Messages.Button_cancel + Messages.Step_signIn, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/clear.png"), null != selectionSupplier && !isAnonymous, new EMenu.ClickListener() {
							public void click() {
								reSignAgain();
							}
						} );
					}
				}else {
					gmenu.addMenuItem(signBtn);
				}
			}
			if(!isAnonymous && checkSignFileExist()){
				gmenu.addMenuItem(MessageFormat.format(Messages.Button_exportFormat, Messages.SignFile), ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
					public void click() {
						exportSignFile();
					}
				} );
			}
		}
		if(!isAnonymous && MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("EXPORT_ALL"))){
			gmenu.addMenuItem(MessageFormat.format(Messages.Button_exportAllFormat, Messages.SignFile), ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/export.png"), true, new EMenu.ClickListener() {
				public void click() {
					exportAllSignFile();
				}
			} );
		}
		gmenu.open();
	}

	/**
	 * @Description: 重新签到事件操作
	 * @author guoyr 
	 */
	public void reSignAgain(){
		if(MessageDialog.openConfirm(getShell(), Messages.Tips_reSign)){
			Supplier supplier =  supplierList.get(supplierGrid.getSelectionIndex());
			if(supplier!=null){
				supplier.setSignTime(null);
				List<Supplier> supplierList = new ArrayList<Supplier>();
				supplierList.add(supplier);
				supplierService.batchUpdateProperty(supplierList, new String[]{"signTime"});
				refreshSupplier(supplier.getId());
//				if(MessageDialog.openConfirm(getShell(), "是否要辅助签到吗？")){
//					SupplierSignInDialog dialog =  new SupplierSignInDialog(getParent().getShell(), tenderProjectEntity, supplier);
//					dialog.open();
//				}
			}
		}
	}

	/**
	 * @Description: 刷新 表格数据
	 * @author guoyr
	 * @param supplierId 
	 */
	private void refreshSupplier(String supplierId){
		supplierGrid.removeAll();
		editSortNo_btn.setEnabled(false);
		sortBySignTime.setEnabled(false);
		if(null != supplierList){
			supplierList.clear();
			supplierList = null;
		}
		if(null != tenderProject){
			List<Supplier> allSupplierList = supplierService.getSupplierList(tenderProject.getId());
			if(null != allSupplierList && allSupplierList.size() > 0){
				if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("ONLY_TENDER_SUPPLIER"))){
					if(null == supplierList){
						supplierList = new ArrayList<Supplier>();
					}
					for(Supplier supplier : allSupplierList){
						if(null != supplier.getTenderTime()){
							supplierList.add(supplier);
						}
					}
				}else {
					supplierList = allSupplierList;
				}
				editSortNo_btn.setEnabled(true);
				sortBySignTime.setEnabled(true);
				
				// 设置匿名和序号
				int index = 1;
				for(Supplier supplier : supplierList){
					supplier.setAnonymous(isAnonymous, index + 1);
					GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
					gridItem.setHeight(30);
					gridItem.setText(0, index+"");
					setSupplierInfo(gridItem, supplier);
					if(null != supplierId && supplierId.equals(supplier.getId())){
						supplierGrid.setSelection(new GridItem[]{gridItem});
						if(null != supplier.getSignTime()){
							viewSignResult.setEnabled(true);
							signBtn.setEnabled(false);
						}
					}
					index ++;
				}
			}
		}
		if(supplierGrid.getItemCount() > 0 && supplierGrid.getSelectionCount() == 0){
			supplierGrid.setSelection(0);
			selectSupplierActdion();
		}
	}

	/**
	 * @Description: 选择投标人事件
	 * @author guoyr 
	 */
	public void selectSupplierActdion(){
		if(supplierGrid.getSelectionCount() > 0){
			Supplier supplier =  supplierList.get(supplierGrid.getSelectionIndex());
			if(null != supplier.getSignTime()){
				signBtn.setEnabled(false);
				viewSignResult.setEnabled(true);
			}else{
				signBtn.setEnabled(true);
				viewSignResult.setEnabled(false);
				
			}
		}else {
			viewSignResult.setEnabled(false);
			signBtn.setEnabled(false);
		}
	}
	
	/**
	 * @Description: 批量编辑
	 * @author guoyr 
	 */
	private void editSortNoAction(){
		if(editSortNo_btn.getEnabled()){
			SupplierBatchOrderDialog dialog = new SupplierBatchOrderDialog(getShell(),supplierList, new CallBack(){
				public void callBack() {
					refreshSupplier(null);
				}
			});
			dialog.open();
		}
	}
	
	/**
	 * @Description: 查看签到结果
	 * @author guoyr
	 */
	private void viewSignResultAction(){
		if(viewSignResult.getEnabled()){
			Supplier supplier =  supplierList.get(supplierGrid.getSelectionIndex());
			//根据签到时间判断当前是否签到，如果签到了，签到时间不为空
			SupplierSignResultDialog dialog = new SupplierSignResultDialog(getShell(), supplier, tenderProject);
			dialog.open();
				
		}
	}

	/**
	 * @Description:辅助签到操作 
	 * @author guoyr
	 */
	private void signIn(){
		if(!signBtn.isEnabled()){
			return ;
		}
		if(!MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("REMOTE_NOT_SIGN"))){
			if (TenderProjectEnum.REMOTE.equals(tenderProject.getRemoteStatus())) {
				MessageDialog.openWarning(getShell(), "当前项目为全流程项目，不允许辅助签到！");
				return;
			}
		}
		
		if (supplierList.isEmpty()) {
			MessageDialog.openWarning(getShell(), "没有要签到的" + SUPPLIER_NAME + "！");
			return;
		}
		if(!MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("BID_OPENING_START_TIME"))){
			if (projectRuleService.isStartTime(tenderProject.getId(), "BID_OPENING_START_TIME")) {
				MessageDialog.openInformation(getShell(), "已到开标时间，不允许再辅助签到！");
				return;
			}
		}
		Supplier supplier =  supplierList.get(supplierGrid.getSelectionIndex());
		if(null != supplier){
			if(!MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority("UNQUALIFIED"))){
				if(Constants.QUALIFIED_STATUS_NG.equals(supplier.getQualifiedStatus())){
					MessageDialog.openInformation(getShell(), "当前供应商为不合格供应商，不允许签到！");	
					return;
				}
			}
			SupplierSignInDialog dialog =  new SupplierSignInDialog(getParent().getShell(), tenderProject, supplier);
			dialog.setOperator(SWT.MAX | SWT.CLOSE);
			dialog.setTitle(SUPPLIER_NAME+Messages.AuxiliarySign);
			dialog.open();
			refreshSupplier(supplier.getId());
		}else{
			MessageDialog.openMessage(null, Messages.Tips_pleaseSelectSupplier + SUPPLIER_NAME+"！");
		}
	}

	/**
	 * @Description: 数据加载 ，设置投标人信息
	 * @author guoyr
	 * @param gridItem
	 * @param supplier
	 */
	private void setSupplierInfo(GridItem gridItem, Supplier supplier){
		// 如果未到开标时间，并且开标规则设置未到开标时间前隐然投标人信息
		gridItem.setText(1, ObjectUtils.getObjString(supplier.getSupplierName()));
		if(supplier.isAnonymous()){
			gridItem.setText(1, "***");
			gridItem.setText(2, "***");
			gridItem.setText(3, "***");
			gridItem.setText(4, "***");
			gridItem.setText(5, "***");
		}else {
			if (null != supplier.getSignTime()) {
				gridItem.setText(2, ObjectUtils.getObjString(supplier.getSignPerson()));
				gridItem.setText(3, ObjectUtils.getObjString(supplier.getSignPersonTel()));
				gridItem.setText(4, ObjectUtils.getObjString(supplier.getEmail()));
				gridItem.setText(5, DateUtils.getTimestampFormat(supplier.getSignTime()));
			}else {
				gridItem.setText(2, "");
				gridItem.setText(3, "");
				gridItem.setText(4, "");
				gridItem.setText(5, "");
			}
		}
	}
	/**
	 * @Description:检查签到文是否存在
	 * @author guoyr
	 * @return 
	 */
	private boolean checkSignFileExist(){
		
		String signPdfPath = FileConstants.getSupplierSignFilePath(tenderProject.getId(), selectionSupplier.getOrgCode());
		File signFile = new File(signPdfPath);
		return signFile.exists();
}
//		return true;
	/**
	 * @Description: 导出签到文件
	 * @author guoyr 
	 */
	private void exportSignFile(){
		// 导出目标文件路径
		final String selectDir = FileDialogUtils.getFileSavePath(selectionSupplier.getSupplierName()+ "("+selectionSupplier.getSignPerson()+").pdf", Messages.Tips_selectExportDic,  new String[]{"*.pdf"}, new String[]{"pdf文件(*.pdf)"});
		if(!StringUtils.isNotEmpty(selectDir)){
			return ;
		}
		String signPdfPath = FileConstants.getSupplierSignFilePath(tenderProject.getId(), selectionSupplier.getOrgCode());
		FileUtils.copy(signPdfPath, selectDir);
		File signFile = new File(selectDir);
		if(signFile.exists()){
			RuntimeUtils.openDirectorAndSelect(selectDir);
		}
	}
	
	
	/**
	 * @Description: 导出所有签到文件
	 * @author guoyr 
	 */
	private void exportAllSignFile(){
		String selectDir = FileDialogUtils.getDirectorySavePath(Messages.SelectASavedDirectory);
		if(!StringUtils.isNotEmpty(selectDir)){
			return ;
		}
		selectDir = selectDir + File.separator + FileUtils.filterFileName("[" + tenderProject.getTenderNo() +"]"+ tenderProject.getTenderName());
		for(Supplier supplier : supplierList){
			String signPdfPath = FileConstants.getSupplierSignFilePath(tenderProject.getId(), supplier.getOrgCode());
			File signFile = new File(signPdfPath);
			
			if(signFile.exists()){
				FileUtils.copy(signPdfPath , selectDir+ File.separator + supplier.getSupplierName()+ "("+supplier.getSignPerson()+").pdf");
			}
		}
		RuntimeUtils.openDirector(selectDir);
	}
	
	/**
	 * @Description: 正动下载投标人信息
	 * @author guoyr
	 * @param visible 
	 */
	private void autoDownloadSupplier() {
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!supplierGrid.isDisposed()) {
							refreshSupplier(null);
						}
					}
				});
			}
			
		});
		messageProgress.setCountDownTime(3);
		new RefreshProjectSupplierTenderInfoThread(tenderProject, messageProgress).start();
		messageProgress.setTitle(MessageFormat.format(Messages.Button_downloadFormat, SUPPLIER_NAME));
		messageProgress.open();
		messageProgress.setVisible(false);
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
