package com.gx.obe.common.composite;

import java.io.File;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.thread.CheckServiceBidFileThread;
import com.gx.obe.common.file.upload.UploadFileUtil;
import com.gx.obe.common.file.upload.infer.UploadFileListener;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.TitleComposite;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18N;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.vo.UploadBidFileInfo;
import com.gx.obe.message.Messages;
import com.gx.obe.report.entity.NewFileOperatorButton;
import com.gx.obe.thread.CheckServiceBiddingFileThread;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.StringUtil;
import com.gx.obe.web.entity.FileInfoEntity;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class UploadDecBidFileComposite extends Composite {
	
	private SupplierService supplierService = new SupplierService();
	private List<Supplier> selectSupplierList;
	private TenderProjectEntity tenderProject;
	private Grid supplierGrid;
	private String supplierName;
	private String supplierId;
	private ExecutorService executorService;
	private boolean isDispose = false;
	private List<Supplier> supplierList;
	private Composite bidOpeningStageComposite;
	private Composite container;
	private Composite composite_4;
	private Composite iComposite;
	private String SUPPLIER_NAME = "投标人";
	private TitleComposite titleComposite;
	private ThreadPoolExecutor upoladThreadPool;
	private CLabel biddingFileSizeLabel;
	private Composite fileOperatorComposite;
	private GridColumn supplierNameColumn;
	{
		LogUtils.logClass(UploadDecBidFileComposite.class);
	}
	
	public UploadDecBidFileComposite(Composite parent, TenderProjectEntity tenderProject, int style) {
		super(parent, style);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				cancelAction();
			}
		});
		this.tenderProject = tenderProject;
		supplierName = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		container = new Composite(this, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		container.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.verticalSpacing = 0;
		gl_container.horizontalSpacing = 0;
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);
		
		bidOpeningStageComposite = new Composite(container, SWT.NONE);
		bidOpeningStageComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_top = new GridLayout(2, false);
		gl_composite_top.marginHeight = 0;
		gl_composite_top.marginWidth = 0;
		bidOpeningStageComposite.setLayout(gl_composite_top);
		bidOpeningStageComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		titleComposite = new TitleComposite(container, SWT.NONE);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		ELink addBidFileBtn = titleComposite.addELink("UPLOAD_BID_FILE");
		addBidFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/upload.png"));
		addBidFileBtn.setText(Messages.Button_uploadBidFile);
		addBidFileBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				supplierMenuDetectELink();
			}
		});
		composite_4 = new Composite(container, SWT.NONE);
		GridLayout gl_composite_4 = new GridLayout(1, false);
		gl_composite_4.verticalSpacing = 1;
		gl_composite_4.horizontalSpacing = 1;
		gl_composite_4.marginHeight = 1;
		gl_composite_4.marginWidth = 1;
		composite_4.setLayout(gl_composite_4);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite_4.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(composite_4, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 1;
		gl_composite_1.horizontalSpacing = 1;
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		supplierGrid = new Grid(composite_1, SWT.V_SCROLL);
		supplierGrid.setHeaderVisible(true);
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierGrid.setItemHeight(Constants.ROW_HIGHT);
		GridColumn gridColumn_2 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn_2.setText(Messages.Num);
		gridColumn_2.setWidth(30);
		gridColumn_2.setMaxmumWidth(50);
		
		supplierNameColumn = new GridColumn(supplierGrid, SWT.LEFT);
		supplierNameColumn.setText(Messages.Supplier);
		supplierNameColumn.setWidth(250);
		
		GridColumn gridColumn1 = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn1.setText(Messages.Status);
		gridColumn1.setWidth(100);
		
		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.CENTER);
		gridColumn.setText(Messages.FileSize);
		gridColumn.setWidth(100);
		
		ESepator downLabel = new ESepator(composite_1, SWT.SEPARATOR | SWT.HORIZONTAL);
		downLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		downLabel.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		iComposite = new Composite(composite_1, SWT.NONE);
		iComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_buttonComposite = new GridLayout(3, false);
		gl_buttonComposite.marginHeight = 0;
		iComposite.setLayout(gl_buttonComposite);
		
		Composite composite = new Composite(iComposite, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		composite.setLayout(new GridLayout(1, false));
		
		Label biddingFileTitle = new Label(composite, SWT.NONE);
		biddingFileTitle.setText(Messages.BiddingFile);
		biddingFileTitle.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1));
		
		biddingFileSizeLabel = new CLabel(composite, SWT.NONE);
		biddingFileSizeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1));
		
		ELink addBiddingFileBtn = new ELink(composite, SWT.NONE);
		addBiddingFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/upload.png"));
		addBiddingFileBtn.setText(MessageFormat.format(Messages.Button_uploadFormat, Messages.BiddingFile));
		addBiddingFileBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, true, 1, 1));
		addBiddingFileBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectFileAndUplaodBiddingFile();
			}
		});
		
		ESepator vSep = new ESepator(iComposite, SWT.SEPARATOR | SWT.VERTICAL);
		vSep.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		vSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		fileOperatorComposite = new Composite(iComposite, SWT.NONE);
		RowLayout rl_fileOperatorComposite = new RowLayout(SWT.HORIZONTAL);
		fileOperatorComposite.setLayout(rl_fileOperatorComposite);
		fileOperatorComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		init();
	}
	
	private void refreshBiddingFile() {
		CheckServiceBiddingFileThread checkSupplierBidFileThread = new CheckServiceBiddingFileThread(tenderProject, new CheckServiceBiddingFileThread.CheckCallBack() {
			@Override
			public void biddingFile(boolean isExist, String returnMessage, String fileSize, List<FileInfoEntity> fileInfoEntityList) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						refreshFileOperatorButton(fileInfoEntityList);
						biddingFileSizeLabel.setText(Messages.FileSize + " ：".concat(fileSize));
						biddingFileSizeLabel.requestLayout();
					}
				});
			}
		});
		checkSupplierBidFileThread.start();;
	}
	
	private void init() {
		SUPPLIER_NAME = I18N.getString(I18NEnum.SUPPLIERNAME, tenderProject.getTenderType());
		titleComposite.setTitle(MessageFormat.format(Messages.Title_list, SUPPLIER_NAME));
		supplierNameColumn.setText(SUPPLIER_NAME);
		refreshSupplierBidFile();
		refreshBiddingFile();
		supplierGrid.addListener(SWT.Selection, new GridSelectionListener() {
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
		});
		supplierGrid.addSelectionListener(new SelectionAdapter() {
			public void widgetDefaultSelected(SelectionEvent e) {
				supplierDefaultSelectedAction();
			}
		});
	}
	
	/**
	 * @Description: 刷新文件按钮界面
	 * @author chenxw
	 * @param fileInfoEntityList
	 */
	private void refreshFileOperatorButton(List<FileInfoEntity> fileInfoEntityList) {
		for (Control control : fileOperatorComposite.getChildren()) {
			control.dispose();
		}
		fileOperatorComposite.requestLayout();
		for (FileInfoEntity fileInfoEntity : fileInfoEntityList) {
			new NewFileOperatorButton(fileOperatorComposite, fileInfoEntity, tenderProject.getId(), FileConstants.getUploadBiddingFilePath(tenderProject.getId()), null);
		}
		fileOperatorComposite.requestLayout();
	}
	
	private void supplierDefaultSelectedAction() {
		GridItem items = supplierGrid.getSelection()[0];
		if (null != items) {
			if (!(boolean) items.getData("isExist")) {
				Supplier supplier = (Supplier) items.getData("supplier");
				selectFileAndUplaodFile(supplier);
			}
		}
	}
	
	private void supplierMenuDetectELink() {
		GridItem[] items = supplierGrid.getSelection();
		if (null != items && items.length > 0) {
			Supplier supplier = (Supplier) items[0].getData("supplier");
			if (!(boolean) items[0].getData("isExist")) {
				selectFileAndUplaodFile(supplier);
			} else {
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_reuploadBidFile, null);
				confirmDialog.setTips(Messages.Tips_sameNameFileCovered);
				confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
				confirmDialog.setTipsAlignment(SWT.CENTER);
				confirmDialog.addButton(Messages.Button_ok, "01", SWTResourceManager.getColor(77, 163, 19));
//				confirmDialog.addButton("清空并重新上传", "02", SWTResourceManager.getColor(77, 163, 19));
				confirmDialog.addCancel(Messages.Button_cancel, null);
//				confirmDialog.setMinimumSize(new Point(600, 250));
				confirmDialog.open();
				
				if (confirmDialog.isCancel()) {
					return;
				}
				if (confirmDialog.getClickStatus().equals("01")) {
					selectFileAndUplaodFile(supplier);
				}
				if (confirmDialog.getClickStatus().equals("02")) {
					selectFileAndUplaodFile(supplier);
				}
			}
		} else {
			MessageDialog.openError(getShell(), MessageFormat.format(Messages.Tips_pleaseSelect, SUPPLIER_NAME));
		}
	}
	
	private void supplierMenuDetectAction() {
		final EMenu gmenu = new EMenu(getShell());
		GridItem items = supplierGrid.getSelection()[0];
		if (null != items) {
			if (!(boolean) items.getData("isExist")) {
				gmenu.addMenuItem(Messages.Button_uploadBidFile, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/upload.png"), true, new EMenu.ClickListener() {
					public void click() {
						Supplier supplier = (Supplier) items.getData("supplier");
						selectFileAndUplaodFile(supplier);
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void selectFileAndUplaodBiddingFile() {
		List<UploadBidFileInfo> addFileList = new ArrayList<UploadBidFileInfo>();
		String selectFiles = FileDialogUtils.getFileNames(SWT.MULTI, Messages.BiddingFile, new String[] { "*.doc;*.docx;*.xlsx;*.xls;*.png;*.jpg;*.pdf"}, new String[] {Messages.BiddingFile});
		if (!StringUtil.empty(selectFiles)) {
			String[] filePathList = selectFiles.split(";");
			for (String filePath : filePathList) {
				UploadBidFileInfo uploadBidFileInfo = new UploadBidFileInfo();
				uploadBidFileInfo.setStrFilePath(filePath);
				uploadBidFileInfo.setTenderId(tenderProject.getId());
				uploadBidFileInfo.setSupperId(null);
				addFileList.add(uploadBidFileInfo);
			}
		}
		if (addFileList.size() <= 0) {
			return;
		}
		uplodaBidFile(addFileList, FileConstants.BIDDING_FILE);
	}
	
	private void selectFileAndUplaodFile(Supplier supplier) {
		List<UploadBidFileInfo> addFileList = new ArrayList<UploadBidFileInfo>();
		String selectFiles = FileDialogUtils.getFileNames(SWT.MULTI, supplier.getSupplierName(), new String[] { "*.doc;*.docx;*.xlsx;*.xls;*.png;*.jpg;*.pdf"}, new String[] {Messages.BidFile});
		if (!StringUtil.empty(selectFiles)) {
			String[] filePathList = selectFiles.split(";");
			for (String filePath : filePathList) {
				UploadBidFileInfo uploadBidFileInfo = new UploadBidFileInfo();
				uploadBidFileInfo.setStrFilePath(filePath);
				uploadBidFileInfo.setTenderId(supplier.getTenderId());
				uploadBidFileInfo.setSupperId(supplier.getId());
				addFileList.add(uploadBidFileInfo);
			}
		}
		if (addFileList.size() <= 0) {
			return;
		}
		uplodaBidFile(addFileList, FileConstants.BID_FILE);
	}
	
	private void refreshSupplierBidFile() {
		supplierGrid.removeAll();
		
		supplierList = supplierService.getSupplierByStatusList(tenderProject.getId(), CommonEnum.REAL_STATUS);
		List<Future<?>> resultList = new ArrayList<Future<?>>();
		
		if (null != supplierList && supplierList.size() > 0) {
			executorService = Executors.newFixedThreadPool(supplierList.size() < 5 ? supplierList.size() : 5);
			int index = 1;
			for (final Supplier supplier : supplierList) {
				final GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
				gridItem.setData("supplierId", supplier.getId());
				gridItem.setData("supplier", supplier);
				gridItem.setText(0, String.valueOf(index));
				gridItem.setText(1, supplier.getSupplierName());
				gridItem.setText(2, Messages.Tips_loading);
				Future<?> future = executorService.submit(checkBidFile(tenderProject, supplier, gridItem));
				resultList.add(future);
				index++;
			}
			if (null != executorService) {
				executorService.shutdown();
			}
		}
	}
	
	private CheckServiceBidFileThread checkBidFile(TenderProjectEntity tenderProject, final Supplier supplier, final GridItem gridItem) {
		
		CheckServiceBidFileThread checkSupplierBidFileThread = new CheckServiceBidFileThread(tenderProject, supplier, new CheckServiceBidFileThread.CheckCallBack() {
			@Override
			public void bidFile(boolean isExist, String returnMessage, long fileSize, List<FileInfoEntity> fileInfoEntityList) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!gridItem.isDisposed()) {
							gridItem.setData("supplier", supplier);
							gridItem.setData("isExist", isExist);
							if (isExist) {
								gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_BLUE));
							} else {
								gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
							}
							gridItem.setText(2, returnMessage);
							if (fileSize > 0) {
								gridItem.setText(3, FileUtils.getFileSize(fileSize));
							}
						}
					}
				});
			}
		});
		return checkSupplierBidFileThread;
	}
	
	private void cancelAction() {
		if (null != executorService) {
			executorService.shutdownNow();
		}
		if (null != upoladThreadPool) {
			upoladThreadPool.shutdownNow();
		}
		isDispose = true;
	}
	
	public List<Supplier> getSelectSupplierList() {
		return selectSupplierList;
	}
	
	public String getSupplierId() {
		return supplierId;
	}
	
	public void setSupplierId(String supplierId) {
		this.supplierId = supplierId;
	}
	
	private void uplodaBidFile(List<UploadBidFileInfo> addFileList, String fileType) {
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, 100 * addFileList.size(), new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!supplierGrid.isDisposed()) {
							if (FileConstants.BIDDING_FILE.equals(fileType)) {
								refreshBiddingFile();
							} else if (FileConstants.BID_FILE.equals(fileType)) {
								refreshSupplierBidFile();
							}
						}
					}
				});
			}
			
		});
		messageProgress.setCountDownTime(3);
		messageProgress.setForceClose(true);
		messageProgress.setOperateVisible(false);
		String url = Constants.getServiceUrl("/bidFileUploader/chunk");
		int poolMaxSize = addFileList.size() <= 3 ? addFileList.size() : 3;
		upoladThreadPool = new ThreadPoolExecutor(poolMaxSize, poolMaxSize, 1, TimeUnit.SECONDS, new LinkedBlockingQueue<Runnable>(), new ThreadPoolExecutor.CallerRunsPolicy());
		upoladThreadPool.allowCoreThreadTimeOut(true);
		List<Future<?>> allFuture = new ArrayList<Future<?>>();
		new Thread(new Runnable() {
			public void run() {
				for (final UploadBidFileInfo uploadBidFileInfo : addFileList) {
					final File file = new File(uploadBidFileInfo.getStrFilePath());
					messageProgress.message(MessageFormat.format(Messages.Tips_uploadingFormat, file.getName()), 0);
					UploadFileUtil UploadFileUtil = new UploadFileUtil(url, uploadBidFileInfo.getStrFilePath(), uploadBidFileInfo.getTenderId(), uploadBidFileInfo.getSupperId(), fileType, new UploadFileListener() {
						@Override
						public void computeherLoadProgress(int percent) {
							messageProgress.addProgress(percent);
						}
						
						@Override
						public void computeRemainingTimeCurrent(String time) {}
						
						@Override
						public void computeDownloadSpeed(String Speed) {}
						
						@Override
						public void MD5check(boolean isCheck) {}
						
						@Override
						public void Completed(boolean loginFlag) {
							if (loginFlag) {
								messageProgress.message(MessageFormat.format(Messages.Tips_uploadSuccessFormat, file.getName()), 1);
							} else {
								messageProgress.message(MessageFormat.format(Messages.Tips_uploadFailFormat, file.getName()), -1);
							}
							
						}
					});
//					UploadFileUtil.startUploadFileFile();
					Future<?> future = upoladThreadPool.submit(UploadFileUtil.getFileUpload());
					allFuture.add(future);
				}
				upoladThreadPool.shutdown();
				for (Future<?> future : allFuture) {
					if (isDispose) {
						break;
					}
					try {
						future.get();
					} catch (InterruptedException e) {} catch (ExecutionException e) {}
				}
				messageProgress.message(Messages.Tips_uploadFinished, 0);
				messageProgress.finish(true);
			}
		}).start();
		messageProgress.setTitle(Messages.Button_uploadBidFile);
		messageProgress.open();
	}
}
